<?php
require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php';
class Cache_Model extends Data_Model {
	
	public function __construct(){
		parent::__construct();
	}
	
	public function get_model(){
		
		$form_data = array();
		
		$form_data['cache']['parameter']['name'] = 'parameter';
		$form_data['cache']['parameter']['title'] = Multilanguage::_('L_PARAMETER');
		$form_data['cache']['parameter']['value'] = 0;
		$form_data['cache']['parameter']['length'] = 40;
		$form_data['cache']['parameter']['type'] = 'primary_key';
		$form_data['cache']['parameter']['required'] = 'off';
		$form_data['cache']['parameter']['unique'] = 'off';
		
		$form_data['cache']['value']['name'] = 'value';
		$form_data['cache']['value']['title'] = Multilanguage::_('L_VALUE');
		$form_data['cache']['value']['value'] = '';
		$form_data['cache']['value']['length'] = 40;
		$form_data['cache']['value']['type'] = 'textarea_editor';
		$form_data['cache']['value']['required'] = 'off';
		$form_data['cache']['value']['unique'] = 'off';
		$form_data['cache']['value']['rows'] = '10';
		$form_data['cache']['value']['cols'] = '40';
		
		$form_data['cache']['created_at']['name'] = 'created_at';
		$form_data['cache']['created_at']['title'] = Multilanguage::_('L_CREATION_DATE');
		$form_data['cache']['created_at']['value'] = '';
		$form_data['cache']['created_at']['length'] = 40;
		$form_data['cache']['created_at']['type'] = 'date';
		$form_data['cache']['created_at']['required'] = 'on';
		$form_data['cache']['created_at']['unique'] = 'off';
		
		$form_data['cache']['valid_for']['name'] = 'valid_for';
		$form_data['cache']['valid_for']['title'] = Multilanguage::_('L_VALID_DATE');
		$form_data['cache']['valid_for']['value'] = '';
		$form_data['cache']['valid_for']['length'] = 40;
		$form_data['cache']['valid_for']['type'] = 'date';
		$form_data['cache']['valid_for']['required'] = 'on';
		$form_data['cache']['valid_for']['unique'] = 'off';
		
		return $form_data;
	}
	
	/**
     * Init model data from db
     * @param string $table_name
     * @param string $primary_key_name primary key name
     * @param int $primary_key_value primary key
     * @param array $model_array
     * @param boolean $force_select_values
     * @return boolean
     */
    function init_model_data_from_db ( $table_name, $primary_key_name, $primary_key_value, $model_array, $force_select_values = false ) {
        $query = "select * from ".DB_PREFIX."_".$table_name." where ".$primary_key_name." = '".$primary_key_value."'";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        if ( $this->db->row[$primary_key_name] == '' ) {
        	$this->riseError('  ');
        	return false;
        }
        $row = $this->db->row;
        
        foreach ( $model_array as $key => $item_array ) {
            //echo "key = $key, value = ".$this->db->row[$key].'<br>';
            $model_array[$key]['value'] =  $row[$key];
            
            if ( $model_array[$key]['type'] == 'uploadify_image' or $model_array[$key]['type'] == 'uploadify_file' ) {
                $model_array[$key]['primary_key_value'] = $primary_key_value;
            }
        	if ( $model_array[$key]['type'] == 'select_by_query' and $force_select_values ) {
                $model_array[$key]['value_string'] = $this->get_string_value_by_id($model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $model_array[$key]['value_name'] ,$model_array[$key]['value']);
            }
            if ( $model_array[$key]['type'] == 'uploadify_image' ) {
                $model_array[$key]['image_array'] = $this->get_image_array ( 'data', 'data', 'id', $primary_key_value );
            }
            if ( $model_array[$key]['type'] == 'uploadify_file' ) {
                $model_array[$key]['image_array'] = $this->get_image_array ( $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $primary_key_value );
            }
        	if ( $model_array[$key]['type'] == 'values_list' ) {
                $model_array[$key]['value'] = $this->get_values_list($model_array[$key]['what'], $model_array[$key]['primary_table'], $model_array[$key]['primary_key'], $model_array[$key]['secondary_table'], $model_array[$key]['secondary_key'], $primary_key_value);
            	//SELECT tag_name FROM re_tag WHERE tag_id IN (SELECT tag_id FROM re_shop_product_tag WHERE shop_product_id=5)
        	}
        	if ( $model_array[$key]['type'] == 'date' and $force_select_values ) {
                $model_array[$key]['value_string'] = date('d-m-Y H:i',$model_array[$key]['value']);
            }
        	
        }
        //echo '<pre>';
        //print_r($model_array);
        //echo '</pre>';
        return $model_array;
    }
	

}