$(document).ready(function(){
	$.fn.columnform = function(){
		
		var form=this;
		
		var sql_template='SELECT * FROM re_[table]';
		var select=this.find('select[name=type]');
		
		var query_field=form.find('[name=query]');
		query_field.after('<div class="showquery"> </div>')
		query_field.hide();
		$('.showquery').live('click',function(){
			$(this).text(' ').removeClass('showquery').addClass('hidequery');
			query_field.show();
		});
		$('.hidequery').live('click',function(){
			$(this).text(' ').removeClass('hidequery').addClass('showquery');
			query_field.hide();
		});
		
		
		form.find('select, input').live('change',function(){
			displayPreview();
		});
		
		
		var controls=[];
		var common_fields=['name','title','value','type','required','unique','dbtype','active_in_topic','active_in_topic[]','tab','hint'];
		controls['date']=common_fields;
		controls['primary_key']=common_fields;
		controls['password']=common_fields;
		controls['photo']=common_fields;
		controls['safe_string']=common_fields;
		controls['hidden']=common_fields;
		controls['checkbox']=common_fields;
		controls['structure']=common_fields.concat(['entity']);
		controls['select_box_structure']=common_fields.concat(['value_string']);
		controls['select_by_query']=common_fields.concat(['primary_key_name','primary_key_table','value_string','query','value_name','title_default','value_default','combo']);;
		controls['select_box']=common_fields.concat(['select_data']);
		controls['auto_add_value']=common_fields.concat(['value_table','value_primary_key','value_field','assign_to']);
		controls['price']=common_fields;
		controls['textarea']=common_fields;
		controls['textarea_editor']=common_fields;
		controls['uploadify_image']=common_fields.concat(['primary_key','primary_key_value','action','table_name']);;
		controls['mobilephone']=common_fields;
		controls['geodata']=common_fields;
		controls['attachment']=common_fields;
		
		//var x=['name','title','value','primary_key_name','primary_key_table','value_string','query','value_name','title_default','value_default','type','required','unique','sort_order','value_table','value_primary_key','value_field','assign_to','dbtype','table_name','primary_key','primary_key_value','action','select_data'];
		function inArray(needle, haystack) {
		    var length = haystack.length;
		    for(var i = 0; i < length; i++) {
		        if(haystack[i] == needle) return true;
		    }
		    return false;
		}
		
		form.find('select[name=primary_key_table]').change(function(){
			var table_name=$(this).val();
			$.ajax({
				url: estate_folder+'/apps/table/js/ajax.php',
				type: 'POST',
				dataType: 'html',
				data: 'action=get_table_fields_select&table_name='+table_name,
				success: function(data) {
					var sb1=$('<select>').attr('name','primary_key_name').append($(data));
					var sb2=$('<select>').attr('name','value_name').append($(data));
					
					form.find('[name=primary_key_name]').replaceWith(sb1);
					form.find('[name=value_name]').replaceWith(sb2);
					form.find('[name=query]').val(sql_template.replace('[table]',table_name));
					//form.find('input[name=value_name]').replaceWith(sb2);
				}
			});
		});
		
		var prepare=function(new_val){
			var inputs=form.find('input').not(':submit').not('input[name=active]');
			var selects=form.find('select').not('#group_id').not('#table_id');
			inputs.each(function(){
				$(this).parents('tr').show();
				$(this).parents('.form_element').show();
				if(!inArray($(this).attr('name'),controls[new_val])){
					$(this).parents('tr').hide();
					$(this).parents('.form_element').hide();
				}
			});
			selects.each(function(){
				$(this).parents('tr').show();
				$(this).parents('.form_element').show();
				//console.log(this);
				if(!inArray($(this).attr('name'),controls[new_val])){
					$(this).parents('tr').hide();
					$(this).parents('.form_element').hide();
				}
			});
			
		}
		
		var displayPreview=function(){
			var data=[];
			var inputs=form.find('input').not(':submit').not('input[name=active]');
			var selects=form.find('select').not('#group_id').not('#table_id');
			inputs.each(function(){
				data.push($(this).attr('name')+':'+$(this).val());
			});
			selects.each(function(){
				data.push($(this).attr('name')+':'+$(this).val());
			});
			$.ajax({
				url: estate_folder+'/apps/table/js/ajax.php',
				type: 'POST',
				dataType: 'html',
				data: 'action=get_preview&data='+data.join('|'),
				success: function(data) {
					$('#element_preview_c').html('<table>'+data+'</table>');
					$('#_element_preview').html('<table>'+data+'</table>');
				}
			});
		}
		
		prepare(select.val());
		
		select.change(function(){
				prepare($(this).val());
		});
		
		
		displayPreview();
		return this; 
	    
	};
	
	$('#column_form').columnform();
	  
});