<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Vendors admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class config_admin extends Object_Manager {
	
	private $dev_status=0;
	private $check_config_array = array();
	
    /**
     * Constructor
     */
    function __construct( $realty_type = false ) {
        $this->SiteBill();
        
        $this->table_name = 'config';
        $this->action = 'config';
        $this->app_title = Multilanguage::_('L_SETTINGS');
        $this->primary_key = 'id';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/config_model.php');
        $this->data_model_object=new Config_Model();
		$this->data_model=$this->data_model_object->get_model();
		
        //$this->install();
        $this->check_config_structure();
    }
    
    function ajax(){
    	if ( $this->getRequestValue('action') == 'resort' ) {
    		return $this->resort();
    	}
    	return false;
    }
    
    function resort(){
    	$ids=trim($this->getRequestValue('ids'));
    	if($ids!=''){
    		$ids_array=explode(',',$ids);
    		$i=1;
    		foreach($ids_array as $id){
    			$query='UPDATE '.DB_PREFIX.'_'.$this->table_name.' SET sort_order='.$i.' WHERE '.$this->primary_key.'='.$id;
    			$this->db->exec($query);
    			$i++;
    		}
    	}
    }
    
    
    function main () {
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
	    global $__user, $__db;
	    $rs=$this->getTopMenu();
		switch($this->getRequestValue('do')){
			case 'new' : {
				$rs.=$this->get_form($this->data_model[$this->table_name],'new');
				break;				
			}
			
			case 'new_done' : {
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
	            $form_data[$this->table_name]['title']['value']=$this->validateParamTitle($form_data[$this->table_name]['title']['value']);
				
				if ( !$this->check_data( $form_data[$this->table_name] ) ) {
			        $rs .= $this->get_form($form_data[$this->table_name], 'new');
			        
			    } else {
			        $this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
			        if ( $this->getError() ) {
			            $rs .= $this->get_form($form_data[$this->table_name], 'new');
			        } else {
			        	
			            $rs .= $this->grid();
			        }
			    }
			    break;
			}
			
			case 'edit' : {
            	$form_data[$this->table_name] = $data_model->init_model_data_from_db ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name] );
                $rs .= $this->get_form($form_data[$this->table_name], 'edit');
                break;
			}
			
			case 'edit_done' : {
				
	            $form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
			    $form_data[$this->table_name]['title']['value']=$this->validateParamTitle($form_data[$this->table_name]['title']['value']);
	            if ( !$this->check_data( $form_data[$this->table_name] ) ) {
			        $rs .= $this->get_form($form_data[$this->table_name], 'edit');
			    } else {
			        $this->edit_data($form_data[$this->table_name]);
			        if ( $this->getError() ) {
			            $rs .= $this->get_form($form_data[$this->table_name], 'edit');
			        } else {
			        	$rs .= $this->grid();
			        }
			    }
				break;
			}
			
			case 'save' : {
				$back_url=FALSE;
		    	if(isset($_SERVER['HTTP_REFERER'])){
		    		$back_url=$_SERVER['HTTP_REFERER'];
		    	}
				//echo '<pre>';
				//print_r($_POST);
                if ( $this->isDemo() ) {
                    $rs .= Multilanguage::_('L_MESSAGE_THIS_IS_TRIAL');
                    return $rs;                    
                }
			    
				$post=$this->getRequestValue('conf_param_value');
				//print_r($post);
				//exit();
				if(count($post)>0){
					foreach($post as $k=>$v){
						$this->updateParamToConfig($k,$v);
					}
				}
				
				if($back_url){
					$data_url=parse_url($back_url);
					if(preg_match('/action=([^&]*)/',$data_url['query'],$matches)){
						if($matches[1]!=='config'){
							$url=$data_url['scheme'].'://'.$data_url['host'].$data_url['path'].'?'.$matches[0];
							header('location:'.$url);
							exit();
						}
						
					}
				}
				
				$rs .= $this->grid();
				break;
			}
			
			case 'delete' : {
				$this->delete_data($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
			    if ( $this->getError() ) {
			        $rs .= '<div align="center">'.Multilanguage::_('L_ERROR_ON_DELETE').': '.$this->GetErrorMessage().'<br>';
			        $rs .= '<a href="?action='.$this->action.'"></a>';
			        $rs .= '</div>';
			    } else {
		            $rs .= $this->grid();
			    }
				break;
			}
			case 'extended' : {
				$rs.=$this->grid_extended();
				break;
			}
			
			default : {
				//$this->loadAllConfigParams();
				$rs.=$this->grid();
				//$rs.=$this->getAddForm();
			}
		}
		$rs_new = $this->get_app_title_bar();
		$rs_new .= $rs;
		return $rs_new;
	}
    
    
    
    
	
    
    function install () {
        $query="CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_".$this->table_name."` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `config_key` varchar(255) NOT NULL DEFAULT '',
  `value` text,
  `title` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." ;";

	$this->db->exec($query);
        
	}
	/*
	function loadAllConfigParams(){
		$ret=array();
		$query='SELECT * FROM '.DB_PREFIX.'_config ORDER BY config_key ASC';
    	$this->db->exec($query);
		while($this->db->fetch_assoc()){
    		$ret[]=$this->db->row;
    	}
    	foreach($ret as $v){
    		$str.='$data_model[\''.$v['config_key'].'\'][\'name\'] = \''.$v['config_key'].'\';'."\r\n";
    		$str.='$data_model[\''.$v['config_key'].'\'][\'title\'] = \''.$v['title'].'\';'."\r\n";
    		$str.='$data_model[\''.$v['config_key'].'\'][\'value\'] = \''.$v['value'].'\';'."\r\n";
    		$str.='$data_model[\''.$v['config_key'].'\'][\'type\'] = \'checkbox\';'."\r\n"."\r\n";
    	}
    	echo '<pre>';
    	echo $str;
    	echo '</pre>';
	}
	*/
	/*
	function createConfigStructure_old(){
		$data=array();
		$query='SELECT * FROM '.DB_PREFIX.'_config ORDER BY config_key ASC';
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$ret[]=$this->db->row;
    		$list=array();
    		$list=explode('.',$this->db->row['config_key']);
    		if(count($list)==1){
    			$data[''][]=$this->db->row;
    		}elseif(count($list)>2){
    			$data[$list[0].'.'.$list[1]][]=$this->db->row;
    		}
    	}
    	return $data;
    	
	}
	*/
	function getConfigSection($section=NULL){
		$ret=array();
		$data=$this->createConfigStructure();
		if($section!==NULL){
			$ret=$data[$section];
		}
		return $ret;
	}
    
       
	function grid () {
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/apps/apps_processor.php');
        $APP = new Apps_Processor();
        $apps=$APP->load_apps_menu(true);
        foreach($apps as $ak=>$av){
        	$apps_array['apps.'.$ak]=$av;
        }
        $apps_array['apps.realty']=array('title'=>'');
        
        $data=$this->createConfigStructure();
        
        $current_tab_nr=(int)$this->getRequestValue('tab_nr');
        
        $keys=array_keys($data);
    	$keys_fl=array_flip($keys);
    	//print_r($keys_fl);
    	foreach($data as $k=>$v){
    		$temp[]='<a href="javascript:void(0)" alt="'.$keys_fl[$k].'">'.$k.'</a>';
    	}
    	/*
    	$rs.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/config/js/jquery-ui-1.8.16.custom.min.js"></script>';
		$rs.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/config/js/utils.js"></script>';
    	$rs.='<div id="tabs-left">';
    	$rs.='<ul>';
    	foreach($keys_fl as $k=>$v){
    		if(strpos($k, 'apps.')!==FALSE){
    			if(isset($apps_array[$k])){
    				$rs.='<li><a href="#tabs-left-'.$v.'">'.$apps_array[$k]['title'].'</a></li>';
    			}else{
    				unset($data[$k]);
    			}
    			
    		}else{
    			$rs.='<li><a href="#tabs-left-'.$keys_fl[$k].'">'.$k.'</a></li>';
    		}
    	}
    	$rs.='</ul>';
		
    	foreach($data as $k=>$v){
    		$rs.='<div id="tabs-left-'.$keys_fl[$k].'">';
				$rs.=$this->getTabForm($v);
			$rs.='</div>';
		}
			
		$rs.='</div>';
		*/
    	
    	
    	$rs.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/config/js/utils.js"></script>';
		$rs.='<style>.form-horizontal .control-label {width: 460px;} .form-horizontal .controls {margin-left: 480px;}</style>';
		
		
		//TABS
		
		$rs.='<div class="tabbable tabs-left">';
		$rs.='<ul class="nav nav-tabs">';
		foreach($keys_fl as $k=>$v){
			if(strpos($k, 'apps.')!==FALSE){
    			if(isset($apps_array[$k])){
    				$rs.='<li'.($v==$current_tab_nr ? ' class="active"' : '').'><a href="#config-tabs-left-'.$v.'" data-toggle="tab">'.$apps_array[$k]['title'].'</a></li>';
    			}else{
    				unset($data[$k]);
    			}
    			
    		}else{
    			$rs.='<li'.($keys_fl[$k]==$current_tab_nr ? ' class="active"' : '').'><a href="#config-tabs-left-'.$keys_fl[$k].'" data-toggle="tab">'.$k.'</a></li>';
    		}
    	}
    	$rs.='</ul>';
		$rs.='<div class="tab-content">';
		//$i=0;
		foreach($data as $k=>$v){
    		$rs.='<div id="config-tabs-left-'.$keys_fl[$k].'" class="tab-pane fade in'.($keys_fl[$k]==$current_tab_nr ? ' active' : '').'">';
			if(isset($apps_array[$k])){
    			$rs.='<h3>'.$apps_array[$k]['title'].'</h3>';
    		}else{
    			$rs.='<h3>'.$k.'</h3>';
    		}
    		$rs.=$this->getTabForm($v, $keys_fl[$k]);
			$rs.='</div>';
			//$i++;
		}
		$rs.='</div>';
		$rs.='</div>';
		
		
		
		//ACCORDION
		
		/*
		$rs.='<div class="accordion" id="accordion2">';
		foreach($keys_fl as $k=>$v){
			//var_dump($current_tab_nr==$v);
			$rs.='<div class="accordion-group">';
			$rs.='<div class="accordion-heading">';
			if(strpos($k, 'apps.')!==FALSE){
				if(isset($apps_array[$k])){
					$rs.='<a href="#config-tabs-left-'.$v.'" class="accordion-toggle" data-toggle="collapse" data-parent="#accordion2" href="#config-tabs-left-'.$v.'">'.$apps_array[$k]['title'].'</a>';
				}else{
					unset($data[$k]);
				}
				 
			}else{
				$rs.='<a href="#config-tabs-left-'.$keys_fl[$k].'" class="accordion-toggle" data-toggle="collapse" data-parent="#accordion2" href="#config-tabs-left-'.$keys_fl[$k].'">'.$k.'</a>';
			}
			$rs.='</div>';
			$rs.='<div id="config-tabs-left-'.$keys_fl[$k].'" class="accordion-body'.($current_tab_nr==$v ? ' in' : '').' collapse">';
			$rs.='<div class="accordion-inner">';
			$rs.=$this->getTabForm($data[$k], $keys_fl[$k]);
			$rs.='</div>';
			$rs.='</div>';
			$rs.='</div>';
		}
		$rs.='</div>';
		*/
		
		
		
		
		return $rs;
    }
    
	function createConfigStructure(){
		$data=array();
		$query='SELECT * FROM '.DB_PREFIX.'_config ORDER BY sort_order ASC, config_key ASC';
		$this->db->exec($query);
		while($this->db->fetch_assoc()){
    		$ret[]=$this->db->row;
    		$list=array();
    		$list=explode('.',$this->db->row['config_key']);
    		if(count($list)==1){
    			$data[Multilanguage::_('L_COMMON')][]=$this->db->row;
    		}elseif(count($list)>2){
    			$data[$list[0].'.'.$list[1]][]=$this->db->row;
    		}
    	}
    	$ob[Multilanguage::_('L_COMMON')]=$data[Multilanguage::_('L_COMMON')];
    	unset($data[Multilanguage::_('L_COMMON')]);
    	//echo '<pre>';
    	
    	ksort($data);
    	foreach($data as $k=>$d){
    	$ob[$k]=$d;
    	}
    	//array_unshift($data, $ob);
    	//print_r($data);
    	return $ob;
    	
	}
	
	function getTabForm($data, $tab_nr=0){
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/config_mask.php');
		$CM=new Config_Mask();
		$config_mask=$CM->get_model();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/config_form_generator.php');
        $FG=new Config_Form_Generator();
        /*
        $rs .= '<form class="config_form" method="post" action="'.SITEBILL_MAIN_URL.'/admin/index.php?action='.$this->action.'">';
        $rs .= '<table border="0" width="700">';
		$rs .= '<thead>';
		$rs .= '<tr><th style="width:400px"></th><th></th></tr>';
		$rs .= '</thead>';
        $rs .= '<tbody class="applied">';
		foreach($data as $d){
			if ( $this->is_demo() and  $d['config_key'] == 'license_key' ) {
		        
		    } else {
		    	$ret=array();
			    if(!isset($config_mask[$d['config_key']])){
					$ret['name']=$d['id'];
					$ret['hint']=$d['config_key'];
					$ret['title']=$d['title'];
					$ret['value']=$d['value'];
					$ret['type']='safe_string';
					$ret['sort_order']=$d['sort_order'];
				}else{
					$ret=$config_mask[$d['config_key']];
					$ret['name']=$d['id'];
					$ret['hint']=$d['config_key'];
					$ret['title']=$d['title'];
					$ret['value']=$d['value'];
					$ret['sort_order']=$d['sort_order'];
				}
				$rs.=$FG->compile_form(array($ret));
			 }
		}
		$rs .= '</tbody>';
		$rs .= '<tr>';
		
		$rs .= '<td><input type="button" name="cnf_resort" class="cnf_resort" value="'.Multilanguage::_('L_SORT').'"></td><td><input type="submit" name="cnf_submit" value="'.Multilanguage::_('L_TEXT_SAVE').'"></td><td></td>';
		$rs .= '</tr>';
		$rs .= '<input type="hidden" name="do" value="save">';
		$rs .= '</table>';
		$rs .= '</form>';
		*/
		
		$rs .= '<form class="config_form form-horizontal applied" method="post" action="'.SITEBILL_MAIN_URL.'/admin/index.php?action='.$this->action.'">';
		//$rs .= '<table border="0" width="700">';
		//$rs .= '<thead>';
		//$rs .= '<tr><th style="width:400px"></th><th></th></tr>';
		//$rs .= '</thead>';
		//$rs .= '<tbody class="applied">';
		foreach($data as $d){
			if ( $this->is_demo() and  $d['config_key'] == 'license_key' ) {
		
			} else {
				$ret=array();
				if(!isset($config_mask[$d['config_key']])){
					$ret['name']=$d['id'];
					$ret['hint']=$d['config_key'];
					$ret['title']=$d['title'];
					$ret['value']=$d['value'];
					$ret['type']='safe_string';
					$ret['sort_order']=$d['sort_order'];
				}else{
					$ret=$config_mask[$d['config_key']];
					$ret['name']=$d['id'];
					$ret['hint']=$d['config_key'];
					$ret['title']=$d['title'];
					$ret['value']=$d['value'];
					$ret['sort_order']=$d['sort_order'];
				}
				//$elements=$FG->compile_form_elements(array($ret));
				$rs.=$FG->compile_form(array($ret));
			}
		}
		//$rs .= '</tbody>';
		//$rs .= '<tr>';
		
		$rs .= '<div class="control-group">';
		
		$rs .= '<label class="control-label">';
		//$rs .= '<button type="button" name="cnf_resort" class="btn btn-info cnf_resort"><i class="icon-refresh icon-white"></i> '.Multilanguage::_('L_SORT').'</button> ';
		$rs .= '<button type="submit" name="cnf_submit" class="btn btn-primary">'.Multilanguage::_('L_TEXT_SAVE').'</button>';
		$rs .= '</label>';
		$rs .= '<div class="controls">';
		$rs .= '</div>';
		$rs .= '</div>';
		
		//$rs .= '<td><input type="button" name="cnf_resort" class="cnf_resort" value="'.Multilanguage::_('L_SORT').'"></td><td>
		//		<input type="submit" name="cnf_submit" value="'.Multilanguage::_('L_TEXT_SAVE').'"></td><td></td>';
		//$rs .= '</tr>';
		$rs .= '<input type="hidden" name="do" value="save">';
		$rs .= '<input type="hidden" name="tab_nr" value="'.$tab_nr.'">';
		//$rs .= '</table>';
		$rs .= '</form>';
		
		return $rs;
    }
    /*
    function getTabForm_old($data){
    	$rs .= '<form method="post" action="'.SITEBILL_MAIN_URL.'/admin/index.php?action='.$this->action.'">';
		$rs .= '<table border="0" width="600">';
		$rs .= '<thead><th></th><th></th><th> </th><th></th><th></th></thead>';
		foreach($data as $d){
			if ( $this->is_demo() and  $d['config_key'] == 'license_key' ) {
		        
		    } else {
			    $rs .= '<tr>';
			    $rs .= '<td>'.$d['title'].'</td>';
			    $rs .= '<td><input type="text" size="20" name="conf_param_value['.$d['id'].']" value="'.htmlspecialchars($d['value']).'"></td>';
			    $rs .= '<td>'.$d['config_key'].'</td>';
			    $rs .= '<td>'.($this->dev_status?'<a href="?action='.$this->action.'&do=delete&'.$this->primary_key.'='.$d['id'].'"></a>':'').'</td>';
			    $rs .= '<td>'.($this->dev_status?'<a href="?action='.$this->action.'&do=edit&'.$this->primary_key.'='.$d['id'].'"></a>':'').'</td>';
			    $rs .= '</tr>';
		    }
		}
		$rs .= '<tr>';
		$rs .= '<td></td><td></td><td><input type="submit" name="cnf_submit" value=""></td>';
		$rs .= '</tr>';
		//$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="do" value="save">';
		$rs .= '</table>';
		$rs .= '</form>';
		return $rs;
    }
    */
	function updateParamToConfig($conf_param_id,$conf_param_value){
		$query="UPDATE ".DB_PREFIX."_".$this->table_name." SET value='".$this->validateParam($conf_param_value)."' WHERE ".$this->primary_key."='".$conf_param_id."'";
		//echo $query;
		$this->db->exec($query);
		return TRUE;
	}
	
	function validateParam($param){
		$quotes=get_magic_quotes_gpc();
		$rs=$param;
		if($quotes){
			$rs=stripslashes($rs);
		}
		$rs=str_replace(array('\'','"','`'),'',$rs);
		$rs=trim($rs);
		//$rs=addslashes($rs);
		$rs=mysql_real_escape_string($rs);
		/*if($quotes==1){
			$rs=mysql_real_escape_string(stripcslashes($rs));
		}else{
			$rs=mysql_real_escape_string($rs);
		}*/
		return $rs;
	}
	
	function validateParamTitle($param){
		$quotes=get_magic_quotes_gpc();
		$rs=$param;
		$rs=str_replace(array('`'),'',$rs);
		$rs=trim($rs);
		if($quotes==1){
			$rs=mysql_real_escape_string(stripcslashes($rs));
		}else{
			$rs=mysql_real_escape_string($rs);
		}
		//$rs=addslashes($rs);
		return $rs;
	}
    

	function is_demo () {
	    global $__user;
	    if ( preg_match('/etown/', $__user) ) {
	        return true;
	    }
	    return false;
	}
	
	/**
	 * Check config item
	 * @param string $key
	 * @return boolean
	 */
	function check_config_item ( $key ) {
		if ( $this->check_config_array[$key] == 1 ) {
			return true;
		}
		return false;
	}
	
	function addParamToConfig($conf_new_param_name,$conf_new_param_value,$conf_new_param_title){
		
		$query="INSERT INTO ".DB_PREFIX."_".$this->table_name." (config_key, value, title) VALUES ('".$this->validateParam($conf_new_param_name)."','".$this->validateParam($conf_new_param_value)."','".$this->validateParamTitle($conf_new_param_title)."')";
		$this->db->exec($query);
		if ( !$this->db->success ) {
		    echo $this->db->error.'<br>';
		}
		$config_id = $this->db->last_insert_id();
		$query = "update ".DB_PREFIX."_".$this->table_name." set sort_order=$config_id where id=$config_id";
		$this->db->exec($query);
		return TRUE;
	}
	
	function getTopMenu(){
		$rs='';
		//$rs.='<a href="'.SITEBILL_MAIN_URL.'/admin/index.php?action='.$this->action.'&do=new"> </a>';
		return $rs;
	}
    
	
	/**
	 * Check config structure
	 * @param void
	 * @return string
	 */
	function check_config_structure () {

		$query = "select * from ".DB_PREFIX."_config";
		$this->db->exec($query);
		while ( $this->db->fetch_assoc() ) {
			$this->check_config_array[$this->db->row['config_key']] = '1';
		}
		
		if ( !$this->check_config_item('use_new_realty_grid') ) {
			$this->addParamToConfig('use_new_realty_grid','0','      ');
		}

		if ( !$this->check_config_item('notify_admin_about_register') ) {
			$this->addParamToConfig('notify_admin_about_register','0','     ');
		}
		
		if ( !$this->check_config_item('notify_about_added_realty') ) {
			$this->addParamToConfig('notify_about_added_realty','0','    ');
		}
		
		if ( !$this->check_config_item('show_cattree_left') ) {
			$this->addParamToConfig('show_cattree_left','1','      ');
		}
		
		if ( !$this->check_config_item('ignore_free_from_parameter') ) {
			$this->addParamToConfig('ignore_free_from_parameter','1','  ');
		}
		
		if ( !$this->check_config_item('disable_root_structure_select') ) {
			$this->addParamToConfig('disable_root_structure_select','0','     ');
		}
		
		if ( !$this->check_config_item('use_combobox') ) {
			$this->addParamToConfig('use_combobox','0',' combobox   select');
		}
		
		if ( !$this->check_config_item('filter_double_data') ) {
			$this->addParamToConfig('filter_double_data','0','    ');
		}
		/*
		if ( !$this->check_config_item('check_permissions') ) {
			$this->addParamToConfig('check_permissions','0','     ');
		}
		*/
		
		
		if ( !$this->check_config_item('divide_step_form') ) {
			$this->addParamToConfig('divide_step_form','0','   ');
		}
		
		if ( !$this->check_config_item('use_registration_email_confirm') ) {
			$this->addParamToConfig('use_registration_email_confirm','0','    email  ');
		}
		
		if ( !$this->check_config_item('email_signature') ) {
			$this->addParamToConfig('email_signature',' ,  '.$_SERVER['SERVER_NAME'],'  ');
		}
		
		
		/* vk */
		if ( !$this->check_config_item('apps.socialauth.vk.enable') ) {
			$this->addParamToConfig('apps.socialauth.vk.enable','0','   ');
		}
		if ( !$this->check_config_item('apps.socialauth.vk.api_key') ) {
			$this->addParamToConfig('apps.socialauth.vk.api_key','vk api_key','VK API_KEY');
		}
		if ( !$this->check_config_item('apps.socialauth.vk.secret') ) {
			$this->addParamToConfig('apps.socialauth.vk.secret','vk secret','VK SECRET');
		}
		if ( !$this->check_config_item('apps.socialauth.vk.redirect_url') ) {
			$this->addParamToConfig('apps.socialauth.vk.redirect_url','vk redirect_url','vk redirect_url');
		}
		
		 
		/* fb */
		if ( !$this->check_config_item('apps.socialauth.fb.enable') ) {
			$this->addParamToConfig('apps.socialauth.fb.enable','0','   Facebook');
		}
		
		
		if ( !$this->check_config_item('registration_notice') ) {
			$this->addParamToConfig('registration_notice','0','   ');
		}
		
		if ( !$this->check_config_item('meta_title_main') ) {
			$this->addParamToConfig('meta_title_main','',' ');
		}
		
		if ( !$this->check_config_item('meta_keywords_main') ) {
			$this->addParamToConfig('meta_keywords_main','','  ');
		}
		
		if ( !$this->check_config_item('meta_description_main') ) {
			$this->addParamToConfig('meta_description_main','','- ');
		}
		
		if ( !$this->check_config_item('allow_topic_images') ) {
			$this->addParamToConfig('allow_topic_images','0','   ');
		}

		if ( !$this->check_config_item('default_tab_name') ) {
			$this->addParamToConfig('default_tab_name','','   -');
		}
		
		
	     
		if ( !$this->check_config_item('apps.accountsms.enable') ) {
			$this->addParamToConfig('apps.accountsms.enable','0','  accountsms');
		}
		
		if ( !$this->check_config_item('template.agency.logo') ) {
			$this->addParamToConfig('template.agency.logo','logo.gif',' Agency.  .');
		}
		
		
	    if ( !$this->check_config_item('apps.registersms.enable') ) {
	    	$this->addParamToConfig('apps.registersms.enable','0','   SMS');
	    }
	     
		if ( !$this->check_config_item('apps.newsparser_rbc.portion') ) {
			$this->addParamToConfig('apps.newsparser_rbc.portion','10','     ');
		}
		
		if ( !$this->check_config_item('apps.yml.delivery') ) {
			$this->addParamToConfig('apps.yml.delivery','true','    ,      http://partner.market.yandex.ru   "" (true/false).');
		}
		
		if ( !$this->check_config_item('apps.yml.pickup') ) {
			$this->addParamToConfig('apps.yml.pickup','false','          (true/false).');
		}
		
		if ( !$this->check_config_item('apps.yml.store') ) {
			$this->addParamToConfig('apps.yml.store','false','           (true/false).');
		}
		
		if ( !$this->check_config_item('apps.freeorder.notification_email') ) {
			$this->addParamToConfig('apps.freeorder.notification_email','','E-mail        Apps.Freeorder (   order_email_acceptor)');
		}
		
		if ( !$this->check_config_item('apps.yandexrealty_parser.default_user_id') ) {
			$this->addParamToConfig('apps.yandexrealty_parser.default_user_id','0','ID   .  0,  ID      .   0,    user_id      .');
		}
		
		if ( !$this->check_config_item('apps.yandexrealty_parser.default_activity_status') ) {
			$this->addParamToConfig('apps.yandexrealty_parser.default_activity_status','1','    ');
		}
		
		
		
		if ( !$this->check_config_item('apps.yandexrealty_parser.allow_create_new_category') ) {
			$this->addParamToConfig('apps.yandexrealty_parser.allow_create_new_category','1','       ');
		}
		
		if ( !$this->check_config_item('apps.yandexrealty_parser.category_for_all') ) {
			$this->addParamToConfig('apps.yandexrealty_parser.category_for_all','1000','ID ,        apps.yandexrealty_parser.allow_create_new_category=0');
		}
		
		if ( !$this->check_config_item('apps.twitter.enable') ) {
			$this->addParamToConfig('apps.twitter.enable','0','  Apps.Twitter');
		}
		
		if ( !$this->check_config_item('apps.twitter.user_secret') ) {
			$this->addParamToConfig('apps.twitter.user_secret','','Access token secret');
		}
		
		if ( !$this->check_config_item('apps.twitter.user_token') ) {
			$this->addParamToConfig('apps.twitter.user_token','','Access token');
		}
		
		if ( !$this->check_config_item('apps.twitter.consumer_secret') ) {
			$this->addParamToConfig('apps.twitter.consumer_secret','','Consumer_secret');
		}
		
		if ( !$this->check_config_item('apps.twitter.consumer_key') ) {
			$this->addParamToConfig('apps.twitter.consumer_key','','Consumer_key');
		}
	
		if ( !$this->check_config_item('apps.sms.max_uses') ) {
			$this->addParamToConfig('apps.sms.max_uses','0','  SMS- (0   -  )');
		}
		
		if ( !$this->check_config_item('apps.realtypro.show_contact.enable') ) {
			$this->addParamToConfig('apps.realtypro.show_contact.enable','0','   ');
		}
		
		
		if ( !$this->check_config_item('apps.watermark.enable') ) {
			$this->addParamToConfig('apps.watermark.enable','1','  Apps.WatermarkPrinter');
		}
		
		if ( !$this->check_config_item('apps.watermark.position') ) {
			$this->addParamToConfig('apps.watermark.position','center','  (center|top-left|top-right|bottom-left|bottom-right)');
		}
		
		if ( !$this->check_config_item('apps.watermark.offset_top') ) {
			$this->addParamToConfig('apps.watermark.offset_top','5','  , px');
		}
		
		if ( !$this->check_config_item('apps.watermark.offset_bottom') ) {
			$this->addParamToConfig('apps.watermark.offset_bottom','5','  , px');
		}
		
		if ( !$this->check_config_item('apps.watermark.offset_left') ) {
			$this->addParamToConfig('apps.watermark.offset_left','5','  , px');
		}
		
		if ( !$this->check_config_item('apps.watermark.offset_right') ) {
			$this->addParamToConfig('apps.watermark.offset_right','5','  , px');
		}
		
		if ( !$this->check_config_item('apps.shoplog.enable') ) {
			$this->addParamToConfig('apps.shoplog.enable','0','  Apps.Shoplog');
		}
		
		if ( !$this->check_config_item('apps.rabota.enable') ) {
			$this->addParamToConfig('apps.rabota.enable','0','  Apps.Rabota');
		}
		
		if ( !$this->check_config_item('apps.shop.current_city_id') ) {
			$this->addParamToConfig('apps.shop.current_city_id','','ID  ');
		}
		
		if ( !$this->check_config_item('apps.shop.mail_title') ) {
			$this->addParamToConfig('apps.shop.mail_title','-','  (      )');
		}
		
		
		if ( !$this->check_config_item('apps.yml.local_delivery_cost') ) {
			$this->addParamToConfig('apps.yml.local_delivery_cost','','C    ');
		}
		
		
		if ( !$this->check_config_item('apps.fasteditor.email_send_password_text') ) {
			$this->addParamToConfig('apps.fasteditor.email_send_password_text','     {password}','        ( {password}       )');
		}
		
		if ( !$this->check_config_item('apps.fasteditor.sms_send_password_text_long') ) {
			$this->addParamToConfig('apps.fasteditor.sms_send_password_text_long','   .      37-86-86, 89289678686     {password}','()  sms      ( {password}       )');
		}
		
		if ( !$this->check_config_item('apps.fasteditor.sms_send_password_text') ) {
			$this->addParamToConfig('apps.fasteditor.sms_send_password_text','   .      37-86-86, 89289678686     {password}',' sms      ( {password}       )');
		}
		
		
		if ( !$this->check_config_item('apps.freeorder.enable') ) {
			$this->addParamToConfig('apps.freeorder.enable','0',' Apps.Freeorder');
		}
		
		if ( !$this->check_config_item('apps.news.news_line.per_page') ) {
			$this->addParamToConfig('apps.news.news_line.per_page','3','       ');
		}
		
		if ( !$this->check_config_item('apps.shopstat.enable') ) {
			$this->addParamToConfig('apps.shopstat.enable','0',' Apps.Shopstat');
		}
		
		if ( !$this->check_config_item('apps.orderhistory.enable') ) {
			$this->addParamToConfig('apps.orderhistory.enable','0',' Apps.Orderhistory');
		}
		
		if ( !$this->check_config_item('apps.sms.apikey') ) {
			$this->addParamToConfig('apps.sms.apikey','XXXXXXXXXXXXYYYYYYYYYYYYZZZZZZZZXXXXXXXXXXXXYYYYYYYYYYYYZZZZZZZZ','SMSPilot API .     <a target=_blank href=http://www.smspilot.ru/apikey.php>http://www.smspilot.ru/apikey.php</a>');
		}

		if ( !$this->check_config_item('apps.sms.sender') ) {
			$this->addParamToConfig('apps.sms.sender','estate.cms','   SMS   SMSPilot');
		}
		
		if ( !$this->check_config_item('apps.fasteditor.enable') ) {
			$this->addParamToConfig('apps.fasteditor.enable','0',' Apps.FastEditor');
		}
		
		if ( !$this->check_config_item('apps.shop.city_enable') ) {
			$this->addParamToConfig('apps.shop.city_enable','0','    ');
		}

		
		if ( !$this->check_config_item('apps.realtybuyorder.enable') ) {
	    	$this->addParamToConfig('apps.realtybuyorder.enable','0',' Realtybuyorder');
	    }
	    
		if ( !$this->check_config_item('apps.realtybuyorder.text_after_send') ) {
	    	$this->addParamToConfig('apps.realtybuyorder.text_after_send','  ','    Realtybuyorder');
	    }
		
		if ( !$this->check_config_item('apps.cache.enable') ) {
	    	$this->addParamToConfig('apps.cache.enable','0',' ');
	    }
		
		if ( !$this->check_config_item('apps.realtycsv.enable') ) {
	    	$this->addParamToConfig('apps.realtycsv.enable','0',' Apps.RealtyCSV');
	    }
		
		if ( !$this->check_config_item('apps.realtylog.enable') ) {
	    	$this->addParamToConfig('apps.realtylog.enable','0',' Apps.Realtylog');
	    }
		
		if ( !$this->check_config_item('apps.shop.enable') ) {
	    	$this->addParamToConfig('apps.shop.enable','0',' Apps.Shop');
	    }
		
		if ( !$this->check_config_item('apps.page.enable') ) {
	    	$this->addParamToConfig('apps.page.enable','1',' Apps.Page');
	    }
	    
	    if ( !$this->check_config_item('apps.realtypro.youtube') ) {
	    	$this->addParamToConfig('apps.realtypro.youtube','1',' youtube-  ');
	    }
	     
		if ( !$this->check_config_item('apps.yml.shop_name') ) {
	    	$this->addParamToConfig('apps.yml.shop_name','Some Shop','  ');
	    }
		if ( !$this->check_config_item('apps.yml.company_name') ) {
	    	$this->addParamToConfig('apps.yml.company_name','Some Company','  ');
	    }
		if ( !$this->check_config_item('apps.yml.shop_platform_name') ) {
	    	$this->addParamToConfig('apps.yml.shop_platform_name','Some CMS','  ');
	    }
		if ( !$this->check_config_item('apps.yml.shop_platform_version') ) {
	    	$this->addParamToConfig('apps.yml.shop_platform_version','1.0',' CMS');
	    }
		if ( !$this->check_config_item('apps.yml.shop_development_team') ) {
	    	$this->addParamToConfig('apps.yml.shop_development_team','Some Dev Team',' ,     -');
	    }
		if ( !$this->check_config_item('apps.yml.shop_development_team_email') ) {
	    	$this->addParamToConfig('apps.yml.shop_development_team_email','Some Email','   CMS');
	    }
	    
	    
	    
	    
	    
	    
	    
	    
		if ( !$this->check_config_item('apps.news.enable') ) {
	    	$this->addParamToConfig('apps.news.enable','1',' News.Apps');
	    }
		if ( !$this->check_config_item('apps.news.front.per_page') ) {
	    	$this->addParamToConfig('apps.news.front.per_page','5','   ');
	    }
	    if ( !$this->check_config_item('apps.plan.enable') ) {
	    	$this->addParamToConfig('apps.plan.enable','0',' Plan.Apps');
	    }
	    if ( !$this->check_config_item('apps.balcony.enable') ) {
	    	$this->addParamToConfig('apps.balcony.enable','0',' Balcony.Apps');
	    }
	    if ( !$this->check_config_item('apps.sanuzel.enable') ) {
	    	$this->addParamToConfig('apps.sanuzel.enable','0',' Sanuzel.Apps');
	    }
	     
	     
	    if ( !$this->check_config_item('apps.company.timelimit') ) {
	    	$this->addParamToConfig('apps.company.timelimit','0','        ');
	    }
	     
	    if ( !$this->check_config_item('apps.watermark.image') ) {
	    	$this->addParamToConfig('apps.watermark.image','watermark.gif','     ,    /img/watermark/');
	    }
	     

	    if ( !$this->check_config_item('apps.billing.enable') ) {
	    	$this->addParamToConfig('apps.billing.enable','0',' Billing.Apps');
	    }
	    
	    if ( !$this->check_config_item('apps.realtyspecial.enable') ) {
	    	$this->addParamToConfig('apps.realtyspecial.enable','0',' RealtySpecial.Apps');
	    }
	     
	    if ( !$this->check_config_item('apps.realtypro.enable') ) {
	    	$this->addParamToConfig('apps.realtypro.enable','0',' RealtyPro.Apps');
	    }
	    
	    if ( !$this->check_config_item('apps.company.enable') ) {
	    	$this->addParamToConfig('apps.company.enable','0',' Company.Apps');
	    }
	    
	    if ( !$this->check_config_item('apps.company.best') ) {
	    	$this->addParamToConfig('apps.company.best','0','   Company.Apps');
	    }
	     
	    
	     
	     
		if ( !$this->check_config_item('apps.realty.ajax_region_refresh') ) {
	        $this->addParamToConfig('apps.realty.ajax_region_refresh','1','Ajax -  ');
	    }
		
	    if ( !$this->check_config_item('apps.realty.ajax_city_refresh') ) {
	        $this->addParamToConfig('apps.realty.ajax_city_refresh','1','Ajax -  ');
	    }
	    
	    if ( !$this->check_config_item('apps.realty.ajax_district_refresh') ) {
	        $this->addParamToConfig('apps.realty.ajax_district_refresh','1','Ajax -  ');
	    }
	    
	    if ( !$this->check_config_item('apps.realty.ajax_metro_refresh') ) {
	        $this->addParamToConfig('apps.realty.ajax_metro_refresh','1','Ajax -  ');
	    }
	    
	    if ( !$this->check_config_item('apps.realty.ajax_street_refresh') ) {
	        $this->addParamToConfig('apps.realty.ajax_street_refresh','1','Ajax -  ');
	    }
	    
	    if ( !$this->check_config_item('apps.shop.recipients_list') ) {
	    	$this->addParamToConfig('apps.shop.recipients_list','','.       ');
	    }
	     
	    if ( !$this->check_config_item('apps.realtypro.admin.items_per_page') ) {
	    	$this->addParamToConfig('apps.realtypro.admin.items_per_page','10','. .    ');
	    }
	    if ( !$this->check_config_item('apps.shop.admin.products_per_page') ) {
	    	$this->addParamToConfig('apps.shop.admin.products_per_page','10','.      ');
	    }
	    if ( !$this->check_config_item('apps.shop.front.products_per_page') ) {
	    	$this->addParamToConfig('apps.shop.front.products_per_page','10','.       ');
	    }
	     
	    
	    //
	    if ( !$this->check_config_item('site_title') ) {
	    	$this->addParamToConfig('site_title',' ',' ');
	    }
	    if ( !$this->check_config_item('theme') ) {
	    	$this->addParamToConfig('theme','agency',' ');
	    }
	    if ( !$this->check_config_item('order_email_acceptor') ) {
	    	$this->addParamToConfig('order_email_acceptor','kondin@etown.ru','Email       ');
	    }
	    if ( !$this->check_config_item('per_page') ) {
	    	$this->addParamToConfig('per_page','20','      ');
	    }
	    if ( !$this->check_config_item('common_per_page') ) {
	    	$this->addParamToConfig('common_per_page','10','    (    )');
	    }
	    if ( !$this->check_config_item('currency_enable') ) {
	    	$this->addParamToConfig('currency_enable','0','     ');
	    }
	    if ( !$this->check_config_item('allow_register_account') ) {
	    	$this->addParamToConfig('allow_register_account','1','   ');
	    }
	    if ( !$this->check_config_item('allow_remind_password') ) {
	    	$this->addParamToConfig('allow_remind_password','1','  ');
	    }
	     
	    
	    //view
	    if ( !$this->check_config_item('use_google_map') ) {
	    	$this->addParamToConfig('use_google_map','0','  Google');
	    }
	    if ( !$this->check_config_item('photo_per_data') ) {
	    	$this->addParamToConfig('photo_per_data','0','     (0   -  )');
	    }
	     
	    
	    
        //notify	    
	    if ( !$this->check_config_item('add_notification_email') ) {
	    	$this->addParamToConfig('add_notification_email','','E-mail       (   order_email_acceptor)');
	    }
	    if ( !$this->check_config_item('notify_about_publishing') ) {
	    	$this->addParamToConfig('notify_about_publishing','0','       .');
	    }
	    
        //form
	    if ( !$this->check_config_item('country_in_form') ) {
	    	$this->addParamToConfig('country_in_form','0','    ');
	    }
	    if ( !$this->check_config_item('region_in_form') ) {
	    	$this->addParamToConfig('region_in_form','0','    ');
	    }
	    if ( !$this->check_config_item('city_in_form') ) {
	    	$this->addParamToConfig('city_in_form','1','    ');
	    }
	    if ( !$this->check_config_item('metro_in_form') ) {
	    	$this->addParamToConfig('metro_in_form','1','    ');
	    }
	     
	    if ( !$this->check_config_item('district_in_form') ) {
	    	$this->addParamToConfig('district_in_form','1','    ');
	    }
	    if ( !$this->check_config_item('street_in_form') ) {
	    	$this->addParamToConfig('street_in_form','1','    ');
	    }
	     
	    if ( !$this->check_config_item('uploader_type') ) {
	    	$this->addParamToConfig('uploader_type','','    .       Uploadify. <a href="http://www.sitebill.ru/uploader-type.html" target="_blank"> ?</a>');
	    }
	    if ( !$this->check_config_item('link_street_to_city') ) {
	    	$this->addParamToConfig('link_street_to_city','0','    ');
	    }
	    if ( !$this->check_config_item('user_add_street_enable') ) {
	    	$this->addParamToConfig('user_add_street_enable','0','   ');
	    }
	    if ( !$this->check_config_item('allow_callme_timelimits') ) {
	    	$this->addParamToConfig('allow_callme_timelimits','0','      ');
	    }
	    if ( !$this->check_config_item('allow_additional_stationary_number') ) {
	    	$this->addParamToConfig('allow_additional_stationary_number','0','    ');
	    }
	    if ( !$this->check_config_item('allow_additional_mobile_number') ) {
	    	$this->addParamToConfig('allow_additional_mobile_number','0','    ');
	    }
	    if ( !$this->check_config_item('post_form_agreement_enable') ) {
	    	$this->addParamToConfig('post_form_agreement_enable','0','    ');
	    }
	    if ( !$this->check_config_item('post_form_agreement_text_add') ) {
	    	$this->addParamToConfig('post_form_agreement_text_add',',  ()   ','     ');
	    }
	    if ( !$this->check_config_item('post_form_agreement_text') ) {
	    	$this->addParamToConfig('post_form_agreement_text',', (),             .','   ');
	    }
	    if ( !$this->check_config_item('ajax_form_in_admin') ) {
	    	$this->addParamToConfig('ajax_form_in_admin','1',' ajax   ');
	    }
	    if ( !$this->check_config_item('ajax_form_in_user') ) {
	    	$this->addParamToConfig('ajax_form_in_user','1',' ajax    ');
	    }
	    if ( !$this->check_config_item('is_watermark') ) {
	    	$this->addParamToConfig('is_watermark','0',' watermark  <br> (-    /img/watermark/watermark.gif)');
	    }
	    if ( !$this->check_config_item('menu_type') ) {
	    	$this->addParamToConfig('menu_type','purecss','   (purecss/slidemenu)');
	    }
	     
	     
	    
	    
	    //admin
	    if ( !$this->check_config_item('hide_empty_catalog') ) {
	    	$this->addParamToConfig('hide_empty_catalog','1','   ');
	    }
	    if ( !$this->check_config_item('user_account_enable') ) {
	    	$this->addParamToConfig('user_account_enable','0','     ');
	    }
	    if ( !$this->check_config_item('seo_photo_name_enable') ) {
	    	$this->addParamToConfig('seo_photo_name_enable','0',' SEO-  ');
	    }
	    /*
	    if ( !$this->check_config_item('autoreg_enable') ) {
	    	$this->addParamToConfig('autoreg_enable','0','  <a href="http://www.sitebill.ru/autoreg.html" target="_blank">  ?</a>');
	    }
	    */
	     
	     
	    
	    /*images*/
	    /*
	    if ( !$this->check_config_item('shop_product_image_big_width') ) {
	    	$this->addParamToConfig('shop_product_image_big_width','800','   ');
	    }
	    if ( !$this->check_config_item('shop_product_image_big_height') ) {
	    	$this->addParamToConfig('shop_product_image_big_height','600','   ');
	    }
	    if ( !$this->check_config_item('shop_product_image_preview_width') ) {
	    	$this->addParamToConfig('shop_product_image_preview_width','180','   ');
	    }
	    if ( !$this->check_config_item('shop_product_image_preview_height') ) {
	    	$this->addParamToConfig('shop_product_image_preview_height','180','   ');
	    }
	    */
	    /*images*/
	    
	    /*
	    if ( !$this->check_config_item('city_in_form') ) {
	        $this->addParamToConfig('city_in_form','1','    ');
	    }
	    */
	    
	    if ( !$this->check_config_item('advert_cost') ) {
	    	$this->addParamToConfig('advert_cost','0','    . <a href="http://www.sitebill.ru/stoimost-obyavleniya.html" target="_blank">  ?</a>');
	    }
	    if ( !$this->check_config_item('special_advert_cost') ) {
	    	$this->addParamToConfig('special_advert_cost','0','    ');
	    }
	    if ( !$this->check_config_item('robokassa_server') ) {
	    	$this->addParamToConfig('robokassa_server','http://test.robokassa.ru/Index.aspx','    robokassa.ru');
	    }
	     
	    if ( !$this->check_config_item('robokassa_login') ) {
	    	$this->addParamToConfig('robokassa_login','robokassa_login','  robokassa.ru');
	    }
	     
	    if ( !$this->check_config_item('robokassa_password1') ) {
	    	$this->addParamToConfig('robokassa_password1','robokassa_password1',' 1  robokassa.ru');
	    }
	    if ( !$this->check_config_item('robokassa_password2') ) {
	    	$this->addParamToConfig('robokassa_password2','robokassa_password2',' 2  robokassa.ru');
	    }
	     
	     
	    if ( !$this->check_config_item('use_smtp') ) {
	    	$this->addParamToConfig('use_smtp','0','   smtp. <a href="http://www.sitebill.ru/smtp.html" target="_blank">  ?</a>');
	    }
	    if ( !$this->check_config_item('smtp1_server') ) {
	        $this->addParamToConfig('smtp1_server','smtp.yandex.ru','SMTP-   ');
	    }
	    
	    if ( !$this->check_config_item('smtp1_login') ) {
	        $this->addParamToConfig('smtp1_login','rumantic.coder','SMTP-login');
	    }
	    
	    if ( !$this->check_config_item('smtp1_password') ) {
	        $this->addParamToConfig('smtp1_password','123456','SMTP-password');
	    }
	    
	    if ( !$this->check_config_item('smtp1_port') ) {
	        $this->addParamToConfig('smtp1_port','587','SMTP-port');
	    }
	    if ( !$this->check_config_item('smtp1_from') ) {
	        $this->addParamToConfig('smtp1_from','rumantic.coder@yandex.ru','SMTP-  <br>(       )');
	    }
	    
	    
	    if ( !$this->check_config_item('editor') ) {
	        $this->addParamToConfig('editor','cleditor','WYSIWYG-');
	    }
	    
		if ( !$this->check_config_item('editor1') ) {
	        $this->addParamToConfig('editor1','bbeditor','WYSIWYG-1');
	    }
	    
	    if ( !$this->check_config_item('show_demo_banners') ) {
	        $this->addParamToConfig('show_demo_banners','0','   sitebill.ru');
	    }
	    
	    
	}
	
	
}