<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Currencies options and courses admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class currency_admin extends Object_Manager {
	
	private $courses=array();
	
	/**
     * Constructor
     */
    function __construct( $realty_type = false ) {
        $this->SiteBill();
        
        $this->table_name = 'currency';
        $this->action = 'currency';
        $this->primary_key = 'currency_id';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/currency/admin/currency_model.php');
        $this->data_model_object=new Currency_Model();
		$this->data_model=$this->data_model_object->get_model();
		
        $this->install();
        $this->loadCourses();
    }
    
    private function loadCourses(){
    	$query='SELECT currency_id, course FROM '.DB_PREFIX.'_'.$this->table_name;
		$this->db->exec($query);
		if($this->db->success){
			while($this->db->fetch_assoc()){
				$this->courses[$this->db->row['currency_id']]=$this->db->row['course'];
			}
		}
	}
    
    public function getUEPrice($sum, $curency_id){
    	if(isset($this->courses[$curency_id])){
    		return $sum*$this->courses[$curency_id];
    	}else{
    		return $sum;
    	}
    }
    
    public function getUECoefficient($currency_from,$currency_to){
    	if(isset($this->courses[$currency_from]) && isset($this->courses[$currency_to])){
    		return $this->courses[$currency_from]/$this->courses[$currency_to];
    	}else{
    		return 1;
    	}
    }
    
    public function getCourse($currency){
    	if(isset($this->courses[$currency])){
    		return $this->courses[$currency];
    	}else{
    		return 1;
    	}
    }
   
    
    function grid () {
    	
    	$params=array();
    	$params['action']=$this->action;
    	
    	
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/grid.php');
        $common_grid = new Common_Grid($this);
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/page.php');
        $common_page = new Common_Page();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/tab.php');
    	$common_tab = new Common_Tab();
		$url='/admin/index.php?action='.$this->action;
		
    	$common_grid->add_grid_item('currency_id');
        $common_grid->add_grid_item('code');
        $common_grid->add_grid_item('name');
        $common_grid->add_grid_item('is_active');
        $common_grid->add_grid_item('sort_order');
        $common_grid->add_grid_item('course');
        
        $common_grid->add_grid_control('edit');
        $common_grid->add_grid_control('delete');
		$common_grid->set_grid_query("SELECT * FROM ".DB_PREFIX."_".$this->table_name." ORDER BY sort_order ASC, code ASC, currency_id ASC");
		$params['page']=$this->getRequestValue('page');
		$params['per_page']=$this->getConfigValue('common_per_page');
        
        $common_grid->setPagerParams($params);
        
        $common_page->setTab($common_tab);
        $common_page->setGrid($common_grid);
        
		$rs .= $common_page->toString();
		return $rs;
    }
    
    function install () {
        $query="CREATE TABLE IF NOT EXISTS `re_currency` (
		  `currency_id` int(11) NOT NULL AUTO_INCREMENT,
		  `code` varchar(3) NOT NULL,
		  `name` varchar(30) NOT NULL,
		  `sort_order` tinyint(4) NOT NULL,
		  `course` varchar(10) NOT NULL,
		  `is_default` tinyint(4) NOT NULL DEFAULT '0',
		  `is_active` tinyint(4) NOT NULL DEFAULT '1',
		  PRIMARY KEY (`currency_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." AUTO_INCREMENT=1";

		$this->db->exec($query);
		
		$query = "alter table ".DB_PREFIX."_data add column currency_id int(11) not null default 0";
		$this->db->exec($query);
        
	}
	
	function getTopMenu(){
		$rs.='<a href="'.SITEBILL_MAIN_URL.'/admin/index.php?action='.$this->action.'&do=new">'.Multilanguage::_('L_ADD_PARAMETER').'</a>';
		return $rs;
	}
	
	function convert($sum, $from_currency, $to_currency){
		$result=$sum;
		$courses=array();
		$koefficient=1;
		$query='SELECT currency_id, course FROM '.DB_PREFIX.'_'.$this->table_name.' WHERE '.$this->primary_key.' IN ('.(int)$from_currency.','.(int)$to_currency.')';
		//echo $query;
		$this->db->exec($query);
		if($this->db->success){
			while($this->db->fetch_assoc()){
				$courses[$this->db->row['currency_id']]=$this->db->row['course'];
			}
		}
		//print_r($courses);
		if(!empty($courses)){
			if((int)$courses[$from_currency]!=0 && (int)$courses[$to_currency]!=0){
				$koefficient=$courses[$from_currency]/$courses[$to_currency];
			}
		}
		return $sum*$koefficient;
	}
    
}