<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * GeoData admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class geodata_admin extends Object_Manager {
    /**
     * Constructor
     */
    function __construct( $realty_type = false ) {
    	$this->SiteBill();
    	Multilanguage::appendAppDictionary('geodata');
    	$this->app_title=Multilanguage::_('APP_NAME','geodata');
    	$this->action = 'geodata';
        //-    
        // 2500
        //yandex 25000
        //  
        //http://maps.googleapis.com/maps/api/geocode/xml?address=%D0%9B%D1%8C%D0%B2%D0%BE%D0%B2+%D0%91%D0%BE%D0%B4%D0%BD%D0%B0%D1%80%D1%81%D0%BA%D0%B0%D1%8F,+16&sensor=false
		//http://geocode-maps.yandex.ru/1.x/?geocode=%D0%9B%D1%8C%D0%B2%D0%BE%D0%B2,+%D0%91%D0%BE%D0%B4%D0%BD%D0%B0%D1%80%D1%81%D0%BA%D0%B0%D1%8F,+16
    	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php');
    	$config_admin = new config_admin();
    	 
    	if ( !$config_admin->check_config_item('apps.geodata.enable') ) {
    		$config_admin->addParamToConfig('apps.geodata.enable','0','  GeoData');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.query_count') ) {
    		$config_admin->addParamToConfig('apps.geodata.query_count','2500','   ');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.per_step') ) {
    		$config_admin->addParamToConfig('apps.geodata.per_step','100','   ');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.geocode_partial') ) {
    		$config_admin->addParamToConfig('apps.geodata.geocode_partial','0','  ');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.geocode_element_name') ) {
    		$config_admin->addParamToConfig('apps.geodata.geocode_element_name','geo','  ');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.new_map_center') ) {
    		$config_admin->addParamToConfig('apps.geodata.new_map_center','55.751667,37.617778','           .XXXXXX,XX.XXXXXX');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.on_home') ) {
    		$config_admin->addParamToConfig('apps.geodata.on_home','0','    ');
    	}
    	if ( !$config_admin->check_config_item('apps.geodata.show_grid_map') ) {
    		$config_admin->addParamToConfig('apps.geodata.show_grid_map','0','     ');
    	}
    	 
    }
    
    public function _preload(){
    	if ( $this->getConfigValue('apps.geodata.show_grid_map') ) {
    		$this->template->assert('geodata_show_grid_map', 1);
    	}else{
    		$this->template->assert('geodata_show_grid_map', 0);
    	}
    	 
    }
    
	function main () {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
		$rs = $this->getTopMenu();

		switch( $this->getRequestValue('do') ){
			case 'geocode' : {
				
				//echo $parsed;
				$rs .= $this->parse();
				break;
			}
			case 'geocode_city' : {
			
				//echo $parsed;
				$rs .= $this->parse_city();
				break;
			}
			default : {
			    $rs .= $this->grid($user_id);
			}
		}
		$rs_new = $this->get_app_title_bar();
		$rs_new .= $rs;
		return $rs_new;
	}
    
    /**
     * Get top menu
     * @param void
     * @return string
     */
    function getTopMenu () {
    	$rs = '';
    	$rs .= '<a href="?action='.$this->action.'&do=geocode" class="btn btn-primary">'.Multilanguage::_('L_GEOCODE','geodata').'</a>';
    	//$rs .= '<form method="post"><input type="hidden" name="action" value="add" /><input type="submit" name="submit" value=" " /></form>';
    	return $rs;
    }
    
   
    
    /**
     * Grid
     * @param void
     * @return string
     */
    
    function grid () {
    	
    }
    
    function parse(){
    	
    	$start=(int)$_SESSION['geodata']['not_geocoded'];
    	$parse_step=$this->getConfigValue('apps.geodata.per_step');
    	$max_per_day=$this->getConfigValue('apps.geodata.query_count');
    	
    	$stat=$this->loadGeodataParserStat();
    	
    	$_x=date('Y-m-d',time());
    	if(isset($stat[$_x])){
    		$geocoded=$stat[$_x];
    	}else{
    		$geocoded=0;
    	}
    	
    	if($geocoded>=$max_per_day){
    		return '   ';
    	}
    	
    	if(($max_per_day-$geocoded)<$parse_step){
    		$parse_step=$max_per_day-$geocoded;
    	}
    	
    	$rs.=$this->_parse($start, $parse_step);
    	
    	
    	$this->saveGeodataParserStat(array(date('Y-m-d',time())=>($geocoded+$_SESSION['geodata']['gc'])));
    	
    	
    	//header('location: /admin/index.php?action=geodata&do=geocode');
    	//$rs.='<a href="/admin/index.php?action=geodata&do=geocode">Next</a>';
    	//return $rs;
    }
    
    function parse_city(){
    	$geo_lat=$this->getConfigValue('apps.geodata.geocode_element_name').'_lat';
    	$geo_lng=$this->getConfigValue('apps.geodata.geocode_element_name').'_lng';
    	$query='SELECT city_id, name 
    			FROM '.DB_PREFIX.'_city WHERE geo_lat IS NULL LIMIT 100';
    	
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$data[]=$this->db->row;
    	}
    	
    	if(count($data)>0){
    		foreach($data as $d){
    			$answer=$this->geocode_city($d['name']);
    			if(false!==$answer){
    				$query='UPDATE '.DB_PREFIX.'_city SET '.$geo_lat.'='.$answer['lat'].', '.$geo_lng.'='.$answer['lng'].' WHERE city_id='.$d['city_id'];
    				//echo $query;
			    	$this->db->exec($query);
    			}
    			
    		}
    		
    	}
    }
    
    private function _parse($start, $parse_step){
    	$_SESSION['geodata']['gc']=0;
    	$data=array();
    	$report=array();
    	$geo_lat=$this->getConfigValue('apps.geodata.geocode_element_name').'_lat';
    	$geo_lng=$this->getConfigValue('apps.geodata.geocode_element_name').'_lng';
    	$query='SELECT d.id, d.number, c.name AS city, s.name AS street, r.name AS region
    			FROM '.DB_PREFIX.'_data d
    			LEFT JOIN '.DB_PREFIX.'_region r ON r.region_id=d.region_id
    			LEFT JOIN '.DB_PREFIX.'_city c ON d.city_id=c.city_id
    			LEFT JOIN '.DB_PREFIX.'_street s ON d.street_id=s.street_id
    			WHERE (d.'.$geo_lat.' IS NULL OR d.'.$geo_lng.' IS NULL) AND d.city_id<>0 AND d.street_id<>0 order by d.id desc LIMIT '.$start.', '.$parse_step;
    	//echo $query;
    	 
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		if($this->db->row['city']=='' && $this->getConfigValue('city')!=''){
    			$this->db->row['city']=$this->getConfigValue('city');
    		}
    		$data[]=$this->db->row;
    	}
    	
    	if(count($data)>0){
    		foreach($data as $d){
    			if($d['city']==''){
    				$report[]=array(
    						'id'=>$d['id'],
    						'report'=>'  .   .',
    						'error_status'=>1
    				);
    				$_SESSION['geodata']['not_geocoded']++;
    				continue;
    			}
    			 
    			if($d['street']==''){
    				$report[]=array(
    						'id'=>$d['id'],
    						'report'=>'  .   .',
    						'error_status'=>1
    				);
    				$_SESSION['geodata']['not_geocoded']++;
    				continue;
    			}
    			 
    			if(($d['number']=='' || $d['number']==0) && 1!=$this->getConfigValue('apps.geodata.geocode_partial')){
    				$report[]=array(
    						'id'=>$d['id'],
    						'report'=>'  .    .',
    						'error_status'=>1
    				);
    				$_SESSION['geodata']['not_geocoded']++;
    				continue;
    			}else{
    				$answer=$this->geocode($d);
    				$geocoded++;
    				if(false!==$answer){
    					$report[]=array(
    							'id'=>$d['id'],
    							'report'=>' . : '.$answer['address'],
    							'error_status'=>0
    					);
    					$this->updateCoords($d['id'], $answer['lat'], $answer['lng']);
    				}else{
    					$report[]=array(
    							'id'=>$d['id'],
    							'report'=>'  . : '.$answer['address'],
    							'error_status'=>1
    					);
    					$_SESSION['geodata']['not_geocoded']++;
    				}
    			}
    		}
    		$rs='';
    		foreach($report as $k=>$r){
    			$rs.=$k.'  ID: '.$r['id'].' ';
    			if($r['error_status']==1){
    				$rs.='ERROR: '.$r['report'];
    			}else{
    				$rs.='SUCCESS: '.$r['report'];
    			}
    			$rs.="\r\n";
    		}
    		$file=SITEBILL_DOCUMENT_ROOT.'/cache/geodata.log.txt';
    		if(!file_exists($file)){
    			$f=fopen($file,'w');
    		}else{
    			$f=fopen($file,'a');
    		}
    		fwrite($f,date('Y-m-d H:i:s',time()).' '.$rs);
    		fclose($f);
    	}
    	
    	//return $rs;
    }
    
    private function updateCoords($id, $lat, $lng){
    	$geo_lat=$this->getConfigValue('apps.geodata.geocode_element_name').'_lat';
    	$geo_lng=$this->getConfigValue('apps.geodata.geocode_element_name').'_lng';
    	$query='UPDATE '.DB_PREFIX.'_data SET '.$geo_lat.'='.$lat.', '.$geo_lng.'='.$lng.' WHERE id='.$id;
    	//echo $query;
    	$this->db->exec($query);
    }
	
	private function loadGeodataParserStat(){
		$file=SITEBILL_DOCUMENT_ROOT.'/cache/geodata.cache.txt';
		if(file_exists($file)){
			
		}else{
			$f=fopen($file,'w');
			fclose($f);
		}
		$d=file_get_contents($file);
		return unserialize($d);
	}
	
	private function saveGeodataParserStat($data=array()){
		$file=SITEBILL_DOCUMENT_ROOT.'/cache/geodata.cache.txt';
		$f=fopen($file,'w');
		fwrite($f,serialize($data));
		fclose($f);
	}
    
    private function geocode($data){
    	
    	$str=$data['city'].', '.$data['street'].(($data['number']=='' || $data['number']==0) ? '' : ', '.$data['number']);
    	$url='http://geocode-maps.yandex.ru/1.x/?geocode='.urlencode($str);
    	/*if(isset($_SESSION['geodata']['address'][$str])){
    		list($lng,$lat)=explode(' ',$_SESSION['geodata']['address'][$str]);
    		return(array('address'=>$str, 'lat'=>$lat, 'lng'=>$lng));
    	}*/
    	
    	$geodata = simplexml_load_file($url);
    	if($geodata && $geodata instanceof SimpleXMLElement){
    		$founded=$geodata->GeoObjectCollection[0]->metaDataProperty->GeocoderResponseMetaData->found;
    		if((int)$founded>0){
    			$pos=$geodata->GeoObjectCollection[0]->featureMember[0]->GeoObject[0]->Point[0]->pos[0];
    			if($pos!=''){
    				/*$_SESSION['geodata']['address'][$str]=(string)$pos;*/
    				$_SESSION['geodata']['gc']++;
    				list($lng,$lat)=explode(' ',$pos);
    				$geodata=NULL;
    				return(array('address'=>$str, 'lat'=>$lat, 'lng'=>$lng));
    			}
    			//echo $data['id'].' '.$str.' '.$lat.' '.$lng.'<br />';
    		}
    		
    		
    	}
    	return false;
    }
    
    private function geocode_city($data){
    	 
    	$str=$data;
    	$url='http://geocode-maps.yandex.ru/1.x/?geocode='.urlencode($str);
    	$geodata = simplexml_load_file($url);
    	if($geodata && $geodata instanceof SimpleXMLElement){
    		$founded=$geodata->GeoObjectCollection[0]->metaDataProperty->GeocoderResponseMetaData->found;
    		if((int)$founded>0){
    			$pos=$geodata->GeoObjectCollection[0]->featureMember[0]->GeoObject[0]->Point[0]->pos[0];
    			if($pos!=''){
    				$_SESSION['geodata']['gc']++;
    				list($lng,$lat)=explode(' ',$pos);
    				$geodata=NULL;
    				return(array('address'=>$str, 'lat'=>$lat, 'lng'=>$lng));
    			}
    		}
    	}
    	return false;
    }
	
	
}