(function($){
	jQuery.fn.Geodata = function(){
		var GDC=$(this)
		var map_center_string=GDC.attr('coords');
		if(map_center_string!=''){
			var c=map_center_string.split(',');
		}else{
			var c=[55.751849,37.622681];
		}
		
		//console.log(c);
		var late=GDC.find('[geodata=lat]');
		var lnge=GDC.find('[geodata=lng]');
		if(late && lnge){
			var map_id='map_'+CryptoJS.MD5((new Date()).toString()+'_'+(Math.floor(Math.random() * (999 - 100 + 1)) + 100));
			
			var map=initializeLocationsMap(map_id);
			
			PositionEditor.init(map);
			google.maps.event.addDomListener(map, 'click', function(event) {
				var geo_c=PositionEditor.createPositionMarker(event.latLng, 0);
				late.val(geo_c[0]);
				lnge.val(geo_c[1]);
			});
			var lat=late.val();
			var lng=lnge.val();
			if(lat!='' && lng!=''){
				PositionEditor.initMarker(lat,lng,0);
			}
		}
		
		
		function initializeLocationsMap(map_id){
			var latlng = new google.maps.LatLng(new Number(c[0]),new Number(c[1]));
			var myOptions = {
				zoom: 14,
				center: latlng,
				mapTypeId: google.maps.MapTypeId.ROADMAP
			};
			var m=$('<div id="'+map_id+'" style="width:400px; height:250px"></div>')
			m.appendTo($('body')).css({'position':'absolute','left':'-1000px','display':'block'});
			var map = new google.maps.Map(document.getElementById(map_id), myOptions);
			
			google.maps.event.addDomListener(map, 'tilesloaded', function(event) {
				m.css({'position':'relative','left':'0'}).appendTo(GDC);
			});
			
			return map;
		}
	};
})(jQuery);



PositionEditor={};
PositionEditor.init=function(map){
	this.map=map;
	this.settedMarker=null;
}

PositionEditor.initMarker=function(x,y,id){
	if(x!='' && y!=''){
		var latlng = new google.maps.LatLng(new Number(x),new Number(y));
		this.createPositionMarker(latlng,id);
		this.map.setCenter(latlng);
	}else{
		if(this.settedMarker!=null){
			this.settedMarker.setMap(null);
			this.settedMarker=null;
		}
	}
	
}

PositionEditor.createPositionMarker=function(latlng,id){
		
	var lat=new String(latlng.lat());
	var lng=new String(latlng.lng());
	var lat_parts=lat.split('.');
	if(lat_parts[1]!==undefined && lat_parts[1].length>6){
		lat=lat_parts[0]+'.'+lat_parts[1].substring(0,6);
	}
	var lng_parts=lng.split('.');
	if(lng_parts[1]!==undefined && lng_parts[1].length>6){
		lng=lng_parts[0]+'.'+lng_parts[1].substring(0,6);
	}
	
	if(this.settedMarker!=null){
		this.settedMarker.setMap(null);
		this.settedMarker=null;
	}
	
	var marker = new google.maps.Marker({
		position: latlng, 
		map: this.map,
		draggable: false,
		title:latlng.lat()+' '+latlng.lng()
	});
	this.settedMarker=marker;
	var ret=[];
	ret.push(lat);
	ret.push(lng);
	return ret;
}



/*function attachSetPositionClickListener(object,map,id) {
	google.maps.event.addDomListener(object, 'click', function(event) {
		PositionEditor.createPositionMarker(event.latLng,id);
	});
}*/


/*
function initializeLocationsMap(map_id) {
	var latlng = new google.maps.LatLng(36.82684,10.120511);
	var myOptions = {
		zoom: 14,
		center: latlng,
		mapTypeId: google.maps.MapTypeId.ROADMAP
	};
	var map = new google.maps.Map(document.getElementById(map_id), myOptions);
	
	return map;
}
*/
$(document).ready(function(){
	var m=$('<div id="map_canvas" style="width:400px; height:250px"></div>');
	//console.log(m);
	var g=$('[geodata=geodata]');
	//m.insertAfter(g.last());
	//var map=initializeLocationsMap();
	//PositionEditor.init(map);
});
