<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * News admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class news_admin extends Object_Manager {
    /**
     * Constructor
     */
    function __construct( $realty_type = false ) {
        $this->SiteBill();
        Multilanguage::appendAppDictionary('news');
        $this->table_name = 'news';
        $this->action = 'news';
        $this->app_title = Multilanguage::_('APPLICATION_NAME','news');
        $this->primary_key = 'news_id';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/news/admin/news_model.php');
        $Object=new News_Model();
		$this->data_model=$Object->get_model();
		$this->install();
    }
    
    function main(){
    	$rs.=parent::main();
    	return $rs;
    }
    
    
    
	function add_data ( $form_data ) {
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $time=date('H:i:s',$form_data['date']['value']);
	    if($time=='00:00:00'){
	    	$form_data['date']['value']=strtotime(date('d-m-Y',$form_data['date']['value']).' '.date('H:i:s',time()));
	    }
	    $query = $data_model->get_insert_query(DB_PREFIX.'_'.$this->table_name, $form_data);
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	    	$this->riseError($this->db->error);
	    	return false;
	    }
	    $new_record_id = $this->db->last_insert_id();
	    $imgs=$this->editImageMulti($this->action, $this->table_name, $this->primary_key, $new_record_id);
		return true;
	}
	
	function edit_data ( $form_data ) {
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $img=$form_data['imgfile'];
	    unset($form_data['imgfile']);
		$time=date('H:i:s',$form_data['date']['value']);
	    if($time=='00:00:00'){
	    	$form_data['date']['value']=strtotime(date('d-m-Y',$form_data['date']['value']).' '.date('H:i:s',time()));
	    }
	    $query = $data_model->get_edit_query(DB_PREFIX.'_'.$this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data);
	    //echo $query;
	    
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	    	$this->riseError($this->db->error);
	    	return false;
	    }
	    $imgs=$this->editImageMulti($this->action, $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
	}
	
	/**
	 * Delete data
	 * @param string $table_name
	 * @param string $primary_key
	 * @param int $primary_key_value
	 */
	function delete_data($table_name, $primary_key, $primary_key_value ) {
		
		$vendor_info=$this->getVendorInfoById($primary_key_value);
        if($vendor_info['imgfile']!=''){
        	unlink(SITEBILL_DOCUMENT_ROOT.'/img/data/vendor/'.$vendor_info['imgfile']);
        }
		
	    $query = "delete from ".DB_PREFIX."_".$table_name." where $primary_key = $primary_key_value";
	    //echo $query;
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	        $this->riseError($this->db->error);
	        return false;
	    }
	}
    
    
    function install () {
        //create tables
        $query = "
CREATE TABLE IF NOT EXISTS `re_news_image` (
  `news_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `news_id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`news_image_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." ;
        ";
        $this->db->exec($query);
        
                $query = "
CREATE TABLE IF NOT EXISTS `re_news` (
  `news_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `description` text,
  `date` int(11) NOT NULL DEFAULT '0',
  `img` varchar(255) NOT NULL DEFAULT '',
  `img_preview` varchar(255) NOT NULL DEFAULT '',
  `anons` text,
  PRIMARY KEY (`news_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." ;
        ";
        $this->db->exec($query);
        
	}
    
    /**
     * Grid
     * @param void
     * @return string
     */
    
    function grid () {
    	
    	$params=array();
    	$params['action']=$this->action;
    	
    	
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/grid.php');
        $common_grid = new Common_Grid($this);
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/page.php');
        $common_page = new Common_Page();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/tab.php');
    	$common_tab = new Common_Tab();
		$url='/admin/index.php?action='.$this->action;
		
    	$common_grid->add_grid_item('news_id');
        $common_grid->add_grid_item('date');
    	$common_grid->add_grid_item('title');
        $common_grid->add_grid_item('anons');
        
        $common_grid->add_grid_control('edit');
        $common_grid->add_grid_control('delete');
		$common_grid->set_grid_query("SELECT * FROM ".DB_PREFIX."_".$this->table_name." ORDER BY date DESC, news_id DESC");
		$params['page']=$this->getRequestValue('page');
		$params['per_page']=$this->getConfigValue('common_per_page');
        
        $common_grid->setPagerParams($params);
        
        $common_page->setTab($common_tab);
        $common_page->setGrid($common_grid);
        
		$rs .= $common_page->toString();
		return $rs;
    }
    
	
	
	
}