<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * RSS v2.0 Exporter at Harvard Law (http://cyber.law.harvard.edu/rss/rss.html) admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class rss_admin extends Object_Manager {
	
	private $rss_title;
	private $site_link;
	private $rss_description;
	private $language;
	private $generator;
	private $editor_email;
	private $webmaster_email;
	private $length;
	private $output_file;
	
	
    /**
     * Constructor
     */
	function __construct( $realty_type = false ) {
        $this->SiteBill();
        Multilanguage::appendAppDictionary('rss');
        $this->checkConfiguration();
        $this->app_title = Multilanguage::_('APPLICATION_NAME','rss');
        $this->action = 'rss';
        
        $this->rss_title=$this->getConfigValue('apps.rss.title');
        $this->rss_description=$this->getConfigValue('apps.rss.description');
        $this->language=$this->getConfigValue('apps.rss.language');
        $this->generator=$this->getConfigValue('apps.rss.generator');
        $this->editor_email=$this->getConfigValue('apps.rss.editor_email');
        $this->webmaster_email=$this->getConfigValue('apps.rss.webmaster_email');
        $this->length=$this->getConfigValue('apps.rss.length');
        $this->site_link='http://'.$_SERVER['SERVER_NAME'].(SITEBILL_MAIN_URL!='' ? SITEBILL_MAIN_URL.'/' : '/');
        $this->output_file=SITEBILL_DOCUMENT_ROOT.'/rss.xml';
    }
    
    function main(){
        $rs .= $this->get_app_title_bar();
        $rs .= Multilanguage::_('RSS_STREAM_ADDRESS','rss').': <a href="'.$this->site_link.'rss/" target="_blank">'.$this->site_link.'rss/</a>';
        return $rs;
    	//$f=fopen($this->output_file,'w');
    	//fwrite($f,$this->generateRSSText());
    	//fclose($f);
    }
    
    private function checkConfiguration(){
    	require_once SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php';
    	$CF=new config_admin();
    	if($CF){
    		if ( !$CF->check_config_item('apps.rss.enable') ) {
				$CF->addParamToConfig('apps.rss.enable','1','  RSS');
			}
    		
	    	if ( !$CF->check_config_item('apps.rss.title') ) {
				$CF->addParamToConfig('apps.rss.title',' RSS ',' RSS ');
			}
			
			if ( !$CF->check_config_item('apps.rss.length') ) {
				$CF->addParamToConfig('apps.rss.length','50',' RSS ');
			}
			
			if ( !$CF->check_config_item('apps.rss.description') ) {
				$CF->addParamToConfig('apps.rss.description',' RSS ',' RSS ');
			}
			
			if ( !$CF->check_config_item('apps.rss.language') ) {
				$CF->addParamToConfig('apps.rss.language','ru-RU','    <a target="_blank" href="http://cyber.law.harvard.edu/rss/languages.html">http://cyber.law.harvard.edu/rss/languages.html</a>');
			}
			
			if ( !$CF->check_config_item('apps.rss.generator') ) {
				$CF->addParamToConfig('apps.rss.generator','CMS Sitebill Application RSS','  RSS ');
			}
			
			if ( !$CF->check_config_item('apps.rss.editor_email') ) {
				$CF->addParamToConfig('apps.rss.editor_email','editor_email@somemail.ru','   ,    ');
			}
			
			if ( !$CF->check_config_item('apps.rss.webmaster_email') ) {
				$CF->addParamToConfig('apps.rss.webmaster_email','webmaster_email@somemail.ru','   ,    ,  ');
			}
    	}
    	unset($CF);
    }
    
    protected function generateRSSText(){
    	$ret='';
    	$ret.='<?xml version="1.0" ?>'."\n";
    	$ret.='<rss version="2.0">'."\n";
    	$ret.='<channel>'."\n";
    	$ret.=$this->generateChannelInfo();
    	$ret.=$this->getItems();
    	$ret.='</channel>'."\n";
    	$ret.='</rss>';
    	return SiteBill::iconv(SITE_ENCODING, 'utf-8', $ret);
    }
    
    private function generateChannelInfo(){
    	$ret='';
    	$ret.='<title>'.$this->rss_title.'</title>'."\n";
      	$ret.='<link>'.$this->site_link.'</link>'."\n";
      	$ret.='<description>'.$this->rss_description.'</description>'."\n";
      	$ret.='<language>'.$this->language.'</language>'."\n";
      	$ret.='<pubDate>'.gmdate('D, d M Y H:i:s T',time()).'</pubDate>'."\n";
      	$ret.='<lastBuildDate>'.gmdate('D, d M Y H:i:s T',time()).'</lastBuildDate>'."\n";
      	$ret.='<docs>http://blogs.law.harvard.edu/tech/rss</docs>'."\n";
      	$ret.='<generator>'.$this->generator.'</generator>'."\n";
      	$ret.='<managingEditor>'.$this->editor_email.'</managingEditor>'."\n";
      	$ret.='<webMaster>'.$this->webmaster_email.'</webMaster>'."\n";
      	return $ret;
    }
    
    private function generateItem($data){
    	$ret='';
    	$ret.='<item>'."\n";
    	$ret.='<title>'.$data['title'].'</title>'."\n";
  		$ret.='<link>'.$this->site_link.'news'.$data['news_id'].'.html</link>'."\n";
    	$ret.='<description><![CDATA['.$data['anons'].']]></description>'."\n";
      	$ret.='<pubDate>'.gmdate('D, d M Y H:i:s T',$data['date']).' ('.date('d M Y H:i:s',$data['date']).')</pubDate>'."\n";
      	$ret.='</item>'."\n";
      	return $ret;
    }
    
    private function getItems(){
    	$ret='';
    	$query='SELECT * FROM '.DB_PREFIX.'_news ORDER BY `date` DESC LIMIT '.$this->length;
    	//echo $query;
    	$this->db->exec($query);
    	if($this->db->success){
    		while($this->db->fetch_assoc()){
    			$ret.=$this->generateItem($this->db->row);
    		}
    	}
    	
    	 
    	return $ret;
    }
    
}