<?php
/**
 * Function manager
 * @author Kondin Dmitriy <kondin@etown.ru> http://sitebill.ru
 */
class Function_Manager extends Object_Manager {
    /**
     * Constructor
     */
    function Function_Manager() {
        $this->Sitebill();
        $this->table_name = 'function';
        $this->action = 'function';
        $this->app_title = Multilanguage::_('FUNCTION_APP_NAME','system');
        $this->primary_key = 'function_id';
        $this->grid_key = 'name';
        
        require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/version/version.php';
        $version = new Version();
        if ( !$version->get_version_value('function.table') ) {
            $this->create_table();
            $version->set_version_value('function.table', 1);
        }
        
        $this->data_model = $this->get_function_model();
    }
    
    function create_table () {
        $query = "
CREATE TABLE `".DB_PREFIX."_function` (
  `function_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `description` text,
  PRIMARY KEY (`function_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
        ";
        $this->db->exec($query);
    }
    
    /**
     * Grid
     * @param void
     * @return string
     */
    function grid () {
        global $_SESSION;
        global $__db_prefix;
        if ( is_object($this->language) ) {
            $query = "select * from ".DB_PREFIX."_".$this->table_name." where language_id = 0 order by name asc";
        } else {
            $query = "select * from ".DB_PREFIX."_".$this->table_name." order by name asc";
        }
        
        $this->db->exec($query);

        $rs = '<div align="left"><table border="0" width="50%">';
        $rs .= '<td ><b>'.Multilanguage::_('L_TEXT_TITLE').'</b></td>';
        $rs .= '<td ><b>'.Multilanguage::_('DESCRIPTION','system').'</b></td>';
        $rs .= '<td></td>';
        $rs .= '</tr>';
        while ( $this->db->fetch_assoc() ) {
            $j++;
            if ( ceil($j/2) > floor($j/2)  ) {
                $row_class = "row1";
            } else {
                $j = 0;
                $row_class = "row2";
            }
            $rs .= '<tr>';
            $rs .= '<td class="'.$row_class.'" nowrap width="20%">'.$this->db->row['name'].'</td>';
            $rs .= '<td class="'.$row_class.'" nowrap width="80%">'.$this->db->row['description'].'</td>';
            $rs .= '<td width="10%" nowrap><a href="?action='.$this->action.'&do=edit&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'"><img src="'.SITEBILL_MAIN_URL.'/img/edit.gif" border="0"></a> <a href="?action='.$this->action.'&do=delete&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'" onclick="if ( confirm(\''.Multilanguage::_('L_MESSAGE_REALLY_WANT_DELETE').'\') ) {return true;} else {return false;}"><img src="'.SITEBILL_MAIN_URL.'/img/delete.gif" border="0"></a>';
            if ( is_object($this->language) ) {
			    if ( $this->language->get_version($this->table_name, $this->primary_key, $this->db->row[$this->primary_key], 1) ) {
                    $exist = true;
                } else {
                    $exist = false;
                }            
                $rs .= $this->language->get_control($this->action, 'edit', $this->primary_key, $this->db->row[$this->primary_key], 1, $exist);
            }
            $rs .= '</td>';
            $rs .= '</tr>';
        }
        $rs .= '</table></div>';
        return $rs;
    }
    
    /**
     * Get function model
     * @param
     * @return
     */
    function get_function_model () {
		$form_function = array();
		
		$form_function['function']['function_id']['name'] = 'function_id';
		$form_function['function']['function_id']['title'] = Multilanguage::_('L_ID');
		$form_function['function']['function_id']['value'] = 0;
		$form_function['function']['function_id']['length'] = 40;
		$form_function['function']['function_id']['type'] = 'primary_key';
		$form_function['function']['function_id']['required'] = 'off';
		$form_function['function']['function_id']['unique'] = 'off';
		
		$form_function['function']['name']['name'] = 'name';
		$form_function['function']['name']['title'] = Multilanguage::_('FUNCTION_NAME','system');
		$form_function['function']['name']['value'] = '';
		$form_function['function']['name']['length'] = 40;
		$form_function['function']['name']['type'] = 'safe_string';
		$form_function['function']['name']['required'] = 'on';
		$form_function['function']['name']['unique'] = 'off';

		$form_function['function']['description']['name'] = 'description';
		$form_function['function']['description']['title'] = Multilanguage::_('DESCRIPTION','system');
		$form_function['function']['description']['value'] = '';
		$form_function['function']['description']['length'] = 40;
		$form_function['function']['description']['type'] = 'safe_string';
		$form_function['function']['description']['required'] = 'on';
		$form_function['function']['description']['unique'] = 'off';
		
		return $form_function;
    }
	
	/**
	 * Get top menu
	 * @param void 
	 * @return string
	 */
	function getTopMenu () {
	    $rs = '';
	    $rs .= '<a href="?action='.$this->action.'&do=new" class="btn btn-primary">'.Multilanguage::_('ADD_FUNCTION','system').'</a>';
	    return $rs;
	}
	
	/**
	 * Delete data
	 * @param string $table_name
	 * @param string $primary_key
	 * @param int $primary_key_value
	 */
	function delete_data($table_name, $primary_key, $primary_key_value ) {
		$search_queries=array(
			Multilanguage::_('TABLE_DNA','system')=>'SELECT COUNT(*) AS rs FROM '.DB_PREFIX.'_dna WHERE function_id=?',
			Multilanguage::_('TABLE_COMP_FUNC','system')=>'SELECT COUNT(*) AS rs FROM '.DB_PREFIX.'_component_function WHERE function_id=?'
		);
		$ans=array();
		foreach($search_queries as $k=>$v){
			$query=str_replace('?', $primary_key_value, $v);
			$this->db->exec($query);
		    if ($this->db->success) {
		    	$this->db->fetch_assoc();
		    	$rs=$this->db->row['rs'];
		        if($rs!=0){
		        	$ans[]=sprintf(Multilanguage::_('MESSAGE_CANT_DELETE','system'), $k);
		        }
		    }
		}
		if(empty($ans)){
			return parent::delete_data($table_name, $primary_key, $primary_key_value);
		}else{
			$this->riseError(implode('<br />',$ans));
		}
		
	}
    
}
?>