<?php
/**
 * Menu manager
 */
class Menu_Manager extends Object_Manager {
    /**
     * Constructor
     */
    function Menu_Manager() {
        $this->SiteBill();
        $this->check_table();
        $this->table_name = 'menu';
        $this->action = 'menu';
        $this->app_title = Multilanguage::_('MENU_APP_NAME','system');
        $this->primary_key = 'menu_id';
        $this->grid_key = 'name';
        
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
        require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/version/version.php';
        $version = new Version();
        if ( !$version->get_version_value('menu.table') ) {
            $this->check_table();
            $version->set_version_value('menu.table', 1);
        }
	    
        $this->data_model = $this->get_menu_model();
    }
    
    private function check_table () {
        $table = "
CREATE TABLE `".DB_PREFIX."_menu` (
  `menu_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `tag` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`menu_id`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=cp1251 ;
        ";
        //echo $table;
        
        $this->db->exec($table);
        
        $table = "
CREATE TABLE `".DB_PREFIX."_menu_structure` (
  `menu_structure_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `url` text,
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `menu_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`menu_structure_id`)
) ENGINE=MyISAM AUTO_INCREMENT=68 DEFAULT CHARSET=cp1251 ;
        ";
        $this->db->exec($table);
        
    }
    
    /**
     * Get menu model
     * @param
     * @return
     */
    function get_menu_model () {
		$form_menu = array();
		
		$form_menu['menu']['menu_id']['name'] = 'menu_id';
		$form_menu['menu']['menu_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_menu['menu']['menu_id']['value'] = 0;
		$form_menu['menu']['menu_id']['length'] = 40;
		$form_menu['menu']['menu_id']['type'] = 'primary_key';
		$form_menu['menu']['menu_id']['required'] = 'off';
		$form_menu['menu']['menu_id']['unique'] = 'off';
		
		$form_menu['menu']['name']['name'] = 'name';
		$form_menu['menu']['name']['title'] = Multilanguage::_('L_TEXT_MENU_NAME');
		$form_menu['menu']['name']['value'] = '';
		$form_menu['menu']['name']['length'] = 40;
		$form_menu['menu']['name']['type'] = 'safe_string';
		$form_menu['menu']['name']['required'] = 'on';
		$form_menu['menu']['name']['unique'] = 'off';
		
		$form_menu['menu']['tag']['name'] = 'tag';
		$form_menu['menu']['tag']['title'] = Multilanguage::_('L_TEXT_MENU_TAG');
		$form_menu['menu']['tag']['value'] = '';
		$form_menu['menu']['tag']['length'] = 40;
		$form_menu['menu']['tag']['type'] = 'safe_string';
		$form_menu['menu']['tag']['required'] = 'on';
		$form_menu['menu']['tag']['unique'] = 'off';
		
		
		return $form_menu;
    }
    
    
	/**
	 * Structure processor
	 * @param void
	 * @return string
	 */
	function structure_processor() {
	    $menu_id = $this->getRequestValue('menu_id');
	    
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/menu/menu_structure_manager.php');
	    
	    $menu_structure_manager = new Menu_Structure_Manager();
	    
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
        $form_menu_structure = $menu_structure_manager->get_menu_structure_model();
        
	    
        $form_data[$this->table_name] = $data_model->init_model_data_from_db ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name] );
        $rs .= '  : <b>'.$form_data[$this->table_name]['name']['value'].'</b><br>';
	    $rs .= $this->get_add_structure_menu( $menu_id );
        
		switch( $this->getRequestValue('subdo') ){
			case 'delete' : {
		        $menu_structure_manager->delete_data('menu_structure', 'menu_structure_id', $this->getRequestValue('menu_structure_id'));
			    $rs .= $menu_structure_manager->grid($menu_id);
		        break;
			}
			
			case 'delete_catalog' : {
		        $menu_catalog_manager->delete_data('menu_catalog', 'menu_catalog_id', $this->getRequestValue('menu_catalog_id'));
			    $rs .= $menu_structure_manager->grid($menu_id);
		        break;
			}
			
			
			case 'edit_done' : {
	            $form_menu_structure['menu_structure'] = $data_model->init_model_data_from_request($form_menu_structure['menu_structure']);
			    if ( !$this->check_data( $form_menu_structure['menu_structure'] ) ) {
                    $rs .= $this->get_form_extended($form_menu_structure['menu_structure'], 'structure', 'edit_done');			    
			    } else {
			        $menu_structure_manager->edit_data($form_menu_structure['menu_structure']);
			        $rs .= $menu_structure_manager->grid($menu_id);
			    }
				break;
			}
			
			case 'edit' : {
                $form_menu_structure['menu_structure'] = $data_model->init_model_data_from_db ( $menu_structure_manager->table_name, $menu_structure_manager->primary_key, $this->getRequestValue($menu_structure_manager->primary_key), $form_menu_structure['menu_structure'] );
                //echo '<pre>';
                //print_r($form_data[$this->table_name]);
                $rs .= $this->get_form_extended($form_menu_structure['menu_structure'], 'structure', 'edit_done');			    
			    break;
			}
			
			case 'edit_catalog_done' : {
	            $form_menu_catalog['menu_catalog'] = $data_model->init_model_data_from_request($form_menu_catalog['menu_catalog']);
			    if ( !$this->check_data( $form_menu_catalog['menu_catalog'] ) ) {
                    $rs .= $this->get_form_extended($form_menu_catalog['menu_catalog'], 'structure', 'edit_catalog_done');			    
			    } else {
			        $menu_catalog_manager->edit_data($form_menu_catalog['menu_catalog']);
			        $rs .= $menu_structure_manager->grid($menu_id);
			    }
				break;
			}
			
			case 'edit_catalog' : {
                $form_menu_catalog['menu_catalog'] = $data_model->init_model_data_from_db ( $menu_catalog_manager->table_name, $menu_catalog_manager->primary_key, $this->getRequestValue($menu_catalog_manager->primary_key), $form_menu_catalog['menu_catalog'] );
                //echo '<pre>';
                //print_r($form_data[$this->table_name]);
                $rs .= $this->get_form_extended($form_menu_catalog['menu_catalog'], 'structure', 'edit_catalog_done');			    
			    break;
			}
			
			
			case 'new_done' : {
	            $form_menu_structure['menu_structure'] = $data_model->init_model_data_from_request($form_menu_structure['menu_structure']);
			    if ( !$this->check_data( $form_menu_structure['menu_structure'] ) ) {
			        $rs .= $this->get_form_extended($form_menu_structure['menu_structure'], 'structure', 'new_done');
			        
			    } else {
			        $menu_structure_manager->add_data($form_menu_structure['menu_structure']);
			        $rs .= $menu_structure_manager->grid($menu_id);
			        //$rs .= '';
			    }
				break;
			}
			
			case 'new_catalog_done' : {
	            $form_menu_catalog['menu_catalog'] = $data_model->init_model_data_from_request($form_menu_catalog['menu_catalog']);
			    if ( !$this->check_data( $form_menu_catalog['menu_catalog'] ) ) {
			        $rs .= $this->get_form_extended($form_menu_catalog['menu_catalog'], 'structure', 'new_catalog_done');
			        
			    } else {
			        $menu_catalog_manager->add_data($form_menu_catalog['menu_catalog']);
			        $rs .= $menu_structure_manager->grid($menu_id);
			        //$rs .= '';
			    }
				break;
			}
			
			
			case 'new_catalog' : {
			        $form_menu_catalog['menu_catalog']['menu_id']['value'] = $menu_id;
    			    $rs .= $this->get_form_extended($form_menu_catalog['menu_catalog'], 'structure', 'new_catalog_done');
				break;
			}
		    
			case 'new' : {
			        $form_menu_structure['menu_structure']['menu_id']['value'] = $menu_id;
    			    $rs .= $this->get_form_extended($form_menu_structure['menu_structure'], 'structure', 'new_done');
				break;
			}
			
			default : {
			    $rs .= $menu_structure_manager->grid($menu_id);
			}
		}
	    return $rs;
	}
	
	/**
	 * Get form extended
	 * @param array $form_data
	 * @param string $do
	 * @param string $subdo
	 * @return string
	 */
	function get_form_extended ( $form_data=array(), $do, $subdo ) {
		
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		
		
		$rs .= '<table>';
		$rs .= '<form method="post" action="index.php">';
		if ( $this->getError() ) {
		    $rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		$rs .= $form_generator->compile_form($form_data);
		
		$rs .= '<input type="hidden" name="do" value="'.$do.'">';
		$rs .= '<input type="hidden" name="subdo" value="'.$subdo.'">';
		$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue('menu_id').'">';
		if ( $subdo == 'edit_done' ) {
		    $rs .= '<input type="hidden" name="menu_structure_id" value="'.$this->getRequestValue('menu_structure_id').'">';
		}
		
		if ( $subdo == 'edit_catalog_done' ) {
		    $rs .= '<input type="hidden" name="menu_catalog_id" value="'.$this->getRequestValue('menu_catalog_id').'">';
		}
		

		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		
		$rs .= '<tr>';
		$rs .= '<td></td>';
		$rs .= '<td><input type="submit" name="submit" value="'.Multilanguage::_('L_TEXT_SAVE').'"></td>';
		$rs .= '</tr>';
		$rs .= '</form>';
		$rs .= '</table>';
		
		return $rs;
		
	}
	
	/**
	 * Get add structure menu
	 * @param int $menu_id
	 */
	function get_add_structure_menu ( $menu_id ) {
	    $rs = '<a href="?action='.$this->action.'&do=structure&subdo=new&menu_id='.$menu_id.'" class="btn btn-primary">'.Multilanguage::_('L_TEXT_ADD_POINT').'</a> ';
	    return $rs;
	}
	
    /**
     * Grid
     * @param void
     * @return string
     */
    function grid () {
        global $_SESSION;
        global $__db_prefix;
        
        $query = "select * from ".DB_PREFIX."_".$this->table_name." order by '".$this->grid_key."'";
        //echo $query;
        
        $this->db->exec($query);

        $rs = '<div align="left"><table border="0" class="table table-hover">';
        $rs .= '<td ><b>'.Multilanguage::_('L_TEXT_TITLE').'</b></td>';
        $rs .= '<td></td>';
        $rs .= '</tr>';
        while ( $this->db->fetch_assoc() ) {
            $j++;
            if ( ceil($j/2) > floor($j/2)  ) {
                $row_class = "row1";
            } else {
                $j = 0;
                $row_class = "row2";
            }
            $rs .= '<tr>';
            $rs .= '<td class="'.$row_class.'" nowrap width="99%">'.$this->db->row[$this->grid_key].'</td>';
            $rs .= '<td width="10%" nowrap>
            <a href="?action='.$this->action.'&do=edit&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'"><img src="'.SITEBILL_MAIN_URL.'/apps/admin/admin/template/img/edit.png" border="0"></a> 
            <a href="?action='.$this->action.'&do=delete&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'" onclick="if ( confirm(\''.Multilanguage::_('L_MESSAGE_REALLY_WANT_DELETE').'\') ) {return true;} else {return false;}"><img src="'.SITEBILL_MAIN_URL.'/apps/admin/admin/template/img/delete.png"></a>
			<a href="?action='.$this->action.'&do=structure&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'" class="btn btn-info">'.Multilanguage::_('L_TEXT_STRUCTURE').'</a>            
            </td>';
            $rs .= '</tr>';
        }
        $rs .= '</table></div>';
        return $rs;
    }
	
	/**
	 * Get top menu
	 * @param void 
	 * @return string
	 */
	function getTopMenu () {
	    $rs = '';
	    $rs .= '<a href="?action='.$this->action.'&do=new" class="btn btn-primary">'.Multilanguage::_('L_TEXT_CREATE_MENU').'</a>';
	    return $rs;
	}
    
}
?>