<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Object manager
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Object_Manager extends SiteBill {
    /**
     * Table name
     * @var string
     */
    var $table_name;
    
    /**
     * Primary key
     * @var string
     */
    var $primary_key;
    
    /**
     * Action name
     * @var string
     */
    var $action;
    
    /**
     * Data model
     * @var array
     */
    var $data_model;
    
    public $app_title;
    
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
    }
    
    function check_table_exist ( $table_name ) {
    	$query = "select * from ".DB_PREFIX."_{$table_name} limit 1";
    	$this->db->exec($query);
    	return $this->db->success;
    }
    
    /**
     * Main
     * @param void
     * @return string
     */
    function main () {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
		$rs = $this->getTopMenu();

		switch( $this->getRequestValue('do') ){
			case 'structure' : {
			        $rs = $this->structure_processor();
				break;
			}
		    
			case 'edit_done' : {
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				$new_values=$this->getRequestValue('_new_value');
				if(1==$this->getConfigValue('use_combobox') && count($new_values)>0){
					$remove_this_names=array();
					foreach($form_data[$this->table_name] as $fd){
						if(isset($new_values[$fd['name']]) && $new_values[$fd['name']]!='' && $fd['combo']==1){
							$id=md5(time().'_'.rand(100,999));
							$remove_this_names[]=$id;
							$form_data[$this->table_name][$id]['value'] = $new_values[$fd['name']];
							$form_data[$this->table_name][$id]['type'] = 'auto_add_value';
							$form_data[$this->table_name][$id]['dbtype'] = 'notable';
							$form_data[$this->table_name][$id]['value_table'] = $form_data[$this->table_name][$fd['name']]['primary_key_table'];
							$form_data[$this->table_name][$id]['value_primary_key'] = $form_data[$this->table_name][$fd['name']]['primary_key_name'];
							$form_data[$this->table_name][$id]['value_field'] = $form_data[$this->table_name][$fd['name']]['value_name'];
							$form_data[$this->table_name][$id]['assign_to'] = $fd['name'];
							$form_data[$this->table_name][$id]['required'] = 'off';
							$form_data[$this->table_name][$id]['unique'] = 'off';
						}
					}
				}
				$data_model->forse_auto_add_values($form_data[$this->table_name]);
	    		//$data_model->clear_auto_add_values($form_data[$this->table_name]);
	            if ( !$this->check_data( $form_data[$this->table_name] ) ) {
	            	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			        $rs = $this->get_form($form_data[$this->table_name], 'edit');
			    } else {
			        $this->edit_data($form_data[$this->table_name]);
			        if ( $this->getError() ) {
			        	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			            $rs = $this->get_form($form_data[$this->table_name], 'edit');
			        } else {
			        	if($this->getConfigValue('apps.realtylog.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
				        	$Logger=new realtylog_admin();
				        	$Logger->addLog($form_data['data']['id']['value'], $_SESSION['user_id_value'], 'edit', $this->table_name);
			        	}
			        	if($this->getConfigValue('apps.shoplog.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
				        	$Logger=new shoplog_admin();
				        	$Logger->addLog($form_data[$this->table_name][$this->primary_key]['value'], $_SESSION['user_id_value'], 'edit', $this->table_name);
			        	}
			        	if($this->getConfigValue('apps.realtylogv2.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
			        		$Logger=new realtylogv2_admin();
			        		$Logger->addLog($form_data['data']['id']['value'], $_SESSION['user_id_value'], 'edit', $this->table_name, $this->primary_key);
			        	}
			            $rs .= $this->grid();
			        }
			    }
				break;
			}
		    
			case 'edit' : {
            	if ( $this->getRequestValue('subdo') == 'delete_image' ) {
            		$this->deleteImage($this->table_name, $this->getRequestValue('image_id'));
            	}
            	
            	if ( $this->getRequestValue('subdo') == 'up_image' ) {
            		$this->reorderImage($this->table_name, $this->getRequestValue('image_id'), $this->primary_key, $this->getRequestValue($this->primary_key),'up');
            	}
            	
            	if ( $this->getRequestValue('subdo') == 'down_image' ) {
            		$this->reorderImage($this->table_name, $this->getRequestValue('image_id'), $this->primary_key, $this->getRequestValue($this->primary_key), 'down');
            	}
			    
                //echo '<pre>';
                //print_r($form_data[$this->table_name]);
                if ( $this->getRequestValue('language_id') > 0 and !$this->language->get_version($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $this->getRequestValue('language_id')) ) {
    			    $rs = $this->get_form($form_data[$this->table_name], 'new', $this->getRequestValue('language_id'));
                } else {
                    if ( $this->getRequestValue('language_id') > 0 ) {
                        $form_data[$this->table_name] = $data_model->init_model_data_from_db_language ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name], false, $this->getRequestValue('language_id') );
                    } else {
                        $form_data[$this->table_name] = $data_model->init_model_data_from_db ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name] );
                    }
                    $rs = $this->get_form($form_data[$this->table_name], 'edit');
                }
				
			    break;
			}
			case 'delete' : {
				if($this->getConfigValue('apps.realtylog.enable')){
		        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
	        		$Logger=new realtylog_admin();
	        		$Logger->addLog($this->getRequestValue($this->primary_key), $_SESSION['user_id_value'], 'delete', $this->table_name);
		        }
				if($this->getConfigValue('apps.shoplog.enable')){
	        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
		        	$Logger=new shoplog_admin();
		        	$Logger->addLog($this->getRequestValue($this->primary_key), $_SESSION['user_id_value'], 'delete', $this->table_name);
	        	}
	        	if($this->getConfigValue('apps.realtylogv2.enable')){
	        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
	        		$Logger=new realtylogv2_admin();
	        		$Logger->addLog($this->getRequestValue($this->primary_key), $_SESSION['user_id_value'], 'delete', $this->table_name, $this->primary_key);
	        	}
		        $this->delete_data($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
			    if ( $this->getError() ) {
			        $rs .= '<div align="center">'.Multilanguage::_('L_ERROR_ON_DELETE').': '.$this->GetErrorMessage().'<br>';
			        $rs .= '<a href="?action='.$this->action.'"></a>';
			        $rs .= '</div>';
			    } else {
		            $rs .= $this->grid();
			    }
		        

		        break;
			}
			
			case 'new_done' : {
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
	            $new_values=$this->getRequestValue('_new_value');
	            if(1==$this->getConfigValue('use_combobox') && count($new_values)>0){
	            	$remove_this_names=array();
	            	foreach($form_data[$this->table_name] as $fd){
	            		if(isset($new_values[$fd['name']]) && $new_values[$fd['name']]!='' && $fd['combo']==1){
	            			$id=md5(time().'_'.rand(100,999));
	            			$remove_this_names[]=$id;
	            			$form_data[$this->table_name][$id]['value'] = $new_values[$fd['name']];
	            			$form_data[$this->table_name][$id]['type'] = 'auto_add_value';
	            			$form_data[$this->table_name][$id]['dbtype'] = 'notable';
	            			$form_data[$this->table_name][$id]['value_table'] = $form_data[$this->table_name][$fd['name']]['primary_key_table'];
	            			$form_data[$this->table_name][$id]['value_primary_key'] = $form_data[$this->table_name][$fd['name']]['primary_key_name'];
	            			$form_data[$this->table_name][$id]['value_field'] = $form_data[$this->table_name][$fd['name']]['value_name'];
	            			$form_data[$this->table_name][$id]['assign_to'] = $fd['name'];
	            			$form_data[$this->table_name][$id]['required'] = 'off';
	            			$form_data[$this->table_name][$id]['unique'] = 'off';
	            		}
	            	}
	            }
	            //echo '<pre>';
	            //print_r($form_data[$this->table_name]);
	            //exit();
	            $data_model->forse_auto_add_values($form_data[$this->table_name]);
	    		if ( !$this->check_data( $form_data[$this->table_name] ) || (1==$this->getConfigValue('filter_double_data') && !$this->checkUniquety($form_data[$this->table_name]))  ) {
	    			$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
	    			$rs = $this->get_form($form_data[$this->table_name], 'new');
			        
			    } else {
			        $new_record_id=$this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
			        if ( $this->getError() ) {
			        	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			        	$rs = $this->get_form($form_data[$this->table_name], 'new');
			        } else {
			        	if($this->getConfigValue('apps.realtylog.enable')){
				        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
				        	$Logger=new realtylog_admin();
				        	$Logger->addLog($new_record_id, $_SESSION['user_id_value'], 'new', $this->table_name);
			        	}
			        	if($this->getConfigValue('apps.shoplog.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
				        	$Logger=new shoplog_admin();
				        	$Logger->addLog($new_record_id, $_SESSION['user_id_value'], 'new', $this->table_name);
			        	}
			        	if($this->getConfigValue('apps.realtylogv2.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
			        		$Logger=new realtylogv2_admin();
			        		$Logger->addLog($new_record_id, $_SESSION['user_id_value'], 'new', $this->table_name, $this->primary_key);
			        	}
			            $rs .= $this->grid();
			        }
			    }
				break;
			}
			
			case 'new' : {
			    $rs = $this->get_form($form_data[$this->table_name]);
				break;
			}
			case 'mass_delete' : {
				$id_array=array();
				$ids=trim($this->getRequestValue('ids'));
				if($ids!=''){
					$id_array=explode(',',$ids);
				}
				$rs.=$this->mass_delete_data($this->table_name, $this->primary_key, $id_array);
				break;
			}
			case 'change_param' : {
				$id_array=array();
				$ids=trim($this->getRequestValue('ids'));
				$param_name=trim($this->getRequestValue('param_name'));
				$param_value=trim($this->getRequestValue('new_param_value'));
				
				if(isset($form_data[$this->table_name][$param_name]) && $ids!=''){
					//echo 1;
					$id_array=explode(',',$ids);
					$rs.=$this->mass_change_param($this->table_name, $this->primary_key, $id_array, $param_name, $param_value);
				}else{
					$rs .= $this->grid();
				}
				break;
			}
			default : {
			    $rs .= $this->grid($user_id);
			}
		}
		$rs_new = $this->get_app_title_bar();
		$rs_new .= $rs;
		return $rs_new;
	}
	
	function checkUniquety($form_data){
		return TRUE;
	}
	
	function get_app_title_bar () {
	    $rs = '<ul class="breadcrumb">';
	    $rs .= '<li>'.Multilanguage::_('L_ADMIN_MENU_APPLICATIONS').' <span class="divider">/</span> ';
	    if ( !empty($this->app_title) ) {
	    	$rs .= '<a href="?action='.$this->action.'">'.$this->app_title.'</a>';
	    } else {
	    	$rs .= '<a href="?action='.$this->action.'">'.$this->action.'</a>';
	    }
	    $rs .= '</li>';
	    $rs .= '</ul>';
	    $rs .= '<div class="clear"></div>';
	    
	    return $rs;
	}
	
	function mass_delete_data($table_name, $primary_key, $ids){
		$errors='';
		if(count($ids)>0){
			foreach($ids as $id){
				$this->delete_data($this->table_name, $this->primary_key, $id);
				if ( $this->getError() ) {
			        $errors .= '<div align="center">'.Multilanguage::_('L_ERROR_ON_DELETE').' ID='.$id.': '.$this->GetErrorMessage().'<br>';
			        $errors .= '</div>';
			        $this->error_message=false;
			    }
			}
		}
		if($errors!=''){
			$rs.=$errors.'<div align="center"><a href="?action='.$this->action.'"></a></div>';
		}else{
			$rs .= $this->grid($user_id);
		}
		return $rs;
	}
	
	function mass_change_param($table_name, $primary_key, $ids, $param_name, $param_value){
		$errors='';
		if(count($ids)>0){
			$data_model = new Data_Model();
			$form_data = $this->data_model;
			$partial_form_data=array();
			$partial_form_data[$this->table_name][$this->primary_key]=$form_data[$this->table_name][$this->primary_key];
			$partial_form_data[$this->table_name][$param_name]=$form_data[$this->table_name][$param_name];
			
			/*foreach($form_data[$this->table_name] as $fk=>$fv){
				if($fk!==$this->primary_key || $fk!==$param_name){
					unset($form_data[$this->table_name][$fk]);
				}
			}*/
			//$FD=$form_data
			foreach($ids as $id){
				$partial_form_data[$this->table_name][$this->primary_key]['value']=$id;
				$partial_form_data[$this->table_name][$param_name]['value']=$param_value;
				//print_r($partial_form_data[$this->table_name]);
				if ( $this->check_data( $partial_form_data[$this->table_name] ) ) {
					$this->edit_data($partial_form_data[$this->table_name]);
				}
			}
		}
		$rs .= $this->grid();
		
		return $rs;
	}
	
    /**
     * Load record by id
     * @param int $record_id
     * @return array
     */
    function load_by_id ( $record_id ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    if ( !is_object($this->data_model_object) ) {
	        $this->data_model_object = new Data_Model();
	    }
	    $form_data = $this->data_model;
	    if ( $record_id > 0 ) {
	    	$form_data[$this->table_name] = $this->data_model_object->init_model_data_from_db ( $this->table_name, $this->primary_key, $record_id, $form_data[$this->table_name], TRUE );
	    }
        return $form_data[$this->table_name];
        //print_r($form_data[$this->table_name]);
    }
    
	/**
	 * Delete data
	 * @param string $table_name
	 * @param string $primary_key
	 * @param int $primary_key_value
	 */
	function delete_data($table_name, $primary_key, $primary_key_value ) {
	    $query = "delete from ".DB_PREFIX."_".$table_name." where $primary_key = $primary_key_value";
	    //echo $query;
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	        $this->riseError($this->db->error);
	        return false;
	    }
	    return TRUE;
	}
	
    /**
     * Grid
     * @param void
     * @return string
     */
    function grid () {
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/grid.php');
        $common_grid = new Common_Grid($this);
        
        
        $common_grid->add_grid_item($this->primary_key);
        $common_grid->add_grid_item('name');
        
        $common_grid->add_grid_control('edit');
        $common_grid->add_grid_control('delete');
        
        $common_grid->setPagerParams(array('action'=>$this->action,'page'=>$this->getRequestValue('page'),'per_page'=>$this->getConfigValue('common_per_page')));
        
        $common_grid->set_grid_query("select * from ".DB_PREFIX."_".$this->table_name." order by ".$this->primary_key." asc");
        $rs = $common_grid->construct_grid();
        return $rs;
    }
		
	/**
	 * Add data
	 * @param array $form_data form data
	 * @param int $language_id
	 * @return boolean
	 */
	function add_data ( $form_data, $language_id = 0 ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $query = $data_model->get_insert_query(DB_PREFIX.'_'.$this->table_name, $form_data, $language_id);
	    //echo $query.'<br>';
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	        $this->riseError($this->db->error);
	        return false;
	    }
	    $new_record_id = $this->db->last_insert_id();
	    $imgs=$this->editImageMulti($this->action, $this->table_name, $this->primary_key, $new_record_id);
	    //echo "new_record_id = $new_record_id<br>";
	    //echo $query;
	    return $new_record_id;
	}
	
	/**
	 * Edit data
	 * @param array $form_data form data
	 * @param int $language_id language id
	 * @return boolean
	 */
	function edit_data ( $form_data, $language_id = 0, $primary_key_value = false ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    if ( $primary_key_value ) {
	    	$query = $data_model->get_edit_query(DB_PREFIX.'_'.$this->table_name, $this->primary_key, $primary_key_value, $form_data, $language_id);
	    } else {
	    	$query = $data_model->get_edit_query(DB_PREFIX.'_'.$this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data, $language_id);
	    }
	   // echo '<br>error query'.$query.'<br>';
	    $this->db->success = true;
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	        //echo '<br>error query'.$query.'<br>';
	         
	        $this->riseError($this->db->error);
	        return false;
	    }
	    $imgs=$this->editImageMulti($this->action, $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
	     
	    //$new_record_id = $this->db->last_insert_id();
	    //echo "new_record_id = $new_record_id<br>";
	    //echo $query;
	}
	
	/**
	 * Check data
	 * @param array $form_data
	 * @return boolean
	 */
	function check_data ( $form_data ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    if ( !$data_model->check_data($form_data) ) {
	        $this->riseError($data_model->GetErrorMessage());
	        return false;
	    }
	    return true;
	}
	
	/**
	 * Get top menu
	 * @param void 
	 * @return string
	 */
	function getTopMenu () {
	    $rs = '';
	    $rs .= '<a href="?action='.$this->action.'&do=new" class="btn btn-primary">'.Multilanguage::_('L_ADD_RECORD_BUTTON').'</a> ';
		//$rs .= '<form method="post"><input type="hidden" name="action" value="add" /><input type="submit" name="submit" value=" " /></form>';
	    return $rs;
	}
   
   
	
	/**
	 * Get form for edit or new record
	 * @param array $form_data
	 * @param string $do
	 * @param int $language_id
	 * @param string $button_title
	 * @return string
	 */
	function get_form ( $form_data=array(), $do = 'new', $language_id = 0, $button_title = '' ) {
		
		$_SESSION['allow_disable_root_structure_select']=true;
		global $smarty;
		if($button_title==''){
			$button_title = Multilanguage::_('L_TEXT_SAVE');
		}
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		 
		 
		$rs .= $this->get_ajax_functions();
		if(1==$this->getConfigValue('apps.geodata.enable')){
			$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
		}
		$rs .= '<form method="post" class="form-horizontal" action="index.php" enctype="multipart/form-data">';
		 
		if ( $this->getError() ) {
			$smarty->assign('form_error',$form_generator->get_error_message_row($this->GetErrorMessage()));
		}
		 
		$el = $form_generator->compile_form_elements($form_data);
		
		if ( $do == 'new' ) {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="new_done" />');
			$el['private'][]=array('html'=>'<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'" />');
		} else {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="edit_done" />');
			$el['private'][]=array('html'=>'<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'" />');
		}
		$el['private'][]=array('html'=>'<input type="hidden" name="action" value="'.$this->action.'">');
		$el['private'][]=array('html'=>'<input type="hidden" name="language_id" value="'.$language_id.'">');
		
		$el['form_header']=$rs;
		$el['form_footer']='</form>';
		 
		/*if ( $do != 'new' ) {
			$el['controls']['apply']=array('html'=>'<button id="apply_changes" class="btn btn-info">'.Multilanguage::_('L_TEXT_APPLY').'</button>');
		}*/
		$el['controls']['submit']=array('html'=>'<button id="formsubmit" name="submit" class="btn btn-primary">'.$button_title.'</button>');
		 
		
	
		
		
		$smarty->assign('form_elements',$el);
		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl')){
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl';
		}else{
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/apps/admin/admin/template/data_form.tpl';
		}
		return $smarty->fetch($tpl_name);
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		if($button_title==''){
			$button_title = Multilanguage::_('L_TEXT_SAVE');
		}
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		
        $rs .= $this->get_ajax_functions();
        $rs .= '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script>';
        $rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
        if(1==$this->getConfigValue('use_combobox')){
        	$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
        	$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
        }
        
        
        $rs .= '<form method="post" action="index.php" enctype="multipart/form-data">';
        $rs .= '<table>';
		if ( $this->getError() ) {
		    $rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		
		$rs .= $form_generator->compile_form($form_data);
		
		if ( $do == 'new' ) {
		    $rs .= '<input type="hidden" name="do" value="new_done">';
		    $rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		} else {
		    $rs .= '<input type="hidden" name="do" value="edit_done">';
		    $rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'">';
		}
		//$rs .= '<input type="hidden" name="page" value="'.$_SESSION['rem_page'].'">';
		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="language_id" value="'.$language_id.'">';
		
		/*
		if($this->getConfigValue('post_form_agreement_enable')==1){
        	
        	$rs .= '<script type="text/javascript">';
        	$rs.='$(document).ready(function(){';
        	$rs.='	if($("#i_am_agree_in_form").attr("checked")){';
        		
        	$rs.='	}else{';
        	$rs.='		$("#formsubmit").attr("disabled","disabled");';
        	$rs.='	}';
        	
        	$rs.='	$("#i_am_agree_in_form").change(function(){';
        	$rs.='			if($(this).attr("checked")){';
        	$rs.='				$("#formsubmit").removeAttr("disabled");';
        	
        	$rs.='			}else{';
        	$rs.='				$("#formsubmit").attr("disabled","disabled");';
        	
        	$rs.='			}';
        	$rs.='	});';
        	
        	$rs.='});';
        	$rs .= '</script>';
        	
        	$rs .= '</script>';
        	$rs .= '<tr>';
	        $rs .= '<td><div align="right"><input type="checkbox" id="i_am_agree_in_form" /></div></td><td>'.$this->getConfigValue('post_form_agreement_text').'</td>';
	        $rs .= '</tr>';
        }
		*/
		$rs .= '<tr>';
		$rs .= '<td><input type="submit" name="submit" id="formsubmit" value="'.$button_title.'"></td>';
		$rs .= '</tr>';
		$rs .= '</table>';
		$rs .= '</form>';
		
		return $rs;
		
	}
	
	/**
	 * Set apps template
	 * @param string $apps_name
	 * @param string $theme
	 * @param string $template_key
	 * @param string $template_value
	 * @return boolean
	 */
	function set_apps_template ( $apps_name, $theme, $template_key, $template_value ) {
		if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$theme.'/apps/'.$apps_name.'/site/template/'.$template_value) ) {
			$this->template->assert($template_key, SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$theme.'/apps/'.$apps_name.'/site/template/'.$template_value);
		} elseif ( !file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$theme.'/'.$apps_name.'/'.$template_value) ) {
			if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/'.$apps_name.'/site/template/'.$template_value) ) {
				$this->template->assert($template_key, SITEBILL_DOCUMENT_ROOT.'/apps/'.$apps_name.'/site/template/'.$template_value);
			} else {
				echo sprintf(Multilanguage::_('L_FILE_NOT_FOUND'),SITEBILL_DOCUMENT_ROOT.'/apps/'.$apps_name.'/site/template/'.$template_value);
				exit;
			}
		} else {
			$this->template->assert($template_key, SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$theme.'/'.$apps_name.'/'.$template_value);
		}
	}
	
	function getSteps($form_data,$step){
	
		$default_tab_name=$this->getConfigValue('default_tab_name');
		$tabs=array($default_tab_name);
			
		foreach ( $form_data as $item_id => $item_array ) {
			if(isset($item_array['tab']) && $item_array['tab']!=''){
				$tabs[$item_array['tab']]=$item_array['tab'];
			}
		}
		$tabs_array=array();
		$i=1;
		foreach($tabs as $t){
			if($i < $step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'done');
			}elseif($i==$step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'current');
			}else{
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'further');
			}
			$i++;
		}
		return $tabs_array;
	}
	
	public function _preload(){
		//echo get_class($this).'<br />';
	}
	
	protected function saveTranslitAlias($id){
		$query='SELECT re_city.name AS city, re_street.name AS street, re_data.number
				FROM re_data
				LEFT JOIN re_city ON re_city.city_id=re_data.city_id
				LEFT JOIN re_street ON re_street.street_id=re_data.street_id
				WHERE re_data.id='.$id;
		$this->db->exec($query);
		if($this->db->success){
			$p=array();
			$this->db->fetch_assoc();
			if($this->db->row['city']!=''){
				$p[]=$this->transliteMe($this->db->row['city']);
			}
			if($this->db->row['street']!=''){
				$p[]=$this->transliteMe($this->db->row['street']);
			}
			if((int)$this->db->row['number']!=0){
				$p[]=(int)$this->db->row['number'];
			}
			if(!empty($p)){
				$alias=implode('-',$p);
				$q="SELECT translit_alias FROM ".DB_PREFIX."_data WHERE translit_alias LIKE '".$alias."%' AND id<>".$id." ORDER BY translit_alias DESC LIMIT 1";
				
				$this->db->exec($q);
				$this->db->fetch_assoc();
				
				if($this->db->row['translit_alias']!=''){
					if(preg_match('/'.$alias.'-(\d+)/',$this->db->row['translit_alias'],$matches)){
						$alias.='-'.((int)$matches[1]+1);
					}else{
						$alias.='-1';
					}
				}
				
				$query='UPDATE re_data SET translit_alias=\''.$alias.'\' WHERE id='.$id;
				$this->db->exec($query);
			}
	
		}
	
	}
	
	protected function removeTemporaryFields(&$model,$remove_this_names=array()){
		if(count($remove_this_names)>0){
			foreach($remove_this_names as $r){
				unset($model[$r]);
			}
		}
		return $model;
	}

}
?>
