<?php
/**
 * Grid constructor
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Grid_Constructor extends SiteBill_Krascap {
	public $grid_total;
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
    }
    
    /**
     * Main
     * @param array $param
     * @return array
     */
    function main ( $params ) {
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        $category_structure = $Structure_Manager->loadCategoryStructure();
        
        $res = $this->get_sitebill_adv_ext( $params );
        $this->template->assign('category_tree', $this->get_category_tree( $params, $category_structure ) );
		$this->template->assign('breadcrumbs', $this->get_category_breadcrumbs( $params, $category_structure, SITEBILL_MAIN_URL ) );
		$this->template->assign('search_params', json_encode($params) );
		$this->template->assign('search_url', $_SERVER['REQUEST_URI'] );
		//print_r(json_encode($params));

        $this->get_sales_grid($res);
    }
    
    /**
     * Main
     * @param array $param
     * @return array
     */
    function main_contact ( $params ) {
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	$category_structure = $Structure_Manager->loadCategoryStructure();
    
    	$res = $this->get_sitebill_adv_ext( $params );
    	$res = $this->add_user_account_info($res);
    	$this->template->assign('category_tree', $this->get_category_tree( $params, $category_structure ) );
    	$this->template->assign('breadcrumbs', $this->get_category_breadcrumbs( $params, $category_structure, SITEBILL_MAIN_URL ) );
    
    	$this->get_sales_grid($res);
    }
    
    function add_user_account_info ( $res ) {
    	if ( !is_array($res) ) {
    		return $res;
    	}
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
    	$Users_Manager = new User_Object_Manager();
    	 
    	foreach ( $res as $item_id => $item ) {
    		$res[$item_id]['user_array'] = $Users_Manager->load_by_id($item['user_id']); 
    	}
    	//echo '<pre>';
    	//print_r($res);
    	//echo '</pre>';
    	return $res;
    }
    
    
    /**
     * Special
     * @param array $params
     */
    function special ( $params ) {
        $res = $this->get_sitebill_adv_ext( $params, true );
        $this->template->assign('special_items', $res);
        
    }
    
    /**
     * Special right
     * @param unknown_type $params
     */
    function special_right ( $params ) {
    	if ( $this->getConfigValue('theme') == '3columns' ) {
    		$params['only_img'] = 1;
    	}
        $res = $this->get_sitebill_adv_ext( $params, true );
        $this->template->assign('special_items2', $res);
    }
    
    /**
     * Get category tree
     * @param array $params
     * @param array $category_structure
     * @return string
     */
    function get_category_tree( $params, $category_structure ) {
        
        if ( count($category_structure['childs'][$params['topic_id']]) > 0 ) {
            foreach ( $category_structure['childs'][$params['topic_id']] as $item_id => $child_id ) {
	            if($category_structure['catalog'][$child_id]['url']!=''){
		        	$rs .= '<li><a href="'.SITEBILL_MAIN_URL.'/'.$category_structure['catalog'][$child_id]['url'].'">'.$category_structure['catalog'][$child_id]['name'].'</a></li>';
		        }else{
		        	$rs .= '<li><a href="'.SITEBILL_MAIN_URL.'/topic'.$child_id.'.html">'.$category_structure['catalog'][$child_id]['name'].'</a></li>';
		        }
                //$rs .= '<li><a href="?topic_id='.$child_id.'">'.$category_structure['catalog'][$child_id]['name'].'</a></li>';
            }
            return $rs;
        }
        return '';
    }
    
    function get_grid_total_records () {
    	return $this->grid_total;
    }
    
    function get_sitebill_adv_ext( $params, $random = false ) {
    	
    	if(defined('IS_DEVELOPER') && IS_DEVELOPER==1){
    		
    		return $this->get_sitebill_adv_ext_modern($params, $random);
    	}
    	//return $this->get_sitebill_adv_ext2($params, $random);
    	//
    	return $this->get_sitebill_adv_ext_base($params, $random);
    }
    
    /**
     * Get sitebill adv ext
     * @param array $params
     * @param boolean $random
     * @return array
     */
    function get_sitebill_adv_ext_base( $params, $random = false ) {
    	
        if ( $this->getConfigValue('currency_enable') ) {
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
            require_once SITEBILL_DOCUMENT_ROOT.'/apps/currency/admin/admin.php';
			$CM=new currency_admin();
        }
        
    	$this->grid_total = 0;
    	$where_array = false;

        if ( $params['order'] == 'city' ) {
        	
            $where_array[] = 're_city.city_id=re_data.city_id';
            $add_from_table .= ' , re_city ';
            $add_select_value .= ' , re_city.name as city ';
        }
        
        if ( $params['order'] == 'district' ) {
            $where_array[] = 're_district.id=re_data.district_id';
            $add_from_table .= ' , re_district ';
            $add_select_value .= ' , re_district.name as district ';
        }
        
        if ( $params['order'] == 'metro' ) {
            $where_array[] = 're_metro.metro_id=re_data.metro_id';
            $add_from_table .= ' , re_metro ';
            $add_select_value .= ' , re_metro.name as metro ';
        }
        
        if ( $params['order'] == 'street' ) {
            $where_array[] = 're_street.street_id=re_data.street_id';
            $add_from_table .= ' , re_street ';
            $add_select_value .= ' , re_street.name as street ';
        }
        
                
        if(isset($params['favorites']) && !empty($params['favorites'])){
        	$where_array[] = 're_data.id IN ('.implode(',',$params['favorites']).')';
        }
        
        if(isset($params['uniq_id']) && $params['uniq_id']!=0){
        	$where_array[] = 're_data.uniq_id='.$params['uniq_id'];
        }
        
        if(isset($params['optype'])){
        	$where_array[] = DB_PREFIX.'_data.optype='.(int)$params['optype'];
        }
        
        $where_array[] = 're_topic.id=re_data.topic_id';
        
        //echo '$params[\'topic_id\'] = '.$params['topic_id'].'<br>';
        
        if ( $params['topic_id'] != '' &&  $params['topic_id'] != 0) {
            require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
            $Structure_Manager = new Structure_Manager();
            $category_structure = $Structure_Manager->loadCategoryStructure();
            global $smarty;
            //echo $category_structure['catalog'][$params['topic_id']]['description'];
            $smarty->assign('topic_description', $category_structure['catalog'][$params['topic_id']]['description']);
            
            $childs = $Structure_Manager->get_all_childs($params['topic_id'], $category_structure);
            if ( count($childs) > 0 ) {
                array_push($childs, $params['topic_id']);
                $where_array[] = 're_data.topic_id in ('.implode(' , ',$childs).') ';
            } else {
                $where_array[] = 're_data.topic_id='.$params['topic_id'];
           }
        }
        
        if ( isset($params['country_id']) and $params['country_id'] != 0  ) {
            $where_array[] = 're_data.country_id = '.$params['country_id'];
        }else{
        	unset($params['country_id']);
        }
        
        if ( isset($params['id']) and $params['id'] != 0  ) {
        	$where_array[] = 're_data.id = '.$params['id'];
        }
        
        if ( isset($params['mvids']) && is_array($params['mvids']) && count($params['mvids']) != 0  ) {
        	$where_array[] = 're_data.id IN ('.implode(',',$params['mvids']).')';
        }
        
        
        if ( isset($params['user_id']) && $params['user_id'] > 0  ) {
            $where_array[] = 're_data.user_id = '.$params['user_id'];
        }
        
        if ( isset($params['onlyspecial']) && $params['onlyspecial'] > 0  ) {
        	$where_array[] = 're_data.hot = 1';
        }
        
        
        if ( isset($params['price']) && $params['price'] != 0  ) {
	        	$where_array[] = 're_data.price  <= '.$params['price'];
	    }
        
        if ( isset($params['price_min']) && $params['price_min'] != 0  ) {
	        	$where_array[] = 're_data.price  >= '.$params['price_min'];
	    }
	    ////
	    if ( isset($params['price_pm']) && $params['price_pm'] != 0  ) {
	    	$where_array[] = 're_data.price_pm  <= '.$params['price_pm'];
	    }
	    if ( isset($params['price_pm_min']) && $params['price_pm_min'] != 0  ) {
	    	$where_array[] = 're_data.price_pm  >= '.$params['price_pm_min'];
	    }
        //////
        if ( isset($params['house_number']) && $params['house_number'] != 0  ) {
            $where_array[] = 're_data.number  = \''.$params['house_number'].'\'';
        }else{
        	unset($params['house_number']);
        }
        
        
        if ( isset($params['region_id']) && $params['region_id'] != 0 ) {
            $where_array[] = 're_data.region_id = '.$params['region_id'];
        }else{
        	unset($params['region_id']);
        }
        
        if ( isset($params['spec']) ) {
            $where_array[] = ' re_data.hot = 1 ';
        }
    	if ( isset($params['hot']) ) {
            $where_array[] = ' re_data.hot = 1 ';
        }
        if ( isset($params['city_id']) and $params['city_id'] != 0  ) {
            $where_array[] = 're_data.city_id = '.$params['city_id'];
        }
        if ( isset($params['district_id']) and $params['district_id'] != 0  ) {
            $where_array[] = 're_data.district_id = '.$params['district_id'];
        }else{
        	unset($params['district_id']);
        }
        /*
        if(isset($params['metro_id']) && is_array($params['metro_id'])){
        	if(!empty($params['metro_id'])){
        		$where_array[] = 're_data.metro_id IN ('.implode(',',$params['metro_id']).')';
        	}
        }elseif(isset($params['metro_id']) && (int)$params['metro_id']!=0){
        	$where_array[] = 're_data.metro_id = '.(int)$params['metro_id'];
        }
        */
       
        if ( isset($params['metro_id']) and $params['metro_id'] != 0  ) {
        	if(is_array($params['metro_id']) && !empty($params['metro_id'])){
        		$where_array[] = 're_data.metro_id IN ('.implode(',',$params['metro_id']).')';
        	}else{
        		$where_array[] = 're_data.metro_id = '.$params['metro_id'];
        	}
            
        }else{
        	unset($params['metro_id']);
        }
        if ( isset($params['street_id']) and $params['street_id'] != 0  ) {
            $where_array[] = 're_data.street_id = '.$params['street_id'];
        }else{
        	unset($params['street_id']);
        }
		
		if(isset($params['srch_phone']) and $params['srch_phone'] !== NULL){
			$phone = preg_replace('/[^\d]/', '', $params['srch_phone']);
			$sub_where=array();
			if($this->getConfigValue('allow_additional_mobile_number')){
				$sub_where[] = '(re_data.ad_mobile_phone LIKE \'%'.$phone.'%\')';
			}
			if($this->getConfigValue('allow_additional_stationary_number')){
				$sub_where[] = '(re_data.ad_stacionary_phone LIKE \'%'.$phone.'%\')';
			}
			$sub_where[] = '(re_data.phone LIKE \'%'.$phone.'%\')';
			$where_array[]='('.implode(' OR ',$sub_where).')';
		}
		
		if(isset($params['srch_word']) and $params['srch_word'] !== NULL){
			$sub_where=array();
			$word=htmlspecialchars($params['srch_word']);
			$sub_where[] = '(re_data.text LIKE \'%'.$word.'%\')';
			$sub_where[] = '(re_data.more1 LIKE \'%'.$word.'%\')';
			$sub_where[] = '(re_data.more2 LIKE \'%'.$word.'%\')';
			$sub_where[] = '(re_data.more3 LIKE \'%'.$word.'%\')';
			$where_array[]='('.implode(' OR ',$sub_where).')';
		}
		
		if(isset($params['room_count'])){
			if(is_array($params['room_count']) && count($params['room_count'])>0){
				$sub_where=array();
				foreach($params['room_count'] as $rq){
					if($rq==4){
						$sub_where[]='room_count>3';
					}elseif(0!=(int)$rq){
						$sub_where[]='room_count='.(int)$rq;
					}
				}
				if(count($sub_where)>0){
					$where_array[]='('.implode(' OR ',$sub_where).')';
				}
			}else{
				unset($params['room_count']);
			}
		}
		
		if($params['srch_date_from']!=0 && $params['srch_date_to']!=0){
			$where_array[]="((re_data.date_added>='".$params['srch_date_from']."') AND (re_data.date_added<='".$params['srch_date_to']."'))";
		}elseif($params['srch_date_from']!=0){
			$where_array[]="(re_data.date_added>='".$params['srch_date_from']."')";
		}elseif($params['srch_date_to']!=0){
			$where_array[]="(re_data.date_added<='".$params['srch_date_to']."')";
		}
		
    	if($params['floor_min']!=0 && $params['floor_max']!=0){
			$where_array[]="(re_data.floor BETWEEN ".$params['floor_min']." AND ".$params['floor_max'].")";
		}elseif($params['floor_min']!=0){
			$where_array[]="(re_data.floor>=".$params['floor_min'].")";
		}elseif($params['floor_max']!=0){
			$where_array[]="(re_data.floor<=".$params['floor_max'].")";
		}
		
    	if($params['floor_count_min']!=0 && $params['floor_count_max']!=0){
			$where_array[]="(re_data.floor_count BETWEEN ".$params['floor_count_min']." AND ".$params['floor_count_max'].")";
		}elseif($params['floor_count_min']!=0){
			$where_array[]="(re_data.floor_count>=".$params['floor_count_min'].")";
		}elseif($params['floor_count_max']!=0){
			$where_array[]="(re_data.floor_count<=".$params['floor_count_max'].")";
		}
		
    	if($params['square_min']!=0 && $params['square_max']!=0){
			$where_array[]="(re_data.square_all BETWEEN ".$params['square_min']." AND ".$params['square_max'].")";
		}elseif($params['square_min']!=0){
			$where_array[]="(re_data.square_all>=".$params['square_min'].")";
		}elseif($params['square_max']!=0){
			$where_array[]="(re_data.square_all<=".$params['square_max'].")";
		}
		
		if(isset($params['not_first_floor']) && $params['not_first_floor']==1){
			$where_array[]="(re_data.floor <> 1)";
		}
		
		if(isset($params['not_last_floor']) && $params['not_last_floor']==1){
			$where_array[]="(re_data.floor <> re_data.floor_count)";
		}
		
		
		////////////////
		if(isset($params['by_ipoteka']) && $params['by_ipoteka']==1){
			
		}
		if(isset($params['status']) && $params['status']==1){
				
		}
		if(isset($params['nout_from_sale']) && $params['nout_from_sale']==1){
				
		}
		if(isset($params['nwith_null_params']) && $params['nwith_null_params']==1){
				
		}
		if(isset($params['new_only']) && $params['new_only']==1){
		
		}
		if(isset($params['is_balkony']) && $params['is_balkony']==1){
		
		}
		if(isset($params['is_sanitary']) && $params['is_sanitary']==1){
		
		}
    	if(isset($params['live_square_min']) && $params['live_square_min']!=0){
    		$where_array[]="(re_data.square_live >= ".$params['live_square_min'].")";
		}
		if(isset($params['live_square_max']) && $params['live_square_max']!=0){
			$where_array[]="(re_data.square_live <= ".$params['live_square_max'].")";
		}
		if(isset($params['kitchen_square_min']) && $params['kitchen_square_min']!=0){
			$where_array[]="(re_data.square_kitchen >= ".$params['kitchen_square_min'].")";
		}
		if(isset($params['kitchen_square_max']) && $params['kitchen_square_max']!=0){
			$where_array[]="(re_data.square_kitchen <= ".$params['kitchen_square_max'].")";
		}
		
		//////////////
		
		if($params['floor_min']!=0 && $params['floor_max']!=0){
			$where_array[]="(re_data.floor BETWEEN ".$params['floor_min']." AND ".$params['floor_max'].")";
		}elseif($params['floor_min']!=0){
			$where_array[]="(re_data.floor>=".$params['floor_min'].")";
		}elseif($params['floor_max']!=0){
			$where_array[]="(re_data.floor<=".$params['floor_max'].")";
		}
		
		if($params['is_phone']==1){
			$where_array[]="(re_data.is_telephone=1)";
		}else{
			unset($params['is_phone']);
		}
		
		if($params['is_internet']==1){
			$where_array[]="(re_data.is_internet=1)";
		}else{
			unset($params['is_internet']);
		}
		
    	if($params['is_furniture']==1){
			$where_array[]="(re_data.furniture=1)";
		}else{
			unset($params['is_furniture']);
		}
		
		if($params['owner']==1){
			$where_array[]="(re_data.whoyuaare=1)";
		}else{
			unset($params['is_furniture']);
		}
		
    	if($params['has_photo']==1){
			$where_array[]='((SELECT COUNT(*) FROM '.DB_PREFIX.'_data_image WHERE id='.DB_PREFIX.'_data.id)>0)';
		}else{
			unset($params['has_photo']);
		}
		
		if($params['infra_greenzone']==1){
			$where_array[]="(re_data.infra_greenzone=1)";
		}else{
			unset($params['infra_greenzone']);
		}
		
		if($params['infra_sea']==1){
			$where_array[]="(re_data.infra_sea=1)";
		}else{
			unset($params['infra_sea']);
		}
		
		if($params['infra_sport']==1){
			$where_array[]="(re_data.infra_sport=1)";
		}else{
			unset($params['infra_sport']);
		}
		
		if($params['infra_clinic']==1){
			$where_array[]="(re_data.infra_clinic=1)";
		}else{
			unset($params['infra_clinic']);
		}
		
		if($params['infra_terminal']==1){
			$where_array[]="(re_data.infra_terminal=1)";
		}else{
			unset($params['infra_terminal']);
		}
		
		if($params['infra_airport']==1){
			$where_array[]="(re_data.infra_airport=1)";
		}else{
			unset($params['infra_airport']);
		}
		
		if($params['infra_bank']==1){
			$where_array[]="(re_data.infra_bank=1)";
		}else{
			unset($params['infra_bank']);
		}
		
		if($params['infra_restaurant']==1){
			$where_array[]="(re_data.infra_restaurant=1)";
		}else{
			unset($params['infra_restaurant']);
		}
		
		if(isset($params['object_state']) && is_array($params['object_state']) && count($params['object_state'])>0){
			$where_array[]="(re_data.object_state IN (".implode(',', $params['object_state'])."))";
		}else{
			unset($params['object_state']);
		}
		
		if(isset($params['object_type']) && is_array($params['object_type']) && count($params['object_type'])>0){
			$where_array[]="(re_data.object_type IN (".implode(',', $params['object_type'])."))";
		}else{
			unset($params['object_type']);
		}
		
		if(isset($params['object_destination']) && is_array($params['object_destination']) && count($params['object_destination'])>0){
			$where_array[]="(re_data.object_destination IN (".implode(',', $params['object_destination'])."))";
		}else{
			unset($params['object_destination']);
		}
		
		if(isset($params['aim']) && is_array($params['aim']) && count($params['aim'])>0){
			$where_array[]="(re_data.aim IN (".implode(',', $params['aim'])."))";
		}else{
			unset($params['aim']);
		}
		
    	if($params['has_geo']==1){
			$where_array[]='('.DB_PREFIX.'_data.geo_lat IS NOT NULL AND '.DB_PREFIX.'_data.geo_lng IS NOT NULL)';
		}
		
		if(isset($params['minbeds']) && (int)$params['minbeds']!=0){
			$where_array[]="(re_data.bedrooms_count >= ".(int)$params['minbeds'].")";
		}
		if(isset($params['minbaths']) && (int)$params['minbaths']!=0){
			$where_array[]="(re_data.bathrooms_count >=".(int)$params['minbaths'].")";
		}
		
        
       
        if ( $params['admin'] != 1 ) {
            $where_array[] = 're_data.active=1';
        } elseif ( $params['active'] == 1 ) {
            $where_array[] = 're_data.active=1';
        } elseif ( $params['active'] == 'notactive' ) {
            $where_array[] = 're_data.active=0';
        }
        
        if ( $this->getConfigValue('apps.company.timelimit') ) {
        	$current_time = time();
        	 
        	$where_array[] = 're_data.user_id=u.user_id';
        	$where_array[] = 'u.company_id=c.company_id';
        	$where_array[] = "c.start_date <= $current_time";
        	$where_array[] = "c.end_date >= $current_time";
        	$add_from_table .= ' , re_user u, re_company c ';        	
        }
        
        if ( $params['only_img'] ) {
        	
        	$where_array[] = 're_data.id=i.id';
        	$add_from_table .= ' , re_data_image i ';        	
        }
        
        
        if ( $where_array ) {
            $where_statement = " WHERE ".implode(' AND ', $where_array);
        }
        
        if ( isset($params['order']) ) {

            if ( !isset($params['asc']) ) {
                $asc = 'desc';
            } 
            if ($params['asc'] == 'asc')  {
            	$asc = 'asc';
            }elseif ($params['asc'] == 'desc') {
            	$asc = 'desc';
            }else{
            	$asc = 'desc';
            }
            //
            if     ( $params['order'] == 'type' ) $order = 'type_sh ';
            elseif ( $params['order'] == 'street' ) $order = 're_street.name ';
            elseif ( $params['order'] == 'district' ) $order = 're_district.name ';
            elseif ( $params['order'] == 'metro' ) $order = 're_metro.name ';
            elseif ( $params['order'] == 'city' ) $order = 're_city.name ';
            elseif ( $params['order'] == 'date_added' ) $order = 're_data.date_added ';
            elseif ( $params['order'] == 'price' ){
            		$order = 'price ';
            }

            $order .= $asc;
        } else {
            //$order = "re_data.id desc";
			$order = "re_data.date_added DESC, re_data.price ASC, re_data.id DESC";
        }
        
        //echo $order.'<br />';
        
        if ( !isset($params['page']) or $params['page'] == 0 ) {
            $page = 1;
        } else {
            $page = $params['page'];
        }
		
        
		if ( $random ) {
		    $order = ' rand() ';
		}
        
		if ( $this->getConfigValue('currency_enable') ) {
			$query = "select count(re_data.id) as total from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ";
		}else{
			$query = "select count(re_data.id) as total from re_data, re_topic $add_from_table $where_statement ";
		}
		
		$query1='SELECT COUNT('.DB_PREFIX.'_data.id) as total FROM '.DB_PREFIX.'_data d 
				LEFT JOIN '.DB_PREFIX.'_topic t ON t.id=d.topic_id';
		
		
		
		$this->db->exec($query);
		if ( !$this->db->success ) {
			echo $this->db->error.'<br>';
		}
		$this->db->fetch_assoc();
		$total = $this->db->row['total'];
		$this->grid_total = $total; 
		global $smarty;
		$smarty->assign('_total_records',$total);
		
		
		$limit = $this->getConfigValue('per_page');
		$max_page=ceil($total/$limit);
		
		if($page>$max_page){
			$page=1;
			$params['page']=1;
		}
		
		$start = ($page-1)*$limit;
		
		$pager_params=$params;
        	
	    
        unset($params['order']);
        unset($params['asc']);
        unset($params['favorites']);
        
        if ( preg_match('/\/special\//', $_SERVER['REQUEST_URI']) ) {
        	unset($params['spec']);
        	unset($pager_params['spec']);
        }
        
	    
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        $category_structure = $Structure_Manager->loadCategoryStructure();
        
       
    	if($params['topic_id']!=''){
        	if(!$params['admin']){
	        	if($this->cityTopicUrlFind($_SERVER['REQUEST_URI'])){
		        	$p=parse_url($_SERVER['REQUEST_URI']);
		        	unset($params['city_id']);
		        	unset($params['topic_id']);
		        	unset($pager_params['city_id']);
		        	unset($pager_params['topic_id']);
		        	$pageurl=trim($p['path'],'/');
		        }elseif($category_structure['catalog'][$params['topic_id']]['url']!='' && 1==$this->getConfigValue('apps.seo.level_enable')){
		        	$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
		        	//unset($pager_params['topic_id']);
		        	unset($params['topic_id']);
		        	unset($pager_params['topic_id']);
		        }elseif($category_structure['catalog'][$params['topic_id']]['url']!=''){
		        	//echo 1;
		        	$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
		        	unset($pager_params['topic_id']);
		        	unset($params['topic_id']);
		        }else{
					if(preg_match('/topic(\d*).html/',$_SERVER['REQUEST_URI'])){
		        		unset($pager_params['topic_id']);
		        	}
					if($params['topic_id']!=0){
		        		$pageurl='topic'.$params['topic_id'].'.html';
		        		unset($params['topic_id']);
		        	}else{
		        		$pageurl='';
		        		unset($params['topic_id']);
		        		unset($pager_params['topic_id']);
		        	}
		        
		        }
        	}else{
        		$pageurl='';
        	}
        }else{
        	$pageurl='';
        }
        $this->template->assert('pager', $this->get_page_links_list ($page, $total, $limit, $pager_params ));
	    
	    
	    
   	 	
        foreach ( $params as $key => $value ) {
        	if(is_array($value)){
        		if(count($value)>0){
        			foreach($value as $v){
        				if($v!=''){
        					$pairs[] = $key.'[]='.$v;
        				}
        			}
        		}
        	}elseif ( $value != '') {
	        	if($key!='topic_id'){
	                //echo "key = $key, value = $value<br>";
		            $pairs[] = "$key=$value";
	        	}elseif($params['admin']){
	        		$pairs[] = "$key=$value";
	        	}
	        	
	        }
	    }
      
	    if ( is_array($pairs) ) {
		    $url = $pageurl.'?'.implode('&', $pairs);
	    }else{
	    	$url = $pageurl.'?key=value';
	    }
        $this->template->assert('url', $url);
        
        
        if ( $this->getConfigValue('apps.company.timelimit') ) {
        	if ( $this->getConfigValue('currency_enable') ) {
        		$query = "select re_currency.code AS currency_code, re_currency.name AS currency_name, ((re_data.price*re_currency.course)/".$CM->getCourse(CURRENT_CURRENCY).") AS price_ue, re_data.*, re_topic.name as type_sh $add_select_value from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
        	} else {
        		$query = "select re_data.*, re_topic.name as type_sh $add_select_value from re_data, re_topic $add_from_table $where_statement order by ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
        	}
        	
        } else {
        	if ( $this->getConfigValue('currency_enable') ) {
        		$query = "select re_currency.code AS currency_code, re_currency.name AS currency_name, ((re_data.price*re_currency.course)/".$CM->getCourse(CURRENT_CURRENCY).") AS price_ue, re_data.*, re_topic.name as type_sh $add_select_value from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
        	} else {
        		$query = "select re_data.*, re_topic.name as type_sh $add_select_value from re_data, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
        	}
        }
       	//echo $query;
        $this->db->exec($query);
        if ( !$this->db->success ) {
        	echo $this->db->error.'<br>';
        }
        
        $ra = array();
        $i = 0;
        if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
            require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
            $Account = new Account;
            
        }
        
        while ( $this->db->fetch_assoc() ) {
            if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
                $company_profile = $Account->get_company_profile($this->db->row['user_id']);
                $this->db->row['company'] = $company_profile['name']['value'];
            }
            $ra[$i] = $this->db->row;
            $i++;
        }
	    
        
        
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $params = array();
	    
	    $_model=$data_model->get_kvartira_model();
	    //print_r($data_model->get_kvartira_model());
	    /*
	    if($this->getConfigValue('apps.mapviewer.enable')){
	    	require_once SITEBILL_DOCUMENT_ROOT.'/apps/mapviewer/admin/admin.php';
	    	$Map_Viewer=new mapviewer_admin();
	    	$coords_info=$Map_Viewer->loadMVData();
	    }else{
	    	$coords_info=array();
	    }
	   */
	    
	    $grid_geodata=array();

        foreach ( $ra as $item_id => $item_array ) {
        	if( isset($item_array['geo_lat']) && isset($item_array['geo_lng']) && $item_array['geo_lat']!='' && $item_array['geo_lng']!='' ){
        		$grid_geodata[]=array(
        				'lat'=>$item_array['geo_lat'],
        				'lng'=>$item_array['geo_lng'],
        				'id'=>$item_array['id']
        				);
        	}
            if ( $item_array['country_id'] > 0 ) {
                $ra[$item_id]['country'] = $data_model->get_string_value_by_id('country', 'country_id', 'name', $item_array['country_id'], true);
            }
            if ( $item_array['region_id'] > 0 ) {
                $ra[$item_id]['region'] = $data_model->get_string_value_by_id('region', 'region_id', 'name', $item_array['region_id'], true);
            }
            if ( $item_array['district_id'] > 0 ) {
                $ra[$item_id]['district'] = $data_model->get_string_value_by_id('district', 'id', 'name', $item_array['district_id'], true);
            }
            if ( $item_array['street_id'] > 0 ) {
                $ra[$item_id]['street'] = $data_model->get_string_value_by_id('street', 'street_id', 'name', $item_array['street_id'], true);
            }
            if ( $item_array['city_id'] > 0 ) {
                $ra[$item_id]['city'] = $data_model->get_string_value_by_id('city', 'city_id', 'name', $item_array['city_id'], true);
            }
            if ( $item_array['metro_id'] > 0 ) {
                $ra[$item_id]['metro'] = $data_model->get_string_value_by_id('metro', 'metro_id', 'name', $item_array['metro_id'], true);
            }
            if ( $item_array['user_id'] > 0 ) {
            	$ra[$item_id]['user'] = $data_model->get_string_value_by_id('user', 'user_id', 'fio', $item_array['user_id'], true);
            	if ( $ra[$item_id]['user'] == '' ) {
            		$ra[$item_id]['user'] = $data_model->get_string_value_by_id('user', 'user_id', 'login', $item_array['user_id'], true);
            	}
            }
         	if ( $item_array['currency_id'] > 0 ) {
         		$ra[$item_id]['currency'] = $data_model->get_string_value_by_id('currency', 'currency_id', 'code', $item_array['currency_id'], true);
         		//$ra[$item_id]['currency_name'] = $data_model->get_string_value_by_id('currency', 'currency_id', 'name', $item_array['currency_id'], true);
         	}
         	
         	if(isset($item_array['optype']) && isset($_model['data']['optype']) && $_model['data']['optype']['type']=='select_box'){
         		$ra[$item_id]['optype']=$_model['data']['optype']['select_data'][(int)$item_array['optype']];
         	}
         	
         	
            $params['topic_id'] = $item_array['topic_id'];
            
            $ra[$item_id]['path'] = $this->get_category_breadcrumbs_string( $params, $category_structure );
            $ra[$item_id]['date'] = date('d.m',strtotime($ra[$item_id]['date_added']));
            
            
            $image_array = $data_model->get_image_array ( 'data', 'data', 'id', $item_array['id'], 1 );
            if ( count($image_array) > 0 ) {
                $ra[$item_id]['img'] = $image_array;
            }
            
            
            
            
            if(1==$this->getConfigValue('apps.seo.level_enable')){
            	
            	if($category_structure['catalog'][$ra[$item_id]['topic_id']]['url']!=''){
            		$ra[$item_id]['parent_category_url']=$category_structure['catalog'][$ra[$item_id]['topic_id']]['url'].'/';
            	}else{
            		$ra[$item_id]['parent_category_url']='';
            	}
            }else{
            	 $ra[$item_id]['parent_category_url']='';
            }
            //echo $this->getConfigValue('apps.seo.data_alias_enable');
            if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $ra[$item_id]['translit_alias']!=''){
            	$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].$ra[$item_id]['translit_alias'];
            	//$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].$this->getTranslitAlias($ra[$item_id]['city'],$ra[$item_id]['street'],$ra[$item_id]['number']);
            }elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
            	$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'].'.html';
            }else{
            	$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'];
            }
            /*
            if(isset($coords_info[$item_array['id']])){
            	$ra[$item_id]['mvdata']=$coords_info[$item_array['id']];
            }
            */
        } 
        $this->template->assert('grid_geodata', json_encode($grid_geodata));
        return $ra;
    }
    
    function getTranslitAlias($city,$street,$number){
    	if($city!=''){
    		$p[]=$this->transliteMe($city);
    	}
    	if($street!=''){
    		$p[]=$this->transliteMe($street);
    	}
    	if((int)$number!=0){
    		$p[]=(int)$number;
    	}
    	return implode('-',$p);
    }
    
    function get_sitebill_adv_ext_modern( $params, $random = false ) {
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
    	$data_model = new Data_Model();
    	$base_model=$data_model->get_kvartira_model();
    	$data_table_name=array_shift(array_keys($base_model));
    	$model_fields=array_keys($base_model[$data_table_name]);
    	//echo '<pre>';
    	//print_r($base_model);
    	//print_r($model_fields);
    	
    	foreach($base_model[$data_table_name] as $model_field){
    		if($model_field['type']=='select_by_query'){
    			$_table=DB_PREFIX.'_'.$model_field['primary_key_table'];
    			$sw[]=$_table.'.'.$model_field['primary_key_table'].' AS '.str_replace('_id', '', $model_field['name']);
    			$ljs[]='LEFT JOIN '.$_table.' ON '.$_table.'.'.$model_field['primary_key_name'].'='.DB_PREFIX.'_'.$data_table_name.'.'.$model_field['name'];
    		}
    	}
    	/*
    	print_r($sw);
    	
    	print_r($ljs);
    	*/
    	$_table_topic=DB_PREFIX.'_topic';
    	$_table_data=DB_PREFIX.'_data';
    	$_table_city=DB_PREFIX.'_city';
    	$_table_district=DB_PREFIX.'_district';
    	$_table_street=DB_PREFIX.'_street';
    	$_table_metro=DB_PREFIX.'_metro';
    	$_table_country=DB_PREFIX.'_country';
    	
    	$query_start='SELECT';
    	$select_what=array();
    	$query_joins=array();
    	
    	$select_what[]=$_table_data.'.*';
    	
    	if(in_array('topic_id',$model_fields)){
    		$select_what[]=$_table_topic.'.name AS type_sh';
    		$query_joins[]='LEFT JOIN '.$_table_topic.' ON '.$_table_topic.'.id='.$_table_data.'.topic_id';
    	}
    	
    	if(in_array('district_id',$model_fields)){
    		$select_what[]=$_table_district.'.name AS district';
    		$query_joins[]='LEFT JOIN '.$_table_district.' ON '.$_table_district.'.id='.$_table_data.'.district_id';
    	}
    	
    	if(in_array('city_id',$model_fields)){
    		$select_what[]=$_table_city.'.name AS city';
    		$query_joins[]='LEFT JOIN '.$_table_city.' ON '.$_table_city.'.city_id='.$_table_data.'.city_id';
    	}
    	
    	if(in_array('metro_id',$model_fields)){
    		$select_what[]=$_table_metro.'.name AS metro';
    		$query_joins[]='LEFT JOIN '.$_table_metro.' ON '.$_table_metro.'.metro_id='.$_table_data.'.metro_id';
    	}
    	
    	if(in_array('street_id',$model_fields)){
    		$select_what[]=$_table_street.'.name AS street';
    		$query_joins[]='LEFT JOIN '.$_table_street.' ON '.$_table_street.'.street_id='.$_table_data.'.street_id';
    	}
    	
    	if(in_array('country_id',$model_fields)){
    		$select_what[]=$_table_country.'.name AS country';
    		$query_joins[]='LEFT JOIN '.$_table_country.' ON '.$_table_country.'.country_id='.$_table_data.'.country_id';
    	}
    	
    	$query_joins[]='LEFT JOIN '.DB_PREFIX.'_user ON '.$_table_data.'.user_id='.DB_PREFIX.'_user.user_id';
    	
    	
    	
    	$select_what[]=DB_PREFIX.'_user.fio AS user';
    	
    	if(count($query_joins)>0){
    		$query_join=implode(' ',$query_joins);
    	}
    	
    	//$query_join='';
    	 
    	if ( $this->getConfigValue('currency_enable') ) {
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/currency/admin/admin.php';
    		$CM=new currency_admin();
    		
    		$select_what[]=DB_PREFIX.'_currency.code AS currency_code';
    		$select_what[]=DB_PREFIX.'_currency.name AS currency_name';
    		$select_what[]='(('.$_table_data.'.price*'.DB_PREFIX.'_currency.course)/'.$CM->getCourse(CURRENT_CURRENCY).') AS price_ue';
    		
    		$query_join.=' LEFT JOIN '.DB_PREFIX.'_currency ON '.$_table_data.'.currency_id='.DB_PREFIX.'_currency.currency_id';
    	}
    
    	$this->grid_total = 0;
    	$where_array = false;
    /*
    	if ( $params['order'] == 'city' ) {
    		 
    		$where_array[] = 're_city.city_id=re_data.city_id';
    		$add_from_table .= ' , re_city ';
    		$add_select_value .= ' , re_city.name as city ';
    	}
    
    	if ( $params['order'] == 'district' ) {
    		$where_array[] = 're_district.id=re_data.district_id';
    		$add_from_table .= ' , re_district ';
    		$add_select_value .= ' , re_district.name as district ';
    	}
    
    	if ( $params['order'] == 'metro' ) {
    		$where_array[] = 're_metro.metro_id=re_data.metro_id';
    		$add_from_table .= ' , re_metro ';
    		$add_select_value .= ' , re_metro.name as metro ';
    	}
    
    	if ( $params['order'] == 'street' ) {
    		$where_array[] = 're_street.street_id=re_data.street_id';
    		$add_from_table .= ' , re_street ';
    		$add_select_value .= ' , re_street.name as street ';
    	}
    */
    
    	if(isset($params['favorites']) && !empty($params['favorites'])){
    		$where_array[] = DB_PREFIX.'_data.id IN ('.implode(',',$params['favorites']).')';
    	}
    
    	 
    
    	if(isset($params['optype'])){
    		$where_array[] = DB_PREFIX.'_data.optype='.(int)$params['optype'];
    	}
    
    	//$where_array[] = DB_PREFIX.'_topic.id='.DB_PREFIX.'_data.topic_id';
    
    	//echo '$params[\'topic_id\'] = '.$params['topic_id'].'<br>';
    
    	if ( $params['topic_id'] != '' &&  $params['topic_id'] != 0) {
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    		$Structure_Manager = new Structure_Manager();
    		$category_structure = $Structure_Manager->loadCategoryStructure();
    		global $smarty;
    		//echo $category_structure['catalog'][$params['topic_id']]['description'];
    		$smarty->assign('topic_description', $category_structure['catalog'][$params['topic_id']]['description']);
    
    		$childs = $Structure_Manager->get_all_childs($params['topic_id'], $category_structure);
    		if ( count($childs) > 0 ) {
    			array_push($childs, $params['topic_id']);
    			$where_array[] = 're_data.topic_id IN ('.implode(' , ',$childs).') ';
    		} else {
    			$where_array[] = 're_data.topic_id='.$params['topic_id'];
    		}
    		//print_r($params);
    	}
    
    	if ( isset($params['country_id']) and $params['country_id'] != 0  ) {
    		$where_array[] = 're_data.country_id = '.$params['country_id'];
    	}else{
    		unset($params['country_id']);
    	}
    
    	if ( isset($params['id']) and $params['id'] != 0  ) {
    		$where_array[] = 're_data.id = '.$params['id'];
    	}
    
    	if ( isset($params['mvids']) && is_array($params['mvids']) && count($params['mvids']) != 0  ) {
    		$where_array[] = 're_data.id IN ('.implode(',',$params['mvids']).')';
    	}
    
    
    	if ( isset($params['user_id']) && $params['user_id'] > 0  ) {
    		$where_array[] = 're_data.user_id = '.$params['user_id'];
    	}
    
    	if ( isset($params['onlyspecial']) && $params['onlyspecial'] > 0  ) {
    		$where_array[] = 're_data.hot = 1';
    	}
    
    
    	if ( isset($params['price']) && $params['price'] != 0  ) {
    		$where_array[] = 're_data.price  <= '.$params['price'];
    	}
    
    	if ( isset($params['price_min']) && $params['price_min'] != 0  ) {
    		$where_array[] = 're_data.price  >= '.$params['price_min'];
    	}
    
    	if ( isset($params['house_number']) && $params['house_number'] != 0  ) {
    		$where_array[] = 're_data.number  = \''.$params['house_number'].'\'';
    	}else{
    		unset($params['house_number']);
    	}
    
    
    	if ( isset($params['region_id']) && $params['region_id'] != 0 ) {
    		$where_array[] = 're_data.region_id = '.$params['region_id'];
    	}else{
    		unset($params['region_id']);
    	}
    
    	if ( isset($params['spec']) ) {
    		$where_array[] = ' re_data.hot = 1 ';
    	}
    	if ( isset($params['hot']) ) {
    		$where_array[] = ' re_data.hot = 1 ';
    	}
    	if ( isset($params['city_id']) and $params['city_id'] != 0  ) {
    		$where_array[] = 're_data.city_id = '.$params['city_id'];
    	}
    	if ( isset($params['district_id']) and $params['district_id'] != 0  ) {
    		$where_array[] = 're_data.district_id = '.$params['district_id'];
    	}else{
    		unset($params['district_id']);
    	}
    	if ( isset($params['metro_id']) and $params['metro_id'] != 0  ) {
    		$where_array[] = 're_data.metro_id = '.$params['metro_id'];
    	}else{
    		unset($params['metro_id']);
    	}
    	if ( isset($params['street_id']) and $params['street_id'] != 0  ) {
    		$where_array[] = 're_data.street_id = '.$params['street_id'];
    	}else{
    		unset($params['street_id']);
    	}
    	
    	if(isset($params['srch_phone']) and $params['srch_phone'] !== NULL){
    		$phone = preg_replace('/[^\d]/', '', $params['srch_phone']);
    		$sub_where=array();
    		if($this->getConfigValue('allow_additional_mobile_number')){
    			$sub_where[] = '(re_data.ad_mobile_phone LIKE \'%'.$phone.'%\')';
    		}
    		if($this->getConfigValue('allow_additional_stationary_number')){
    			$sub_where[] = '(re_data.ad_stacionary_phone LIKE \'%'.$phone.'%\')';
    		}
    		$sub_where[] = '(re_data.phone LIKE \'%'.$phone.'%\')';
    		$where_array[]='('.implode(' OR ',$sub_where).')';
    	}
    	
    	if(isset($params['srch_word']) and $params['srch_word'] !== NULL){
    		$sub_where=array();
    		$word=htmlspecialchars($params['srch_word']);
    		$sub_where[] = '(re_data.text LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more1 LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more2 LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more3 LIKE \'%'.$word.'%\')';
    		$where_array[]='('.implode(' OR ',$sub_where).')';
    	}
    
    	if(isset($params['room_count'])){
    		if(is_array($params['room_count']) && count($params['room_count'])>0){
    			$sub_where=array();
    			foreach($params['room_count'] as $rq){
    				if($rq==4){
    					$sub_where[]='room_count>3';
    				}elseif(0!=(int)$rq){
    					$sub_where[]='room_count='.(int)$rq;
    				}
    			}
    			if(count($sub_where)>0){
    				$where_array[]='('.implode(' OR ',$sub_where).')';
    			}
    		}else{
    			unset($params['room_count']);
    		}
    	}
    
    	if($params['srch_date_from']!=0 && $params['srch_date_to']!=0){
    		$where_array[]="((re_data.date_added>='".$params['srch_date_from']."') AND (re_data.date_added<='".$params['srch_date_to']."'))";
    	}elseif($params['srch_date_from']!=0){
    		$where_array[]="(re_data.date_added>='".$params['srch_date_from']."')";
    	}elseif($params['srch_date_to']!=0){
    		$where_array[]="(re_data.date_added<='".$params['srch_date_to']."')";
    	}
    
    	if($params['floor_min']!=0 && $params['floor_max']!=0){
    		$where_array[]="(re_data.floor BETWEEN ".$params['floor_min']." AND ".$params['floor_max'].")";
    	}elseif($params['floor_min']!=0){
    		$where_array[]="(re_data.floor>=".$params['floor_min'].")";
    	}elseif($params['floor_max']!=0){
    		$where_array[]="(re_data.floor<=".$params['floor_max'].")";
    	}
    
    	if($params['floor_count_min']!=0 && $params['floor_count_max']!=0){
    		$where_array[]="(re_data.floor_count BETWEEN ".$params['floor_count_min']." AND ".$params['floor_count_max'].")";
    	}elseif($params['floor_count_min']!=0){
    		$where_array[]="(re_data.floor_count>=".$params['floor_count_min'].")";
    	}elseif($params['floor_count_max']!=0){
    		$where_array[]="(re_data.floor_count<=".$params['floor_count_max'].")";
    	}
    
    	if($params['square_min']!=0 && $params['square_max']!=0){
    		$where_array[]="(re_data.square_all BETWEEN ".$params['square_min']." AND ".$params['square_max'].")";
    	}elseif($params['square_min']!=0){
    		$where_array[]="(re_data.square_all>=".$params['square_min'].")";
    	}elseif($params['square_max']!=0){
    		$where_array[]="(re_data.square_all<=".$params['square_max'].")";
    	}
    
    	if($params['is_phone']==1){
    		$where_array[]="(re_data.is_telephone=1)";
    	}else{
    		unset($params['is_phone']);
    	}
    
    	if($params['is_internet']==1){
    		$where_array[]="(re_data.is_internet=1)";
    	}else{
    		unset($params['is_internet']);
    	}
    
    	if($params['is_furniture']==1){
    		$where_array[]="(re_data.furniture=1)";
    	}else{
    		unset($params['is_furniture']);
    	}
    
    	if($params['owner']==1){
    		$where_array[]="(re_data.whoyuaare=1)";
    	}else{
    		unset($params['is_furniture']);
    	}
    
    	if($params['has_photo']==1){
    		$where_array[]='((SELECT COUNT(*) FROM '.DB_PREFIX.'_data_image WHERE id='.DB_PREFIX.'_data.id)>0)';
    	}else{
    		unset($params['has_photo']);
    	}
    
    	if($params['infra_greenzone']==1){
    		$where_array[]="(re_data.infra_greenzone=1)";
    	}else{
    		unset($params['infra_greenzone']);
    	}
    
    	if($params['infra_sea']==1){
    		$where_array[]="(re_data.infra_sea=1)";
    	}else{
    		unset($params['infra_sea']);
    	}
    
    	if($params['infra_sport']==1){
    		$where_array[]="(re_data.infra_sport=1)";
    	}else{
    		unset($params['infra_sport']);
    	}
    
    	if($params['infra_clinic']==1){
    		$where_array[]="(re_data.infra_clinic=1)";
    	}else{
    		unset($params['infra_clinic']);
    	}
    
    	if($params['infra_terminal']==1){
    		$where_array[]="(re_data.infra_terminal=1)";
    	}else{
    		unset($params['infra_terminal']);
    	}
    
    	if($params['infra_airport']==1){
    		$where_array[]="(re_data.infra_airport=1)";
    	}else{
    		unset($params['infra_airport']);
    	}
    
    	if($params['infra_bank']==1){
    		$where_array[]="(re_data.infra_bank=1)";
    	}else{
    		unset($params['infra_bank']);
    	}
    
    	if($params['infra_restaurant']==1){
    		$where_array[]="(re_data.infra_restaurant=1)";
    	}else{
    		unset($params['infra_restaurant']);
    	}
    
    	if(isset($params['object_state']) && is_array($params['object_state']) && count($params['object_state'])>0){
    		$where_array[]="(re_data.object_state IN (".implode(',', $params['object_state'])."))";
    	}else{
    		unset($params['object_state']);
    	}
    
    	if(isset($params['object_type']) && is_array($params['object_type']) && count($params['object_type'])>0){
    		$where_array[]="(re_data.object_type IN (".implode(',', $params['object_type'])."))";
    	}else{
    		unset($params['object_type']);
    	}
    
    	if(isset($params['object_destination']) && is_array($params['object_destination']) && count($params['object_destination'])>0){
    		$where_array[]="(re_data.object_destination IN (".implode(',', $params['object_destination'])."))";
    	}else{
    		unset($params['object_destination']);
    	}
    
    	if(isset($params['aim']) && is_array($params['aim']) && count($params['aim'])>0){
    		$where_array[]="(re_data.aim IN (".implode(',', $params['aim'])."))";
    	}else{
    		unset($params['aim']);
    	}
    
    	if($params['has_geo']==1){
    		$where_array[]='('.DB_PREFIX.'_data.geo_lat IS NOT NULL AND '.DB_PREFIX.'_data.geo_lng IS NOT NULL)';
    	}
    
    
    	/*
    	 if ($_SERVER['REQUEST_URI'] == '/')
    		$order = "re_data.id desc";
    	else
    		$order = "re_data.date_added desc";
    	*/
    	if ( $params['admin'] != 1 ) {
    		$where_array[] = 're_data.active=1';
    	} elseif ( $params['active'] == 1 ) {
    		$where_array[] = 're_data.active=1';
    	} elseif ( $params['active'] == 'notactive' ) {
    		$where_array[] = 're_data.active=0';
    	}
    
    	if ( $this->getConfigValue('apps.company.timelimit') ) {
    		$current_time = time();
    		
    		$query_join.=' LEFT JOIN '.DB_PREFIX.'_company ON '.DB_PREFIX.'_user.company_id='.DB_PREFIX.'_company.company_id';
    		$where_array[] = DB_PREFIX."_company.start_date <= ".$current_time;
    		$where_array[] = DB_PREFIX."_company.end_date >= ".$current_time;
    		
    		/*
    		$where_array[] = 're_data.user_id=u.user_id';
    		$where_array[] = 'u.company_id=c.company_id';
    		$where_array[] = "c.start_date <= $current_time";
    		$where_array[] = "c.end_date >= $current_time";
    		$add_from_table .= ' , re_user u, re_company c ';
    		*/
    	}
    
    	if ( $params['only_img'] ) {
    		 
    		$where_array[] = 're_data.id=i.id';
    		$add_from_table .= ' , re_data_image i ';
    	}
    
    
    	if ( $where_array ) {
    		$where_statement = " WHERE ".implode(' AND ', $where_array);
    	}
    
    	if ( isset($params['order']) ) {
    
    		if ( !isset($params['asc']) ) {
    			$asc = 'desc';
    		}
    		if ($params['asc'] == 'asc')  {
    			$asc = 'asc';
    		}elseif ($params['asc'] == 'desc') {
    			$asc = 'desc';
    		}else{
    			$asc = 'desc';
    		}
    		//
    		if     ( $params['order'] == 'type' ) $order = 'type_sh ';
    		elseif ( $params['order'] == 'street' ) $order = $_table_street.'.name ';
    		elseif ( $params['order'] == 'district' ) $order = $_table_district.'.name ';
    		elseif ( $params['order'] == 'metro' ) $order = $_table_metro.'.name ';
    		elseif ( $params['order'] == 'city' ) $order = $_table_city.'.name ';
    		elseif ( $params['order'] == 'date_added' ) $order = 're_data.date_added ';
    		elseif ( $params['order'] == 'price' ){
    			if ( $this->getConfigValue('currency_enable') ) {
    				$order = 'price_ue ';
    			}else{
    				$order = 'price ';
    			}
    		}
    
    		$order .= $asc;
    	} else {
    		//$order = "re_data.id desc";
    		$order = "re_data.date_added DESC, re_data.id DESC";
    	}
    
    	if ( !isset($params['page']) or $params['page'] == 0 ) {
    		$page = 1;
    	} else {
    		$page = $params['page'];
    	}
    
    
    	if ( $random ) {
    		$order = ' rand() ';
    	}
    	$query = "select count(re_data.id) as total from re_data ".$query_join." $add_from_table $where_statement ";
    	/*if ( $this->getConfigValue('currency_enable') ) {
    		$query = "select count(re_data.id) as total from re_data ".$query_join." $add_from_table $where_statement ";
    	}else{
    		$query = "select count(re_data.id) as total from re_data ".$query_join." $add_from_table $where_statement ";
    	}*/
    //echo '<br /><br />'.$query.'<br /><br />';
    	//$query1='SELECT COUNT('.DB_PREFIX.'_data.id) as total FROM '.DB_PREFIX.'_data d
				//LEFT JOIN '.DB_PREFIX.'_topic t ON t.id=d.topic_id';
    
    	//$query = "select count(re_data.id) as total from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ";
    	//echo $query.'<br>';
    
    	$this->db->exec($query);
    	if ( !$this->db->success ) {
    		echo $this->db->error.'<br>';
    	}
    	$this->db->fetch_assoc();
    	$total = $this->db->row['total'];
    	$this->grid_total = $total;
    	global $smarty;
    	$smarty->assign('_total_records',$total);
    
    	//echo "total = $total<br>";
    	$limit = $this->getConfigValue('per_page');
    	$max_page=ceil($total/$limit);
    	//echo "max_page = $max_page<br>";
    	if($page>$max_page){
    		$page=1;
    		$params['page']=1;
    	}
    
    	$start = ($page-1)*$limit;
    
    	$pager_params=$params;
    	//print_r($pager_params);
    	 
    	unset($params['order']);
    	unset($params['asc']);
    	unset($params['favorites']);
    
    	 
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	$category_structure = $Structure_Manager->loadCategoryStructure();
    
    	//print_r($params);
    	if($params['topic_id']!=''){
    		if(!$params['admin']){
    			if($this->cityTopicUrlFind($_SERVER['REQUEST_URI'])){
    				$p=parse_url($_SERVER['REQUEST_URI']);
    				unset($params['city_id']);
    				unset($params['topic_id']);
    				unset($pager_params['city_id']);
    				unset($pager_params['topic_id']);
    				$pageurl=trim($p['path'],'/');
    			}elseif($category_structure['catalog'][$params['topic_id']]['url']!='' && 1==$this->getConfigValue('apps.seo.level_enable')){
    				$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
    				//unset($pager_params['topic_id']);
    				unset($params['topic_id']);
    			}elseif($category_structure['catalog'][$params['topic_id']]['url']!=''){
    				//echo 1;
    				$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
    				unset($pager_params['topic_id']);
    				unset($params['topic_id']);
    			}else{
    				if(preg_match('/topic(\d*).html/',$_SERVER['REQUEST_URI'])){
    					unset($pager_params['topic_id']);
    				}
    				if($params['topic_id']!=0){
    					$pageurl='topic'.$params['topic_id'].'.html';
    					unset($params['topic_id']);
    				}else{
    					$pageurl='';
    					unset($params['topic_id']);
    					unset($pager_params['topic_id']);
    				}
    				/*$pageurl='topic'.$params['topic_id'].'.html';
    				 unset($pager_params['topic_id']);
    				unset($params['topic_id']);*/
    			}
    		}else{
    			$pageurl='';
    		}
    	}else{
    		$pageurl='';
    	}
    	$this->template->assert('pager', $this->get_page_links_list ($page, $total, $limit, $pager_params ));
    	 
    	 
    	 
    
    	foreach ( $params as $key => $value ) {
    		if(is_array($value)){
    			if(count($value)>0){
    				foreach($value as $v){
    					if($v!=''){
    						$pairs[] = $key.'[]='.$v;
    					}
    				}
    			}
    		}elseif ( $value != '') {
    			if($key!='topic_id'){
    				//echo "key = $key, value = $value<br>";
    				$pairs[] = "$key=$value";
    			}elseif($params['admin']){
    				$pairs[] = "$key=$value";
    			}
    
    		}
    	}
    
    	if ( is_array($pairs) ) {
    		$url = $pageurl.'?'.implode('&', $pairs);
    	}else{
    		$url = $pageurl.'?key=value';
    	}
    	$this->template->assert('url', $url);
    	
    
    
    	/*if ( $this->getConfigValue('apps.company.timelimit') ) {
    		$query = "SELECT ".implode(',',$select_what)." FROM re_data ".$query_join." ".$add_from_table." ".$where_statement." ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    		
    	} else {
    		$query = "SELECT ".implode(',',$select_what)." FROM re_data ".$query_join." ".$add_from_table." ".$where_statement." ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    	}*/
    	
    	$query = "SELECT ".implode(',',$select_what)." FROM re_data ".$query_join." ".$add_from_table." ".$where_statement." ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    	//echo $query.'<br>';
    	$this->db->exec($query);
    	if ( !$this->db->success ) {
    		echo $this->db->error.'<br>';
    	}
    
    	$ra = array();
    	$i = 0;
    	if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
    		$Account = new Account;
    
    	}
    
    	while ( $this->db->fetch_assoc() ) {
    		if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
    			$company_profile = $Account->get_company_profile($this->db->row['user_id']);
    			
    			$this->db->row['company'] = $company_profile['name']['value'];
    		}
    		$ra[$i] = $this->db->row;
    		$i++;
    	}
    	 
    	
    
    
    	
    	$params = array();
    	
    	 
    	if($this->getConfigValue('apps.mapviewer.enable')){
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/mapviewer/admin/admin.php';
    		$Map_Viewer=new mapviewer_admin();
    		$coords_info=$Map_Viewer->loadMVData();
    	}else{
    		$coords_info=array();
    	}
    
    
    	foreach ( $ra as $item_id => $item_array ) {
    		$params['topic_id'] = $item_array['topic_id'];
    
    		$ra[$item_id]['path'] = $this->get_category_breadcrumbs_string( $params, $category_structure );
    		$ra[$item_id]['date'] = date('d.m',strtotime($ra[$item_id]['date_added']));
    
    
    		$image_array = $data_model->get_image_array ( 'data', 'data', 'id', $item_array['id'], 1 );
    		if ( count($image_array) > 0 ) {
    			$ra[$item_id]['img'] = $image_array;
    		}
    
    
    		if(1==$this->getConfigValue('apps.seo.level_enable')){
    			 
    			if($category_structure['catalog'][$ra[$item_id]['topic_id']]['url']!=''){
    				$ra[$item_id]['parent_category_url']=$category_structure['catalog'][$ra[$item_id]['topic_id']]['url'].'/';
    			}else{
    				$ra[$item_id]['parent_category_url']='';
    			}
    		}else{
    			$ra[$item_id]['parent_category_url']='';
    		}
    		if(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
    			$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'].'.html';
    		}elseif(1==$this->getConfigValue('apps.seo.data_alias_enable')){
    			
    		}else{
    			$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'];
    		}
    
    		if(isset($coords_info[$item_array['id']])){
    			$ra[$item_id]['mvdata']=$coords_info[$item_array['id']];
    		}
    
    
    		
    
    	}
    	
    
    	
    	return $ra;
    }
    
    function get_sitebill_adv_ext2( $params, $random = false ) {
    	//require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/querybuilder/querybuilder.php';
    	$QB=new Query_Builder();
    	$QB->addSelectFrom(DB_PREFIX.'_data');
    	$QB->addSelectWhat(DB_PREFIX.'_data.*');
    	$QB->addSelectWhat(DB_PREFIX.'_topic.name AS topic');
    	$QB->addSelectWhat(DB_PREFIX.'_city.name AS city');
    	$QB->addSelectWhat(DB_PREFIX.'_street.name AS street');
    	$QB->addSelectWhat(DB_PREFIX.'_district.name AS district');
    	$QB->addLeftJoin(DB_PREFIX.'_topic', DB_PREFIX.'_topic.id='.DB_PREFIX.'_data.topic_id');
    	$QB->addLeftJoin(DB_PREFIX.'_city', DB_PREFIX.'_city.city_id='.DB_PREFIX.'_data.city_id');
    	$QB->addLeftJoin(DB_PREFIX.'_street', DB_PREFIX.'_street.street_id='.DB_PREFIX.'_data.street_id');
    	$QB->addLeftJoin(DB_PREFIX.'_district', DB_PREFIX.'_district.id='.DB_PREFIX.'_data.district_id');
    	 
    	echo $QB->build();
    	 
    	if ( $this->getConfigValue('currency_enable') ) {
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/currency/admin/admin.php';
    		$CM=new currency_admin();
    	}
    
    	$this->grid_total = 0;
    	$where_array = false;
    
    	if ( $params['order'] == 'city' ) {
    		 
    		$where_array[] = 're_city.city_id=re_data.city_id';
    		$add_from_table .= ' , re_city ';
    		$add_select_value .= ' , re_city.name as city ';
    	}
    
    	if ( $params['order'] == 'district' ) {
    		$where_array[] = 're_district.id=re_data.district_id';
    		$add_from_table .= ' , re_district ';
    		$add_select_value .= ' , re_district.name as district ';
    	}
    
    	if ( $params['order'] == 'metro' ) {
    		$where_array[] = 're_metro.metro_id=re_data.metro_id';
    		$add_from_table .= ' , re_metro ';
    		$add_select_value .= ' , re_metro.name as metro ';
    	}
    
    	if ( $params['order'] == 'street' ) {
    		$where_array[] = 're_street.street_id=re_data.street_id';
    		$add_from_table .= ' , re_street ';
    		$add_select_value .= ' , re_street.name as street ';
    	}
    
    
    	if(isset($params['favorites']) && !empty($params['favorites'])){
    		$QB->addCondition(DB_PREFIX.'_data.id', 'in', $params['favorites']);
    		$where_array[] = 're_data.id IN ('.implode(',',$params['favorites']).')';
    	}
    
    	 
    
    	if(isset($params['optype'])){
    		$QB->addCondition(DB_PREFIX.'_data.optype', 'eq', (int)$params['optype']);
    		$where_array[] = DB_PREFIX.'_data.optype='.(int)$params['optype'];
    	}
    
    	$where_array[] = 're_topic.id=re_data.topic_id';
    
    	//echo '$params[\'topic_id\'] = '.$params['topic_id'].'<br>';
    
    	if ( $params['topic_id'] != '' &&  $params['topic_id'] != 0) {
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    		$Structure_Manager = new Structure_Manager();
    		$category_structure = $Structure_Manager->loadCategoryStructure();
    		global $smarty;
    		//echo $category_structure['catalog'][$params['topic_id']]['description'];
    		$smarty->assign('topic_description', $category_structure['catalog'][$params['topic_id']]['description']);
    
    		$childs = $Structure_Manager->get_all_childs($params['topic_id'], $category_structure);
    		if ( count($childs) > 0 ) {
    			array_push($childs, $params['topic_id']);
    			$where_array[] = 're_data.topic_id in ('.implode(' , ',$childs).') ';
    			$QB->addCondition(DB_PREFIX.'_data.topic_id', 'in', $childs);
    		} else {
    			$where_array[] = 're_data.topic_id='.$params['topic_id'];
    			$QB->addCondition(DB_PREFIX.'_data.topic_id', 'eq', $params['topic_id']);
    		}
    		//print_r($params);
    	}
    
    	if ( isset($params['country_id']) and $params['country_id'] != 0  ) {
    		$where_array[] = 're_data.country_id = '.$params['country_id'];
    		$QB->addCondition(DB_PREFIX.'_data.country_id', 'eq', $params['country_id']);
    	}else{
    		unset($params['country_id']);
    	}
    
    	if ( isset($params['id']) and $params['id'] != 0  ) {
    		$where_array[] = 're_data.id = '.$params['id'];
    		$QB->addCondition(DB_PREFIX.'_data.id', 'eq', $params['id']);
    	}
    
    	if ( isset($params['mvids']) && is_array($params['mvids']) && count($params['mvids']) != 0  ) {
    		$where_array[] = 're_data.id IN ('.implode(',',$params['mvids']).')';
    	}
    
    
    	if ( isset($params['user_id']) && $params['user_id'] > 0  ) {
    		$where_array[] = 're_data.user_id = '.$params['user_id'];
    		$QB->addCondition(DB_PREFIX.'_data.user_id', 'eq', $params['user_id']);
    	}
    
    	if ( isset($params['onlyspecial']) && $params['onlyspecial'] > 0  ) {
    		$where_array[] = 're_data.hot = 1';
    		$QB->addCondition(DB_PREFIX.'_data.hot', 'eq', 1);
    	}
    
    
    	if ( isset($params['price']) && $params['price'] != 0  ) {
    		$where_array[] = 're_data.price  <= '.$params['price'];
    		$QB->addCondition(DB_PREFIX.'_data.price', '<=', $params['price']);
    	}
    
    	if ( isset($params['price_min']) && $params['price_min'] != 0  ) {
    		$where_array[] = 're_data.price  >= '.$params['price_min'];
    		$QB->addCondition(DB_PREFIX.'_data.price', '>=', $params['price_min']);
    	}
    
    	if ( isset($params['house_number']) && $params['house_number'] != 0  ) {
    		$where_array[] = 're_data.number  = \''.$params['house_number'].'\'';
    		$QB->addCondition(DB_PREFIX.'_data.number', '=', $params['house_number']);
    	}else{
    		unset($params['house_number']);
    	}
    
    
    	if ( isset($params['region_id']) && $params['region_id'] != 0 ) {
    		$where_array[] = 're_data.region_id = '.$params['region_id'];
    		$QB->addCondition(DB_PREFIX.'_data.region_id', '=', $params['region_id']);
    	}else{
    		unset($params['region_id']);
    	}
    
    	if ( isset($params['spec']) ) {
    		$where_array[] = ' re_data.hot = 1 ';
    		$QB->addCondition(DB_PREFIX.'_data.hot', '=', 1);
    	}
    	if ( isset($params['hot']) ) {
    		$where_array[] = ' re_data.hot = 1 ';
    		$QB->addCondition(DB_PREFIX.'_data.hot', '=', 1);
    	}
    	if ( isset($params['city_id']) and $params['city_id'] != 0  ) {
    		$where_array[] = 're_data.city_id = '.$params['city_id'];
    		$QB->addCondition(DB_PREFIX.'_data.city_id', '=', $params['city_id']);
    	}
    	if ( isset($params['district_id']) and $params['district_id'] != 0  ) {
    		$where_array[] = 're_data.district_id = '.$params['district_id'];
    		$QB->addCondition(DB_PREFIX.'_data.district_id', '=', $params['district_id']);
    	}else{
    		unset($params['district_id']);
    	}
    	if ( isset($params['metro_id']) and $params['metro_id'] != 0  ) {
    		$where_array[] = 're_data.metro_id = '.$params['metro_id'];
    		$QB->addCondition(DB_PREFIX.'_data.metro_id', '=', $params['metro_id']);
    	}else{
    		unset($params['metro_id']);
    	}
    	if ( isset($params['street_id']) and $params['street_id'] != 0  ) {
    		$where_array[] = 're_data.street_id = '.$params['street_id'];
    		$QB->addCondition(DB_PREFIX.'_data.street_id', '=', $params['street_id']);
    	}else{
    		unset($params['street_id']);
    	}
    	////////////  OR
    	if(isset($params['srch_phone']) and $params['srch_phone'] !== NULL){
    		$phone = preg_replace('/[^\d]/', '', $params['srch_phone']);
    		$sub_where=array();
    		if($this->getConfigValue('allow_additional_mobile_number')){
    			$sub_where[] = '(re_data.ad_mobile_phone LIKE \'%'.$phone.'%\')';
    			$QB->addCondition(DB_PREFIX.'_data.ad_mobile_phone', 'like', '%'.$phone.'%');
    		}
    		if($this->getConfigValue('allow_additional_stationary_number')){
    			$sub_where[] = '(re_data.ad_stacionary_phone LIKE \'%'.$phone.'%\')';
    			$QB->addCondition(DB_PREFIX.'_data.ad_stacionary_phone', 'like', '%'.$phone.'%');
    		}
    		$sub_where[] = '(re_data.phone LIKE \'%'.$phone.'%\')';
    		$where_array[]='('.implode(' OR ',$sub_where).')';
    	}
    	////////////  OR
    	if(isset($params['srch_word']) and $params['srch_word'] !== NULL){
    		$sub_where=array();
    		$word=htmlspecialchars($params['srch_word']);
    		$sub_where[] = '(re_data.text LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more1 LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more2 LIKE \'%'.$word.'%\')';
    		$sub_where[] = '(re_data.more3 LIKE \'%'.$word.'%\')';
    		$where_array[]='('.implode(' OR ',$sub_where).')';
    	}
    
    	if(isset($params['room_count'])){
    		if(is_array($params['room_count']) && count($params['room_count'])>0){
    			$sub_where=array();
    			foreach($params['room_count'] as $rq){
    				if($rq==4){
    					$sub_where[]='room_count>3';
    				}elseif(0!=(int)$rq){
    					$sub_where[]='room_count='.(int)$rq;
    				}
    			}
    			if(count($sub_where)>0){
    				$where_array[]='('.implode(' OR ',$sub_where).')';
    			}
    		}else{
    			unset($params['room_count']);
    		}
    	}
    
    	if($params['srch_date_from']!=0 && $params['srch_date_to']!=0){
    		$where_array[]="((re_data.date_added>='".$params['srch_date_from']."') AND (re_data.date_added<='".$params['srch_date_to']."'))";
    		$QB->addCondition(DB_PREFIX.'_data.date_added', '>=', $params['srch_date_from']);
    		$QB->addCondition(DB_PREFIX.'_data.date_added', '<=', $params['srch_date_to']);
    	}elseif($params['srch_date_from']!=0){
    		$where_array[]="(re_data.date_added>='".$params['srch_date_from']."')";
    		$QB->addCondition(DB_PREFIX.'_data.date_added', '>=', $params['srch_date_from']);
    	}elseif($params['srch_date_to']!=0){
    		$where_array[]="(re_data.date_added<='".$params['srch_date_to']."')";
    		$QB->addCondition(DB_PREFIX.'_data.date_added', '<=', $params['srch_date_to']);
    	}
    
    	if($params['floor_min']!=0 && $params['floor_max']!=0){
    		$where_array[]="(re_data.floor BETWEEN ".$params['floor_min']." AND ".$params['floor_max'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor', '>=', $params['floor_min']);
    		$QB->addCondition(DB_PREFIX.'_data.floor', '<=', $params['floor_max']);
    	}elseif($params['floor_min']!=0){
    		$where_array[]="(re_data.floor>=".$params['floor_min'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor', '>=', $params['floor_min']);
    	}elseif($params['floor_max']!=0){
    		$where_array[]="(re_data.floor<=".$params['floor_max'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor', '<=', $params['floor_max']);
    	}
    
    	if($params['floor_count_min']!=0 && $params['floor_count_max']!=0){
    		$where_array[]="(re_data.floor_count BETWEEN ".$params['floor_count_min']." AND ".$params['floor_count_max'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor_count', '>=', $params['floor_count_min']);
    		$QB->addCondition(DB_PREFIX.'_data.floor_count', '<=', $params['floor_count_max']);
    	}elseif($params['floor_count_min']!=0){
    		$where_array[]="(re_data.floor_count>=".$params['floor_count_min'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor_count', '>=', $params['floor_count_min']);
    	}elseif($params['floor_count_max']!=0){
    		$where_array[]="(re_data.floor_count<=".$params['floor_count_max'].")";
    		$QB->addCondition(DB_PREFIX.'_data.floor_count', '<=', $params['floor_count_max']);
    	}
    
    	if($params['square_min']!=0 && $params['square_max']!=0){
    		$where_array[]="(re_data.square_all BETWEEN ".$params['square_min']." AND ".$params['square_max'].")";
    	}elseif($params['square_min']!=0){
    		$where_array[]="(re_data.square_all>=".$params['square_min'].")";
    	}elseif($params['square_max']!=0){
    		$where_array[]="(re_data.square_all<=".$params['square_max'].")";
    	}
    
    	if($params['is_phone']==1){
    		$where_array[]="(re_data.is_telephone=1)";
    	}else{
    		unset($params['is_phone']);
    	}
    
    	if($params['is_internet']==1){
    		$where_array[]="(re_data.is_internet=1)";
    	}else{
    		unset($params['is_internet']);
    	}
    
    	if($params['is_furniture']==1){
    		$where_array[]="(re_data.furniture=1)";
    	}else{
    		unset($params['is_furniture']);
    	}
    
    	if($params['owner']==1){
    		$where_array[]="(re_data.whoyuaare=1)";
    	}else{
    		unset($params['is_furniture']);
    	}
    
    	if($params['has_photo']==1){
    		$where_array[]='((SELECT COUNT(*) FROM '.DB_PREFIX.'_data_image WHERE id='.DB_PREFIX.'_data.id)>0)';
    	}else{
    		unset($params['has_photo']);
    	}
    
    	if($params['infra_greenzone']==1){
    		$where_array[]="(re_data.infra_greenzone=1)";
    	}else{
    		unset($params['infra_greenzone']);
    	}
    
    	if($params['infra_sea']==1){
    		$where_array[]="(re_data.infra_sea=1)";
    	}else{
    		unset($params['infra_sea']);
    	}
    
    	if($params['infra_sport']==1){
    		$where_array[]="(re_data.infra_sport=1)";
    	}else{
    		unset($params['infra_sport']);
    	}
    
    	if($params['infra_clinic']==1){
    		$where_array[]="(re_data.infra_clinic=1)";
    	}else{
    		unset($params['infra_clinic']);
    	}
    
    	if($params['infra_terminal']==1){
    		$where_array[]="(re_data.infra_terminal=1)";
    	}else{
    		unset($params['infra_terminal']);
    	}
    
    	if($params['infra_airport']==1){
    		$where_array[]="(re_data.infra_airport=1)";
    	}else{
    		unset($params['infra_airport']);
    	}
    
    	if($params['infra_bank']==1){
    		$where_array[]="(re_data.infra_bank=1)";
    	}else{
    		unset($params['infra_bank']);
    	}
    
    	if($params['infra_restaurant']==1){
    		$where_array[]="(re_data.infra_restaurant=1)";
    	}else{
    		unset($params['infra_restaurant']);
    	}
    
    	if(isset($params['object_state']) && is_array($params['object_state']) && count($params['object_state'])>0){
    		$where_array[]="(re_data.object_state IN (".implode(',', $params['object_state'])."))";
    	}else{
    		unset($params['object_state']);
    	}
    
    	if(isset($params['object_type']) && is_array($params['object_type']) && count($params['object_type'])>0){
    		$where_array[]="(re_data.object_type IN (".implode(',', $params['object_type'])."))";
    	}else{
    		unset($params['object_type']);
    	}
    
    	if(isset($params['object_destination']) && is_array($params['object_destination']) && count($params['object_destination'])>0){
    		$where_array[]="(re_data.object_destination IN (".implode(',', $params['object_destination'])."))";
    	}else{
    		unset($params['object_destination']);
    	}
    
    	if(isset($params['aim']) && is_array($params['aim']) && count($params['aim'])>0){
    		$where_array[]="(re_data.aim IN (".implode(',', $params['aim'])."))";
    	}else{
    		unset($params['aim']);
    	}
    
    	if($params['has_geo']==1){
    		$where_array[]='('.DB_PREFIX.'_data.geo_lat IS NOT NULL AND '.DB_PREFIX.'_data.geo_lng IS NOT NULL)';
    	}
    
    
    	/*
    	 if ($_SERVER['REQUEST_URI'] == '/')
    		$order = "re_data.id desc";
    	else
    		$order = "re_data.date_added desc";
    	*/
    	if ( $params['admin'] != 1 ) {
    		$where_array[] = 're_data.active=1';
    	} elseif ( $params['active'] == 1 ) {
    		$where_array[] = 're_data.active=1';
    	} elseif ( $params['active'] == 'notactive' ) {
    		$where_array[] = 're_data.active=0';
    	}
    
    	if ( $this->getConfigValue('apps.company.timelimit') ) {
    		$current_time = time();
    
    		$where_array[] = 're_data.user_id=u.user_id';
    		$where_array[] = 'u.company_id=c.company_id';
    		$where_array[] = "c.start_date <= $current_time";
    		$where_array[] = "c.end_date >= $current_time";
    		$add_from_table .= ' , re_user u, re_company c ';
    	}
    
    	if ( $params['only_img'] ) {
    		 
    		$where_array[] = 're_data.id=i.id';
    		$add_from_table .= ' , re_data_image i ';
    	}
    
    
    	if ( $where_array ) {
    		$where_statement = " WHERE ".implode(' AND ', $where_array);
    	}
    
    	if ( isset($params['order']) ) {
    
    		if ( !isset($params['asc']) ) {
    			$asc = 'desc';
    		}
    		if ($params['asc'] == 'asc')  {
    			$asc = 'asc';
    		}elseif ($params['asc'] == 'desc') {
    			$asc = 'desc';
    		}else{
    			$asc = 'desc';
    		}
    		//
    		if     ( $params['order'] == 'type' ) $order = 'type_sh ';
    		elseif ( $params['order'] == 'street' ) $order = 're_street.name ';
    		elseif ( $params['order'] == 'district' ) $order = 're_district.name ';
    		elseif ( $params['order'] == 'metro' ) $order = 're_metro.name ';
    		elseif ( $params['order'] == 'city' ) $order = 're_city.name ';
    		elseif ( $params['order'] == 'date_added' ) $order = 're_data.date_added ';
    		elseif ( $params['order'] == 'price' ){
    			$order = 'price ';
    		}
    
    		$order .= $asc;
    	} else {
    		//$order = "re_data.id desc";
    		$order = "re_data.date_added DESC, re_data.id DESC";
    	}
    
    	if ( !isset($params['page']) or $params['page'] == 0 ) {
    		$page = 1;
    	} else {
    		$page = $params['page'];
    	}
    
    
    	if ( $random ) {
    		$order = ' rand() ';
    	}
    
    	if ( $this->getConfigValue('currency_enable') ) {
    		$query = "select count(re_data.id) as total from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ";
    	}else{
    		$query = "select count(re_data.id) as total from re_data, re_topic $add_from_table $where_statement ";
    	}
    
    	$query1='SELECT COUNT('.DB_PREFIX.'_data.id) as total FROM '.DB_PREFIX.'_data d
				LEFT JOIN '.DB_PREFIX.'_topic t ON t.id=d.topic_id';
    
    	//$query = "select count(re_data.id) as total from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ";
    	//echo $query.'<br>';
    
    	$this->db->exec($query);
    	if ( !$this->db->success ) {
    		echo $this->db->error.'<br>';
    	}
    	$this->db->fetch_assoc();
    	$total = $this->db->row['total'];
    	$this->grid_total = $total;
    	global $smarty;
    	$smarty->assign('_total_records',$total);
    
    	//echo "total = $total<br>";
    	$limit = $this->getConfigValue('per_page');
    	$max_page=ceil($total/$limit);
    	//echo "max_page = $max_page<br>";
    	if($page>$max_page){
    		$page=1;
    		$params['page']=1;
    	}
    
    	$start = ($page-1)*$limit;
    
    	$pager_params=$params;
    	//print_r($pager_params);
    	 
    	unset($params['order']);
    	unset($params['asc']);
    	unset($params['favorites']);
    
    	 
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	$category_structure = $Structure_Manager->loadCategoryStructure();
    
    	//print_r($params);
    	if($params['topic_id']!=''){
    		if(!$params['admin']){
    			if($this->cityTopicUrlFind($_SERVER['REQUEST_URI'])){
    				$p=parse_url($_SERVER['REQUEST_URI']);
    				unset($params['city_id']);
    				unset($params['topic_id']);
    				unset($pager_params['city_id']);
    				unset($pager_params['topic_id']);
    				$pageurl=trim($p['path'],'/');
    			}elseif($category_structure['catalog'][$params['topic_id']]['url']!='' && 1==$this->getConfigValue('apps.seo.level_enable')){
    				$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
    				//unset($pager_params['topic_id']);
    				unset($params['topic_id']);
    			}elseif($category_structure['catalog'][$params['topic_id']]['url']!=''){
    				//echo 1;
    				$pageurl=$category_structure['catalog'][$params['topic_id']]['url'];
    				unset($pager_params['topic_id']);
    				unset($params['topic_id']);
    			}else{
    				if(preg_match('/topic(\d*).html/',$_SERVER['REQUEST_URI'])){
    					unset($pager_params['topic_id']);
    				}
    				if($params['topic_id']!=0){
    					$pageurl='topic'.$params['topic_id'].'.html';
    					unset($params['topic_id']);
    				}else{
    					$pageurl='';
    					unset($params['topic_id']);
    					unset($pager_params['topic_id']);
    				}
    				/*$pageurl='topic'.$params['topic_id'].'.html';
    				 unset($pager_params['topic_id']);
    				unset($params['topic_id']);*/
    			}
    		}else{
    			$pageurl='';
    		}
    	}else{
    		$pageurl='';
    	}
    	$this->template->assert('pager', $this->get_page_links_list ($page, $total, $limit, $pager_params ));
    	 
    	 
    	 
    
    	foreach ( $params as $key => $value ) {
    		if(is_array($value)){
    			if(count($value)>0){
    				foreach($value as $v){
    					if($v!=''){
    						$pairs[] = $key.'[]='.$v;
    					}
    				}
    			}
    		}elseif ( $value != '') {
    			if($key!='topic_id'){
    				//echo "key = $key, value = $value<br>";
    				$pairs[] = "$key=$value";
    			}elseif($params['admin']){
    				$pairs[] = "$key=$value";
    			}
    
    		}
    	}
    
    	if ( is_array($pairs) ) {
    		$url = $pageurl.'?'.implode('&', $pairs);
    	}else{
    		$url = $pageurl.'?key=value';
    	}
    	$this->template->assert('url', $url);
    
    
    	if ( $this->getConfigValue('apps.company.timelimit') ) {
    		if ( $this->getConfigValue('currency_enable') ) {
    			$query = "select re_currency.code AS currency_code, re_currency.name AS currency_name, ((re_data.price*re_currency.course)/".$CM->getCourse(CURRENT_CURRENCY).") AS price_ue, re_data.*, re_topic.name as type_sh $add_select_value from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    		} else {
    			$query = "select re_data.*, re_topic.name as type_sh $add_select_value from re_data, re_topic $add_from_table $where_statement order by ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    		}
    		//echo $query.'<br>';
    	} else {
    		if ( $this->getConfigValue('currency_enable') ) {
    			$query = "select re_currency.code AS currency_code, re_currency.name AS currency_name, ((re_data.price*re_currency.course)/".$CM->getCourse(CURRENT_CURRENCY).") AS price_ue, re_data.*, re_topic.name as type_sh $add_select_value from re_data LEFT JOIN re_currency ON re_data.currency_id=re_currency.currency_id, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    		} else {
    			$query = "select re_data.*, re_topic.name as type_sh $add_select_value from re_data, re_topic $add_from_table $where_statement ORDER BY ".$order.($params['no_portions']==1 ? '' : " LIMIT ".$start.", ".$limit);
    		}
    	}
    	//echo $query."<br>";
    	$this->db->exec($query);
    	if ( !$this->db->success ) {
    		echo $this->db->error.'<br>';
    	}
    
    	$ra = array();
    	$i = 0;
    	if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
    		$Account = new Account;
    
    	}
    
    	while ( $this->db->fetch_assoc() ) {
    		if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/company/company.xml') ) {
    			$company_profile = $Account->get_company_profile($this->db->row['user_id']);
    			//echo '<pre>';
    			//print_r($company_profile);
    			//echo '</pre>';
    			$this->db->row['company'] = $company_profile['name']['value'];
    		}
    		$ra[$i] = $this->db->row;
    		$i++;
    	}
    	 
    	//require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	//$Structure_Manager = new Structure_Manager();
    	//$category_structure = $Structure_Manager->loadCategoryStructure();
    
    
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
    	$data_model = new Data_Model();
    	$params = array();
    	//echo '<pre>';
    	//print_r($ra);
    	/*
    	 if($this->getConfigValue('apps.agentphones.enable')==1){
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/agentphones/admin/admin.php');
    	$AP=new agentphones_admin();
    	$AP->init();
    	}else{
    	$AP=NULL;
    	}
    	*/
    	 
    	if($this->getConfigValue('apps.mapviewer.enable')){
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/mapviewer/admin/admin.php';
    		$Map_Viewer=new mapviewer_admin();
    		$coords_info=$Map_Viewer->loadMVData();
    	}else{
    		$coords_info=array();
    	}
    
    
    	foreach ( $ra as $item_id => $item_array ) {
    		if ( $item_array['country_id'] > 0 ) {
    			$ra[$item_id]['country'] = $data_model->get_string_value_by_id('country', 'country_id', 'name', $item_array['country_id'], true);
    		}
    		if ( $item_array['region_id'] > 0 ) {
    			$ra[$item_id]['region'] = $data_model->get_string_value_by_id('region', 'region_id', 'name', $item_array['region_id'], true);
    		}
    		if ( $item_array['district_id'] > 0 ) {
    			$ra[$item_id]['district'] = $data_model->get_string_value_by_id('district', 'id', 'name', $item_array['district_id'], true);
    		}
    		if ( $item_array['street_id'] > 0 ) {
    			$ra[$item_id]['street'] = $data_model->get_string_value_by_id('street', 'street_id', 'name', $item_array['street_id'], true);
    		}
    		if ( $item_array['city_id'] > 0 ) {
    			$ra[$item_id]['city'] = $data_model->get_string_value_by_id('city', 'city_id', 'name', $item_array['city_id'], true);
    		}
    		if ( $item_array['metro_id'] > 0 ) {
    			$ra[$item_id]['metro'] = $data_model->get_string_value_by_id('metro', 'metro_id', 'name', $item_array['metro_id'], true);
    		}
    		if ( $item_array['user_id'] > 0 ) {
    			$ra[$item_id]['user'] = $data_model->get_string_value_by_id('user', 'user_id', 'fio', $item_array['user_id'], true);
    		}
    		if ( $item_array['currency_id'] > 0 ) {
    			$ra[$item_id]['currency'] = $data_model->get_string_value_by_id('currency', 'currency_id', 'code', $item_array['currency_id'], true);
    			//$ra[$item_id]['currency_name'] = $data_model->get_string_value_by_id('currency', 'currency_id', 'name', $item_array['currency_id'], true);
    		}
    
    		$params['topic_id'] = $item_array['topic_id'];
    
    		$ra[$item_id]['path'] = $this->get_category_breadcrumbs_string( $params, $category_structure );
    		$ra[$item_id]['date'] = date('d.m',strtotime($ra[$item_id]['date_added']));
    
    
    		$image_array = $data_model->get_image_array ( 'data', 'data', 'id', $item_array['id'], 1 );
    		if ( count($image_array) > 0 ) {
    			$ra[$item_id]['img'] = $image_array;
    		}
    
    
    		if(1==$this->getConfigValue('apps.seo.level_enable')){
    			 
    			if($category_structure['catalog'][$ra[$item_id]['topic_id']]['url']!=''){
    				$ra[$item_id]['parent_category_url']=$category_structure['catalog'][$ra[$item_id]['topic_id']]['url'].'/';
    			}else{
    				$ra[$item_id]['parent_category_url']='';
    			}
    		}else{
    			$ra[$item_id]['parent_category_url']='';
    		}
    		if(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
    			$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'].'.html';
    		}else{
    			$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].'realty'.$ra[$item_id]['id'];
    		}
    
    		if(isset($coords_info[$item_array['id']])){
    			$ra[$item_id]['mvdata']=$coords_info[$item_array['id']];
    		}
    
    
    		/*
    		 if($AP!==NULL){
    		$phones=array();
    		$phones[]=$ra[$item_id]['phone'];
    		if($this->getConfigValue('allow_additional_mobile_number')==1 && $ra[$item_id]['ad_mobile_phone']!=''){
    		$phones[]=$ra[$item_id]['ad_mobile_phone'];
    		}
    		if($this->getConfigValue('allow_additional_stationary_number')==1 && $ra[$item_id]['ad_stacionary_phone']!=''){
    		$phones[]=$ra[$item_id]['ad_stacionary_phone'];
    		}
    		$phone_check=$AP->checkCoincidence($phones,$ra[$item_id]['id']);
    		//print_r($phone_check);
    		$ra[$item_id]['check_result']=$phone_check;
    		}
    		*/
    
    	}
    	//echo '<pre>';
    	//print_r($ra);
    	//echo '</pre>';
    
    	echo '<br /><br />'.$QB->build().'<br /><br />';
    	return $ra;
    }
    
    /**
     * Get sales grid
     * @param array $adv res
     * @return string
     */
    function get_sales_grid ( $adv ) {
        global $topic_id;

        if ( $this->getConfigValue('theme') != 'estate' and !file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/realty_grid.tpl') ) {
            $this->template->assign('main_file_tpl', '../estate/realty_grid.tpl');
        } else {
		
            $this->template->assign('main_file_tpl', 'realty_grid.tpl');
        }
        $this->template->assign('grid_items', $adv);

        return true;
    }
}
?>
