<?php
/**
 * Kvartira view
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Kvartira_View extends SiteBill {
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
    }
    
    /**
     * Main
     * @param int $realty_id realty id
     * @return mixed
     */
    function main ( $realty_id ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
        
        
        
        
        $Structure_Manager = new Structure_Manager();
        $category_structure = $Structure_Manager->loadCategoryStructure();
        $user_object_manager = new User_Object_Manager();

        $data_model = new Data_Model();
        $form_data = $data_model->get_kvartira_model(false);
        
        $form_data['data']['fio']['name'] = 'fio';
		$form_data['data']['fio']['title'] = Multilanguage::_('L_FIO');
		$form_data['data']['fio']['value'] = '';
		$form_data['data']['fio']['length'] = 40;
		$form_data['data']['fio']['type'] = 'safe_string';
		$form_data['data']['fio']['required'] = 'on';
		$form_data['data']['fio']['unique'] = 'off';
		
	    $form_data['data']['phone']['name'] = 'phone';
		$form_data['data']['phone']['title'] = Multilanguage::_('L_PHONE');
		$form_data['data']['phone']['value'] = '';
		$form_data['data']['phone']['length'] = 40;
		$form_data['data']['phone']['type'] = 'safe_string';
		$form_data['data']['phone']['required'] = 'on';
		$form_data['data']['phone']['unique'] = 'off';
		
		if ( $this->getConfigValue('theme') == 'etown' or $this->getConfigValue('theme') == 'domdizart' ) {
			$form_data['data']['url']['name'] = 'url';
			$form_data['data']['url']['title'] = Multilanguage::_('URL_NAME','system');
			$form_data['data']['url']['value'] = '';
			$form_data['data']['url']['length'] = 40;
			$form_data['data']['url']['type'] = 'safe_string';
			$form_data['data']['url']['required'] = 'off';
			$form_data['data']['url']['unique'] = 'off';
		}
		
		if($this->getConfigValue('more_fields_in_lk')==1){
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/data/user_data.php');
			$UDM=new User_Data_Manager();
			$form_data=$UDM->init_more_fields($form_data);
			$this->template->assign('see_my_fields', '1');
		}
		
		
        
        
        $form_user = $user_object_manager->get_user_model();
        
        $form_data = $data_model->init_model_data_from_db ( 'data', 'id', $realty_id, $form_data['data'], true );

        
        
        $topic_id=0;
        if(isset($form_data['topic_id'])){
        	$topic_id=(int)$form_data['topic_id']['value'];
        }
        
        if($topic_id!=0){
        	//require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        	//$SM=new Structure_Manager();
        	//$category_structure=$SM->loadCategoryStructure();
        
	        foreach ( $form_data as $key => $item_array ) {
	        	
	        	if($topic_id!=0 && isset($item_array['active_in_topic']) && $item_array['active_in_topic']!=0){
	        		$active_array_ids = explode(',',$item_array['active_in_topic']);
	        		$child_cats = array();
	        		foreach ($active_array_ids as $item_id => $check_active_id) {
	        			//echo '$check_active_id = '.$check_active_id.'<br>';
	        			$child_cats_compare = $Structure_Manager->get_all_childs($check_active_id, $category_structure);
	        			if ( is_array($child_cats_compare) ) {
	        				$child_cats = array_merge($child_cats, $child_cats_compare);
	        			}
	        			$child_cats[]=$check_active_id;
	        
	        		}
	        		
	        			        
	        		if(!in_array($topic_id, $child_cats)){
	        			unset($form_data[$key]);
	        			continue;
	        		}
	        	}
	        }
        }
        
        /*echo '<pre>';
        print_r($form_data);
        echo '</pre>';*/
        
    	if ( !$form_data ) {
    		header("Status: 404 Not Found");
    		$this->template->assign('title', Multilanguage::_('L_MESSAGE_PAGE_NOT_FOUND'));
    		$this->template->assign('error_message', '<h1>'.Multilanguage::_('L_MESSAGE_PAGE_NOT_FOUND').'</h1>');
        	$this->template->assign('main_file_tpl', 'error_message.tpl');
        	return false;
        }
        
        if($this->getConfigValue('apps.realtypro.show_contact.enable')){
        	$form_user = $data_model->init_model_data_from_db ( 'user', 'user_id', $form_data['user_id']['value'], $form_user['user'], true);
        }else{
        	$form_user = $data_model->init_model_data_from_db ( 'user', 'user_id', $form_data['user_id']['value'], $form_user['user'], true);
        }
        
       
        
        if(isset($form_data['date_added']) && $form_data['date_added']['value']!=''){
        	$form_data['date_added']['value_string']=date('d-m-Y', strtotime($form_data['date_added']['value']));
        }
		
		
       	
        if ( $this->getConfigValue('apps.company.timelimit') ) {
        	//check timelimit for this company
        	$current_time = time();
        	$query = "select re_data.* from re_data, re_user u, re_company c where re_data.id=$realty_id and re_data.user_id=u.user_id and u.company_id=c.company_id and c.start_date <= $current_time and c.end_date >= $current_time";
        	$this->db->exec($query);
        	$this->db->fetch_assoc();
        	if ( $this->db->row['id'] == '' ) {
        		$this->template->assign('error_message', Multilanguage::_('L_MESSAGE_ARCHIVED_AD'));
        		$this->template->assign('main_file_tpl', 'error_message.tpl');
        		return false;
        	}
        	 
        }
        if ( $this->getConfigValue('apps.company.enable') ) {
        	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/company/admin/admin.php');
        	$company_admin = new company_admin();
       		$company_profile = $company_admin->load_by_id($form_user['company_id']['value']);
       		//print_r($company_profile);
        	if ( $company_profile ) {
        		$this->template->assign('company_profile', $company_profile);
			}
			$this->template->assign('user_company_data', $company_admin->getUserCompanyData($form_user['user_id']['value']));
			
        }
        
        if(isset($form_data['topic_id'])){
        	$form_data['topic_id']['value_string']=$category_structure['catalog'][$form_data['topic_id']['value']]['name'];
        }
        
        
        //$data_view_data=$form_data['booking_hotel'];
    	foreach($form_data as $hvd){
    		if($hvd['tab']==''){
    			$hvd_tabbed[$this->getConfigValue('default_tab_name')][]=$hvd;
    		}else{
    			$hvd_tabbed[$hvd['tab']][]=$hvd;
    		}
    		
    	}
    	
    	$this->template->assert('hvd_tabbed',$hvd_tabbed);
    	
        
        
       require_once SITEBILL_DOCUMENT_ROOT.'/apps/currency/admin/admin.php';
       $CA=new currency_admin();
      // echo $form_data['price']['value']. ' '.$form_data['curency_id']['value'];
	    //$form_data['price']['value']=$CA->convert($form_data['price']['value'], $form_data['currency_id']['value'],CURRENT_CURRENCY);
	    $simparams=array(
	    	'id'=>(int)$form_data['id']['value'],
	    	'topic_id'=>(int)$form_data['topic_id']['value'],
	    	'city_id'=>(int)$form_data['city_id']['value'],
	    	'district_id'=>(int)$form_data['district_id']['value'],
	    	'street_id'=>(int)$form_data['street_id']['value'],
	    );
	    $this->template->assign('similar_data', $this->getSimilar($category_structure,$simparams));
	    
	    $this->template->assign('data', $form_data);
	    
	    if($form_user['login']['value']=='_unregistered'){
	    	$form_user['fio']['value']=$form_data['fio']['value'];
	    	$form_user['phone']['value']=$form_data['phone']['value'];
	    }
	    
	    if($this->getConfigValue('use_google_map')){
			$this->template->assign('map_type', 'google');
		}
	    	  
	    $this->template->assign('current_user_id', $this->getSessionUserId());
	    $this->template->assign('photo', $form_data['image']['image_array']);
	    $this->template->assign('user_data', $form_user);
        $this->template->assign('yandex_map_key', $this->getConfigValue('yandex_map_key'));
        $this->template->assign('pmap', $this->getConfigValue('pmap'));
	    
        
	    
	    $params['topic_id'] = (int)$form_data['topic_id']['value'];
	    
	    $d=$this->get_category_breadcrumbs( $params, $category_structure, SITEBILL_MAIN_URL.'/' );
	    
	    $this->template->assign('realty_breadcrumbs', explode(' / ', $d));
        $this->template->assign('breadcrumbs', $this->get_category_breadcrumbs( $params, $category_structure, SITEBILL_MAIN_URL.'/' ) );
        
        if($form_data['meta_title']['value']==''){
        	$this->template->assign('title', $this->get_category_breadcrumbs_string( $params, $category_structure, SITEBILL_MAIN_URL.'/' ).", ".$form_data['city_id']['value_string'].", ".$form_data['street_id']['value_string'].', '.number_format($form_data['price']['value'],0,',',' ') );
        }else{
        	$this->template->assign('title', $form_data['meta_title']['value']);
        }
        
        if($form_data['meta_description']['value']!=''){
        	$this->template->assign('meta_description', $form_data['meta_description']['value']);
        }
        
        if($form_data['meta_keywords']['value']!=''){
        	$this->template->assign('meta_keywords', $form_data['meta_keywords']['value']);
        }
        
       
        /*
        if($form_data['meta_title']['value']==''){
        	$this->template->assign('title', $form_data['topic_id']['value_string'].", ".$form_data['city_id']['value_string'].", ".$form_data['street_id']['value_string'].', : '.$form_data['price']['value'].' '.($form_data['currency_id']['value_string']=='' ? Multilanguage::_('L_RUR_SHORT') : $form_data['currency_id']['value_string']).' | '.$this->getConfigValue('site_title') );
        }else{
        	$this->template->assign('title', $form_data['meta_title']['value']);
        }
        
        if($form_data['meta_description']['value']!=''){
        	$this->template->assign('meta_description', $form_data['meta_description']['value']);
        }else{
			$this->template->assign('meta_description', $form_data['text']['value'].' '.$this->getConfigValue('site_title'));
		}
        
        if($form_data['meta_keywords']['value']!=''){
        	$this->template->assign('meta_keywords', $form_data['meta_keywords']['value']);
        }else{
			$kw=array();
			

			$kw[]=$this->getConfigValue('meta_keywords_main');
			$kw[]=$form_data['optype']['value_string'];
			$kw[]=$form_data['topic_id']['value_string'];
			$kw[]=$form_data['city_id']['value_string'];
			$kw[]=$form_data['district_id']['value_string'];
			if($form_data['room_count']['value']>0){
				$kw[]=' '.$form_data['room_count']['value'];
			}
			$kw=array_filter($kw);
			if(count($kw)>0){
				$this->template->assign('meta_keywords', implode(', ', $kw));
			}else{
				$this->template->assign('meta_keywords', $this->getConfigValue('meta_keywords_main'));
			}
		}
        */
        if(1==$this->getConfigValue('apps.comment.enable')){
        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/comment/admin/admin.php';
        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/comment/site/site.php';
        	$CoM=new comment_site();
        	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/login.php');
			$Login = new Login();
		   	$user_id=(int)$Login->getSessionUserId();
        	$commentsPanel=$CoM->generateCommentPanel($user_id, 'data', $realty_id);
        }
       
        
	    if ( $this->getConfigValue('theme') != 'estate' and !file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/realty_view.tpl') ) {
            $this->template->assign('main_file_tpl', '../estate/realty_view.tpl');
        } else {
            $this->template->assign('main_file_tpl', 'realty_view.tpl');
        }
        
        return __METHOD__;
    }
	
	protected function formatPhoneNumber($num){
		$parts=array();
		$matches=array();
		$num=preg_replace('/[^\d]/','',$num);
		//echo 
		if(substr($num,0,1)=='8' && strlen($num)==11){
			preg_match_all('/(\d*)(\d{3})(\d{3})(\d{2})(\d{2})$/',$num,$matches);
		}elseif(strlen($num)==11 || strlen($num)==10){
			preg_match_all('/(\d*)(\d{3})(\d{3})(\d{2})(\d{2})$/',$num,$matches);
		}else{
			preg_match_all('/(\d*)(\d{2})(\d{2})$/',$num,$matches);
		}
		for($i=1; $i<6; $i++){
			if(isset($matches[$i]) && $matches[$i]!==''){
				$parts[]=$matches[$i][0];
			}
		}
		if(count($parts)>0){
			return implode('-',$parts);
		}else{
			return $num;
		}
	}
    
    protected function getSimilar($categories,$params=array()){
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	$category_structure = $Structure_Manager->loadCategoryStructure();
    	
    	$ret=array();
    	$datas=array();
    	$where=array();
    	if(!empty($params)){
    		$ids[]=$params['id'];
    		$where['active']='active=1';
    		if($params['street_id']!=0){
    			$where['street_id']='street_id='.$params['street_id'];
    		}
    		if($params['topic_id']!=0){
    			$where['topic_id']='topic_id='.$params['topic_id'];
    		}
    		if($params['city_id']!=0){
    			$where['city_id']='city_id='.$params['city_id'];
    		}
    		if($params['district_id']!=0){
    			$where['district_id']='district_id='.$params['district_id'];
    		}
    		if($params['id']!=0){
    			$where['id']='id NOT IN ('.implode(',',$ids).')';
    		}
    		$q='SELECT id FROM '.DB_PREFIX.'_data'.(!empty($where) ? ' WHERE '.implode(' AND ',$where) : '').' LIMIT 5';
    		
    		$this->db->exec($q);
    		while($this->db->fetch_assoc()){
    			$ret[]=$this->db->row['id'];
    			$ids[]=$this->db->row['id'];
    		}
    		
    		if(count($ret)<5){
    			unset($where['district_id']);
    			unset($where['street_id']);
    			$where['id']='id NOT IN ('.implode(',',$ids).')';
    			$q='SELECT id FROM '.DB_PREFIX.'_data'.(!empty($where) ? ' WHERE '.implode(' AND ',$where) : '').' LIMIT 5';
	    		
    			$this->db->exec($q);
	    		while($this->db->fetch_assoc()){
	    			$ret[]=$this->db->row['id'];
	    			$ids[]=$this->db->row['id'];
	    		}
    		}
    		if(count($ret)<5){
    			unset($where['city_id']);
    			//unset($where['street_id']);
    			$where['id']='id NOT IN ('.implode(',',$ids).')';
    			$q='SELECT id FROM '.DB_PREFIX.'_data'.(!empty($where) ? ' WHERE '.implode(' AND ',$where) : '').' LIMIT 5';
	    		$this->db->exec($q);
	    		while($this->db->fetch_assoc()){
	    			$ret[]=$this->db->row['id'];
	    			$ids[]=$this->db->row['id'];
	    		}
    		}
    		if(count($ret)<5){
    			$last=5-count($ret);
    			unset($where['topic_id']);
    			$where['id']='id NOT IN ('.implode(',',$ids).')';
    			$q='SELECT id FROM '.DB_PREFIX.'_data'.(!empty($where) ? ' WHERE '.implode(' AND ',$where) : '').' LIMIT '.$last;
	    		$this->db->exec($q);
	    		while($this->db->fetch_assoc()){
	    			$ret[]=$this->db->row['id'];
	    			$ids[]=$this->db->row['id'];
	    		}
    		}
    		
    		
    	}
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
    	$data_model = new Data_Model();
    	$i=0;
    	foreach($ret as $r){
	    	
	        $form_data = $data_model->get_kvartira_model();
	        $form_data = $data_model->init_model_data_from_db ( 'data', 'id', $r, $form_data['data'], true );
    		$form_data['topic_id']['value_string']=$categories['catalog'][$form_data['topic_id']['value']]['name'];
    		if(1==$this->getConfigValue('apps.seo.level_enable')){
    			if($category_structure['catalog'][$form_data['topic_id']['value']]['url']!=''){
    				$form_data['parent_category_url']=$category_structure['catalog'][$form_data['topic_id']['value']]['url'].'/';
    			}else{
    				$form_data['parent_category_url']='';
    			}
    		}else{
    			$form_data['parent_category_url']='';
    		}
    		
    		if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $form_data['translit_alias']['value']!=''){
            	$form_data['href']=SITEBILL_MAIN_URL.'/'.$form_data['parent_category_url'].$form_data['translit_alias']['value'];
            	//$ra[$item_id]['href']=SITEBILL_MAIN_URL.'/'.$ra[$item_id]['parent_category_url'].$this->getTranslitAlias($ra[$item_id]['city'],$ra[$item_id]['street'],$ra[$item_id]['number']);
            }elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
    			$form_data['href']=SITEBILL_MAIN_URL.'/'.$form_data['parent_category_url'].'realty'.$form_data['id']['value'].'.html';
    		}else{
    			$form_data['href']=SITEBILL_MAIN_URL.'/'.$form_data['parent_category_url'].'realty'.$form_data['id']['value'];
    		}
    		
    		$datas[]=$form_data;
	        $i++;
	        if($i==5){
	        	break;
	        }
    	}
    	/*echo '<pre>';
    	print_r($datas);
    	echo '</pre>';*/
    	return $datas;
    }
}
?>
