<?php
/**
 * Data model
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Data_Model extends SiteBill {
    /**
     * Construct
     */
    function __construct() {
        $this->SiteBill();
    }
    
    
    /**
     * Init model data from request
     * @param array $model_array
     * @return boolean
     */
    function init_model_data_from_request ( $model_array ) {
    	$topic_id=0;
    	if(isset($model_array['topic_id'])){
    		$topic_id=(int)$_REQUEST['topic_id'];
    	}
    	if($topic_id!=0){
	    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
	    	$SM=new Structure_Manager();
	    	$category_structure=$SM->loadCategoryStructure();
	    	//echo 'start get childs topic_id = '.$topic_id.'<br>';
	    	//$child_cats=$SM->get_all_childs($topic_id, $category_structure);
	    	//$child_cats[]=$topic_id;
	    	//echo '<pre>';
	    	//print_r($child_cats);
	    	//echo '</pre>';
	    	
    	}
    	foreach ( $model_array as $key => $item_array ) {
        	if($topic_id!=0 && isset($item_array['active_in_topic']) && $item_array['active_in_topic']!=0){
        		//echo '$item_array[\'active_in_topic\'] = '.$item_array['active_in_topic'].'<br>';
        		//echo 'topic_id = '.$topic_id.'<br>';
        		//echo 'child_cats = '.'<br>';
        		
        		$active_array_ids = explode(',',$item_array['active_in_topic']);
        		
        		//echo 'active array = ';
        		//echo '<pre>';
        		//print_r($active_array_ids);
        		//echo '</pre>';
        		$child_cats = array();
        		foreach ($active_array_ids as $item_id => $check_active_id) {
        			//echo '$check_active_id = '.$check_active_id.'<br>';
        			$child_cats_compare = $SM->get_all_childs($check_active_id, $category_structure);
        			if ( is_array($child_cats_compare) ) {
        				$child_cats = array_merge($child_cats, $child_cats_compare);
        			}
        			$child_cats[]=$check_active_id;
        			 
        		}
        		
        		//echo 'childs cats after';
        		//echo '<pre>';
        		//print_r($child_cats);
        		//echo '</pre>';
        		
        		
        		if(!in_array($topic_id, $child_cats)){
        			//echo 'skip = ';
        			//echo '<pre>';
        			//print_r($model_array[$key]);
        			//echo '</pre>';
        			unset($model_array[$key]);
        			continue;
        		}
        	}
            if ( $model_array[$key]['type'] == 'checkbox' ) {
            	
                if (  $this->getRequestValue($key) !== NULL/* && $this->getRequestValue($key) !== ''*/ ) {
                    $model_array[$key]['value'] = 1;
                } else {
                    $model_array[$key]['value'] = 0;
                }
                continue;
            }
            if ( $model_array[$key]['type'] == 'date'   ) {
                $model_array[$key]['value'] = strtotime($this->getRequestValue($key));
                //          ,    
                //$model_array[$key]['value'] = strtotime($this->getRequestValue($key).' '.date('H:i:s',time()));
                continue;
            }
            if ( $model_array[$key]['type'] == 'geodata' ) {
            	$geodata=array();
            	$geodata=$this->getRequestValue($model_array[$key]['name']);
            	if(preg_match('/^(-?)([0-9]?)([0-9])((\.?)(\d*)?)$/',trim($geodata['lat']))){
            		$model_array[$key]['value']['lat']=trim($geodata['lat']);
            	}else{
            		$model_array[$key]['value']['lat']='';
            	}
            	if(preg_match('/^(-?)([0-9]?)([0-9])((\.?)(\d*)?)$/',trim($geodata['lng']))){
            		$model_array[$key]['value']['lng']=trim($geodata['lng']);
            	}else{
            		$model_array[$key]['value']['lng']='';
            	}	
            	continue;
            }
            
            if ( $model_array[$key]['type'] == 'photo'   ) {
                $model_array[$key]['value'] = $_FILES[$model_array[$key]['name']]['name'];
                continue;
            }
            if ( $model_array[$key]['type'] == 'select_box_structure_simple_multiple'   ) {
                $model_array[$key]['values_array'] = $this->getRequestValue($key);
                if(is_array($model_array[$key]['values_array']) && count($model_array[$key]['values_array'])!=0){
                	$model_array[$key]['value']=implode(',', $model_array[$key]['values_array']);
                }
                continue;
            }
            if ( $model_array[$key]['type'] == 'mobilephone'   ) {
            	$model_array[$key]['value']=preg_replace('/\D/','',$this->getRequestValue($key));
            	continue;
            }
        	if ( $model_array[$key]['type'] == 'select_by_query_multiple'   ) {
                $model_array[$key]['values_array'] = $this->getRequestValue($key);
                if(count($model_array[$key]['values_array'])!=0){
                	$model_array[$key]['value']=implode(',', $model_array[$key]['values_array']);
                }
                continue;
            }
            
            $model_array[$key]['value'] = $this->getRequestValue($key);
        }
        return $model_array;
    }
    
    /**
     * Init model data from db
     * @param string $table_name
     * @param string $primary_key_name primary key name
     * @param int $primary_key_value primary key
     * @param array $model_array
     * @param boolean $force_select_values
     * @return boolean
     */
    function init_model_data_from_db ( $table_name, $primary_key_name, $primary_key_value, $model_array, $force_select_values = false ) {
        $query = "select * from ".DB_PREFIX."_".$table_name." where $primary_key_name = $primary_key_value";
        //echo $query;
        $this->db->exec($query);
        $this->db->fetch_assoc();
        if ( $this->db->row[$primary_key_name] == '' ) {
        	$this->riseError(Multilanguage::_('L_ERROR_RECORD_NOT_FOUND'));
        	return false;
        }
        $row = $this->db->row;
        
        //echo '<pre>';
        //print_r($_REQUEST);
        foreach ( $model_array as $key => $item_array ) {
            //echo "key = $key, value = ".$this->db->row[$key].'<br>';
            $model_array[$key]['value'] =  $row[$key];
            
            if ( $model_array[$key]['type'] == 'uploadify_image' or $model_array[$key]['type'] == 'uploadify_file' ) {
                $model_array[$key]['primary_key_value'] = $primary_key_value;
            }
        	if ( $model_array[$key]['type'] == 'select_box_structure_simple_multiple' ) {
                $model_array[$key]['value'] = $row[$key];
        		$model_array[$key]['values_array'] = explode(',',$row[$key]);
            }
            if ( $model_array[$key]['type'] == 'geodata' ) {
            	$model_array[$key]['value']['lat'] = $row[$model_array[$key]['name'].'_lat'];
            	$model_array[$key]['value']['lng'] = $row[$model_array[$key]['name'].'_lng'];
            }
        	if ( $model_array[$key]['type'] == 'select_by_query_multiple' ) {
                $model_array[$key]['value'] = $row[$key];
        		$model_array[$key]['values_array'] = explode(',',$row[$key]);
            }
        	if ( $model_array[$key]['type'] == 'select_by_query' and $force_select_values ) {
                $model_array[$key]['value_string'] = $this->get_string_value_by_id($model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $model_array[$key]['value_name'] ,$model_array[$key]['value']);
            }
            if ( $model_array[$key]['type'] == 'uploadify_image' ) {
                $model_array[$key]['image_array'] = $this->get_image_array ( 'data', 'data', 'id', $primary_key_value );
            }
            if ( $model_array[$key]['type'] == 'uploadify_file' ) {
                $model_array[$key]['image_array'] = $this->get_image_array ( $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $primary_key_value );
            }
        	if ( $model_array[$key]['type'] == 'values_list' ) {
                $model_array[$key]['value'] = $this->get_values_list($model_array[$key]['what'], $model_array[$key]['primary_table'], $model_array[$key]['primary_key'], $model_array[$key]['secondary_table'], $model_array[$key]['secondary_key'], $primary_key_value);
            	//SELECT tag_name FROM re_tag WHERE tag_id IN (SELECT tag_id FROM re_shop_product_tag WHERE shop_product_id=5)
        	}
        	if ( $model_array[$key]['type'] == 'date' and $force_select_values ) {
        		if(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2}) (\d{2,2}):(\d{2,2}):(\d{2,2})/',$model_array[$key]['value'])){
        			$model_array[$key]['value'] = date('d.m.Y', strtotime($model_array[$key]['value']));
        		}elseif(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2})/',$model_array[$key]['value'])){
        			$model_array[$key]['value'] = date('d.m.Y', strtotime($model_array[$key]['value']));
        		}elseif($model_array[$key]['value']==0 || $model_array[$key]['value']==''){
        		
        			$model_array[$key]['value'] = '';
        		}else{
        			$model_array[$key]['value'] = date('d.m.Y', $model_array[$key]['value']);
        		
        		}
            }
            if ( $model_array[$key]['type'] == 'select_box' and $force_select_values ) {
            	$model_array[$key]['value_string'] = $model_array[$key]['select_data'][$model_array[$key]['value']];
            }
            if ( $model_array[$key]['type'] == 'structure' and $force_select_values ) {
            	require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php';
            	$Manager=Structure_Implements::getManager($model_array[$key]['entity']);
            	$cs=$Manager->loadCategoryStructure();
            	$model_array[$key]['value_string']=$cs['catalog'][$model_array[$key]['value']]['name'];
            }
            if ( $model_array[$key]['type'] == 'select_box_structure' and $force_select_values ) {
            	//echo 1;
            	require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php';
            	$Manager=Structure_Implements::getManager();
            	$cs=$Manager->loadCategoryStructure();
            	$model_array[$key]['value_string']=$cs['catalog'][$model_array[$key]['value']]['name'];
            }
        	
        }
        return $model_array;
    }
    
    
    
    /**
     * Init model data from db (language_version)
     * @param string $table_name
     * @param string $primary_key_name primary key name
     * @param int $primary_key_value primary key
     * @param array $model_array
     * @param boolean $force_select_values
     * @param int $language_id
     * @return boolean
     */
    function init_model_data_from_db_language ( $table_name, $primary_key_name, $primary_key_value, $model_array, $force_select_values, $language_id ) {
        $query = "select * from ".DB_PREFIX."_".$table_name." where link_id = $primary_key_value and language_id = $language_id";
        //echo $query;
        $this->db->exec($query);
        $this->db->fetch_assoc();
        $row = $this->db->row;
        
        //echo '<pre>';
        //print_r($_REQUEST);
        foreach ( $model_array as $key => $item_array ) {
            //echo "key = $key, value = ".$this->db->row[$key].'<br>';
            $model_array[$key]['value'] =  $row[$key];
            if ( $model_array[$key]['type'] == 'uploadify_image' ) {
                $model_array[$key]['primary_key_value'] = $primary_key_value;
            }
            if ( $model_array[$key]['type'] == 'select_by_query' and $force_select_values ) {
                $model_array[$key]['value_string'] = $this->get_string_value_by_id($model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $model_array[$key]['value_name'] ,$model_array[$key]['value']);
            }
            if ( $model_array[$key]['type'] == 'uploadify_image' ) {
                $model_array[$key]['image_array'] = $this->get_image_array ( 'data', 'data', 'id', $primary_key_value );
            }
        }
        return $model_array;
    }
    
    function init_model_data_from_var ( $var, $primary_key_value, $model_array, $force_select_values = false ) {
    	
    	$row = $var;
    
    	foreach ( $model_array as $key => $item_array ) {
    		$model_array[$key]['value'] =  $row[$key];
    
    		if ( $model_array[$key]['type'] == 'uploadify_image' or $model_array[$key]['type'] == 'uploadify_file' ) {
    			$model_array[$key]['primary_key_value'] = $primary_key_value;
    		}
    		if ( $model_array[$key]['type'] == 'select_box_structure_simple_multiple' ) {
    			$model_array[$key]['value'] = $row[$key];
    			$model_array[$key]['values_array'] = explode(',',$row[$key]);
    		}
    		if ( $model_array[$key]['type'] == 'geodata' ) {
    			$model_array[$key]['value']['lat'] = $row[$model_array[$key]['name'].'_lat'];
    			$model_array[$key]['value']['lng'] = $row[$model_array[$key]['name'].'_lng'];
    		}
    		if ( $model_array[$key]['type'] == 'select_by_query_multiple' ) {
    			$model_array[$key]['value'] = $row[$key];
    			$model_array[$key]['values_array'] = explode(',',$row[$key]);
    		}
    		if ( $model_array[$key]['type'] == 'select_by_query' and $force_select_values ) {
    			$model_array[$key]['value_string'] = $this->get_string_value_by_id($model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $model_array[$key]['value_name'] ,$model_array[$key]['value']);
    		}
    		if ( $model_array[$key]['type'] == 'uploadify_image' ) {
    			$model_array[$key]['image_array'] = $this->get_image_array ( 'data', 'data', 'id', $primary_key_value );
    		}
    		if ( $model_array[$key]['type'] == 'uploadify_file' ) {
    			$model_array[$key]['image_array'] = $this->get_image_array ( $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_table'], $model_array[$key]['primary_key_name'], $primary_key_value );
    		}
    		if ( $model_array[$key]['type'] == 'values_list' ) {
    			$model_array[$key]['value'] = $this->get_values_list($model_array[$key]['what'], $model_array[$key]['primary_table'], $model_array[$key]['primary_key'], $model_array[$key]['secondary_table'], $model_array[$key]['secondary_key'], $primary_key_value);
    		}
    		if ( $model_array[$key]['type'] == 'date' and $force_select_values ) {
    			if(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2}) (\d{2,2}):(\d{2,2}):(\d{2,2})/',$model_array[$key]['value'])){
    				$model_array[$key]['value'] = date('d.m.Y', strtotime($model_array[$key]['value']));
    			}elseif(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2})/',$model_array[$key]['value'])){
    				$model_array[$key]['value'] = date('d.m.Y', strtotime($model_array[$key]['value']));
    			}elseif($model_array[$key]['value']==0 || $model_array[$key]['value']==''){
    
    				$model_array[$key]['value'] = '';
    			}else{
    				$model_array[$key]['value'] = date('d.m.Y', $model_array[$key]['value']);
    
    			}
    		}
    		if ( $model_array[$key]['type'] == 'select_box' and $force_select_values ) {
    			$model_array[$key]['value_string'] = $model_array[$key]['select_data'][$model_array[$key]['value']];
    		}
    		if ( $model_array[$key]['type'] == 'structure' and $force_select_values ) {
    			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php';
    			$Manager=Structure_Implements::getManager($model_array[$key]['entity']);
    			$cs=$Manager->loadCategoryStructure();
    			$model_array[$key]['value_string']=$cs['catalog'][$model_array[$key]['value']]['name'];
    		}
    		 
    	}
    	return $model_array;
    }
    
    
    /**
     * Get string value by ID
     * @param string $primary_key_table
     * @param string $primary_key_name
     * @param string $value_name
     * @param string $primary_key_value
     * @param boolean $cache use cache
     * @return string
     */
    function get_string_value_by_id ( $primary_key_table, $primary_key_name, $value_name, $value, $cache = false ) {
    	if ( $cache ) {
    		//check cache
    		if ( !isset($this->cache[$primary_key_table]) ) {
    			$query = "select * from ".DB_PREFIX."_".$primary_key_table."";
    			$this->db->exec($query);
    			$this->cache[$primary_key_table] = array();
    			while ( $this->db->fetch_assoc() ) {
    				$this->cache[$primary_key_table][$this->db->row[$primary_key_name]][$value_name] = $this->db->row[$value_name];
    			}
    			
    			//echo '<pre>';
    			//print_r($this->cache[$primary_key_table]);
    			//echo '</pre>';
    		
    		}
    		return	$this->cache[$primary_key_table][$value][$value_name];
    	} else {
    		$query = "select * from ".DB_PREFIX."_".$primary_key_table." where $primary_key_name = $value";
    		//echo $query.'<br>';
    		$this->db->exec($query);
    		$this->db->fetch_assoc();
    		return $this->db->row[$value_name];
    	}
    }
    
	/**
     * Get string values from outer table by ID
     * @param string $primary_key_table
     * @param string $primary_key_name
     * @param string $value_name
     * @param string $primary_key_value
     * @return string
     */
    function get_values_list ( $what, $primary_table_name, $primary_key_name, $secondary_table_name, $secondary_key_name, $value ) {
        $ret=array();
        $query='SELECT '.$what.' FROM '.$primary_table_name.' WHERE '.$primary_key_name.' IN (SELECT '.$primary_key_name.' FROM '.$secondary_table_name.' WHERE '.$secondary_key_name.'='.$value.')';
    	//$query = "select * from ".DB_PREFIX."_".$primary_key_table." where $primary_key_name = $value";
        //echo $query.'<br>';
        $this->db->exec($query);
        while($row=$this->db->fetch_assoc()){
        	$ret[]=$this->db->row[$what];
        }
        if(count($ret)>0){
        	return implode(', ',$ret);
        }else{
        	return '';
        }
    }
    
    /**
     * Check data
     * @param array $model_array
     * @return boolean
     */
    function check_data ( $model_array ) {
    	foreach ( $model_array as $key => $item_array ) {
    		
            //echo "key = $key, value = ".$model_array[$key]['value'].', required = '.$model_array[$key]['required'].'<br>';
            if ( $model_array[$key]['type'] == 'safe_string' or $model_array[$key]['type'] == 'textarea' ) {
                if ( $model_array[$key]['required'] == 'on' and  $model_array[$key]['value'] == ''  ) {
                    //echo "key = $key, value = ".$model_array[$key]['value'].', required = '.$model_array[$key]['required'].'<br>';
                    $this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    return false;
                }
            } elseif ( $model_array[$key]['type'] == 'captcha' ) {
                //echo 'captcha!<br>';
                //echo 'captcha_session_key = '.$this->getRequestValue('captcha_session_key').'<br>';
                //echo '<pre>';
                //print_r($_SESSION);
                //echo '</pre>';
                if ( $model_array[$key]['value'] != $_SESSION[$this->getRequestValue('captcha_session_key')] ) {
                    $this->riseError(Multilanguage::_('L_ERROR_CAPTCHA_INVALID'));
                    return false;
                }
            } elseif( $model_array[$key]['type'] == 'email' ){
            	if ( $model_array[$key]['required'] == 'on' and  $model_array[$key]['value'] == ''  ) {
                    //echo "key = $key, value = ".$model_array[$key]['value'].', required = '.$model_array[$key]['required'].'<br>';
                    $this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    return false;
                }
            	if($model_array[$key]['value'] != '' AND !$this->validateEmailFormat($model_array[$key]['value'])){
    				$this->riseError(Multilanguage::_('L_ERROR_EMAIL_FORMAT_INVALID').' '.$model_array[$key]['title']);
                    return false;
    			}
            } elseif( $model_array[$key]['type'] == 'mobilephone' ){
            	if ( $model_array[$key]['required'] == 'on' and  $model_array[$key]['value'] == ''  ) {
                    //echo "key = $key, value = ".$model_array[$key]['value'].', required = '.$model_array[$key]['required'].'<br>';
                    $this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    return false;
                }
                if(($model_array[$key]['value']!='') AND (!$this->validateMobilePhoneNumberFormat($model_array[$key]['value']))){
                	$this->riseError(Multilanguage::_('L_ERROR_PHONE_FORMAT_INVALID').' '.$model_array[$key]['title']);
                	return false;
                }
            	
            } elseif($model_array[$key]['type'] == 'select_box_structure_simple_multiple') {
            	if ( $model_array[$key]['required'] == 'on' &&  count($model_array[$key]['values_array']) == 0  ) {
                    $this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    return false;
                }
            } elseif($model_array[$key]['type'] == 'select_by_query_multiple') {
            	if ( $model_array[$key]['required'] == 'on' &&  count($model_array[$key]['values_array']) == 0  ) {
                    $this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    return false;
                }
            } else {
            	//echo "key = $key, value = ".$model_array[$key]['value'].', required = '.$model_array[$key]['required'].'<br>';
                if ( $model_array[$key]['required'] == 'on' ) {
                    if(!is_array($model_array[$key]['value'])){
                    	if(!preg_match('/.+/', $model_array[$key]['value']) || preg_match('/^[0]$/', $model_array[$key]['value'])){
                    		$this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    		return false;
                    	}
                    }elseif(empty($model_array[$key]['value'])){
                    	$this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    	return false;
                    	
                    }else{
                    	$values=$model_array[$key]['value'];
                    	foreach($values as $value){
                    		if(!preg_match('/.+/', $value) || preg_match('/^[0]$/', $value)){
                    			$this->riseError(Multilanguage::_('L_ERROR_FIELD_NOT_FILLED').' '.$model_array[$key]['title']);
                    			return false;
                    		}
                    	}
                    }
                }
            }
    	}
        return true;
    }
    
    function forse_auto_add_values(&$model_array){
    	foreach ( $model_array as $key => $item_array ) {
    		if($item_array['type']=='auto_add_value' AND $item_array['value']!=''){
    			$id=$this->get_value_id_by_name($item_array['value_table'],$item_array['value_field'],$item_array['value_primary_key'],$item_array['value']);
    			if($id===FALSE){
	    			$query="INSERT INTO ".DB_PREFIX."_".$item_array['value_table']." (".$item_array['value_field'].") VALUES ('".$item_array['value']."')";
	    			$this->db->exec($query);
	    			$id=$this->db->last_insert_id();
	    			if($id!=0){
	    				$model_array[$item_array['assign_to']]['value']=$id;
	    			}
    			}else{
    				$model_array[$item_array['assign_to']]['value']=$id;
    			}
    		}
    	}
    }
    
    function get_value_id_by_name($table,$field,$primary_key,$value){
    	$query="SELECT ".$primary_key." FROM ".DB_PREFIX."_".$table." WHERE ".$field."='".$value."'";
    	
    	$this->db->exec($query);
    	if($this->db->success){
    		$this->db->fetch_assoc();
    		
    		if($this->db->row[$primary_key]!=0){
    			return $this->db->row[$primary_key];
    		}else{
    			return FALSE;
    		}
    	}else{
    		return FALSE;
    	}
    }
    /*
    function clear_auto_add_values($model_array){
    	foreach ( $model_array as $key => $item_array ) {
    		if($item_array['type']=='auto_add_value'){
    			unset($model_array[$key]);
    		}
    	}
    }
    */
    /**
     * Get insert query
     * @param string $table_name table name
     * 
     * @param array $model_array
     * @param int $language_id 
     * @return boolean
     */
    function get_insert_query ( $table_name, $model_array, $language_id = 0 ) {
        $set = array();
        $values = array();
        unset($model_array['image']);
        
        foreach ( $model_array as $key => $item_array ) {
            if ( $item_array['type'] == 'primary_key' ) {
                $primary_key = $item_array['name'];
                
                //echo "primary_key = $primary_key<br>";
                //echo "value = ".$model_array[$primary_key]['value']; 
                continue;
            }
            
            if ( $item_array['type'] == 'separator' ) {
                continue;
            }
            
            if ( $item_array['type'] == 'spacer_text' ) {
                continue;
            }
            
            if ( $item_array['type'] == 'photo' ) {
                continue;
            }
            if ( $item_array['dbtype'] == 'notable' ) {
                continue;
            }
            
            if ( $item_array['type'] == 'geodata' ) {
            	$set[] = '`'.$key.'_lat`';
            	if($item_array['value']['lat']==''){
            		$values[] = "NULL";
            	}else{
            		$values[] = "'".$this->escape($item_array['value']['lat'])."'";
            	}
            	
            	$set[] = '`'.$key.'_lng`';
            	
            	if($item_array['value']['lng']==''){
            		$values[] = "NULL";
            	}else{
            		$values[] = "'".$this->escape($item_array['value']['lng'])."'";
            	}
            	continue;
            }
            
            $set[] = '`'.$key.'`';
			$item_array['value']=preg_replace('/<script.*\/script>/','',$item_array['value']);
            $values[] = "'".$this->escape($item_array['value'])."'";
        }
        //echo "primary_key = $primary_key<br>";
        //echo '$this->getRequestValue($primary_key) = '.$this->getRequestValue($primary_key).'<br>';
        if ( $language_id > 0 ) {
            $set[] = '`language_id`';
            $values[] = "'".$language_id."'";
            $set[] = '`link_id`';
            $values[] = "'".$this->getRequestValue($primary_key)."'";
        }
        $query = "insert into $table_name (".implode(' , ', $set).") values (".implode(' , ', $values).")";
        //echo $query;
        return $query;
    }
    
    /**
     * Get edit query
     * @param string $table_name table name
     * @param string $primary_key_name primary key name
     * @param int $primary_key_value primary key
     * @param array $model_array
     * @param int $language_id
     * @return boolean
     */
    function get_edit_query ( $table_name, $primary_key_name, $primary_key_value, $model_array, $language_id = 0 ) {
        unset($model_array['image']);
        
        $set = array();
        $values = array();
        foreach ( $model_array as $key => $item_array ) {
            if ( $item_array['type'] == 'primary_key' ) {
                $primary_key = $item_array['name'];
                continue;
            }
            
            if ( $item_array['type'] == 'separator' ) {
                continue;
            }
            
            if ( $item_array['type'] == 'spacer_text' ) {
                continue;
            }
            
            if ( $item_array['type'] == 'photo' ) {
                continue;
            }
            if ( $item_array['dbtype'] == 'notable' ) {
                continue;
            }
            if ( $item_array['type'] == 'geodata' ) {
            	if($item_array['value']['lat']==''){
            		$pairs[] = '`'.$key.'_lat` = NULL';
            	}else{
            		$pairs[] = '`'.$key.'_lat` = '."'".$this->escape($item_array['value']['lat'])."'";
            	}
            	 
            	if($item_array['value']['lng']==''){
            		$pairs[] = '`'.$key.'_lng` = NULL';
            	}else{
            		$pairs[] = '`'.$key.'_lng` = '."'".$this->escape($item_array['value']['lng'])."'";
            	}
            	
            	
            	continue;
            }
            
            
            
            $item_array['value']=preg_replace('/<script.*\/script>/','',$item_array['value']);
            $pairs[] = '`'.$key.'` = '."'".$this->escape($item_array['value'])."'"; 
            
            //$set[] = '`'.$key.'`';
            //$values[] = "'".$item_array['value']."'";
        }
        if ( $language_id > 0 ) {
            $set[] = '`language_id`';
            $values[] = "'".$language_id."'";
            $set[] = '`link_id`';
            $values[] = "'".$this->getRequestValue($primary_key)."'";
            $query = "update `$table_name` set ".implode(' , ', $pairs)." where link_id = $primary_key_value";
        } else {
            $query = "update `$table_name` set ".implode(' , ', $pairs)." where $primary_key_name = $primary_key_value";
        }
        
        //echo $query;
        return $query;
    }
    
    /**
     * Get city model
     * @param
     * @return
     */
    function get_city_model () {
		$form_city = array();
		
		$form_city['city']['city_id']['name'] = 'city_id';
		$form_city['city']['city_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_city['city']['city_id']['value'] = 0;
		$form_city['city']['city_id']['length'] = 40;
		$form_city['city']['city_id']['type'] = 'primary_key';
		$form_city['city']['city_id']['required'] = 'off';
		$form_city['city']['city_id']['unique'] = 'off';
		
		$form_city['city']['region_id']['name'] = 'region_id';
		$form_city['city']['region_id']['primary_key_name'] = 'region_id';
		$form_city['city']['region_id']['title'] = Multilanguage::_('L_REGION');
		$form_city['city']['region_id']['value'] = 0;
		$form_city['city']['region_id']['length'] = 40;
		$form_city['city']['region_id']['type'] = 'select_by_query';
		$form_city['city']['region_id']['query'] = 'select * from '.DB_PREFIX.'_region order by name';
		$form_city['city']['region_id']['value_name'] = 'name';
		$form_city['city']['region_id']['title_default'] = Multilanguage::_('L_CHOOSE_REGION');
		$form_city['city']['region_id']['value_default'] = 0;
		$form_city['city']['region_id']['required'] = 'off';
		$form_city['city']['region_id']['unique'] = 'off';
		
		$form_city['city']['name']['name'] = 'name';
		$form_city['city']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_city['city']['name']['value'] = '';
		$form_city['city']['name']['length'] = 40;
		$form_city['city']['name']['type'] = 'safe_string';
		$form_city['city']['name']['required'] = 'on';
		$form_city['city']['name']['unique'] = 'off';
		if ( $this->getConfigValue('theme') == 'etown' ) {
			$form_city['city']['geo']['name'] = 'geo';
			$form_city['city']['geo']['title'] = Multilanguage::_('L_GEO_COORDS');
			$form_city['city']['geo']['value'] = '';
			$form_city['city']['geo']['length'] = 40;
			$form_city['city']['geo']['type'] = 'geodata';
			$form_city['city']['geo']['required'] = 'off';
			$form_city['city']['geo']['unique'] = 'off';
		}
		
		return $form_city;
    }
    
    /**
     * Get region model
     * @param
     * @return
     */
    function get_region_model () {
		$form_region = array();
		
		$form_region['region']['region_id']['name'] = 'region_id';
		$form_region['region']['region_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_region['region']['region_id']['value'] = 0;
		$form_region['region']['region_id']['length'] = 40;
		$form_region['region']['region_id']['type'] = 'primary_key';
		$form_region['region']['region_id']['required'] = 'off';
		$form_region['region']['region_id']['unique'] = 'off';
		
		$form_region['region']['country_id']['name'] = 'country_id';
		$form_region['region']['country_id']['primary_key_name'] = 'country_id';
		$form_region['region']['country_id']['title'] = '';
		$form_region['region']['country_id']['value'] = 0;
		$form_region['region']['country_id']['length'] = 40;
		$form_region['region']['country_id']['type'] = 'select_by_query';
		$form_region['region']['country_id']['query'] = 'select * from '.DB_PREFIX.'_country order by name';
		$form_region['region']['country_id']['value_name'] = 'name';
		$form_region['region']['country_id']['title_default'] = Multilanguage::_('L_CHOOSE_COUNTRY');
		$form_region['region']['country_id']['value_default'] = 0;
		$form_region['region']['country_id']['required'] = 'off';
		$form_region['region']['country_id']['unique'] = 'off';
		
		$form_region['region']['name']['name'] = 'name';
		$form_region['region']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_region['region']['name']['value'] = '';
		$form_region['region']['name']['length'] = 40;
		$form_region['region']['name']['type'] = 'safe_string';
		$form_region['region']['name']['required'] = 'on';
		$form_region['region']['name']['unique'] = 'off';
		
		return $form_region;
    }
    
    
    /**
     * Get district model
     * @param
     * @return
     */
    function get_district_model () {
		$form_district = array();
		
		$form_district['district']['id']['name'] = 'id';
		$form_district['district']['id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_district['district']['id']['value'] = 0;
		$form_district['district']['id']['length'] = 40;
		$form_district['district']['id']['type'] = 'primary_key';
		$form_district['district']['id']['required'] = 'off';
		$form_district['district']['id']['unique'] = 'off';
		
		$form_district['district']['city_id']['name'] = 'city_id';
		$form_district['district']['city_id']['primary_key_name'] = 'city_id';
		$form_district['district']['city_id']['title'] = Multilanguage::_('L_CITY');
		$form_district['district']['city_id']['value'] = 0;
		$form_district['district']['city_id']['length'] = 40;
		$form_district['district']['city_id']['type'] = 'select_by_query';
		$form_district['district']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
		$form_district['district']['city_id']['value_name'] = 'name';
		$form_district['district']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
		$form_district['district']['city_id']['value_default'] = 0;
		$form_district['district']['city_id']['required'] = 'off';
		$form_district['district']['city_id']['unique'] = 'off';
		
		$form_district['district']['name']['name'] = 'name';
		$form_district['district']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_district['district']['name']['value'] = '';
		$form_district['district']['name']['length'] = 40;
		$form_district['district']['name']['type'] = 'safe_string';
		$form_district['district']['name']['required'] = 'on';
		$form_district['district']['name']['unique'] = 'off';
		
		return $form_district;
    }
    
    
    /**
     * Get metro model
     * @param
     * @return
     */
    function get_metro_model () {
		$form_metro = array();
		
		$form_metro['metro']['metro_id']['name'] = 'metro_id';
		$form_metro['metro']['metro_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_metro['metro']['metro_id']['value'] = 0;
		$form_metro['metro']['metro_id']['length'] = 40;
		$form_metro['metro']['metro_id']['type'] = 'primary_key';
		$form_metro['metro']['metro_id']['required'] = 'off';
		$form_metro['metro']['metro_id']['unique'] = 'off';
		
		$form_metro['metro']['city_id']['name'] = 'city_id';
		$form_metro['metro']['city_id']['primary_key_name'] = 'city_id';
		$form_metro['metro']['city_id']['title'] = Multilanguage::_('L_CITY');
		$form_metro['metro']['city_id']['value'] = 0;
		$form_metro['metro']['city_id']['length'] = 40;
		$form_metro['metro']['city_id']['type'] = 'select_by_query';
		$form_metro['metro']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
		$form_metro['metro']['city_id']['value_name'] = 'name';
		$form_metro['metro']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
		$form_metro['metro']['city_id']['value_default'] = 0;
		$form_metro['metro']['city_id']['required'] = 'off';
		$form_metro['metro']['city_id']['unique'] = 'off';
		
		$form_metro['metro']['name']['name'] = 'name';
		$form_metro['metro']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_metro['metro']['name']['value'] = '';
		$form_metro['metro']['name']['length'] = 40;
		$form_metro['metro']['name']['type'] = 'safe_string';
		$form_metro['metro']['name']['required'] = 'on';
		$form_metro['metro']['name']['unique'] = 'off';
		
		return $form_metro;
    }
    
    /**
     * Get street model
     * @param
     * @return
     */
    function get_street_model () {
		$form_street = array();
		
		$form_street['street']['street_id']['name'] = 'street_id';
		$form_street['street']['street_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_street['street']['street_id']['value'] = 0;
		$form_street['street']['street_id']['length'] = 40;
		$form_street['street']['street_id']['type'] = 'primary_key';
		$form_street['street']['street_id']['required'] = 'off';
		$form_street['street']['street_id']['unique'] = 'off';
		
		if($this->getConfigValue('link_street_to_city')){
			$form_street['street']['city_id']['name'] = 'city_id';
			$form_street['street']['city_id']['primary_key_name'] = 'city_id';
			$form_street['street']['city_id']['title'] = Multilanguage::_('L_CITY');
			$form_street['street']['city_id']['value'] = 0;
			$form_street['street']['city_id']['length'] = 40;
			$form_street['street']['city_id']['type'] = 'select_by_query';
			$form_street['street']['city_id']['query'] = 'select city_id, name  from '.DB_PREFIX.'_city order by name';
			$form_street['street']['city_id']['value_name'] = 'name';
			$form_street['street']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
			$form_street['street']['city_id']['value_default'] = 0;
			$form_street['street']['city_id']['required'] = 'off';
			$form_street['street']['city_id']['unique'] = 'off';
		}else{
			$form_street['street']['district_id']['name'] = 'district_id';
			$form_street['street']['district_id']['primary_key_name'] = 'id';
			$form_street['street']['district_id']['title'] = Multilanguage::_('L_DISTRICT');
			$form_street['street']['district_id']['value'] = 0;
			$form_street['street']['district_id']['length'] = 40;
			$form_street['street']['district_id']['type'] = 'select_by_query';
			$form_street['street']['district_id']['query'] = 'select d.id, CONCAT_WS(\'/\',d.name,c.name) as name  from '.DB_PREFIX.'_district d LEFT JOIN '.DB_PREFIX.'_city c ON d.city_id=c.city_id order by name';
			$form_street['street']['district_id']['value_name'] = 'name';
			$form_street['street']['district_id']['title_default'] = Multilanguage::_('L_CHOOSE_DISTRICT');
			$form_street['street']['district_id']['value_default'] = 0;
			$form_street['street']['district_id']['required'] = 'off';
			$form_street['street']['district_id']['unique'] = 'off';
		}
		
		
		
		$form_street['street']['name']['name'] = 'name';
		$form_street['street']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_street['street']['name']['value'] = '';
		$form_street['street']['name']['length'] = 40;
		$form_street['street']['name']['type'] = 'safe_string';
		$form_street['street']['name']['required'] = 'on';
		$form_street['street']['name']['unique'] = 'off';
		
		return $form_street;
    }
    
    /**
     * Get country model
     * @param
     * @return
     */
    function get_country_model () {
		$form_country = array();
		
		$form_country['country']['country_id']['name'] = 'country_id';
		$form_country['country']['country_id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_country['country']['country_id']['value'] = 0;
		$form_country['country']['country_id']['length'] = 40;
		$form_country['country']['country_id']['type'] = 'primary_key';
		$form_country['country']['country_id']['required'] = 'off';
		$form_country['country']['country_id']['unique'] = 'off';

		$form_country['country']['name']['name'] = 'name';
		$form_country['country']['name']['title'] = Multilanguage::_('L_TEXT_TITLE');
		$form_country['country']['name']['value'] = '';
		$form_country['country']['name']['length'] = 40;
		$form_country['country']['name']['type'] = 'safe_string';
		$form_country['country']['name']['required'] = 'on';
		$form_country['country']['name']['unique'] = 'off';
		
		return $form_country;
    }
    
    /**
     * Get ipoteka model
     * @param boolean $ajax mode
     * @return array
     */
    function get_ipoteka_model ( $ajax = false ) {
		$form_data = array();
		
		$form_data['ipoteka']['id']['name'] = 'id';
		$form_data['ipoteka']['id']['title'] = Multilanguage::_('L_TEXT_IDENTIFIER');
		$form_data['ipoteka']['id']['value'] = 0;
		$form_data['ipoteka']['id']['length'] = 40;
		$form_data['ipoteka']['id']['type'] = 'primary_key';
		$form_data['ipoteka']['id']['required'] = 'off';
		$form_data['ipoteka']['id']['unique'] = 'off';
		
		$form_data['ipoteka']['fio']['name'] = 'fio';
		$form_data['ipoteka']['fio']['title'] = '';
		$form_data['ipoteka']['fio']['value'] = '';
		$form_data['ipoteka']['fio']['length'] = 40;
		$form_data['ipoteka']['fio']['type'] = 'safe_string';
		$form_data['ipoteka']['fio']['required'] = 'on';
		$form_data['ipoteka']['fio']['unique'] = 'off';
		
		$form_data['ipoteka']['phone']['name'] = 'phone';
		$form_data['ipoteka']['phone']['title'] = ' ';
		$form_data['ipoteka']['phone']['value'] = '';
		$form_data['ipoteka']['phone']['length'] = 40;
		$form_data['ipoteka']['phone']['type'] = 'safe_string';
		$form_data['ipoteka']['phone']['required'] = 'on';
		$form_data['ipoteka']['phone']['unique'] = 'off';

		$form_data['ipoteka']['email']['name'] = 'email';
		$form_data['ipoteka']['email']['title'] = '.';
		$form_data['ipoteka']['email']['value'] = '';
		$form_data['ipoteka']['email']['length'] = 40;
		$form_data['ipoteka']['email']['type'] = 'safe_string';
		$form_data['ipoteka']['email']['required'] = 'on';
		$form_data['ipoteka']['email']['unique'] = 'off';
		
		$form_data['ipoteka']['city_id']['name'] = 'city_id';
		$form_data['ipoteka']['city_id']['primary_key_name'] = 'city_id';
		$form_data['ipoteka']['city_id']['primary_key_table'] = 'city';
		$form_data['ipoteka']['city_id']['title'] = '  ';
		$form_data['ipoteka']['city_id']['value_string'] = '';
		$form_data['ipoteka']['city_id']['value'] = 0;
		$form_data['ipoteka']['city_id']['length'] = 40;
		$form_data['ipoteka']['city_id']['type'] = 'select_by_query';
		$form_data['ipoteka']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
		$form_data['ipoteka']['city_id']['value_name'] = 'name';
		$form_data['ipoteka']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
		$form_data['ipoteka']['city_id']['value_default'] = 0;
		$form_data['ipoteka']['city_id']['required'] = 'off';
		$form_data['ipoteka']['city_id']['unique'] = 'off';

		$form_data['ipoteka']['workage']['name'] = 'workage';
		$form_data['ipoteka']['workage']['title'] = '    ';
		$form_data['ipoteka']['workage']['value'] = '';
		$form_data['ipoteka']['workage']['length'] = 40;
		$form_data['ipoteka']['workage']['type'] = 'select_box';
		$form_data['ipoteka']['workage']['select_data'] = array('' => '', ' 3 .' => ' 3 .', ' 3 .' => ' 3 .', ' ' => ' ' );
		$form_data['ipoteka']['workage']['required'] = 'off';
		$form_data['ipoteka']['workage']['unique'] = 'off';
		
		$form_data['ipoteka']['age']['name'] = 'age';
		$form_data['ipoteka']['age']['title'] = '  ()';
		$form_data['ipoteka']['age']['value'] = '';
		$form_data['ipoteka']['age']['length'] = 40;
		$form_data['ipoteka']['age']['type'] = 'safe_string';
		$form_data['ipoteka']['age']['required'] = 'on';
		$form_data['ipoteka']['age']['unique'] = 'off';

		$form_data['ipoteka']['kredit']['name'] = 'kredit';
		$form_data['ipoteka']['kredit']['title'] = '    ';
		$form_data['ipoteka']['kredit']['value'] = '';
		$form_data['ipoteka']['kredit']['length'] = 40;
		$form_data['ipoteka']['kredit']['type'] = 'select_box';
		$form_data['ipoteka']['kredit']['select_data'] = array(' ' => ' ', '' => '', '  ' => '  ', ' ' => ' ', '' => '', ' ' => ' ');
		$form_data['ipoteka']['kredit']['required'] = 'off';
		$form_data['ipoteka']['kredit']['unique'] = 'off';
		
		$form_data['ipoteka']['cost']['name'] = 'cost';
		$form_data['ipoteka']['cost']['title'] = '';
		$form_data['ipoteka']['cost']['value'] = '';
		$form_data['ipoteka']['cost']['length'] = 40;
		$form_data['ipoteka']['cost']['type'] = 'safe_string';
		$form_data['ipoteka']['cost']['required'] = 'on';
		$form_data['ipoteka']['cost']['unique'] = 'off';
		
		$form_data['ipoteka']['dohod']['name'] = 'dohod';
		$form_data['ipoteka']['dohod']['title'] = ' ';
		$form_data['ipoteka']['dohod']['value'] = '';
		$form_data['ipoteka']['dohod']['length'] = 40;
		$form_data['ipoteka']['dohod']['type'] = 'select_box';
		$form_data['ipoteka']['dohod']['select_data'] = array('' => '', '2-' => '2-', ' ' => ' ');
		$form_data['ipoteka']['dohod']['required'] = 'off';
		$form_data['ipoteka']['dohod']['unique'] = 'off';
		
		$form_data['ipoteka']['dohod_per_month']['name'] = 'dohod_per_month';
		$form_data['ipoteka']['dohod_per_month']['title'] = '  ';
		$form_data['ipoteka']['dohod_per_month']['value'] = '';
		$form_data['ipoteka']['dohod_per_month']['length'] = 40;
		$form_data['ipoteka']['dohod_per_month']['type'] = 'safe_string';
		$form_data['ipoteka']['dohod_per_month']['required'] = 'off';
		$form_data['ipoteka']['dohod_per_month']['unique'] = 'off';
		
		$form_data['ipoteka']['vznos']['name'] = 'vznos';
		$form_data['ipoteka']['vznos']['title'] = ' ';
		$form_data['ipoteka']['vznos']['value'] = '';
		$form_data['ipoteka']['vznos']['length'] = 40;
		$form_data['ipoteka']['vznos']['type'] = 'safe_string';
		$form_data['ipoteka']['vznos']['required'] = 'off';
		$form_data['ipoteka']['vznos']['unique'] = 'off';
		
		$form_data['ipoteka']['captcha']['name'] = 'captcha';
		$form_data['ipoteka']['captcha']['title'] = ' ';
		$form_data['ipoteka']['captcha']['value'] = '';
		$form_data['ipoteka']['captcha']['length'] = 40;
		$form_data['ipoteka']['captcha']['type'] = 'captcha';
		$form_data['ipoteka']['captcha']['required'] = 'on';
		$form_data['ipoteka']['captcha']['unique'] = 'off';

        //$item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'];
		
		return $form_data;
    }
    
    
    /**
     * Get kvartira model
     * @param boolean $ajax mode
     * @return array
     */
    function get_kvartira_model ( $ajax = false, $ignore_user_group=false ) {
    	$form_data = array();
    	$table_name='data';
    	if(file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/admin.php') && file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/columns/admin/admin.php') && file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/helper.php') ){
    		require_once SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/helper.php';
    		$ATH=new Admin_Table_Helper();
    		$form_data=$ATH->load_model($table_name, $ignore_user_group);
    		
    		
    		if(empty($form_data)){
    			$form_data = array();
    			$form_data = $this->_get_kvartira_model($ajax);
    			//$form_data = $this->_get_big_city_kvartira_model2($ajax);
    			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
    			require_once SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/admin.php';
    			$TA=new table_admin();
    			$TA->create_table_and_columns($form_data, $table_name);
    			$form_data = array();
    			$form_data=$ATH->load_model($table_name, $ignore_user_group);
    		}
    		
    		$form_data = $ATH->add_ajax($form_data);
    		
    		
    	}else{
    		$form_data = $this->_get_kvartira_model($ajax);
    		//$form_data = $this->_get_big_city_kvartira_model2($ajax);
    	}
    	
    	return $form_data;
    }
    

    
    function _get_kvartira_model ( $ajax = false ){
    	$form_data = array();
			
		$form_data['data']['id']['name'] = 'id';
		$form_data['data']['id']['title'] = '';
		$form_data['data']['id']['value'] = 0;
		$form_data['data']['id']['length'] = 40;
		$form_data['data']['id']['type'] = 'primary_key';
		$form_data['data']['id']['required'] = 'off';
		$form_data['data']['id']['unique'] = 'off';
		
		$form_data['data']['user_id']['name'] = 'user_id';
		$form_data['data']['user_id']['title'] = ' ';
		$form_data['data']['user_id']['value'] = 0;
		$form_data['data']['user_id']['length'] = 40;
		$form_data['data']['user_id']['type'] = 'user_id';
		$form_data['data']['user_id']['required'] = 'off';
		$form_data['data']['user_id']['unique'] = 'off';
		
		$form_data['data']['date_added']['name'] = 'date_added';
		$form_data['data']['date_added']['title'] = ' ';
		$form_data['data']['date_added']['value'] = date('Y-m-d H:i:s',time());
		$form_data['data']['date_added']['length'] = 40;
		$form_data['data']['date_added']['type'] = 'hidden';
		$form_data['data']['date_added']['required'] = 'off';
		$form_data['data']['date_added']['unique'] = 'off';
		
		$form_data['data']['active']['name'] = 'active';
		$form_data['data']['active']['title'] = '  ';
		$form_data['data']['active']['value'] = 0;
		$form_data['data']['active']['length'] = 40;
		$form_data['data']['active']['type'] = 'checkbox';
		$form_data['data']['active']['required'] = 'off';
		$form_data['data']['active']['unique'] = 'off';

		$form_data['data']['hot']['name'] = 'hot';
		$form_data['data']['hot']['title'] = '';
		$form_data['data']['hot']['value'] = 0;
		$form_data['data']['hot']['length'] = 40;
		$form_data['data']['hot']['type'] = 'checkbox';
		$form_data['data']['hot']['required'] = 'off';
		$form_data['data']['hot']['unique'] = 'off';
		
		
		
		if($this->getConfigValue('apps.realtypro.show_contact.enable')==1){
			$form_data['data']['show_contact']['name'] = 'show_contact';
			$form_data['data']['show_contact']['title'] = '   ';
			$form_data['data']['show_contact']['value'] = 0;
			$form_data['data']['show_contact']['length'] = 40;
			$form_data['data']['show_contact']['type'] = 'checkbox';
			$form_data['data']['show_contact']['required'] = 'off';
			$form_data['data']['show_contact']['unique'] = 'off';
		}
		
		
		if ( $this->getConfigValue('apps.company.best') ) {
			$form_data['data']['best']['name'] = 'best';
			$form_data['data']['best']['title'] = ' ';
			$form_data['data']['best']['value'] = 0;
			$form_data['data']['best']['length'] = 40;
			$form_data['data']['best']['type'] = 'checkbox';
			$form_data['data']['best']['required'] = 'off';
			$form_data['data']['best']['unique'] = 'off';
		}
		
		$form_data['data']['topic_id']['name'] = 'topic_id';
		$form_data['data']['topic_id']['title'] = '';
		$form_data['data']['topic_id']['value_string'] = '';
		$form_data['data']['topic_id']['value'] = 0;
		$form_data['data']['topic_id']['length'] = 40;
		$form_data['data']['topic_id']['type'] = 'select_box_structure';
		$form_data['data']['topic_id']['required'] = 'on';
		$form_data['data']['topic_id']['unique'] = 'off';
		
		if ( $this->getConfigValue('country_in_form') ) {
		    $form_data['data']['country_id']['name'] = 'country_id';
		    $form_data['data']['country_id']['primary_key_name'] = 'country_id';
		    $form_data['data']['country_id']['primary_key_table'] = 'country';
		    $form_data['data']['country_id']['title'] = '';
		    $form_data['data']['country_id']['value_string'] = '';
		    $form_data['data']['country_id']['value'] = 0;
		    $form_data['data']['country_id']['length'] = 40;
		    $form_data['data']['country_id']['type'] = 'select_by_query';
		    $form_data['data']['country_id']['query'] = 'select * from '.DB_PREFIX.'_country order by name';
		    $form_data['data']['country_id']['value_name'] = 'name';
		    $form_data['data']['country_id']['title_default'] = Multilanguage::_('L_CHOOSE_COUNTRY');
		    $form_data['data']['country_id']['value_default'] = 0;
		    $form_data['data']['country_id']['required'] = 'off';
		    $form_data['data']['country_id']['unique'] = 'off';
		    if ( $ajax ) {
		        $form_data['data']['country_id']['onchange'] = '';

		        if ( $this->getConfigValue('apps.realty.ajax_region_refresh') ) {
		            $form_data['data']['country_id']['onchange'] .= ' update_child_list(\'region_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_city_refresh') ) {
		            $form_data['data']['country_id']['onchange'] .= ' set_empty(\'city_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
		            $form_data['data']['country_id']['onchange'] .= ' set_empty(\'district_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
		            $form_data['data']['country_id']['onchange'] .= ' set_empty(\'metro_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
		            $form_data['data']['country_id']['onchange'] .= ' set_empty(\'street_id\', this); ';     
		        }
		    }
		}
		
		if ( $this->getConfigValue('region_in_form') ) {
		    $form_data['data']['region_id']['name'] = 'region_id';
		    $form_data['data']['region_id']['primary_key_name'] = 'region_id';
		    $form_data['data']['region_id']['primary_key_table'] = 'region';
		    $form_data['data']['region_id']['title'] = Multilanguage::_('L_REGION');
		    $form_data['data']['region_id']['value_string'] = '';
		    $form_data['data']['region_id']['value'] = 0;
		    $form_data['data']['region_id']['length'] = 40;
		    $form_data['data']['region_id']['type'] = 'select_by_query';
		    $form_data['data']['region_id']['query'] = 'select * from '.DB_PREFIX.'_region order by name';

		    if ( $this->getRequestValue('country_id') != 0 and $this->getRequestValue('country_id') != '' ) {
		        $form_data['data']['region_id']['query'] = 'select * from '.DB_PREFIX.'_region where country_id='.$this->getRequestValue('country_id').' order by name';
		    }
		    
		    $form_data['data']['region_id']['value_name'] = 'name';
		    $form_data['data']['region_id']['title_default'] = Multilanguage::_('L_CHOOSE_REGION');
		    $form_data['data']['region_id']['value_default'] = 0;
		    $form_data['data']['region_id']['required'] = 'off';
		    $form_data['data']['region_id']['unique'] = 'off';
		    if ( $ajax ) {
		        if ( $this->getConfigValue('apps.realty.ajax_city_refresh') ) {
		            $form_data['data']['region_id']['onchange'] .= ' update_child_list(\'city_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
		            $form_data['data']['region_id']['onchange'] .= ' set_empty(\'district_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
		            $form_data['data']['region_id']['onchange'] .= ' set_empty(\'metro_id\', this); ';     
		        }
		        
		        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
		            $form_data['data']['region_id']['onchange'] .= ' set_empty(\'street_id\', this); ';     
		        }
		        
		    }
		}
		
		if ( $this->getConfigValue('city_in_form') ) {
		    $form_data['data']['city_id']['name'] = 'city_id';
		    $form_data['data']['city_id']['primary_key_name'] = 'city_id';
		    $form_data['data']['city_id']['primary_key_table'] = 'city';
		    $form_data['data']['city_id']['title'] = Multilanguage::_('L_CITY');
		    $form_data['data']['city_id']['value_string'] = '';
		    $form_data['data']['city_id']['value'] = 0;
		    $form_data['data']['city_id']['length'] = 40;
		    $form_data['data']['city_id']['type'] = 'select_by_query';
		    $form_data['data']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
		    if ( $this->getRequestValue('region_id') != 0 and $this->getRequestValue('region_id') != '' ) {
		        $form_data['data']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city where region_id='.$this->getRequestValue('region_id').' order by name';
		    }
		    $form_data['data']['city_id']['value_name'] = 'name';
		    if ( $this->getConfigValue('theme') == 'kgs' ) {
		    	$form_data['data']['city_id']['title_default'] = ' ';
		    } else {
		    	$form_data['data']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
		    }
		    $form_data['data']['city_id']['value_default'] = 0;
		    $form_data['data']['city_id']['required'] = 'off';
		    $form_data['data']['city_id']['unique'] = 'off';
		    if ( $ajax ) {
		        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
		            $form_data['data']['city_id']['onchange'] .= ' update_child_list(\'metro_id\', this); ';     
		        }
		        if($this->getConfigValue('link_street_to_city')){
		        	if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
			            $form_data['data']['city_id']['onchange'] .= ' update_child_list(\'district_id\', this); ';     
			        }
			        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
			            $form_data['data']['city_id']['onchange'] .= ' update_child_list(\'street_id\', this); ';     
			        }
		        }else{
			        if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
			            $form_data['data']['city_id']['onchange'] .= ' update_child_list(\'district_id\', this); ';     
			        }
		        	if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
			            $form_data['data']['city_id']['onchange'] .= ' set_empty(\'street_id\', this); ';     
			        }
		        }
		        
		        
		        
		        
		    }
		}
		
		
		if ( $this->getConfigValue('metro_in_form') ) {
		    $form_data['data']['metro_id']['name'] = 'metro_id';
		    $form_data['data']['metro_id']['primary_key_name'] = 'metro_id';
		    $form_data['data']['metro_id']['primary_key_table'] = 'metro';
		    $form_data['data']['metro_id']['title'] = '';
		    $form_data['data']['metro_id']['value_string'] = '';
		    $form_data['data']['metro_id']['value'] = 0;
		    $form_data['data']['metro_id']['length'] = 40;
		    $form_data['data']['metro_id']['type'] = 'select_by_query';
		    $form_data['data']['metro_id']['query'] = 'select * from '.DB_PREFIX.'_metro order by name';
		    if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
		        $form_data['data']['metro_id']['query'] = 'select * from '.DB_PREFIX.'_metro where city_id='.$this->getRequestValue('city_id').' order by name';
		    }
		
		    $form_data['data']['metro_id']['value_name'] = 'name';
		    $form_data['data']['metro_id']['title_default'] = ' ';
		    $form_data['data']['metro_id']['value_default'] = 0;
		    $form_data['data']['metro_id']['required'] = 'off';
		    $form_data['data']['metro_id']['unique'] = 'off';
		}
		
		if ( $this->getConfigValue('district_in_form') ) {
		    $form_data['data']['district_id']['name'] = 'district_id';
		    $form_data['data']['district_id']['primary_key_name'] = 'id';
		    $form_data['data']['district_id']['primary_key_table'] = 'district';
		    $form_data['data']['district_id']['title'] = Multilanguage::_('L_DISTRICT');
		    $form_data['data']['district_id']['value_string'] = '';
		    $form_data['data']['district_id']['value'] = 0;
		    $form_data['data']['district_id']['length'] = 40;
		    $form_data['data']['district_id']['type'] = 'select_by_query';
		    $form_data['data']['district_id']['query'] = 'select * from '.DB_PREFIX.'_district order by name';
		    if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
		        $form_data['data']['district_id']['query'] = 'select * from '.DB_PREFIX.'_district where city_id='.$this->getRequestValue('city_id').' order by name';
		    }
		    $form_data['data']['district_id']['value_name'] = 'name';
		    $form_data['data']['district_id']['title_default'] = Multilanguage::_('L_CHOOSE_DISTRICT');
		    $form_data['data']['district_id']['value_default'] = 0;
		    $form_data['data']['district_id']['required'] = 'off';
		    $form_data['data']['district_id']['unique'] = 'off';
		    if ( $ajax ) {
		        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
		        	 if($this->getConfigValue('link_street_to_city')){
		        	 	
		        	 }else{
		        	 	$form_data['data']['district_id']['onchange'] .= ' update_child_list(\'street_id\', this); ';     
		        	 }
		            
		        }
		        
		    }
		}
		
		if ( $this->getConfigValue('street_in_form') ) {
		    $form_data['data']['street_id']['name'] = 'street_id';
		    $form_data['data']['street_id']['primary_key_name'] = 'street_id';
		    $form_data['data']['street_id']['primary_key_table'] = 'street';
		    $form_data['data']['street_id']['title'] = Multilanguage::_('L_STREET');
		    $form_data['data']['street_id']['value_string'] = '';
		    $form_data['data']['street_id']['value'] = 0;
		    $form_data['data']['street_id']['length'] = 40;
		    $form_data['data']['street_id']['type'] = 'select_by_query';
		    $form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street order by name';
		    if ( $this->getRequestValue('district_id') != 0 and $this->getRequestValue('district_id') != '' ) {
		        $form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street where district_id='.$this->getRequestValue('district_id').' order by name';
		    }
		    if($this->getConfigValue('link_street_to_city')){
			    if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
			        $form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street where city_id='.$this->getRequestValue('city_id').' order by name';
			    }
		    }
			
		    $form_data['data']['street_id']['value_name'] = 'name';
		    $form_data['data']['street_id']['title_default'] = Multilanguage::_('L_CHOOSE_STREET');
		    $form_data['data']['street_id']['value_default'] = 0;
		    $form_data['data']['street_id']['required'] = 'off';
		    $form_data['data']['street_id']['unique'] = 'off';
		    
		    if ( $this->getConfigValue('user_add_street_enable') ) {
		    	$form_data['data']['new_street']['name'] = 'new_street';
		    	$form_data['data']['new_street']['title'] = ' ';
		    	$form_data['data']['new_street']['value'] = '';
		    	$form_data['data']['new_street']['length'] = 40;
		    	$form_data['data']['new_street']['type'] = 'auto_add_value';
		    	$form_data['data']['new_street']['dbtype'] = 'notable';
		    	$form_data['data']['new_street']['value_table'] = 'street';
		    	$form_data['data']['new_street']['value_primary_key'] = 'street_id';
		    	$form_data['data']['new_street']['value_field'] = 'name';
		    	$form_data['data']['new_street']['assign_to'] = 'street_id';
		    	$form_data['data']['new_street']['required'] = 'off';
		    	$form_data['data']['new_street']['unique'] = 'off';
		    }
		}
		
		
		$form_data['data']['number']['name'] = 'number';
		$form_data['data']['number']['title'] = ' ';
		$form_data['data']['number']['value'] = '';
		$form_data['data']['number']['length'] = 40;
		$form_data['data']['number']['type'] = 'safe_string';
		$form_data['data']['number']['required'] = 'off';
		$form_data['data']['number']['unique'] = 'off';
		
		$form_data['data']['price']['name'] = 'price';
		$form_data['data']['price']['title'] = '';
		$form_data['data']['price']['value'] = '';
		$form_data['data']['price']['length'] = 40;
		$form_data['data']['price']['type'] = 'price';
		if ( $this->getConfigValue('theme') == 'albostar' ) {
			$form_data['data']['price']['required'] = 'on';
		} else {
			$form_data['data']['price']['required'] = 'off';
		}
		$form_data['data']['price']['unique'] = 'off';
		
		if ( $this->getConfigValue('currency_enable') ) {
			$form_data['data']['currency_id']['name'] = 'currency_id';
			$form_data['data']['currency_id']['primary_key_name'] = 'currency_id';
			$form_data['data']['currency_id']['primary_key_table'] = 'currency';
			$form_data['data']['currency_id']['title'] = '';
			$form_data['data']['currency_id']['value_string'] = '';
			$form_data['data']['currency_id']['value'] = 0;
			$form_data['data']['currency_id']['length'] = 40;
			$form_data['data']['currency_id']['type'] = 'select_by_query';
			$form_data['data']['currency_id']['query'] = 'select * from '.DB_PREFIX.'_currency WHERE is_active=1 ORDER BY sort_order ASC, code ASC, currency_id ASC';
			$form_data['data']['currency_id']['value_name'] = 'name';
			$form_data['data']['currency_id']['title_default'] = '';
			$form_data['data']['currency_id']['value_default'] = 0;
			$form_data['data']['currency_id']['required'] = 'off';
			$form_data['data']['currency_id']['unique'] = 'off';
		}
		
		$form_data['data']['room_count']['name'] = 'room_count';
		$form_data['data']['room_count']['title'] = '. ';
		$form_data['data']['room_count']['value'] = '';
		$form_data['data']['room_count']['length'] = 40;
		$form_data['data']['room_count']['type'] = 'safe_string';
		$form_data['data']['room_count']['required'] = 'off';
		$form_data['data']['room_count']['unique'] = 'off';
		
		$form_data['data']['floor']['name'] = 'floor';
		$form_data['data']['floor']['title'] = '';
		$form_data['data']['floor']['value'] = '';
		$form_data['data']['floor']['length'] = 40;
		$form_data['data']['floor']['type'] = 'safe_string';
		$form_data['data']['floor']['required'] = 'off';
		$form_data['data']['floor']['unique'] = 'off';
		
		$form_data['data']['floor_count']['name'] = 'floor_count';
		$form_data['data']['floor_count']['title'] = '';
		$form_data['data']['floor_count']['value'] = '';
		$form_data['data']['floor_count']['length'] = 40;
		$form_data['data']['floor_count']['type'] = 'safe_string';
		$form_data['data']['floor_count']['required'] = 'off';
		$form_data['data']['floor_count']['unique'] = 'off';
		
		
		$form_data['data']['walls']['name'] = 'walls';
		$form_data['data']['walls']['title'] = ' ';
		$form_data['data']['walls']['value'] = '';
		$form_data['data']['walls']['length'] = 40;
		$form_data['data']['walls']['type'] = 'safe_string';
		$form_data['data']['walls']['required'] = 'off';
		$form_data['data']['walls']['unique'] = 'off';

		if ( $this->getConfigValue('apps.plan.enable') ) {
			
			$form_data['data']['planning']['name'] = 'planning';
			$form_data['data']['planning']['primary_key_name'] = 'plan_id';
			$form_data['data']['planning']['primary_key_table'] = 'plan';
			$form_data['data']['planning']['title'] = '';
			$form_data['data']['planning']['value_string'] = '';
			$form_data['data']['planning']['value'] = 0;
			$form_data['data']['planning']['length'] = 40;
			$form_data['data']['planning']['type'] = 'select_by_query';
			$form_data['data']['planning']['query'] = 'select * from '.DB_PREFIX.'_plan order by name';
			$form_data['data']['planning']['value_name'] = 'name';
			$form_data['data']['planning']['title_default'] = ' ';
			$form_data['data']['planning']['value_default'] = 0;
			$form_data['data']['planning']['required'] = 'off';
			$form_data['data']['planning']['unique'] = 'off';

		} else {
			$form_data['data']['planning']['name'] = 'planning';
			$form_data['data']['planning']['title'] = '';
			$form_data['data']['planning']['value'] = '';
			$form_data['data']['planning']['length'] = 40;
			$form_data['data']['planning']['type'] = 'safe_string';
			$form_data['data']['planning']['required'] = 'off';
			$form_data['data']['planning']['unique'] = 'off';
		}
		
		if ( $this->getConfigValue('apps.balcony.enable') ) {
			$form_data['data']['balcony']['name'] = 'balcony';
			$form_data['data']['balcony']['primary_key_name'] = 'balcony_id';
			$form_data['data']['balcony']['primary_key_table'] = 'balcony';
			$form_data['data']['balcony']['title'] = '';
			$form_data['data']['balcony']['value_string'] = '';
			$form_data['data']['balcony']['value'] = 0;
			$form_data['data']['balcony']['length'] = 40;
			$form_data['data']['balcony']['type'] = 'select_by_query';
			$form_data['data']['balcony']['query'] = 'select * from '.DB_PREFIX.'_balcony order by name';
			$form_data['data']['balcony']['value_name'] = 'name';
			$form_data['data']['balcony']['title_default'] = ' ';
			$form_data['data']['balcony']['value_default'] = 0;
			$form_data['data']['balcony']['required'] = 'off';
			$form_data['data']['balcony']['unique'] = 'off';
		} else {
			$form_data['data']['balcony']['name'] = 'balcony';
			$form_data['data']['balcony']['title'] = '';
			$form_data['data']['balcony']['value'] = '';
			$form_data['data']['balcony']['length'] = 40;
			$form_data['data']['balcony']['type'] = 'safe_string';
			$form_data['data']['balcony']['required'] = 'off';
			$form_data['data']['balcony']['unique'] = 'off';
		}
		/*
		$form_data['data']['date_added']['name'] = 'date_added';
		$form_data['data']['date_added']['title'] = ' ';
		$form_data['data']['date_added']['value'] = time();
		$form_data['data']['date_added']['length'] = 40;
		$form_data['data']['date_added']['type'] = 'safe_string';
		$form_data['data']['date_added']['required'] = 'off';
		$form_data['data']['date_added']['unique'] = 'off';
		*/

		$form_data['data']['square_all']['name'] = 'square_all';
		$form_data['data']['square_all']['title'] = ' ';
		$form_data['data']['square_all']['value'] = '';
		$form_data['data']['square_all']['length'] = 40;
		$form_data['data']['square_all']['type'] = 'safe_string';
		$form_data['data']['square_all']['required'] = 'off';
		$form_data['data']['square_all']['unique'] = 'off';
		
		$form_data['data']['square_live']['name'] = 'square_live';
		$form_data['data']['square_live']['title'] = ' ';
		$form_data['data']['square_live']['value'] = '';
		$form_data['data']['square_live']['length'] = 40;
		$form_data['data']['square_live']['type'] = 'safe_string';
		$form_data['data']['square_live']['required'] = 'off';
		$form_data['data']['square_live']['unique'] = 'off';
		
		$form_data['data']['square_kitchen']['name'] = 'square_kitchen';
		$form_data['data']['square_kitchen']['title'] = ' ';
		$form_data['data']['square_kitchen']['value'] = '';
		$form_data['data']['square_kitchen']['length'] = 40;
		$form_data['data']['square_kitchen']['type'] = 'safe_string';
		$form_data['data']['square_kitchen']['required'] = 'off';
		$form_data['data']['square_kitchen']['unique'] = 'off';

		if ( $this->getConfigValue('theme') == 'albostar' ) {
			$form_data['data']['square_land']['name'] = 'square_land';
			$form_data['data']['square_land']['title'] = ' ';
			$form_data['data']['square_land']['value'] = '';
			$form_data['data']['square_land']['length'] = 40;
			$form_data['data']['square_land']['type'] = 'safe_string';
			$form_data['data']['square_land']['required'] = 'off';
			$form_data['data']['square_land']['unique'] = 'off';
		}
		

		if ( $this->getConfigValue('apps.sanuzel.enable') ) {
			
			$form_data['data']['bathroom']['name'] = 'bathroom';
			$form_data['data']['bathroom']['primary_key_name'] = 'sanuzel_id';
			$form_data['data']['bathroom']['primary_key_table'] = 'sanuzel';
			$form_data['data']['bathroom']['title'] = '. ';
			$form_data['data']['bathroom']['value_string'] = '';
			$form_data['data']['bathroom']['value'] = 0;
			$form_data['data']['bathroom']['length'] = 40;
			$form_data['data']['bathroom']['type'] = 'select_by_query';
			$form_data['data']['bathroom']['query'] = 'select * from '.DB_PREFIX.'_sanuzel order by name';
			$form_data['data']['bathroom']['value_name'] = 'name';
			$form_data['data']['bathroom']['title_default'] = ' . ';
			$form_data['data']['bathroom']['value_default'] = 0;
			$form_data['data']['bathroom']['required'] = 'off';
			$form_data['data']['bathroom']['unique'] = 'off';

		} else {
			$form_data['data']['bathroom']['name'] = 'bathroom';
			$form_data['data']['bathroom']['title'] = '. ';
			$form_data['data']['bathroom']['value'] = '';
			$form_data['data']['bathroom']['length'] = 40;
			$form_data['data']['bathroom']['type'] = 'safe_string';
			$form_data['data']['bathroom']['required'] = 'off';
			$form_data['data']['bathroom']['unique'] = 'off';
		}
		
		$form_data['data']['plate']['name'] = 'plate';
		$form_data['data']['plate']['title'] = '';
		$form_data['data']['plate']['value'] = '';
		$form_data['data']['plate']['length'] = 40;
		$form_data['data']['plate']['type'] = 'select_box';
		$form_data['data']['plate']['select_data'] = array('' => '', '' => '', '' => '' );
		$form_data['data']['plate']['required'] = 'off';
		$form_data['data']['plate']['unique'] = 'off';
		
		if($this->getConfigValue('theme')!='albostar'){
			$form_data['data']['is_telephone']['name'] = 'is_telephone';
			$form_data['data']['is_telephone']['title'] = '';
			$form_data['data']['is_telephone']['value'] = 0;
			$form_data['data']['is_telephone']['length'] = 40;
			$form_data['data']['is_telephone']['type'] = 'checkbox';
			$form_data['data']['is_telephone']['required'] = 'off';
			$form_data['data']['is_telephone']['unique'] = 'off';
		
		
			$form_data['data']['furniture']['name'] = 'furniture';
			$form_data['data']['furniture']['title'] = '';
			$form_data['data']['furniture']['value'] = 0;
			$form_data['data']['furniture']['length'] = 40;
			$form_data['data']['furniture']['type'] = 'checkbox';
			$form_data['data']['furniture']['required'] = 'off';
			$form_data['data']['furniture']['unique'] = 'off';
		}
		
		$form_data['data']['text']['name'] = 'text';
		$form_data['data']['text']['title'] = '';
		$form_data['data']['text']['value'] = '';
		$form_data['data']['text']['length'] = 40;
		$form_data['data']['text']['type'] = 'textarea_editor';
		$form_data['data']['text']['required'] = 'off';
		$form_data['data']['text']['unique'] = 'off';
		$form_data['data']['text']['rows'] = '10';
		$form_data['data']['text']['cols'] = '40';

        //$item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'];
		
		$form_data['data']['image']['name'] = 'image';
		$form_data['data']['image']['table_name'] = 'data';
		$form_data['data']['image']['primary_key'] = 'id';
		$form_data['data']['image']['primary_key_value'] = 0;
		$form_data['data']['image']['action'] = 'data';
		$form_data['data']['image']['title'] = ' ';
		$form_data['data']['image']['value'] = '';
		$form_data['data']['image']['length'] = 40;
		$form_data['data']['image']['type'] = 'uploadify_image';
		$form_data['data']['image']['required'] = 'off';
		$form_data['data']['image']['unique'] = 'off';
		
		if ( $this->getConfigValue('apps.realtypro.youtube') ) {
			$form_data['data']['youtube']['name'] = 'youtube';
			$form_data['data']['youtube']['title'] = '';
			$form_data['data']['youtube']['value'] = '';
			$form_data['data']['youtube']['length'] = 40;
			$form_data['data']['youtube']['type'] = 'safe_string';
			$form_data['data']['youtube']['required'] = 'off';
			$form_data['data']['youtube']['unique'] = 'off';
		}
		
		$form_data['data']['fio']['name'] = 'fio';
		$form_data['data']['fio']['title'] = ' ';
		$form_data['data']['fio']['value'] = '';
		$form_data['data']['fio']['length'] = 40;
		$form_data['data']['fio']['type'] = 'safe_string';
		$form_data['data']['fio']['required'] = 'on';
		$form_data['data']['fio']['unique'] = 'off';
		
		$form_data['data']['email']['name'] = 'email';
		$form_data['data']['email']['title'] = 'E-mail';
		$form_data['data']['email']['value'] = '';
		$form_data['data']['email']['length'] = 40;
		$form_data['data']['email']['type'] = 'safe_string';
		$form_data['data']['email']['required'] = 'off';
		$form_data['data']['email']['unique'] = 'off';
		
		$form_data['data']['phone']['name'] = 'phone';
		$form_data['data']['phone']['title'] = ' ';
		$form_data['data']['phone']['value'] = '';
		$form_data['data']['phone']['length'] = 40;
		$form_data['data']['phone']['type'] = 'mobilephone';
		$form_data['data']['phone']['required'] = 'off';
		$form_data['data']['phone']['unique'] = 'off';
		
		
    	if($this->getConfigValue('allow_callme_timelimits')){
			$form_data['data']['can_call_start']['name'] = 'can_call_start';
			$form_data['data']['can_call_start']['title'] = '      (HH:MM)';
			$form_data['data']['can_call_start']['value'] = '';
			$form_data['data']['can_call_start']['length'] = 40;
			$form_data['data']['can_call_start']['type'] = 'select_box';
			$form_data['data']['can_call_start']['select_data'] = array(' ','6:00','7:00','8:00','9:00','10:00','11:00','12:00','13:00','14:00','15:00','16:00','17:00','18:00','19:00','20:00','21:00','22:00','23:00');
			$form_data['data']['can_call_start']['required'] = 'off';
			$form_data['data']['can_call_start']['unique'] = 'off';
			
			$form_data['data']['can_call_end']['name'] = 'can_call_end';
			$form_data['data']['can_call_end']['title'] = '      (HH:MM)';
			$form_data['data']['can_call_end']['value'] = '';
			$form_data['data']['can_call_end']['length'] = 40;
			$form_data['data']['can_call_end']['type'] = 'select_box';
			$form_data['data']['can_call_end']['select_data'] = array(' ','6:00','7:00','8:00','9:00','10:00','11:00','12:00','13:00','14:00','15:00','16:00','17:00','18:00','19:00','20:00','21:00','22:00','23:00');
			$form_data['data']['can_call_end']['required'] = 'off';
			$form_data['data']['can_call_end']['unique'] = 'off';
		}

		/*
		if ( $this->getConfigValue('apps.fasteditor.enable') ) {
			$form_data['data']['tmp_password']['name'] = 'tmp_password';
			$form_data['data']['tmp_password']['title'] = 'tmp_password';
			$form_data['data']['tmp_password']['value'] = '';
			$form_data['data']['tmp_password']['length'] = 40;
			$form_data['data']['tmp_password']['type'] = 'hidden';
			$form_data['data']['tmp_password']['required'] = 'off';
			$form_data['data']['tmp_password']['unique'] = 'off';
		}
		*/
		
		$form_data['data']['meta_title']['name'] = 'meta_title';
		$form_data['data']['meta_title']['title'] = 'Meta title';
		$form_data['data']['meta_title']['value'] = '';
		$form_data['data']['meta_title']['type'] = 'safe_string';
		$form_data['data']['meta_title']['required'] = 'off';
		$form_data['data']['meta_title']['unique'] = 'off';
		$form_data['data']['meta_title']['tab'] = '-';
		
		$form_data['data']['meta_keywords']['name'] = 'meta_keywords';
		$form_data['data']['meta_keywords']['title'] = 'Meta keywords';
		$form_data['data']['meta_keywords']['value'] = '';
		$form_data['data']['meta_keywords']['type'] = 'textarea';
		$form_data['data']['meta_keywords']['required'] = 'off';
		$form_data['data']['meta_keywords']['unique'] = 'off';
		$form_data['data']['meta_keywords']['tab'] = '-';
		$form_data['data']['meta_keywords']['rows'] = '5';
		$form_data['data']['meta_keywords']['cols'] = '40';
		
		$form_data['data']['meta_description']['name'] = 'meta_description';
		$form_data['data']['meta_description']['title'] = 'Meta description';
		$form_data['data']['meta_description']['value'] = '';
		$form_data['data']['meta_description']['type'] = 'textarea';
		$form_data['data']['meta_description']['required'] = 'off';
		$form_data['data']['meta_description']['unique'] = 'off';
		$form_data['data']['meta_description']['tab'] = '-';
		$form_data['data']['meta_description']['rows'] = '8';
		$form_data['data']['meta_description']['cols'] = '40';
		
		$form_data['data']['geo']['name'] = 'geo';
		$form_data['data']['geo']['title'] = '';
		$form_data['data']['geo']['value'] = '';
		$form_data['data']['geo']['type'] = 'geodata';
		$form_data['data']['geo']['required'] = 'off';
		$form_data['data']['geo']['unique'] = 'off';
		$form_data['data']['geo']['tab'] = '';
		
		$form_data['data']['view_count']['name'] = 'view_count';
		$form_data['data']['view_count']['title'] = ' ';
		$form_data['data']['view_count']['value'] = '';
		$form_data['data']['view_count']['length'] = 40;
		$form_data['data']['view_count']['type'] = 'hidden';
		$form_data['data']['view_count']['required'] = 'off';
		$form_data['data']['view_count']['unique'] = 'off';
		
		if ( $this->getConfigValue('theme') == 'kgs' ) {
			$form_data = $this->define_kgs_titles($form_data);
		}
		return $form_data;
    }
    
    function _get_big_city_kvartira_model ( $ajax = false ){
    	$form_data = array();
    		
    	$form_data['data']['id']['name'] = 'id';
    	$form_data['data']['id']['title'] = '';
    	$form_data['data']['id']['value'] = 0;
    	$form_data['data']['id']['length'] = 40;
    	$form_data['data']['id']['type'] = 'primary_key';
    	$form_data['data']['id']['required'] = 'off';
    	$form_data['data']['id']['unique'] = 'off';
    
    	$form_data['data']['user_id']['name'] = 'user_id';
    	$form_data['data']['user_id']['title'] = ' ';
    	$form_data['data']['user_id']['value'] = 0;
    	$form_data['data']['user_id']['length'] = 40;
    	$form_data['data']['user_id']['type'] = 'select_by_query';
    	$form_data['data']['user_id']['query'] = 'select * from '.DB_PREFIX.'_user order by login';
    	$form_data['data']['user_id']['value_name'] = 'login';
    	$form_data['data']['user_id']['primary_key_name'] = 'user_id';
    	$form_data['data']['user_id']['primary_key_table'] = 'user';
    	$form_data['data']['user_id']['title_default'] = ' ';
    	$form_data['data']['user_id']['value_default'] = 0;
    	$form_data['data']['user_id']['required'] = 'off';
    	$form_data['data']['user_id']['unique'] = 'off';
    
    	$form_data['data']['date_added']['name'] = 'date_added';
    	$form_data['data']['date_added']['title'] = ' ';
    	$form_data['data']['date_added']['value'] = '';
    	$form_data['data']['date_added']['length'] = 40;
    	$form_data['data']['date_added']['type'] = 'hidden';
    	$form_data['data']['date_added']['required'] = 'off';
    	$form_data['data']['date_added']['unique'] = 'off';
    
    	$form_data['data']['active']['name'] = 'active';
    	$form_data['data']['active']['title'] = '  ';
    	$form_data['data']['active']['value'] = 0;
    	$form_data['data']['active']['length'] = 40;
    	$form_data['data']['active']['type'] = 'checkbox';
    	$form_data['data']['active']['required'] = 'off';
    	$form_data['data']['active']['unique'] = 'off';
    
    	$form_data['data']['hot']['name'] = 'hot';
    	$form_data['data']['hot']['title'] = '';
    	$form_data['data']['hot']['value'] = 0;
    	$form_data['data']['hot']['length'] = 40;
    	$form_data['data']['hot']['type'] = 'checkbox';
    	$form_data['data']['hot']['required'] = 'off';
    	$form_data['data']['hot']['unique'] = 'off';
    	
    	$form_data['data']['optype']['name'] = 'optype';
    	$form_data['data']['optype']['title'] = ' ';
    	$form_data['data']['optype']['value'] = 0;
    	$form_data['data']['optype']['length'] = 40;
    	$form_data['data']['optype']['type'] = 'select_box';
    	$form_data['data']['optype']['select_data'] = array('0' => '', '1' => '' );
    	$form_data['data']['optype']['required'] = 'off';
    	$form_data['data']['optype']['unique'] = 'off';
    
    	$form_data['data']['topic_id']['name'] = 'topic_id';
    	$form_data['data']['topic_id']['title'] = '';
    	$form_data['data']['topic_id']['value_string'] = '';
    	$form_data['data']['topic_id']['value'] = 0;
    	$form_data['data']['topic_id']['length'] = 40;
    	$form_data['data']['topic_id']['type'] = 'select_box_structure';
    	$form_data['data']['topic_id']['required'] = 'on';
    	$form_data['data']['topic_id']['unique'] = 'off';
        	
    	$form_data['data']['metro_id']['name'] = 'metro_id';
    	$form_data['data']['metro_id']['primary_key_name'] = 'metro_id';
    	$form_data['data']['metro_id']['primary_key_table'] = 'metro';
    	$form_data['data']['metro_id']['title'] = '';
    	$form_data['data']['metro_id']['value_string'] = '';
    	$form_data['data']['metro_id']['value'] = 0;
    	$form_data['data']['metro_id']['length'] = 40;
    	$form_data['data']['metro_id']['type'] = 'select_by_query';
    	$form_data['data']['metro_id']['query'] = 'select * from '.DB_PREFIX.'_metro order by name';
    	$form_data['data']['metro_id']['value_name'] = 'name';
    	$form_data['data']['metro_id']['title_default'] = ' ';
    	$form_data['data']['metro_id']['value_default'] = 0;
    	$form_data['data']['metro_id']['required'] = 'off';
    	$form_data['data']['metro_id']['unique'] = 'off';
    	
    	$form_data['data']['metro_time_onfoot']['name'] = 'metro_time_onfoot';
    	$form_data['data']['metro_time_onfoot']['title'] = '   ';
    	$form_data['data']['metro_time_onfoot']['value'] = '';
    	$form_data['data']['metro_time_onfoot']['length'] = 40;
    	$form_data['data']['metro_time_onfoot']['type'] = 'safe_string';
    	$form_data['data']['metro_time_onfoot']['required'] = 'off';
    	$form_data['data']['metro_time_onfoot']['unique'] = 'off';
    	
    	$form_data['data']['metro_time_oncar']['name'] = 'metro_time_oncar';
    	$form_data['data']['metro_time_oncar']['title'] = '   ';
    	$form_data['data']['metro_time_oncar']['value'] = '';
    	$form_data['data']['metro_time_oncar']['length'] = 40;
    	$form_data['data']['metro_time_oncar']['type'] = 'safe_string';
    	$form_data['data']['metro_time_oncar']['required'] = 'off';
    	$form_data['data']['metro_time_oncar']['unique'] = 'off';
    	
    	/*$form_data['data']['is_city']['name'] = 'is_city';
    	$form_data['data']['is_city']['title'] = '';
    	$form_data['data']['is_city']['hint'] = '  ,  ';
    	$form_data['data']['is_city']['value'] = 1;
    	$form_data['data']['is_city']['type'] = 'checkbox';
    	$form_data['data']['is_city']['required'] = 'off';
    	$form_data['data']['is_city']['unique'] = 'off';*/
    	
    	$form_data['data']['city_id']['name'] = 'city_id';
    	$form_data['data']['city_id']['primary_key_name'] = 'city_id';
    	$form_data['data']['city_id']['primary_key_table'] = 'city';
    	$form_data['data']['city_id']['title'] = Multilanguage::_('L_CITY');
    	$form_data['data']['city_id']['value_string'] = '';
    	$form_data['data']['city_id']['value'] = 0;
    	$form_data['data']['city_id']['length'] = 40;
    	$form_data['data']['city_id']['type'] = 'select_by_query';
    	$form_data['data']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
    	$form_data['data']['city_id']['value_name'] = 'name';
    	$form_data['data']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
    	$form_data['data']['city_id']['value_default'] = 0;
    	$form_data['data']['city_id']['required'] = 'off';
    	$form_data['data']['city_id']['unique'] = 'off';
    	
    	$form_data['data']['street_id']['name'] = 'street_id';
    	$form_data['data']['street_id']['primary_key_name'] = 'street_id';
    	$form_data['data']['street_id']['primary_key_table'] = 'street';
    	$form_data['data']['street_id']['title'] = Multilanguage::_('L_STREET');
    	$form_data['data']['street_id']['value_string'] = '';
    	$form_data['data']['street_id']['value'] = 0;
    	$form_data['data']['street_id']['length'] = 40;
    	$form_data['data']['street_id']['type'] = 'select_by_query';
    	$form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street order by name';
    	$form_data['data']['street_id']['value_name'] = 'name';
    	$form_data['data']['street_id']['title_default'] = Multilanguage::_('L_CHOOSE_STREET');
    	$form_data['data']['street_id']['value_default'] = 0;
    	$form_data['data']['street_id']['required'] = 'off';
    	$form_data['data']['street_id']['unique'] = 'off';
    	
    	if ( $this->getConfigValue('user_add_street_enable') ) {
    		$form_data['data']['new_street']['name'] = 'new_street';
    		$form_data['data']['new_street']['title'] = ' ';
    		$form_data['data']['new_street']['value'] = '';
    		$form_data['data']['new_street']['length'] = 40;
    		$form_data['data']['new_street']['type'] = 'auto_add_value';
    		$form_data['data']['new_street']['dbtype'] = 'notable';
    		$form_data['data']['new_street']['value_table'] = 'street';
    		$form_data['data']['new_street']['value_primary_key'] = 'street_id';
    		$form_data['data']['new_street']['value_field'] = 'name';
    		$form_data['data']['new_street']['assign_to'] = 'street_id';
    		$form_data['data']['new_street']['required'] = 'off';
    		$form_data['data']['new_street']['unique'] = 'off';
    	}
    	
    	$form_data['data']['number']['name'] = 'number';
    	$form_data['data']['number']['title'] = ' ';
    	$form_data['data']['number']['value'] = '';
    	$form_data['data']['number']['length'] = 40;
    	$form_data['data']['number']['type'] = 'safe_string';
    	$form_data['data']['number']['required'] = 'off';
    	$form_data['data']['number']['unique'] = 'off';
    
    	$form_data['data']['housing_number']['name'] = 'housing_number';
    	$form_data['data']['housing_number']['title'] = ' ';
    	$form_data['data']['housing_number']['value'] = '';
    	$form_data['data']['housing_number']['length'] = 40;
    	$form_data['data']['housing_number']['type'] = 'safe_string';
    	$form_data['data']['housing_number']['required'] = 'off';
    	$form_data['data']['housing_number']['unique'] = 'off';
    
    	$form_data['data']['price']['name'] = 'price';
    	$form_data['data']['price']['title'] = '';
    	$form_data['data']['price']['value'] = '';
    	$form_data['data']['price']['length'] = 40;
    	$form_data['data']['price']['type'] = 'price';
    	$form_data['data']['price']['required'] = 'off';
    	$form_data['data']['price']['unique'] = 'off';
    
    	if ( $this->getConfigValue('currency_enable') ) {
    		$form_data['data']['currency_id']['name'] = 'currency_id';
    		$form_data['data']['currency_id']['primary_key_name'] = 'currency_id';
    		$form_data['data']['currency_id']['primary_key_table'] = 'currency';
    		$form_data['data']['currency_id']['title'] = '';
    		$form_data['data']['currency_id']['value_string'] = '';
    		$form_data['data']['currency_id']['value'] = 0;
    		$form_data['data']['currency_id']['length'] = 40;
    		$form_data['data']['currency_id']['type'] = 'select_by_query';
    		$form_data['data']['currency_id']['query'] = 'select * from '.DB_PREFIX.'_currency WHERE is_active=1 ORDER BY sort_order ASC, code ASC, currency_id ASC';
    		$form_data['data']['currency_id']['value_name'] = 'name';
    		$form_data['data']['currency_id']['title_default'] = '';
    		$form_data['data']['currency_id']['value_default'] = 0;
    		$form_data['data']['currency_id']['required'] = 'off';
    		$form_data['data']['currency_id']['unique'] = 'off';
    	}
    	
    	$form_data['data']['rent_term']['name'] = 'rent_term';
    	$form_data['data']['rent_term']['title'] = ' ';
    	$form_data['data']['rent_term']['value'] = 0;
    	$form_data['data']['rent_term']['length'] = 40;
    	$form_data['data']['rent_term']['type'] = 'select_box';
    	$form_data['data']['rent_term']['select_data'] = array('0' => '', '1' => '');
    	$form_data['data']['rent_term']['required'] = 'off';
    	$form_data['data']['rent_term']['unique'] = 'off';
    
    	$form_data['data']['room_count']['name'] = 'room_count';
    	$form_data['data']['room_count']['title'] = '. ';
    	$form_data['data']['room_count']['value'] = '';
    	$form_data['data']['room_count']['length'] = 40;
    	$form_data['data']['room_count']['type'] = 'safe_string';
    	$form_data['data']['room_count']['required'] = 'off';
    	$form_data['data']['room_count']['unique'] = 'off';
    
    	$form_data['data']['floor']['name'] = 'floor';
    	$form_data['data']['floor']['title'] = '';
    	$form_data['data']['floor']['value'] = '';
    	$form_data['data']['floor']['length'] = 40;
    	$form_data['data']['floor']['type'] = 'safe_string';
    	$form_data['data']['floor']['required'] = 'off';
    	$form_data['data']['floor']['unique'] = 'off';
    
    	$form_data['data']['floor_count']['name'] = 'floor_count';
    	$form_data['data']['floor_count']['title'] = '';
    	$form_data['data']['floor_count']['value'] = '';
    	$form_data['data']['floor_count']['length'] = 40;
    	$form_data['data']['floor_count']['type'] = 'safe_string';
    	$form_data['data']['floor_count']['required'] = 'off';
    	$form_data['data']['floor_count']['unique'] = 'off';
    	
    	$form_data['data']['refrigerator']['name'] = 'refrigerator';
    	$form_data['data']['refrigerator']['title'] = '';
    	$form_data['data']['refrigerator']['value'] = 0;
    	$form_data['data']['refrigerator']['length'] = 40;
    	$form_data['data']['refrigerator']['type'] = 'select_box';
    	$form_data['data']['refrigerator']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['refrigerator']['required'] = 'off';
    	$form_data['data']['refrigerator']['unique'] = 'off';
    	
    	$form_data['data']['tvset']['name'] = 'tvset';
    	$form_data['data']['tvset']['title'] = '';
    	$form_data['data']['tvset']['value'] = 0;
    	$form_data['data']['tvset']['length'] = 40;
    	$form_data['data']['tvset']['type'] = 'select_box';
    	$form_data['data']['tvset']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['tvset']['required'] = 'off';
    	$form_data['data']['tvset']['unique'] = 'off';
    	
    	$form_data['data']['washer']['name'] = 'washer';
    	$form_data['data']['washer']['title'] = 'C ';
    	$form_data['data']['washer']['value'] = 0;
    	$form_data['data']['washer']['length'] = 40;
    	$form_data['data']['washer']['type'] = 'select_box';
    	$form_data['data']['washer']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['washer']['required'] = 'off';
    	$form_data['data']['washer']['unique'] = 'off';
    	
    	$form_data['data']['furniture_kitchen']['name'] = 'furniture_kitchen';
    	$form_data['data']['furniture_kitchen']['title'] = '  ';
    	$form_data['data']['furniture_kitchen']['value'] = 0;
    	$form_data['data']['furniture_kitchen']['length'] = 40;
    	$form_data['data']['furniture_kitchen']['type'] = 'select_box';
    	$form_data['data']['furniture_kitchen']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['furniture_kitchen']['required'] = 'off';
    	$form_data['data']['furniture_kitchen']['unique'] = 'off';
    	
    	$form_data['data']['furniture_room']['name'] = 'furniture_room';
    	$form_data['data']['furniture_room']['title'] = '  ';
    	$form_data['data']['furniture_room']['value'] = 0;
    	$form_data['data']['furniture_room']['length'] = 40;
    	$form_data['data']['furniture_room']['type'] = 'select_box';
    	$form_data['data']['furniture_room']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['furniture_room']['required'] = 'off';
    	$form_data['data']['furniture_room']['unique'] = 'off';
    	
    	$form_data['data']['balcony']['name'] = 'balcony';
    	$form_data['data']['balcony']['title'] = '';
    	$form_data['data']['balcony']['value'] = 0;
    	$form_data['data']['balcony']['length'] = 40;
    	$form_data['data']['balcony']['type'] = 'select_box';
    	$form_data['data']['balcony']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['balcony']['required'] = 'off';
    	$form_data['data']['balcony']['unique'] = 'off';
    	
    	$form_data['data']['is_telephone']['name'] = 'is_telephone';
    	$form_data['data']['is_telephone']['title'] = '';
    	$form_data['data']['is_telephone']['value'] = 0;
    	$form_data['data']['is_telephone']['length'] = 40;
    	$form_data['data']['is_telephone']['type'] = 'select_box';
    	$form_data['data']['is_telephone']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['is_telephone']['required'] = 'off';
    	$form_data['data']['is_telephone']['unique'] = 'off';
    	
    	$form_data['data']['plate']['name'] = 'plate';
    	$form_data['data']['plate']['title'] = '';
    	$form_data['data']['plate']['value'] = 0;
    	$form_data['data']['plate']['length'] = 40;
    	$form_data['data']['plate']['type'] = 'select_box';
    	$form_data['data']['plate']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['plate']['required'] = 'off';
    	$form_data['data']['plate']['unique'] = 'off';
    	    	
    	$form_data['data']['square_all']['name'] = 'square_all';
    	$form_data['data']['square_all']['title'] = ' ';
    	$form_data['data']['square_all']['value'] = '';
    	$form_data['data']['square_all']['length'] = 40;
    	$form_data['data']['square_all']['type'] = 'safe_string';
    	$form_data['data']['square_all']['required'] = 'off';
    	$form_data['data']['square_all']['unique'] = 'off';
    	
    	$form_data['data']['square_live']['name'] = 'square_live';
    	$form_data['data']['square_live']['title'] = ' ';
    	$form_data['data']['square_live']['value'] = '';
    	$form_data['data']['square_live']['length'] = 40;
    	$form_data['data']['square_live']['type'] = 'safe_string';
    	$form_data['data']['square_live']['required'] = 'off';
    	$form_data['data']['square_live']['unique'] = 'off';
    	
    	$form_data['data']['square_kitchen']['name'] = 'square_kitchen';
    	$form_data['data']['square_kitchen']['title'] = ' ';
    	$form_data['data']['square_kitchen']['value'] = '';
    	$form_data['data']['square_kitchen']['length'] = 40;
    	$form_data['data']['square_kitchen']['type'] = 'safe_string';
    	$form_data['data']['square_kitchen']['required'] = 'off';
    	$form_data['data']['square_kitchen']['unique'] = 'off';
    	
    	
    	$form_data['data']['contact_phone_1']['name'] = 'contact_phone_1';
    	$form_data['data']['contact_phone_1']['title'] = '1';
    	$form_data['data']['contact_phone_1']['value'] = '';
    	$form_data['data']['contact_phone_1']['length'] = 40;
    	$form_data['data']['contact_phone_1']['type'] = 'safe_string';
    	$form_data['data']['contact_phone_1']['required'] = 'off';
    	$form_data['data']['contact_phone_1']['unique'] = 'off';
    	
    	$form_data['data']['contact_phone_2']['name'] = 'contact_phone_2';
    	$form_data['data']['contact_phone_2']['title'] = '2';
    	$form_data['data']['contact_phone_2']['value'] = '';
    	$form_data['data']['contact_phone_2']['length'] = 40;
    	$form_data['data']['contact_phone_2']['type'] = 'safe_string';
    	$form_data['data']['contact_phone_2']['required'] = 'off';
    	$form_data['data']['contact_phone_2']['unique'] = 'off';
    	
    	$form_data['data']['text']['name'] = 'text';
    	$form_data['data']['text']['title'] = '';
    	$form_data['data']['text']['value'] = '';
    	$form_data['data']['text']['length'] = 40;
    	$form_data['data']['text']['type'] = 'textarea';
    	$form_data['data']['text']['required'] = 'off';
    	$form_data['data']['text']['unique'] = 'off';
    	$form_data['data']['text']['rows'] = '10';
    	$form_data['data']['text']['cols'] = '40';
    	
    	$form_data['data']['renter_slavic']['name'] = 'renter_slavic';
    	$form_data['data']['renter_slavic']['title'] = 'C';
    	$form_data['data']['renter_slavic']['value'] = 0;
    	$form_data['data']['renter_slavic']['type'] = 'checkbox';
    	$form_data['data']['renter_slavic']['required'] = 'off';
    	$form_data['data']['renter_slavic']['unique'] = 'off';
    	$form_data['data']['renter_slavic']['tab'] = '  ';
    	
    	$form_data['data']['renter_decent']['name'] = 'renter_decent';
    	$form_data['data']['renter_decent']['title'] = ' ';
    	$form_data['data']['renter_decent']['value'] = 0;
    	$form_data['data']['renter_decent']['type'] = 'checkbox';
    	$form_data['data']['renter_decent']['required'] = 'off';
    	$form_data['data']['renter_decent']['unique'] = 'off';
    	$form_data['data']['renter_decent']['tab'] = '  ';
    	
    	$form_data['data']['renter_rfcitisen']['name'] = 'renter_rfcitisen';
    	$form_data['data']['renter_rfcitisen']['title'] = '  ';
    	$form_data['data']['renter_rfcitisen']['value'] = 0;
    	$form_data['data']['renter_rfcitisen']['type'] = 'checkbox';
    	$form_data['data']['renter_rfcitisen']['required'] = 'off';
    	$form_data['data']['renter_rfcitisen']['unique'] = 'off';
    	$form_data['data']['renter_rfcitisen']['tab'] = '  ';
    	
    	$form_data['data']['renter_family']['name'] = 'renter_family';
    	$form_data['data']['renter_family']['title'] = '. ';
    	$form_data['data']['renter_family']['value'] = 0;
    	$form_data['data']['renter_family']['type'] = 'checkbox';
    	$form_data['data']['renter_family']['required'] = 'off';
    	$form_data['data']['renter_family']['unique'] = 'off';
    	$form_data['data']['renter_family']['tab'] = '  ';
    	
    	$form_data['data']['renter_onegirl']['name'] = 'renter_onegirl';
    	$form_data['data']['renter_onegirl']['title'] = ' ';
    	$form_data['data']['renter_onegirl']['value'] = 0;
    	$form_data['data']['renter_onegirl']['type'] = 'checkbox';
    	$form_data['data']['renter_onegirl']['required'] = 'off';
    	$form_data['data']['renter_onegirl']['unique'] = 'off';
    	$form_data['data']['renter_onegirl']['tab'] = '  ';
    	
    	$form_data['data']['renter_twogirl']['name'] = 'renter_twogirl';
    	$form_data['data']['renter_twogirl']['title'] = ' ';
    	$form_data['data']['renter_twogirl']['value'] = 0;
    	$form_data['data']['renter_twogirl']['type'] = 'checkbox';
    	$form_data['data']['renter_twogirl']['required'] = 'off';
    	$form_data['data']['renter_twogirl']['unique'] = 'off';
    	$form_data['data']['renter_twogirl']['tab'] = '  ';
    	
    	$form_data['data']['renter_oneman']['name'] = 'renter_oneman';
    	$form_data['data']['renter_oneman']['title'] = ' ';
    	$form_data['data']['renter_oneman']['value'] = 0;
    	$form_data['data']['renter_oneman']['type'] = 'checkbox';
    	$form_data['data']['renter_oneman']['required'] = 'off';
    	$form_data['data']['renter_oneman']['unique'] = 'off';
    	$form_data['data']['renter_oneman']['tab'] = '  ';
    	
    	$form_data['data']['renter_twomen']['name'] = 'renter_twomen';
    	$form_data['data']['renter_twomen']['title'] = ' ';
    	$form_data['data']['renter_twomen']['value'] = 0;
    	$form_data['data']['renter_twomen']['type'] = 'checkbox';
    	$form_data['data']['renter_twomen']['required'] = 'off';
    	$form_data['data']['renter_twomen']['unique'] = 'off';
    	$form_data['data']['renter_twomen']['tab'] = '  ';
    	
    	$form_data['data']['renter_with_children']['name'] = 'renter_with_children';
    	$form_data['data']['renter_with_children']['title'] = '  ';
    	$form_data['data']['renter_with_children']['value'] = 0;
    	$form_data['data']['renter_with_children']['type'] = 'checkbox';
    	$form_data['data']['renter_with_children']['required'] = 'off';
    	$form_data['data']['renter_with_children']['unique'] = 'off';
    	$form_data['data']['renter_with_children']['tab'] = '  ';
    	
    	$form_data['data']['renter_with_animals']['name'] = 'renter_with_animals';
    	$form_data['data']['renter_with_animals']['title'] = '  ';
    	$form_data['data']['renter_with_animals']['value'] = 0;
    	$form_data['data']['renter_with_animals']['type'] = 'checkbox';
    	$form_data['data']['renter_with_animals']['required'] = 'off';
    	$form_data['data']['renter_with_animals']['unique'] = 'off';
    	$form_data['data']['renter_with_animals']['tab'] = '  ';
    	
    	$form_data['data']['renter_another']['name'] = 'renter_another';
    	$form_data['data']['renter_another']['title'] = ' ';
    	$form_data['data']['renter_another']['value'] = 0;
    	$form_data['data']['renter_another']['type'] = 'checkbox';
    	$form_data['data']['renter_another']['required'] = 'off';
    	$form_data['data']['renter_another']['unique'] = 'off';
    	$form_data['data']['renter_another']['tab'] = '  ';
    
    	
    	$form_data['data']['image']['name'] = 'image';
    	$form_data['data']['image']['table_name'] = 'data';
    	$form_data['data']['image']['primary_key'] = 'id';
    	$form_data['data']['image']['primary_key_value'] = 0;
    	$form_data['data']['image']['action'] = 'data';
    	$form_data['data']['image']['title'] = ' ';
    	$form_data['data']['image']['value'] = '';
    	$form_data['data']['image']['length'] = 40;
    	$form_data['data']['image']['type'] = 'uploadify_image';
    	$form_data['data']['image']['required'] = 'off';
    	$form_data['data']['image']['unique'] = 'off';
    	
    	if ( $this->getConfigValue('apps.realtypro.youtube') ) {
    		$form_data['data']['youtube']['name'] = 'youtube';
    		$form_data['data']['youtube']['title'] = '';
    		$form_data['data']['youtube']['value'] = '';
    		$form_data['data']['youtube']['length'] = 40;
    		$form_data['data']['youtube']['type'] = 'safe_string';
    		$form_data['data']['youtube']['required'] = 'off';
    		$form_data['data']['youtube']['unique'] = 'off';
    	}
    	
    	$form_data['data']['view_count']['name'] = 'view_count';
    	$form_data['data']['view_count']['title'] = ' ';
    	$form_data['data']['view_count']['value'] = '';
    	$form_data['data']['view_count']['length'] = 40;
    	$form_data['data']['view_count']['type'] = 'hidden';
    	$form_data['data']['view_count']['required'] = 'off';
    	$form_data['data']['view_count']['unique'] = 'off';
    	
    	$form_data['data']['whoyuaare']['name'] = 'whoyuaare';
    	$form_data['data']['whoyuaare']['title'] = ' ';
    	$form_data['data']['whoyuaare']['value'] = 0;
    	$form_data['data']['whoyuaare']['length'] = 40;
    	$form_data['data']['whoyuaare']['type'] = 'select_box';
    	$form_data['data']['whoyuaare']['select_data'] = array('0' => ' ', '1' => '', '2' => '', '3' => ' ' );
    	$form_data['data']['whoyuaare']['required'] = 'off';
    	$form_data['data']['whoyuaare']['unique'] = 'off';
    	
    	$form_data['data']['fio']['name'] = 'fio';
    	$form_data['data']['fio']['title'] = ' ';
    	$form_data['data']['fio']['value'] = '';
    	$form_data['data']['fio']['length'] = 40;
    	$form_data['data']['fio']['type'] = 'safe_string';
    	$form_data['data']['fio']['required'] = 'on';
    	$form_data['data']['fio']['unique'] = 'off';
    	
    	$form_data['data']['email']['name'] = 'email';
    	$form_data['data']['email']['title'] = 'E-mail';
    	$form_data['data']['email']['value'] = '';
    	$form_data['data']['email']['length'] = 40;
    	$form_data['data']['email']['type'] = 'email';
    	$form_data['data']['email']['required'] = 'off';
    	$form_data['data']['email']['unique'] = 'off';
    	
    	$form_data['data']['phone']['name'] = 'phone';
    	$form_data['data']['phone']['title'] = '  ()<br />  <b>8**********</b>';
    	$form_data['data']['phone']['value'] = '';
    	$form_data['data']['phone']['length'] = 40;
    	$form_data['data']['phone']['type'] = 'mobilephone';
    	$form_data['data']['phone']['required'] = 'on';
    	$form_data['data']['phone']['unique'] = 'off';
    	
    	$form_data['data']['agency_cooperation']['name'] = 'agency_cooperation';
    	$form_data['data']['agency_cooperation']['title'] = '     ';
    	$form_data['data']['agency_cooperation']['value'] = 1;
    	$form_data['data']['agency_cooperation']['type'] = 'checkbox';
    	$form_data['data']['agency_cooperation']['required'] = 'off';
    	$form_data['data']['agency_cooperation']['unique'] = 'off';
    
    	return $form_data;
    }
    
    function _get_big_city_kvartira_model2 ( $ajax = false ){
    	$form_data = array();
    
    	$form_data['data']['id']['name'] = 'id';
    	$form_data['data']['id']['title'] = '';
    	$form_data['data']['id']['value'] = 0;
    	$form_data['data']['id']['length'] = 40;
    	$form_data['data']['id']['type'] = 'primary_key';
    	$form_data['data']['id']['required'] = 'off';
    	$form_data['data']['id']['unique'] = 'off';
    
    	$form_data['data']['user_id']['name'] = 'user_id';
    	$form_data['data']['user_id']['title'] = ' ';
    	$form_data['data']['user_id']['value'] = 0;
    	$form_data['data']['user_id']['length'] = 40;
    	$form_data['data']['user_id']['type'] = 'select_by_query';
    	$form_data['data']['user_id']['query'] = 'select * from '.DB_PREFIX.'_user order by login';
    	$form_data['data']['user_id']['value_name'] = 'login';
    	$form_data['data']['user_id']['primary_key_name'] = 'user_id';
    	$form_data['data']['user_id']['primary_key_table'] = 'user';
    	$form_data['data']['user_id']['title_default'] = ' ';
    	$form_data['data']['user_id']['value_default'] = 0;
    	$form_data['data']['user_id']['required'] = 'off';
    	$form_data['data']['user_id']['unique'] = 'off';
    
    	$form_data['data']['date_added']['name'] = 'date_added';
    	$form_data['data']['date_added']['title'] = ' ';
    	$form_data['data']['date_added']['value'] = '';
    	$form_data['data']['date_added']['length'] = 40;
    	$form_data['data']['date_added']['type'] = 'hidden';
    	$form_data['data']['date_added']['required'] = 'off';
    	$form_data['data']['date_added']['unique'] = 'off';
    
    	$form_data['data']['active']['name'] = 'active';
    	$form_data['data']['active']['title'] = '  ';
    	$form_data['data']['active']['value'] = 0;
    	$form_data['data']['active']['length'] = 40;
    	$form_data['data']['active']['type'] = 'checkbox';
    	$form_data['data']['active']['required'] = 'off';
    	$form_data['data']['active']['unique'] = 'off';
    
    	$form_data['data']['hot']['name'] = 'hot';
    	$form_data['data']['hot']['title'] = '';
    	$form_data['data']['hot']['value'] = 0;
    	$form_data['data']['hot']['length'] = 40;
    	$form_data['data']['hot']['type'] = 'checkbox';
    	$form_data['data']['hot']['required'] = 'off';
    	$form_data['data']['hot']['unique'] = 'off';
    	 
    	$form_data['data']['optype']['name'] = 'optype';
    	$form_data['data']['optype']['title'] = ' ';
    	$form_data['data']['optype']['value'] = 0;
    	$form_data['data']['optype']['length'] = 40;
    	$form_data['data']['optype']['type'] = 'select_box';
    	$form_data['data']['optype']['select_data'] = array('0' => '', '1' => '' );
    	$form_data['data']['optype']['required'] = 'off';
    	$form_data['data']['optype']['unique'] = 'off';
    
    	$form_data['data']['topic_id']['name'] = 'topic_id';
    	$form_data['data']['topic_id']['title'] = '';
    	$form_data['data']['topic_id']['value_string'] = '';
    	$form_data['data']['topic_id']['value'] = 0;
    	$form_data['data']['topic_id']['length'] = 40;
    	$form_data['data']['topic_id']['type'] = 'select_box_structure';
    	$form_data['data']['topic_id']['required'] = 'on';
    	$form_data['data']['topic_id']['unique'] = 'off';
    	 
    	$form_data['data']['metro_id']['name'] = 'metro_id';
    	$form_data['data']['metro_id']['primary_key_name'] = 'metro_id';
    	$form_data['data']['metro_id']['primary_key_table'] = 'metro';
    	$form_data['data']['metro_id']['title'] = '';
    	$form_data['data']['metro_id']['value_string'] = '';
    	$form_data['data']['metro_id']['value'] = 0;
    	$form_data['data']['metro_id']['length'] = 40;
    	$form_data['data']['metro_id']['type'] = 'select_by_query';
    	$form_data['data']['metro_id']['query'] = 'select * from '.DB_PREFIX.'_metro order by name';
    	$form_data['data']['metro_id']['value_name'] = 'name';
    	$form_data['data']['metro_id']['title_default'] = ' ';
    	$form_data['data']['metro_id']['value_default'] = 0;
    	$form_data['data']['metro_id']['required'] = 'off';
    	$form_data['data']['metro_id']['unique'] = 'off';
    	 
    	/*$form_data['data']['metro_time_onfoot']['name'] = 'metro_time_onfoot';
    	$form_data['data']['metro_time_onfoot']['title'] = '   ';
    	$form_data['data']['metro_time_onfoot']['value'] = '';
    	$form_data['data']['metro_time_onfoot']['length'] = 40;
    	$form_data['data']['metro_time_onfoot']['type'] = 'safe_string';
    	$form_data['data']['metro_time_onfoot']['required'] = 'off';
    	$form_data['data']['metro_time_onfoot']['unique'] = 'off';
    	 
    	$form_data['data']['metro_time_oncar']['name'] = 'metro_time_oncar';
    	$form_data['data']['metro_time_oncar']['title'] = '   ';
    	$form_data['data']['metro_time_oncar']['value'] = '';
    	$form_data['data']['metro_time_oncar']['length'] = 40;
    	$form_data['data']['metro_time_oncar']['type'] = 'safe_string';
    	$form_data['data']['metro_time_oncar']['required'] = 'off';
    	$form_data['data']['metro_time_oncar']['unique'] = 'off';*/
    	 
    	/*$form_data['data']['is_city']['name'] = 'is_city';
    	 $form_data['data']['is_city']['title'] = '';
    	$form_data['data']['is_city']['hint'] = '  ,  ';
    	$form_data['data']['is_city']['value'] = 1;
    	$form_data['data']['is_city']['type'] = 'checkbox';
    	$form_data['data']['is_city']['required'] = 'off';
    	$form_data['data']['is_city']['unique'] = 'off';*/
    	 
    	$form_data['data']['city_id']['name'] = 'city_id';
    	$form_data['data']['city_id']['primary_key_name'] = 'city_id';
    	$form_data['data']['city_id']['primary_key_table'] = 'city';
    	$form_data['data']['city_id']['title'] = Multilanguage::_('L_CITY');
    	$form_data['data']['city_id']['value_string'] = '';
    	$form_data['data']['city_id']['value'] = 0;
    	$form_data['data']['city_id']['length'] = 40;
    	$form_data['data']['city_id']['type'] = 'select_by_query';
    	$form_data['data']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city order by name';
    	$form_data['data']['city_id']['value_name'] = 'name';
    	$form_data['data']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
    	$form_data['data']['city_id']['value_default'] = 0;
    	$form_data['data']['city_id']['required'] = 'off';
    	$form_data['data']['city_id']['unique'] = 'off';
    	 
    	$form_data['data']['street_id']['name'] = 'street_id';
    	$form_data['data']['street_id']['primary_key_name'] = 'street_id';
    	$form_data['data']['street_id']['primary_key_table'] = 'street';
    	$form_data['data']['street_id']['title'] = Multilanguage::_('L_STREET');
    	$form_data['data']['street_id']['value_string'] = '';
    	$form_data['data']['street_id']['value'] = 0;
    	$form_data['data']['street_id']['length'] = 40;
    	$form_data['data']['street_id']['type'] = 'select_by_query';
    	$form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street order by name';
    	$form_data['data']['street_id']['value_name'] = 'name';
    	$form_data['data']['street_id']['title_default'] = Multilanguage::_('L_CHOOSE_STREET');
    	$form_data['data']['street_id']['value_default'] = 0;
    	$form_data['data']['street_id']['required'] = 'off';
    	$form_data['data']['street_id']['unique'] = 'off';
    	 
    	if ( $this->getConfigValue('user_add_street_enable') ) {
    		$form_data['data']['new_street']['name'] = 'new_street';
    		$form_data['data']['new_street']['title'] = ' ';
    		$form_data['data']['new_street']['value'] = '';
    		$form_data['data']['new_street']['length'] = 40;
    		$form_data['data']['new_street']['type'] = 'auto_add_value';
    		$form_data['data']['new_street']['dbtype'] = 'notable';
    		$form_data['data']['new_street']['value_table'] = 'street';
    		$form_data['data']['new_street']['value_primary_key'] = 'street_id';
    		$form_data['data']['new_street']['value_field'] = 'name';
    		$form_data['data']['new_street']['assign_to'] = 'street_id';
    		$form_data['data']['new_street']['required'] = 'off';
    		$form_data['data']['new_street']['unique'] = 'off';
    	}
    	 
    	$form_data['data']['number']['name'] = 'number';
    	$form_data['data']['number']['title'] = ' ';
    	$form_data['data']['number']['value'] = '';
    	$form_data['data']['number']['length'] = 40;
    	$form_data['data']['number']['type'] = 'safe_string';
    	$form_data['data']['number']['required'] = 'off';
    	$form_data['data']['number']['unique'] = 'off';
    
    	/*$form_data['data']['housing_number']['name'] = 'housing_number';
    	$form_data['data']['housing_number']['title'] = ' ';
    	$form_data['data']['housing_number']['value'] = '';
    	$form_data['data']['housing_number']['length'] = 40;
    	$form_data['data']['housing_number']['type'] = 'safe_string';
    	$form_data['data']['housing_number']['required'] = 'off';
    	$form_data['data']['housing_number']['unique'] = 'off';*/
    
    	$form_data['data']['price']['name'] = 'price';
    	$form_data['data']['price']['title'] = '';
    	$form_data['data']['price']['value'] = '';
    	$form_data['data']['price']['length'] = 40;
    	$form_data['data']['price']['type'] = 'price';
    	$form_data['data']['price']['required'] = 'off';
    	$form_data['data']['price']['unique'] = 'off';
    
    	if ( $this->getConfigValue('currency_enable') ) {
    		$form_data['data']['currency_id']['name'] = 'currency_id';
    		$form_data['data']['currency_id']['primary_key_name'] = 'currency_id';
    		$form_data['data']['currency_id']['primary_key_table'] = 'currency';
    		$form_data['data']['currency_id']['title'] = '';
    		$form_data['data']['currency_id']['value_string'] = '';
    		$form_data['data']['currency_id']['value'] = 0;
    		$form_data['data']['currency_id']['length'] = 40;
    		$form_data['data']['currency_id']['type'] = 'select_by_query';
    		$form_data['data']['currency_id']['query'] = 'select * from '.DB_PREFIX.'_currency WHERE is_active=1 ORDER BY sort_order ASC, code ASC, currency_id ASC';
    		$form_data['data']['currency_id']['value_name'] = 'name';
    		$form_data['data']['currency_id']['title_default'] = '';
    		$form_data['data']['currency_id']['value_default'] = 0;
    		$form_data['data']['currency_id']['required'] = 'off';
    		$form_data['data']['currency_id']['unique'] = 'off';
    	}
    	 
    	$form_data['data']['aim']['name'] = 'aim';
    	$form_data['data']['aim']['title'] = '';
    	$form_data['data']['aim']['value'] = 0;
    	$form_data['data']['aim']['length'] = 40;
    	$form_data['data']['aim']['type'] = 'select_box';
    	$form_data['data']['aim']['select_data'] = array('0' => ' ', '1' => '', '2' => ' ', '3' => ' ');
    	$form_data['data']['aim']['required'] = 'off';
    	$form_data['data']['aim']['unique'] = 'off';
    
    	$form_data['data']['room_count']['name'] = 'room_count';
    	$form_data['data']['room_count']['title'] = '. ';
    	$form_data['data']['room_count']['value'] = '';
    	$form_data['data']['room_count']['length'] = 40;
    	$form_data['data']['room_count']['type'] = 'safe_string';
    	$form_data['data']['room_count']['required'] = 'off';
    	$form_data['data']['room_count']['unique'] = 'off';
    
    	$form_data['data']['floor']['name'] = 'floor';
    	$form_data['data']['floor']['title'] = '';
    	$form_data['data']['floor']['value'] = '';
    	$form_data['data']['floor']['length'] = 40;
    	$form_data['data']['floor']['type'] = 'safe_string';
    	$form_data['data']['floor']['required'] = 'off';
    	$form_data['data']['floor']['unique'] = 'off';
    
    	$form_data['data']['floor_count']['name'] = 'floor_count';
    	$form_data['data']['floor_count']['title'] = '';
    	$form_data['data']['floor_count']['value'] = '';
    	$form_data['data']['floor_count']['length'] = 40;
    	$form_data['data']['floor_count']['type'] = 'safe_string';
    	$form_data['data']['floor_count']['required'] = 'off';
    	$form_data['data']['floor_count']['unique'] = 'off';
    	 
    	$form_data['data']['refrigerator']['name'] = 'refrigerator';
    	$form_data['data']['refrigerator']['title'] = '';
    	$form_data['data']['refrigerator']['value'] = 0;
    	$form_data['data']['refrigerator']['length'] = 40;
    	$form_data['data']['refrigerator']['type'] = 'select_box';
    	$form_data['data']['refrigerator']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['refrigerator']['required'] = 'off';
    	$form_data['data']['refrigerator']['unique'] = 'off';
    	 
    	$form_data['data']['tvset']['name'] = 'tvset';
    	$form_data['data']['tvset']['title'] = '';
    	$form_data['data']['tvset']['value'] = 0;
    	$form_data['data']['tvset']['length'] = 40;
    	$form_data['data']['tvset']['type'] = 'select_box';
    	$form_data['data']['tvset']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['tvset']['required'] = 'off';
    	$form_data['data']['tvset']['unique'] = 'off';
    	 
    	$form_data['data']['washer']['name'] = 'washer';
    	$form_data['data']['washer']['title'] = 'C ';
    	$form_data['data']['washer']['value'] = 0;
    	$form_data['data']['washer']['length'] = 40;
    	$form_data['data']['washer']['type'] = 'select_box';
    	$form_data['data']['washer']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['washer']['required'] = 'off';
    	$form_data['data']['washer']['unique'] = 'off';
    	 
    	$form_data['data']['furniture_kitchen']['name'] = 'furniture_kitchen';
    	$form_data['data']['furniture_kitchen']['title'] = '  ';
    	$form_data['data']['furniture_kitchen']['value'] = 0;
    	$form_data['data']['furniture_kitchen']['length'] = 40;
    	$form_data['data']['furniture_kitchen']['type'] = 'select_box';
    	$form_data['data']['furniture_kitchen']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['furniture_kitchen']['required'] = 'off';
    	$form_data['data']['furniture_kitchen']['unique'] = 'off';
    	 
    	$form_data['data']['furniture_room']['name'] = 'furniture_room';
    	$form_data['data']['furniture_room']['title'] = '  ';
    	$form_data['data']['furniture_room']['value'] = 0;
    	$form_data['data']['furniture_room']['length'] = 40;
    	$form_data['data']['furniture_room']['type'] = 'select_box';
    	$form_data['data']['furniture_room']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['furniture_room']['required'] = 'off';
    	$form_data['data']['furniture_room']['unique'] = 'off';
    	 
    	$form_data['data']['balcony']['name'] = 'balcony';
    	$form_data['data']['balcony']['title'] = '';
    	$form_data['data']['balcony']['value'] = 0;
    	$form_data['data']['balcony']['length'] = 40;
    	$form_data['data']['balcony']['type'] = 'select_box';
    	$form_data['data']['balcony']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['balcony']['required'] = 'off';
    	$form_data['data']['balcony']['unique'] = 'off';
    	 
    	$form_data['data']['is_telephone']['name'] = 'is_telephone';
    	$form_data['data']['is_telephone']['title'] = '';
    	$form_data['data']['is_telephone']['value'] = 0;
    	$form_data['data']['is_telephone']['length'] = 40;
    	$form_data['data']['is_telephone']['type'] = 'select_box';
    	$form_data['data']['is_telephone']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['is_telephone']['required'] = 'off';
    	$form_data['data']['is_telephone']['unique'] = 'off';
    	 
    	$form_data['data']['plate']['name'] = 'plate';
    	$form_data['data']['plate']['title'] = '';
    	$form_data['data']['plate']['value'] = 0;
    	$form_data['data']['plate']['length'] = 40;
    	$form_data['data']['plate']['type'] = 'select_box';
    	$form_data['data']['plate']['select_data'] = array('0' => ' ', '1' => '', '2' => '' );
    	$form_data['data']['plate']['required'] = 'off';
    	$form_data['data']['plate']['unique'] = 'off';
    
    	$form_data['data']['square_all']['name'] = 'square_all';
    	$form_data['data']['square_all']['title'] = ' ';
    	$form_data['data']['square_all']['value'] = '';
    	$form_data['data']['square_all']['length'] = 40;
    	$form_data['data']['square_all']['type'] = 'safe_string';
    	$form_data['data']['square_all']['required'] = 'off';
    	$form_data['data']['square_all']['unique'] = 'off';
    	 
    	$form_data['data']['square_live']['name'] = 'square_live';
    	$form_data['data']['square_live']['title'] = ' ';
    	$form_data['data']['square_live']['value'] = '';
    	$form_data['data']['square_live']['length'] = 40;
    	$form_data['data']['square_live']['type'] = 'safe_string';
    	$form_data['data']['square_live']['required'] = 'off';
    	$form_data['data']['square_live']['unique'] = 'off';
    	 
    	$form_data['data']['square_kitchen']['name'] = 'square_kitchen';
    	$form_data['data']['square_kitchen']['title'] = ' ';
    	$form_data['data']['square_kitchen']['value'] = '';
    	$form_data['data']['square_kitchen']['length'] = 40;
    	$form_data['data']['square_kitchen']['type'] = 'safe_string';
    	$form_data['data']['square_kitchen']['required'] = 'off';
    	$form_data['data']['square_kitchen']['unique'] = 'off';
    	
    	$form_data['data']['object_type']['name'] = 'object_type';
    	$form_data['data']['object_type']['title'] = ' ';
    	$form_data['data']['object_type']['value'] = 0;
    	$form_data['data']['object_type']['length'] = 40;
    	$form_data['data']['object_type']['type'] = 'select_box';
    	$form_data['data']['object_type']['select_data'] = array('0' => ' ', '1' => '', '2' => '', '3' => '' );
    	$form_data['data']['object_type']['required'] = 'off';
    	$form_data['data']['object_type']['unique'] = 'off';
    	
    	$form_data['data']['object_state']['name'] = 'object_state';
    	$form_data['data']['object_state']['title'] = '';
    	$form_data['data']['object_state']['value'] = 0;
    	$form_data['data']['object_state']['length'] = 40;
    	$form_data['data']['object_state']['type'] = 'select_box';
    	$form_data['data']['object_state']['select_data'] = array('0' => ' ', '1' => ' ', '2' => '', '3' => ' ' );
    	$form_data['data']['object_state']['required'] = 'off';
    	$form_data['data']['object_state']['unique'] = 'off';
    	
    	$form_data['data']['object_destination']['name'] = 'object_destination';
    	$form_data['data']['object_destination']['title'] = 'c';
    	$form_data['data']['object_destination']['value'] = 0;
    	$form_data['data']['object_destination']['length'] = 40;
    	$form_data['data']['object_destination']['type'] = 'select_box';
    	$form_data['data']['object_destination']['select_data'] = array('0' => ' ', '1' => ' ', '2' => ' ', '3' => ' ' );
    	$form_data['data']['object_destination']['required'] = 'off';
    	$form_data['data']['object_destination']['unique'] = 'off';
    	
    	$form_data['data']['infra_greenzone']['name'] = 'infra_greenzone';
    	$form_data['data']['infra_greenzone']['title'] = ' ';
    	$form_data['data']['infra_greenzone']['value'] = 0;
    	$form_data['data']['infra_greenzone']['type'] = 'checkbox';
    	$form_data['data']['infra_greenzone']['required'] = 'off';
    	$form_data['data']['infra_greenzone']['unique'] = 'off';
    	$form_data['data']['infra_greenzone']['tab'] = ' ';
    	
    	$form_data['data']['infra_sea']['name'] = 'infra_sea';
    	$form_data['data']['infra_sea']['title'] = '';
    	$form_data['data']['infra_sea']['value'] = 0;
    	$form_data['data']['infra_sea']['type'] = 'checkbox';
    	$form_data['data']['infra_sea']['required'] = 'off';
    	$form_data['data']['infra_sea']['unique'] = 'off';
    	$form_data['data']['infra_sea']['tab'] = ' ';
    	
    	$form_data['data']['infra_sport']['name'] = 'infra_sport';
    	$form_data['data']['infra_sport']['title'] = '';
    	$form_data['data']['infra_sport']['value'] = 0;
    	$form_data['data']['infra_sport']['type'] = 'checkbox';
    	$form_data['data']['infra_sport']['required'] = 'off';
    	$form_data['data']['infra_sport']['unique'] = 'off';
    	$form_data['data']['infra_sport']['tab'] = ' ';
    	
    	$form_data['data']['infra_clinic']['name'] = 'infra_clinic';
    	$form_data['data']['infra_clinic']['title'] = '';
    	$form_data['data']['infra_clinic']['value'] = 0;
    	$form_data['data']['infra_clinic']['type'] = 'checkbox';
    	$form_data['data']['infra_clinic']['required'] = 'off';
    	$form_data['data']['infra_clinic']['unique'] = 'off';
    	$form_data['data']['infra_clinic']['tab'] = ' ';
    	
    	$form_data['data']['infra_terminal']['name'] = 'infra_terminal';
    	$form_data['data']['infra_terminal']['title'] = '';
    	$form_data['data']['infra_terminal']['value'] = 0;
    	$form_data['data']['infra_terminal']['type'] = 'checkbox';
    	$form_data['data']['infra_terminal']['required'] = 'off';
    	$form_data['data']['infra_terminal']['unique'] = 'off';
    	$form_data['data']['infra_terminal']['tab'] = ' ';
    	
    	$form_data['data']['infra_airport']['name'] = 'infra_airport';
    	$form_data['data']['infra_airport']['title'] = '';
    	$form_data['data']['infra_airport']['value'] = 0;
    	$form_data['data']['infra_airport']['type'] = 'checkbox';
    	$form_data['data']['infra_airport']['required'] = 'off';
    	$form_data['data']['infra_airport']['unique'] = 'off';
    	$form_data['data']['infra_airport']['tab'] = ' ';
    	
    	$form_data['data']['infra_bank']['name'] = 'infra_bank';
    	$form_data['data']['infra_bank']['title'] = '';
    	$form_data['data']['infra_bank']['value'] = 0;
    	$form_data['data']['infra_bank']['type'] = 'checkbox';
    	$form_data['data']['infra_bank']['required'] = 'off';
    	$form_data['data']['infra_bank']['unique'] = 'off';
    	$form_data['data']['infra_bank']['tab'] = ' ';
    	
    	$form_data['data']['infra_restaurant']['name'] = 'infra_restaurant';
    	$form_data['data']['infra_restaurant']['title'] = '';
    	$form_data['data']['infra_restaurant']['value'] = 0;
    	$form_data['data']['infra_restaurant']['type'] = 'checkbox';
    	$form_data['data']['infra_restaurant']['required'] = 'off';
    	$form_data['data']['infra_restaurant']['unique'] = 'off';
    	$form_data['data']['infra_restaurant']['tab'] = ' ';
    	
    	
    	
    	
    	 
    	 
    	$form_data['data']['contact_phone_1']['name'] = 'contact_phone_1';
    	$form_data['data']['contact_phone_1']['title'] = '1';
    	$form_data['data']['contact_phone_1']['value'] = '';
    	$form_data['data']['contact_phone_1']['length'] = 40;
    	$form_data['data']['contact_phone_1']['type'] = 'safe_string';
    	$form_data['data']['contact_phone_1']['required'] = 'off';
    	$form_data['data']['contact_phone_1']['unique'] = 'off';
    	 
    	$form_data['data']['contact_phone_2']['name'] = 'contact_phone_2';
    	$form_data['data']['contact_phone_2']['title'] = '2';
    	$form_data['data']['contact_phone_2']['value'] = '';
    	$form_data['data']['contact_phone_2']['length'] = 40;
    	$form_data['data']['contact_phone_2']['type'] = 'safe_string';
    	$form_data['data']['contact_phone_2']['required'] = 'off';
    	$form_data['data']['contact_phone_2']['unique'] = 'off';
    	 
    	$form_data['data']['text']['name'] = 'text';
    	$form_data['data']['text']['title'] = '';
    	$form_data['data']['text']['value'] = '';
    	$form_data['data']['text']['length'] = 40;
    	$form_data['data']['text']['type'] = 'textarea';
    	$form_data['data']['text']['required'] = 'off';
    	$form_data['data']['text']['unique'] = 'off';
    	$form_data['data']['text']['rows'] = '10';
    	$form_data['data']['text']['cols'] = '40';
    	 
    	
    
    	 
    	$form_data['data']['image']['name'] = 'image';
    	$form_data['data']['image']['table_name'] = 'data';
    	$form_data['data']['image']['primary_key'] = 'id';
    	$form_data['data']['image']['primary_key_value'] = 0;
    	$form_data['data']['image']['action'] = 'data';
    	$form_data['data']['image']['title'] = ' ';
    	$form_data['data']['image']['value'] = '';
    	$form_data['data']['image']['length'] = 40;
    	$form_data['data']['image']['type'] = 'uploadify_image';
    	$form_data['data']['image']['required'] = 'off';
    	$form_data['data']['image']['unique'] = 'off';
    	 
    	if ( $this->getConfigValue('apps.realtypro.youtube') ) {
    		$form_data['data']['youtube']['name'] = 'youtube';
    		$form_data['data']['youtube']['title'] = '';
    		$form_data['data']['youtube']['value'] = '';
    		$form_data['data']['youtube']['length'] = 40;
    		$form_data['data']['youtube']['type'] = 'safe_string';
    		$form_data['data']['youtube']['required'] = 'off';
    		$form_data['data']['youtube']['unique'] = 'off';
    	}
    	 
    	$form_data['data']['view_count']['name'] = 'view_count';
    	$form_data['data']['view_count']['title'] = ' ';
    	$form_data['data']['view_count']['value'] = '';
    	$form_data['data']['view_count']['length'] = 40;
    	$form_data['data']['view_count']['type'] = 'hidden';
    	$form_data['data']['view_count']['required'] = 'off';
    	$form_data['data']['view_count']['unique'] = 'off';
    	 
    	$form_data['data']['whoyuaare']['name'] = 'whoyuaare';
    	$form_data['data']['whoyuaare']['title'] = ' ';
    	$form_data['data']['whoyuaare']['value'] = 0;
    	$form_data['data']['whoyuaare']['length'] = 40;
    	$form_data['data']['whoyuaare']['type'] = 'select_box';
    	$form_data['data']['whoyuaare']['select_data'] = array('0' => ' ', '1' => '', '2' => '', '3' => ' ' );
    	$form_data['data']['whoyuaare']['required'] = 'off';
    	$form_data['data']['whoyuaare']['unique'] = 'off';
    	 
    	$form_data['data']['fio']['name'] = 'fio';
    	$form_data['data']['fio']['title'] = ' ';
    	$form_data['data']['fio']['value'] = '';
    	$form_data['data']['fio']['length'] = 40;
    	$form_data['data']['fio']['type'] = 'safe_string';
    	$form_data['data']['fio']['required'] = 'off';
    	$form_data['data']['fio']['unique'] = 'off';
    	 
    	$form_data['data']['email']['name'] = 'email';
    	$form_data['data']['email']['title'] = 'E-mail';
    	$form_data['data']['email']['value'] = '';
    	$form_data['data']['email']['length'] = 40;
    	$form_data['data']['email']['type'] = 'email';
    	$form_data['data']['email']['required'] = 'off';
    	$form_data['data']['email']['unique'] = 'off';
    	 
    	$form_data['data']['phone']['name'] = 'phone';
    	$form_data['data']['phone']['title'] = '  ()<br />  <b>8**********</b>';
    	$form_data['data']['phone']['value'] = '';
    	$form_data['data']['phone']['length'] = 40;
    	$form_data['data']['phone']['type'] = 'mobilephone';
    	$form_data['data']['phone']['required'] = 'off';
    	$form_data['data']['phone']['unique'] = 'off';
    	
    
    	return $form_data;
    }
    
    
    function define_kgs_titles ( $form_data ) {
    	$form_data['data']['city_id']['title'] = Multilanguage::_('L_TEXT_ARRAY');
    	return $form_data;
    }
    
    function escape($data){
    	$quotes=get_magic_quotes_gpc();
		if($quotes==1){
			$rs=mysql_real_escape_string(stripcslashes($data));
		}else{
			$rs=mysql_real_escape_string($data);
		}
		return $rs;
    }
} 
?>