<?php

class Debugger {

	private static $exceptions = array ();

	private static $queries = array ();

	static public function appendQuery($sql) {
		if (defined('DEBUG_ENABLED') && DEBUG_ENABLED) {
			array_push ( self::$queries, $sql );
		}
	}

	static public function appendException($e) {
		if (defined('DEBUG_ENABLED') && DEBUG_ENABLED) {
			array_push ( self::$exceptions, $e->getMessage () );
		}
	}

	static public function formatedMessages() {
		$total = count(self::$queries);
		$message = '';

		if ($total) {
			$message .= '<p>';
			$message .= implode('</p><p>', self::$queries);
			$message .= '</p>';
		}

		if (count(self::$exceptions)) {
			$message .= '<p>';
			$message .= implode('</p><p>', self::$exceptions);
			$message .= '</p>';
		}

		$message .= "<p>Total queries: $total</p>";
		$message .= '<p>Memory usage: ' . (memory_get_usage( true ) / 1024  / 1024) . ' MB</p>';
		return $message;
	}
}