<?php
/**
 * Form generator
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Form_Generator extends SiteBill {
    
    /**
     * Total values count in select
     * @var array
     */
    
    var $total_in_select = array();
    /**
     * Construct
     * @param void
     * @return void
     */
    function __construct() {
        $this->SiteBill();
    }
    
    function compile_price_element($item_array){
    	$value=number_format((int)str_replace(' ', '', $item_array['value']),0,',',' ');
    	$id=md5($item_array['name'].'_'.rand(100,999));
    	$string = '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/js/autoNumeric-1.7.5.js"></script>';
    	$string .= '<script type="text/javascript">
		    	$(document).ready(function() {
		    		$("#'.$id.'").autoNumeric({aSep: \' \', vMax: \'999999999999\', vMin: \'0\'});
      
      
				});
    		</script>';
   		return array(
    		'title'=>$item_array['title'],
    		'required'=>($item_array['required'] == "on" ? 1 : 0),
    		'html'=>$string.'<input type="text" id="'.$id.'" class="price_field" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value.'" />',
    		'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_textarea_editor_element($item_array){
    	sleep(1);
    	$id='id'.time().'_'.rand(0,9);
    	$rs='';
    	if(isset($item_array['editor']) AND ($item_array['editor']!=='editor')){
    		if($this->getConfigValue($item_array['editor'])!=''){
    			$editor_code=$this->getConfigValue($item_array['editor']);
    		}else{
    			$editor_code=$this->getConfigValue('editor');
    		}
    	}else{
    		$editor_code=$this->getConfigValue('editor');
    	}
    	if ( $editor_code == 'ckeditor' ) {
    		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/ckeditor/ckeditor.js"></script>';
    		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/ckeditor/adapters/jquery.js"></script>';
    		$rs .= '<script type="text/javascript">
		    	$(document).ready(function() {
        			$("textarea#'.$id.'").ckeditor({
		filebrowserBrowseUrl : \'/ckfinder/ckfinder.html\',
        filebrowserImageBrowseUrl : \'/ckfinder/ckfinder.html?Type=Images\',
        filebrowserFlashBrowseUrl : \'/ckfinder/ckfinder.html?Type=Flash\',
        filebrowserUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Files\',
        filebrowserImageUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Images\',
        filebrowserFlashUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Flash\'
    				});
				});
    		</script>';
    	} elseif( $editor_code == 'bbeditor' ){
    		$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/bbeditor.css" />';
    		$rs .= '<script src="'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/jquery.bbcode.js" type="text/javascript"></script>';
    		$rs .= '<script type="text/javascript">
			  $(document).ready(function(){
			    $("textarea#'.$id.'").bbcode({tag_bold:true,tag_italic:true,tag_underline:true,tag_link:true,tag_image:true,button_image:false});
			    process();
			  });
			
			  var bbcode="";
			  function process()
			  {
			    if (bbcode != $("textarea#'.$id.'").val())
			      {
			        bbcode = $("textarea#'.$id.'").val();
			        $.get("'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/bbParser.php",
			        {
			          bbcode: bbcode
			        },
			        function(txt){
			          $("#test'.$id.'").html(txt);
			        })
			      }
			    setTimeout("process()", 2000);
			  }
			</script>';
    	}else {
    		$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/js/cleditor/jquery.cleditor.css" />
    		<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/js/cleditor/jquery.cleditor.min.js"></script>
    		<script type="text/javascript">
      			$(document).ready(function() {
        			$("textarea#'.$id.'").cleditor();
				});
    		</script>
        	';
    	}
    	
    	
    	if ( $item_array['rows'] == '' ) {
    		$item_array['rows'] = 10;
    	}
    	
    	if ( $item_array['cols'] == '' ) {
    		$item_array['cols'] = 50;
    	}
    	
    	$rs .= '<textarea id="'.$id.'" class="input" name="'.$item_array['name'].'" rows="'.$item_array['rows'].'" cols="'.$item_array['cols'].'">'.$item_array['value'].'</textarea>';
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$rs,
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_textarea_element ( $item_array ) {
        if ( !isset($item_array['rows']) ) {
            $item_array['rows'] = 10;
        }
        
        if ( !isset($item_array['cols']) ) {
        	$item_array['cols'] = 40;
        }
        
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<textarea name="'.$item_array['name'].'" rows="'.$item_array['rows'].'" cols="'.$item_array['cols'].'">'.$item_array['value'].'</textarea>',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_captcha_element ( $item_array ) {
    	$this->clear_captcha_session_table();
    	$captcha_session_key = $this->generateCaptchaSessionKey();
    
    	$string = '<img id="capcha_img" class="capcha_img" src="'.SITEBILL_MAIN_URL.'/captcha.php?captcha_session_key='.$captcha_session_key.'" width="180" height="80" />';
    	$string .= '<br /><a href="javascript:void(0);" id="captcha_refresh" class="captcha_refresh"> </a>';
    	$string .= '<br /><input type="text" name="'.$item_array['name'].'" value="" size="23" maxlength="'.$item_array['maxlength'].'" />';
    	$string .= '<input type="hidden" name="captcha_session_key" value="'.$captcha_session_key.'">';
    	$string .= '<script src="http://crypto-js.googlecode.com/svn/tags/3.1.2/build/rollups/md5.js"></script>';
    	
    	$string .= '<script type="text/javascript">';
    	$string .= '$(document).ready(function(){
    		$(".captcha_refresh").click(function(){
				var new_key=new Date().getTime();
				var hash = CryptoJS.MD5(String(new_key));
    			$(this).prevAll(".capcha_img").eq(0).attr("src", estate_folder+\'/captcha.php?captcha_session_key=\' + hash);
        		$(this).nextAll("input[name=captcha_session_key]").val(hash);
    		});
    		/*$("#captcha_refresh").click(function(){
				var new_key=new Date().getTime();
				var hash = CryptoJS.MD5(String(new_key));
        		document.getElementById("capcha_img").src = estate_folder+\'/captcha.php?captcha_session_key=\' + hash;
        		$("input[name=captcha_session_key]").val(hash);
    		});*/
    	});';
    	$string .= '</script>';
    
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$string,
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_safe_string_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="text" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value.'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_attachment_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="text" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value.'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_select_box_structure_simple_multiple_element ( $item_array ) {
    	if ( !isset($item_array['values_array']) ) {
    		$item_array['values_array'] = array(0 => 0);
    	}
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$Structure_Manager->getCategorySelectBoxWithName($item_array['name'], $item_array['values_array'] ),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    
    	$rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
    	$rs .= '<td>';
    	$rs .= $item_array['title'];
    	if ( $item_array['required'] == "on" ) {
    		$rs .= " <span style=\"color: red;\">*</span> \n";
    	}
    	$rs .= '</td>';
    	$rs .= '<td>';
    	$rs .= $Structure_Manager->getCategorySelectBoxWithName($item_array['name'], $item_array['values_array'] );
    	$rs .= '</td>';
    	$rs .= '</tr>';
    
    	return $rs;
    }
    
    function compile_grade_element ( $item_array ) {
    	/*$rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
    	$rs .= '<td>';
    	$rs .= $item_array['title'];
    	if ( $item_array['required'] == "on" ) {
    		$rs .= " <span style=\"color: red;\">*</span> \n";
    	}
    	$rs .= '</td>';
    	$rs .= '<td>';*/
    	$html='';
    	foreach ( $item_array['grade_values'] as $item_id ) {
    		if ( $item_array['value'] == $item_id ) {
    			$checked = 'checked="checked"';
    		} else {
    			$checked = '';
    		}
    		$html .= '<span>'.$item_id.'</span><input type="radio" name="'.$item_array['name'].'" value="'.$item_id.'" '.$checked.'>&nbsp;&nbsp;&nbsp;';
    	}
    	/*$rs .= '</td>';
    	$rs .= '</tr>';*/
    
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$html,
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_geodata_element($item_array){
    	$value=$item_array['value'];
    	$str='';
    	//$str.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/geodata.js"></script>';
    	
    	
    	$str.='<div id="geodata" coords="'.$this->getConfigValue('apps.geodata.new_map_center').'">';
    	$str.='<input type="text" geodata="lat" name="'.$item_array['name'].'[lat]"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value['lat'].'" />';
    	$str.='<input type="text" geodata="lng" name="'.$item_array['name'].'[lng]"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value['lng'].'" />';
    	$str.='</div>';
    	if(1==$this->getConfigValue('apps.geodata.enable')){
    		$str.='<script src="http://crypto-js.googlecode.com/svn/tags/3.1.2/build/rollups/md5.js"></script>';
    		$str.='<script>$(document).ready(function(){$("#geodata").Geodata();});</script>';
    	}
    	
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$str,
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_photo_element($item_array){
    	
    	if ( $item_array['value'] != '' ) {
    		$image_list = '<img src="'.SITEBILL_MAIN_URL.'/img/data/user/'.$item_array['value'].'" border="0"/><br>';
    	}else{
    		$image_list = '';
    	}
    	
    	
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="file" name="'.$item_array['name'].'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : ''),
    			'image_list'=>$image_list
    	);
    }
    
    function compile_password_element($item_array){
    	//$value=htmlspecialchars($item_array['value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="password" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$item_array['value'].'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_hidden_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="hidden" name="'.$item_array['name'].'" value="'.$value.'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_primary_key_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>'<input type="hidden" name="'.$item_array['name'].'" value="'.$value.'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_mobilephone_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	$id=md5($item_array['name'].'_'.rand(100,999));
    	$string = '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/jquery.maskedinput.min.js"></script>';
    	$string .= '<script type="text/javascript">
		    	$(document).ready(function() {
    				$.mask.definitions["h"] = "[0-9]"
		    		$("#'.$id.'").mask("h (hhh) hhh-hh-hh");
      			});
    		</script>';
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$string.'<input id="'.$id.'" type="text" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value.'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    	//return $this->compile_safe_string_element($item_array);
    }
    
    function compile_email_element($item_array){
    	return $this->compile_safe_string_element($item_array);
    }
    
    function compile_spacer_text_element ( $item_array ) {
    	   
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$item_array['value'],
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_selectbox_element($item_array){
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$this->get_select_box($item_array),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_checkbox_element($item_array){
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$this->get_checkbox($item_array),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_select_box_by_query_element($item_array){
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$this->get_single_select_box_by_query($item_array),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_select_box_structure_element($item_array){
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	$Structure_Manager = new Structure_Manager();
    	
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$Structure_Manager->getCategorySelectBoxWithName($item_array['name'], $item_array['value'] ),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_structure_element($item_array){
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php');
    	$SM=Structure_Implements::getManager($item_array['entity']);
    	
    	//$equire_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
    	//$Structure_Manager = new Structure_Manager();
    	 
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$SM->getCategorySelectBoxWithName($item_array['name'], $item_array['value'] ),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compie_select_box_by_query_multiple_element ( $item_array ) {
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$this->get_single_select_box_by_query_multiple($item_array),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    	$rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
    	$rs .= '<td>';
    	$rs .= $item_array['title'];
    	if ( $item_array['required'] == "on" ) {
    		$rs .= " <span style=\"color: red;\">*</span> \n";
    	}
    	$rs .= '</td>';
    	$rs .= '<td>';
    	$rs .= $this->get_single_select_box_by_query_multiple($item_array);
    	$rs .= '</td>';
    	$rs .= '</tr>';
    
    	return $rs;
    }
    
    function compile_pluploader_element ( $item_array ) {
    	
    	$_count=0;
    	$image_list=$this->getImageListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'],$_count);
    	 
    	if($this->getConfigValue('photo_per_data')>0 AND $item_array['action']=='data'){
    		if($_count>=$this->getConfigValue('photo_per_data')){
    			return array(
    					'title'=>$item_array['title'],
    					'required'=>($item_array['required'] == "on" ? 1 : 0),
    					'image_list'=>$image_list,
    					'html'=>'',
    					'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    			);
    		}
    	}
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'image_list'=>$image_list,
    			'html'=>$this->getPluploaderPlugin($this->get_session_key()),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    	
    	
    }
    
    function compile_uploadify_element($item_array){
    	
    	$_count=0;
    	$image_list=$this->getImageListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'],$_count);
    	
    	if($this->getConfigValue('photo_per_data')>0 AND $item_array['action']=='data'){
    		if($_count>=$this->getConfigValue('photo_per_data')){
    			return array(
	    			'title'=>$item_array['title'],
	    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    				'image_list'=>$image_list,
	    			'html'=>'',
	    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    			);
    		}
    	}
    	return array(
			'title'=>$item_array['title'],
			'required'=>($item_array['required'] == "on" ? 1 : 0),
			'image_list'=>$image_list,
			'html'=>$this->getUploadifyPlugin($this->get_session_key()),
			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
		);
    	
    	
    }
    
    function compile_uploadify_file_element ( $item_array ) {
    	$image_list=$this->getFileListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'image_list'=>$image_list,
    			'html'=>$this->getUploadifyFilePlugin($this->get_session_key()),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    /*
    	$rs .= '<tr  class="row3"  alt="'.$item_array['name'].'">';
    	$rs .= '<td colspan="2">';
    	$rs .= '<h2>'.Multilanguage::_('L_ATTACH_FILE').'</h2>';
    
    	//$action, $table_name, $key, $record_id
    
    	$rs .= $this->getFileListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value']);
    	$rs .= '</td>';
    	$rs .= '</tr>';
    
    	$rs .= '<tr  class="row3">';
    	$rs .= '<td>';
    	$rs .= $item_array['title'];
    	if ( $item_array['required'] == "on" ) {
    		$rs .= " <span style=\"color: red;\">*</span> \n";
    	}
    	$rs .= '</td>';
    	$rs .= '<td>';
    	$rs .= $this->getUploadifyFilePlugin($this->get_session_key());
    	$rs .= '</td>';
    	$rs .= '</tr>';
    
    	//echo $rs;
    	//exit;
    
    	return $rs;*/
    }
    
    function compile_pluploader_file_element ( $item_array ) {
    	$image_list=$this->getFileListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value']);
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'image_list'=>$image_list,
    			'html'=>$this->getPluploaderPlugin($this->get_session_key()),
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    function compile_form_elements($form_data, $ignore_tabs=false){
    	 
    	$elements[]=array();
    	$default_tab_name=$this->getConfigValue('default_tab_name');
    	$tabs=array($default_tab_name);
    	
    	foreach ( $form_data as $item_id => $item_array ) {
    		if ( !isset($item_array['name']) ) {
    			continue;
    		}
    		 
    		switch ( $item_array['type'] ) {
    			case 'price':
    				$rs = $this->compile_price_element($item_array);
    				break;
    			case 'select_box':
    				$rs = $this->compile_selectbox_element($item_array);
    				break;
    			case 'attachment':
    				$rs = $this->compile_attachment_element($item_array);
    				break;
    			case 'geodata':
    				$rs = $this->compile_geodata_element($item_array);
    				break;
    	
    			case 'email':
    				$rs = $this->compile_email_element($item_array);
    				break;
    	
    			case 'mobilephone':
    				$rs = $this->compile_mobilephone_element($item_array);
    				break;
    	
    			case 'select_by_query':
    				$rs = $this->compile_select_box_by_query_element($item_array);
    				break;
    	
    			case 'select_by_query_multiple':
    				$rs = $this->compie_select_box_by_query_multiple_element($item_array);
    				break;
    	
    			case 'select_box_structure':
    				$rs = $this->compile_select_box_structure_element($item_array);
    				break;
    	
    			case 'select_box_structure_simple_multiple':
    				$rs = $this->compile_select_box_structure_simple_multiple_element($item_array);
    				break;
    	
    			case 'shop_select_box_structure':
    				$rs = $this->get_shop_select_box_structure_row($item_array);
    				break;
    	
    			case 'service_type_select_box_structure':
    				{
    					$rs = $this->get_service_type_select_box_structure_row($item_array);
    				}
    				break;
    				/*
    				 case 'uploader':
    				$rs .= $this->get_uploader_row($item_array);
    				break;
    	
    				case 'pluploader':
    				$rs .= $this->get_pluploader_row($item_array);
    				break;
    				*/
    			case 'uploadify_image':
    				switch($this->getConfigValue('uploader_type')){
    					case 'pluploader' : {
    						$rs = $this->compile_pluploader_element($item_array);
    						break;
    					}
    					default : {
    						$rs = $this->compile_uploadify_element($item_array);
    					}
    				}
    	
    				break;
    	
    			case 'uploadify_file':
    				switch($this->getConfigValue('uploader_type')){
    					case 'pluploader' : {
    						//$rs = $this->compile_pluploader_element($item_array);
    						$rs = $this->compile_pluploader_file_element($item_array);
    						break;
    					}
    					default : {
    						$rs = $this->compile_uploadify_file_element($item_array);
    					}
    				}
    				//$rs = $this->get_uploadify_file_row($item_array);
    				break;
    	
    			case 'separator':
    				$rs = $this->get_separator_row($item_array);
    				break;
    	
    			case 'checkbox':
    				$rs = $this->compile_checkbox_element($item_array);
    				break;
    	
    			case 'textarea':
    				$rs = $this->compile_textarea_element($item_array);
    				break;
    	
    			case 'textarea_editor':
    				$rs = $this->compile_textarea_editor_element($item_array);
    				break;
    	
    			case 'grade':
    				$rs = $this->compile_grade_element($item_array);
    				break;
    	
    			case 'date':
    				//$rs = $this->get_date_input($item_array);
    				$rs = $this->compile_date_element($item_array);
    				break;
    	
    			case 'auto_add_value':
    				$rs = $this->compile_safe_string_element($item_array);
    				break;
    	
    			case 'safe_string':
    				$rs = $this->compile_safe_string_element($item_array);
    				break;
    	
    			case 'password':
    				//$rs = $this->get_password_input($item_array);
    				$rs = $this->compile_password_element($item_array);
    				break;
    	
    			case 'photo':
    				$rs = $this->compile_photo_element($item_array);
    				break;
    	
    			case 'captcha':
    				$rs = $this->compile_captcha_element($item_array);
    				break;
    	
    			case 'spacer_text':
    				$rs = $this->compile_spacer_text_element($item_array);
    				break;
    	
    			case 'hidden':
    				$rs = $this->compile_hidden_element($item_array);
    				break;
    				
    			case 'primary_key':
    					$rs = $this->compile_primary_key_element($item_array);
    					break;
    	
    			case 'values_list':
    				$rs = $this->get_safe_text_input($item_array);
    				break;
    				
    			case 'structure':
    				$rs = $this->compile_structure_element($item_array);
    				break;
    			default:
    				break;
    		}
    		
    		$rs['hint']=$item_array['hint'];
    		$rs['name']=$item_array['name'];
    		$rs['active_in_topic']=$item_array['active_in_topic'];
    		if($item_array['type']=='hidden' || $item_array['type']=='primary_key'){
    			$elements['private'][$item_array['name']]=$rs;
    		}else{
    			if($rs['tab']==''){
    				$rs['tab']=$default_tab_name;
    			}
    			if($ignore_tabs){
    				$elements['public'][$default_tab_name][$item_array['name']]=$rs;
    			}else{
    				$elements['public'][$rs['tab']][$item_array['name']]=$rs;
    			}
    			
    		}
    		$elements['hash'][$item_array['name']]=$rs;
    		
    	}
    	return $elements;
    }
    
    /**
     * Compile form inputs
     * @param $form_data form data
     * @return string
     */
    function compile_form ( $form_data, $ignore_tabs=false ) {
    	$Sitebill_Registry=Sitebill_Registry::getInstance();
    	
    	 
    	$elements[]=array();
    	$default_tab_name=$this->getConfigValue('default_tab_name');
    	$tabs=array($default_tab_name);
    	
        foreach ( $form_data as $item_id => $item_array ) {
        	$rs='';
        	//echo "type = {$item_array['type']}, name = {$item_array['name']}<br>";
            switch ( $item_array['type'] ) {
            	case 'price':
                    $rs = $this->get_price_input($item_array);
                break;
                case 'select_box':
                    $rs = $this->get_select_box_row($item_array);
                break;
                
                case 'email':
                    $rs = $this->get_email_input($item_array);
                break;
                
                case 'mobilephone':
                    $rs = $this->get_mobilephone_input($item_array);
                break;
                
                case 'select_by_query':
                    $rs = $this->get_select_box_by_query_row($item_array);
                break;
                
                case 'select_by_query_multiple':
                    $rs = $this->get_select_box_by_query_multiple_row($item_array);
                break;
                
                case 'select_box_structure':
                    $rs = $this->get_select_box_structure_row($item_array);
                break;
                
                case 'structure':
                	$rs = $this->get_structure_row($item_array);
                break;
                
                case 'select_box_structure_simple_multiple':
                    $rs = $this->get_select_box_structure_simple_multiple_row($item_array);
                break;
                
                case 'shop_select_box_structure':
                    $rs = $this->get_shop_select_box_structure_row($item_array);
                break;
                
                case 'service_type_select_box_structure':
                	{
                	$rs = $this->get_service_type_select_box_structure_row($item_array);
                	}
                break;
                /*
                case 'uploader':
                    $rs .= $this->get_uploader_row($item_array);
                break;
                
                case 'pluploader':
                    $rs .= $this->get_pluploader_row($item_array);
                break;
                */
                case 'uploadify_image':
                	switch($this->getConfigValue('uploader_type')){
                		case 'pluploader' : {
                			$rs = $this->get_pluploader_row($item_array);
                			break;
                		}
                		default : {
                			$rs = $this->get_uploadify_row($item_array);
                		}
                	}
                    
                break;
                
                case 'uploadify_file':
                    $rs = $this->get_uploadify_file_row($item_array);
                break;
                
                case 'separator':
                    $rs = $this->get_separator_row($item_array);
                break;
                
                case 'checkbox':
                    $rs = $this->get_checkbox_box_row($item_array);
                break;
                
                case 'textarea':
                    $rs = $this->get_textarea_row($item_array);
                break;
                
                case 'textarea_editor':
                    $rs = $this->get_textarea_editor_row($item_array);
                break;
                
                case 'grade':
                    $rs = $this->get_grade_row($item_array);
                break;

                case 'date':
                    $rs = $this->get_date_input($item_array);
                break;
                
                case 'auto_add_value':
                    $rs = $this->get_safe_text_input($item_array);
                break;
                
                case 'safe_string':
                    $rs = $this->get_safe_text_input($item_array);
                break;
                
                case 'geodata':
                	$rs = $this->get_geodata_input($item_array);
                break;

                case 'password':
                    $rs = $this->get_password_input($item_array);
                break;
                
                case 'photo':
                    $rs = $this->get_photo_input($item_array);
                break;
                
                case 'captcha':
                    $rs = $this->get_captcha_input($item_array);
                break;
                
                case 'spacer_text':
                    $rs = $this->get_spacer_text($item_array);
                break;
                
                case 'hidden':
                    $rs = $this->get_hidden_input($item_array);
                break;
                
                case 'values_list':
                    $rs = $this->get_safe_text_input($item_array);
                break;
            }
            
            
           // echo $default_tab_name;
           
            
            if(isset($item_array['tab']) && $item_array['tab']!=''){
            	$tabs[$item_array['tab']]=$item_array['tab'];
            	if($rs!=''){
            		$elements[$item_array['tab']][]=$rs;
            	}
            }else{
            	if($rs!=''){
            		$elements[$default_tab_name][]=$rs;
            	}
            }
            
        }
        $rt='';
        
        if($Sitebill_Registry->getFeedback('divide_step_form')){
        	$tabs_count=count($tabs);
        	$current_step=$Sitebill_Registry->getFeedback('step');
        	$Sitebill_Registry->addFeedback('steps',$tabs_count);
        	if($tabs_count>1){
        		$tabs_names=array_keys($tabs);
        	}
        	$tabs_names=array_keys($tabs);
        	        	
        	$rt.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/form_tabs.js"></script>';
        	if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/css/form_tabs.css') ) {
        		$rt.='<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/template/frontend/'.$this->getConfigValue('theme').'/css/form_tabs.css" />';
        	} else {
        		$rt.='<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/system/css/form_tabs.css" />';
        	}
        	
        	$rt.='<tbody id="form_tab_switcher" style="display:none;">';
        	$rt.='<tr colspan="2"><td>';
        	$ti=1;
        	
        	foreach($tabs as $tab){
        		if($ti>$current_step){
        			$rt.='<span>'.$tab.'</span>';
        		}elseif($ti==$current_step){
        			$rt.='<a href="'.md5($tab).'" class="active_tab">'.$tab.'</a>';
        		}else{
        			$rt.='<a href="'.md5($tab).'">'.$tab.'</a>';
        		}
        		
        		$ti++;
        	}
        	$rt.='</td></tr></tbody>';
        	
        	$ti=1;
        	foreach($tabs as $tab){
        		if($ti>$tabs_count){
        			break;
        		}
        		if($ti==$current_step){
        			$rt.='<tbody class="form_tab" id="'.md5($tab).'">';
        			$rt.='<tr colspan="2"><td>'.$tab.'</td></tr>';
        			if(count($elements[$tab])>0){
        				foreach($elements[$tab] as $el){
        					$rt.=$el;
        				}
        			}
        			$rt.='</tbody>';
        		}else{
        			$rt.='<tbody class="form_tab">';
        			$rt.='<tr colspan="2"><td>'.$tab.'</td></tr>';
        			if(count($elements[$tab])>0){
        				foreach($elements[$tab] as $el){
        					$rt.=$el;
        				}
        			}
        			$rt.='</tbody>';
        		}
        		
        		
        		$ti++;
        	}
        }elseif(count($tabs)>1 && !$ignore_tabs){
        	
        	$rt.='<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/form_tabs.js"></script>';
        	if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/css/form_tabs.css') ) {
        		$rt.='<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/template/frontend/'.$this->getConfigValue('theme').'/css/form_tabs.css" />';
        	} else {
        		$rt.='<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/system/css/form_tabs.css" />';
        	}
        	$rt.='<tbody id="form_tab_switcher">';
        	$rt.='<tr colspan="2"><td>';
        	foreach($tabs as $tab){
        		$rt.='<a href="'.md5($tab).'">'.$tab.'</a>';
        	}
        	$rt.='</td></tr></tbody>';
        	
        	foreach($tabs as $tab){
	        	$rt.='<tbody class="form_tab" id="'.md5($tab).'">';
	        	$rt.='<tr colspan="2"><td>'.$tab.'</td></tr>';
	        	if(count($elements[$tab])>0){
	        		foreach($elements[$tab] as $el){
	        			//echo $el;
	        			$rt.=$el;
	        		}
	        	}
	        	$rt.='</tbody>';
	        }
        }elseif(count($tabs)>1){
        	foreach($tabs as $tab){
        		if(count($elements[$tab])>0){
        			foreach($elements[$tab] as $el){
        				$rt.=$el;
        			}
        		}
        	}
        }else{
        	if(count($elements[$default_tab_name])>0){
        		foreach($elements[$default_tab_name] as $el){
        			$rt.=$el;
        		}
        	}
        	
        }
        return $rt;
        //return $rs;
    }
    
    /**
     * Get spacer text
     * @param array $item_array
     * @return string
     */
    function get_spacer_text ( $item_array ) {
        //echo 'spacer!<br>';
        $string .= "<tr>\n";
		$string .= '<td>';
        $string .= $item_array['title'];
        $string .= '</td>';
        $string .= "<td colspan=\"2\">".$item_array['value']."</td>\n";
        $string .= "</tr>\n";
        //echo $item_array['value'].'<br>';
        //echo $string;

        /*Return html code*/
        return $string;
    }
    
    
    /**
     * Get error message row
     * @param string $error_message
     * @return string
     */
    function get_error_message_row ( $error_message ) {
        $rs = '<tr>';
        $rs .= '<td colspan="2">';
        $rs .= '<span class="error"><div class="alert alert-error">'.$error_message.'</div></span>';
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    /**
     * Get select box row
     * @param array $item_array
     * @return string
     */
    function get_select_box_by_query_row ( $item_array ) {
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $this->get_single_select_box_by_query($item_array);
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
/**
     * Get select box row
     * @param array $item_array
     * @return string
     */
    function get_select_box_by_query_multiple_row ( $item_array ) {
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $this->get_single_select_box_by_query_multiple($item_array);
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    /**
     * Get total in select
     * @param string $key
     * @return int
     */
    function get_total_in_select ( $key ) {
        return $this->total_in_select[$key];
    }
    
    /**
     * Get single select box by query
     * @param array $item_array
     * @return string
     */
    function get_single_select_box_by_query ( $item_array ) {
    	//return '';
    	
    	$combo=false;
    	if(isset($item_array['combo']) && $item_array['combo']==1 && 1==$this->getConfigValue('use_combobox')){
    		$combo=true;
    		$tmp=$this->getRequestValue('tmp');
    		//$ajax_
    		if(isset($item_array['ajax_options']) && count($item_array['ajax_options'])>0){
    			$d=json_encode($item_array['ajax_options']);
    		}else{
    			$d=json_encode(array());
    		}
    		$rs.='<script type="text/javascript">
    			$(document).ready(function(){
					$("select[id='.$item_array['name'].']").mycombobox({tmp_val:\''.$tmp[$item_array['name']].'\',ajax_options:'.$d.'});
				
				});
    			</script>';
    	}
    	
    	$this->total_in_select[$item_array['name']] = 0;
        $rs .= '<div id="'.$item_array['name'].'_div">';
        $rs .= '<select name="'.$item_array['name'].'" id="'.$item_array['name'].'" onchange="'.$item_array['onchange'].'">';
       	//if ( $item_array['title_default'] != '' && !$combo ) {
            $rs .= '<option value="'.$item_array['value_default'].'" '.$selected.'>'.$item_array['title_default'].'</option>';
        //}
        //if($item_array['name']=='district_id'){
        //	echo $item_array['query'];
        //}
        //echo $item_array['query'];
        $this->db->exec($item_array['query']);
        while ( $this->db->fetch_assoc() ) {
            $this->total_in_select[$item_array['name']]++;
            $value = $this->db->row[$item_array['value_name']];
            $value = trim($value);
            $value = htmlspecialchars_decode($value);
            if ( $this->db->row[$item_array['primary_key_name']] ==  $item_array['value'] ) {
                $selected = "selected";
            } else {
                $selected = "";
            }
            $rs .= '<option value="'.$this->db->row[$item_array['primary_key_name']].'" '.$selected.'>'.$value.'</option>';
        }
        $rs .= '</select>';
        /*if(1==$this->getConfigValue('use_combobox')){
        	$rs .= '<input type="text" name="nw" id="nw" />';
        }*/
        $rs .= '</div>';
        
        return $rs;
    }
    
/**
     * Get single select box by query
     * @param array $item_array
     * @return string
     */
    function get_single_select_box_by_query_multiple ( $item_array ) {
        $this->total_in_select[$item_array['name']] = 0;
        $rs .= '<div id="'.$item_array['name'].'_div">';
        $rs .= '<select name="'.$item_array['name'].'[]" id="'.$item_array['name'].'" onchange="'.$item_array['onchange'].'" multiple="multiple">';
        
        $this->db->exec($item_array['query']);
        while ( $this->db->fetch_assoc() ) {
            $this->total_in_select[$item_array['name']]++;
            $value = $this->db->row[$item_array['value_name']];
            $value = trim($value);
            $value = htmlspecialchars_decode($value);
            $selected = '';
            if ( is_array($item_array['values_array']) ) {
                if ( in_array($this->db->row[$item_array['primary_key_name']],$item_array['values_array'])) {
                	$selected = "selected";
                }
            }
            $rs .= '<option value="'.$this->db->row[$item_array['primary_key_name']].'" '.$selected.'>'.$value.'</option>';
        }
        $rs .= '</select>';
        $rs .= '</div>';
        
        return $rs;
    }
    
    /**
     * Get select box row
     * @param array $item_array
     * @return string
     */
    function get_select_box_row ( $item_array ) {
        $rs = '<tr class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= ((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '').'</td>';
        $rs .= '<td>';
        $rs .= $this->get_select_box($item_array);
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
 	/**
     * Get uploader row
     * @param array $item_array
     * @return string
     */
    function get_uploader_row ( $item_array ) {
        $rs .= '<tr  alt="'.$item_array['name'].'">';
        $rs .= '<td colspan="2">';
        $rs .= '<h2>'.Multilanguage::_('L_PHOTO_1').'</h2>';
        
        
        
        $rs .= '</td>';
        $rs .= '</tr>';
        
        $rs .= '<tr>';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $this->getUploaderPlugin($this->get_session_key());
        $rs .= '</td>';
        $rs .= '</tr>';
        
        //echo $rs;
        //exit;
        
        return $rs;
    }
    
/**
     * Get uploader row
     * @param array $item_array
     * @return string
     */
    function get_pluploader_row ( $item_array ) {
        $rs .= '<tr  class="row3">';
        $rs .= '<td colspan="2">';
        $rs .= '<h2>'.Multilanguage::_('L_PHOTO_1').'</h2>';
        
        $rs .= $this->getImageListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'],$_count);
        
        $rs .= '</td>';
        $rs .= '</tr>';
        
        $rs .= '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        //$rs .= $this->getPP($this->get_session_key());
        $rs .= $this->getPluploaderPlugin($this->get_session_key());
        $rs .= '</td>';
        $rs .= '</tr>';
        
        //echo $rs;
        //exit;
        
        return $rs;
    }
    
    /**
     * Get uploadify row
     * @param array $item_array
     * @return string
     */
    function get_uploadify_row ( $item_array ) {
        $rs .= '<tr  class="row3">';
        $rs .= '<td colspan="2">';
        $rs .= '<h2>'.Multilanguage::_('L_PHOTO_1').'</h2>';
        
        //$action, $table_name, $key, $record_id
        $_count=0;
        $rs .= $this->getImageListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value'],$_count);
        
        $rs .= '</td>';
        $rs .= '</tr>';
        if($this->getConfigValue('photo_per_data')>0 AND $item_array['action']=='data'){
        	if($_count>=$this->getConfigValue('photo_per_data')){
        		return $rs;
        	}
        }
        $rs .= '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $this->getUploadifyPlugin($this->get_session_key());
        $rs .= '</td>';
        $rs .= '</tr>';
       
        
        //echo $rs;
        //exit;
        
        return $rs;
    }
    
    /**
     * Get uploadify file row
     * @param array $item_array
     * @return string
     */
    function get_uploadify_file_row ( $item_array ) {
        
        $rs .= '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td colspan="2">';
        $rs .= '<h2>'.Multilanguage::_('L_ATTACH_FILE').'</h2>';
        
        //$action, $table_name, $key, $record_id
        
        $rs .= $this->getFileListAdmin($item_array['action'], $item_array['table_name'], $item_array['primary_key'], $item_array['primary_key_value']);
        $rs .= '</td>';
        $rs .= '</tr>';
        
        $rs .= '<tr  class="row3">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $this->getUploadifyFilePlugin($this->get_session_key());
        $rs .= '</td>';
        $rs .= '</tr>';
        
        //echo $rs;
        //exit;
        
        return $rs;
    }
    
    
    /**
     * Get separator row
     * @param array $item_array
     * @return string
     */
    function get_separator_row ( $item_array ) {
        
        $rs .= '<tr>';
        $rs .= '<td colspan="2">';
        $rs .= '<h2>'.$item_array['title'].'</h2>';
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    
    /**
     * Get select box structure row
     * @param array $item_array
     * @return string
     */
    function get_select_box_structure_row ( $item_array ) {
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $Structure_Manager->getCategorySelectBoxWithName($item_array['name'], $item_array['value'] );
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    function get_structure_row ( $item_array ) {
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php');
    	$SM=Structure_Implements::getManager($item_array['entity']);
    
    	$rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
    	$rs .= '<td>';
    	$rs .= $item_array['title'];
    	if ( $item_array['required'] == "on" ) {
    		$rs .= " <span style=\"color: red;\">*</span> \n";
    	}
    	$rs .= '</td>';
    	$rs .= '<td>';
    	$rs .= $SM->getCategorySelectBoxWithName($item_array['name'], $item_array['value'] );
    	$rs .= '</td>';
    	$rs .= '</tr>';
    
    	return $rs;
    }
    
	/**
     * Get select box structure row
     * @param array $item_array
     * @return string
     */
    function get_select_box_structure_simple_multiple_row ( $item_array ) {
        if ( !isset($item_array['values_array']) ) {
            $item_array['values_array'] = array(0 => 0);
        }
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $Structure_Manager->getCategorySelectBoxWithName($item_array['name'], $item_array['values_array'] );
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    
    
	function get_shop_select_box_structure_row ( $item_array ) {
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $Structure_Manager->getShopCategorySelectBoxWithName($item_array['name'], $item_array['value'] );
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    /**
     * Get select box for tree table structure type
     * @param array $item_arrayy
     * @return select tag string
     * @author Kris
     */
    function get_service_type_select_box_structure_row ( $item_array) {
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= $Structure_Manager->getServiceTypesTree_selectBox($item_array['name'], $item_array['value'] );
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    
	/**
     * Get checkbox box row
     * @param array $item_array
     * @return string
     */
    function get_checkbox_box_row ( $item_array ) {
        $rs = '<tr  class="row3" alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= ((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '').'</td>';
        $rs .= '<td>';
        $rs .= $this->get_checkbox($item_array);
        if ( $item_array['ajax_popup'] != '' ) {
            $rs .= $item_array['ajax_popup'];
        }
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    /**
     * Get textarea row
     * @param array $item_array
     * @return string
     */
    function get_textarea_row ( $item_array ) {
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        
        if ( $item_array['rows'] == '' ) {
            $item_array['rows'] = 10;
        }
        
        if ( $item_array['cols'] == '' ) {
            $item_array['cols'] = 50;
        }
        
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= '<textarea name="'.$item_array['name'].'" rows="'.$item_array['rows'].'" cols="'.$item_array['cols'].'">'.$item_array['value'].'</textarea>';
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
	/**
     * Get textarea with editor row
     * @param array $item_array
     * @return string
     */
    function get_textarea_editor_row ( $item_array ) {
    	sleep(1);
    	$id='id'.time().'_'.rand(0,9);
    	$rs='';
    	if(isset($item_array['editor']) AND ($item_array['editor']!=='editor')){
    		if($this->getConfigValue($item_array['editor'])!=''){
    			$editor_code=$this->getConfigValue($item_array['editor']);
    		}else{
    			$editor_code=$this->getConfigValue('editor');
    		}
    	}else{
    		$editor_code=$this->getConfigValue('editor');
    	}
    	if ( $editor_code == 'ckeditor' ) {
		    $rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/ckeditor/ckeditor.js"></script>';
		    $rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/ckeditor/adapters/jquery.js"></script>';
		    $rs .= '<script type="text/javascript">
		    	$(document).ready(function() {
        			$("textarea#'.$id.'").ckeditor({
		filebrowserBrowseUrl : \'/ckfinder/ckfinder.html\',
        filebrowserImageBrowseUrl : \'/ckfinder/ckfinder.html?Type=Images\',
        filebrowserFlashBrowseUrl : \'/ckfinder/ckfinder.html?Type=Flash\',
        filebrowserUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Files\',
        filebrowserImageUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Images\',
        filebrowserFlashUploadUrl : \'/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Flash\'	
    				});
				});
    		</script>';
        } elseif( $editor_code == 'bbeditor' ){
        	$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/bbeditor.css" />';
        	
        	//$rs .= '<H5>Preview</H5>';
//$rs .= '<DIV id=test style="BORDER-RIGHT: #c0c0c0 1px solid; PADDING-RIGHT: 3px; BORDER-TOP: #c0c0c0 1px solid; PADDING-LEFT: 3px; PADDING-BOTTOM: 3px; BORDER-LEFT: #c0c0c0 1px solid; WIDTH: 500px; PADDING-TOP: 3px; BORDER-BOTTOM: #c0c0c0 1px solid; HEIGHT: 200px"></DIV>';
        	
        	
        	$rs .= '<script src="'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/jquery.bbcode.js" type="text/javascript"></script>';
			$rs .= '<script type="text/javascript">
			  $(document).ready(function(){
			    $("textarea#'.$id.'").bbcode({tag_bold:true,tag_italic:true,tag_underline:true,tag_link:true,tag_image:true,button_image:false});
			    process();
			  });
			  
			  var bbcode="";
			  function process()
			  {
			    if (bbcode != $("textarea#'.$id.'").val())
			      {
			        bbcode = $("textarea#'.$id.'").val();
			        $.get("'.SITEBILL_MAIN_URL.'/apps/bbcode/site/js/bbeditor/bbParser.php",
			        {
			          bbcode: bbcode
			        },
			        function(txt){
			          $("#test'.$id.'").html(txt);
			        })
			      }
			    setTimeout("process()", 2000);
			  }
			</script>';
			/*
        	$rs .= '<tr>';
	        $rs .= '<td>';
	        $rs .= '</td>';
	        $rs .= '<td>';
	        $rs .= '<DIV id=test'.$id.' style="BORDER-RIGHT: #c0c0c0 1px solid; PADDING-RIGHT: 3px; BORDER-TOP: #c0c0c0 1px solid; PADDING-LEFT: 3px; PADDING-BOTTOM: 3px; BORDER-LEFT: #c0c0c0 1px solid; WIDTH: 400px; PADDING-TOP: 3px; BORDER-BOTTOM: #c0c0c0 1px solid; HEIGHT: 100px; overflow:scroll"></DIV>';
	        $rs .= '</td>';
	        $rs .= '</tr>';
        	*/
        	
        }else {
            $rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/js/cleditor/jquery.cleditor.css" />
    		<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/js/cleditor/jquery.cleditor.min.js"></script>
    		<script type="text/javascript">
      			$(document).ready(function() {
        			$("textarea#'.$id.'").cleditor();
				});
    		</script>
        	';
        }
        $rs .= '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        
        if ( $item_array['rows'] == '' ) {
            $item_array['rows'] = 10;
        }
        
        if ( $item_array['cols'] == '' ) {
            $item_array['cols'] = 50;
        }
        
        $rs .= '</td>';
        $rs .= '<td>';
        $rs .= '<textarea id="'.$id.'" class="input" name="'.$item_array['name'].'" rows="'.$item_array['rows'].'" cols="'.$item_array['cols'].'">'.$item_array['value'].'</textarea>';
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    /**
     * Get grade row
     * @param array $item_array
     * @return string
     */
    function get_grade_row ( $item_array ) {
        $rs = '<tr  class="row3"  alt="'.$item_array['name'].'">';
        $rs .= '<td>';
        $rs .= $item_array['title'];
        if ( $item_array['required'] == "on" ) {
            $rs .= " <span style=\"color: red;\">*</span> \n";
        }
        $rs .= '</td>';
        $rs .= '<td>';
        
        foreach ( $item_array['grade_values'] as $item_id ) {
            if ( $item_array['value'] == $item_id ) {
                $checked = 'checked';
            } else {
                $checked = '';
            }
            $rs .= '<span>'.$item_id.'</span><input type="radio" name="'.$item_array['name'].'" value="'.$item_id.'" '.$checked.'>&nbsp;&nbsp;&nbsp;';
        }
        $rs .= '</td>';
        $rs .= '</tr>';
        
        return $rs;
    }
    
    
    /**
     * Get check box
     * @param array $item_array
     * @return string
     */
    function get_checkbox ( $item_array ) {
        $rs = '<input type="checkbox" name="'.$item_array['name'].'" value="'.$item_array['value'].'"';
        if ( $item_array['value'] == 1 ) {
            $rs .= ' checked ';
        }
        $rs .= '/>';
        return $rs;
    }
    
    
    /**
     * Get select box
     * @param array $item_array
     * @return string
     */
    function get_select_box ( $item_array ) {
        //echo '<pre>';
        //print_r($item_array);
        $rs = '<select name="'.$item_array['name'].'">';
        if ( !empty($item_array['select_data']) ) {
        	foreach ( $item_array['select_data'] as $item_id => $item_value ) {
        		
        		if($item_id==='__optgroup'){
        			//echo $item_id.'=__optgroup'.'<br />';;
        			$optgroup_content=$item_value;
        			$rs .= '<optgroup label="'.$optgroup_content['name'].'">';
        			if(is_array($optgroup_content['select_data']) && count($optgroup_content['select_data'])>0){
        				foreach($optgroup_content['select_data'] as $ogi=>$ogv){
        					if ( $ogi ==  $item_array['value'] ) {
        						$selected = "selected";
        					} else {
        						$selected = "";
        					}
        					$rs .= '<option value="'.$ogi.'" '.$selected.'>'.$ogv.'</option>';
        				}
        				$rs .= '</optgroup>';
        			}
        			
        		}else{
        			//echo $item_id.'!=__optgroup'.'<br />';;
        			if ( $item_id ==  $item_array['value'] ) {
        				$selected = "selected";
        			} else {
        				$selected = "";
        			}
        			$rs .= '<option value="'.$item_id.'" '.$selected.'>'.$item_value.'</option>';
        		}
        		
        	}
        }
        $rs .= '</select>';
        return $rs;
        
        
    }
    
    /**
     * Get captcha input
     * @param unknown_type $item_array
     * @return string
     */
    function get_captcha_input ( $item_array ) {
		$this->clear_captcha_session_table();
        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";
        
        $captcha_session_key = $this->generateCaptchaSessionKey();
    
        /*Mark required field with simbol '*' */
        $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";

        $string .= "<td class=\"$bg_color\"><img id=\"capcha_img\" class=\"capcha_img\" src=\"".SITEBILL_MAIN_URL."/captcha.php?captcha_session_key=".$captcha_session_key."\" width=\"180\" height=\"80\">";
        $string .= '<br /><a href="javascript:void(0);" id="captcha_refresh" class="captcha_refresh"> </a>';
        $string .= "<br><input type=\"text\" name=\"".$item_array['name']."\" value=\"\" size=\"23\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>"."\n";
        $string .= '<input type="hidden" name="captcha_session_key" value="'.$captcha_session_key.'">';
        $string .= "</tr>\n";
        $string .= '<script src="http://crypto-js.googlecode.com/svn/tags/3.1.2/build/rollups/md5.js"></script>';
        
        $string .= '<script type="text/javascript">';
		$string .= '$(document).ready(function(){
			$(".captcha_refresh").click(function(){
				var new_key=new Date().getTime();
				var hash = CryptoJS.MD5(String(new_key));
				var parent=$(this).parents("td").eq(0);
    			parent.find(".capcha_img").eq(0).attr("src", estate_folder+\'/captcha.php?captcha_session_key=\' + hash);
        		parent.find("input[name=captcha_session_key]").val(hash);
    		});
    		/*$("#captcha_refresh").click(function(){
				var new_key=new Date().getTime();
				var hash = CryptoJS.MD5(String(new_key));
        		document.getElementById("capcha_img").src = estate_folder+\'/captcha.php?captcha_session_key=\' + hash;
        		$("input[name=captcha_session_key]").val(hash);
    		});*/
    	});';
        $string .= '</script>';

        /*Return html code*/
        return $string;
    }
    
    /**
     * Generate captcha session key
     * @param void
     * @return string
     */
    function generateCaptchaSessionKey () {
        return md5(time().rand(9999, 4).'random key captcha string core sitebill');
    }

    /**
     * Get date input
     * @param array $item_array
     * @return string
     */
    function get_date_input ( $item_array ) {
        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= '
    		<script type="text/javascript">
      			$(document).ready(function() {
					$( "#'.$item_array['name'].'" ).datepicker({
						showOn: "button",
						dateFormat: "dd.mm.yy",
						buttonImage: "'.SITEBILL_MAIN_URL.'/img/calendar.gif",
						buttonImageOnly: true
					});        			
      			});
    		</script>
        ';
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }
       
    	/*if($item_array['value']==='' || $item_array['value']===0){
    		$item_array['value'] = date('d.m.Y', time());
    		//$item_array['value'] = '';
    	}else*/if(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2}) (\d{2,2}):(\d{2,2}):(\d{2,2})/',$item_array['value'])){
    		$item_array['value'] = date('d.m.Y', strtotime($item_array['value']));
    	}elseif(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2})/',$item_array['value'])){
    		$item_array['value'] = date('d.m.Y', strtotime($item_array['value']));
    	}elseif($item_array['value']==0 || $item_array['value']==''){
    		
    		$item_array['value'] = '';
    	}else{
    		$item_array['value'] = date('d.m.Y', $item_array['value']);
    		
    	}
        
        $string .= "<td class=\"$bg_color\"><input type=\"text\" name=\"".$item_array['name']."\" id=\"".$item_array['name']."\" value=\"".htmlspecialchars($item_array['value'])."\" size=\"10\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
    function compile_date_element($item_array){
    	$value=htmlspecialchars($item_array['value']);
    	$string .= '
    		<script type="text/javascript">
      			$(document).ready(function() {
					$( "#'.$item_array['name'].'" ).datepicker({
						showOn: "button",
						dateFormat: "dd.mm.yy",
						buttonImage: "'.SITEBILL_MAIN_URL.'/img/calendar.gif",
						buttonImageOnly: true
					});
      			});
    		</script>
        ';
    	//echo $item_array['value'];
    	/*if($item_array['value']==='' || $item_array['value']===0){
    		$item_array['value'] = date('d.m.Y', time());
    		//$item_array['value'] = '';
    	}else*/if(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2}) (\d{2,2}):(\d{2,2}):(\d{2,2})/',$item_array['value'])){
    		$item_array['value'] = date('d.m.Y', strtotime($item_array['value']));
    	}elseif(preg_match('/(\d{4,4})-(\d{2,2})-(\d{2,2})/',$item_array['value'])){
    		$item_array['value'] = date('d.m.Y', strtotime($item_array['value']));
    	}elseif($item_array['value']==0 || $item_array['value']==''){
    		
    		$item_array['value'] = '';
    	}else{
    		$item_array['value'] = date('d.m.Y', $item_array['value']);
    		
    	}
    	return array(
    			'title'=>$item_array['title'],
    			'required'=>($item_array['required'] == "on" ? 1 : 0),
    			'html'=>$string.'<input type="text" id="'.$item_array['name'].'" name="'.$item_array['name'].'"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$item_array['value'].'" />',
    			'tab'=>(isset($item_array['tab']) ? $item_array['tab'] : '')
    	);
    }
    
    
    /**
     * Get safe string input
     * @param array  $item_array
     * @return string
     */
    function get_safe_text_input ( $item_array ) {

        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<tr class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span>".((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '')."</td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title'].((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '')."</td>\n";
        }

        $string .= "<td class=\"$bg_color\"><input type=\"text\" name=\"".$item_array['name']."\" value=\"".htmlspecialchars($item_array['value'])."\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
    function get_geodata_input ( $item_array ) {
    
    	/*Un-quote slashes*/
    	$value = stripslashes( $value );
    	/*HTML code*/
    	$string .= "<tr class=\"row3\" alt=\"".$item_array['name']."\">\n";
    	
    	/*$str.='<div id="geodata">';
    	$str.='<input type="text" geodata="lat" name="'.$item_array['name'].'[lat]"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value['lat'].'" />';
    	$str.='<input type="text" geodata="lng" name="'.$item_array['name'].'[lng]"  size="'.$item_array['length'].'" maxlength="'.$item_array['maxlength'].'" value="'.$value['lng'].'" />';
    	$str.='</div>';
    	$str.='<script src="http://crypto-js.googlecode.com/svn/tags/3.1.2/build/rollups/md5.js"></script>';
    	$str.='<script>$(document).ready(function(){$("#geodata").Geodata();});</script>';
    	*/
    
    	/*Mark required field with simbol '*' */
    	if ( $item_array['required'] == "on" ) {
    		$string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span>".((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '')."</td>\n";
    	} else {
    		$string .= "<td class=\"$bg_color\">".$item_array['title'].((isset($item_array['hint']) && $item_array['hint']!='') ? ' <span class="hint">('.$item_array['hint'].')</span>' : '')."</td>\n";
    	}
    
    	$string .= "<td class=\"$bg_color\">";
    	$string .= '<div id="geodata" coords="'.$this->getConfigValue('apps.geodata.new_map_center').'">';
    	$string .= "Lat: <input type=\"text\" geodata=\"lat\" name=\"".$item_array['name']."[lat]\" value=\"".htmlspecialchars($item_array['value']['lat'])."\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\">";
    	$string .= "Lng: <input type=\"text\" geodata=\"lng\" name=\"".$item_array['name']."[lng]\" value=\"".htmlspecialchars($item_array['value']['lng'])."\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\">";
    	$string .= '</div>';
    	
    	if(1==$this->getConfigValue('apps.geodata.enable')){
    		$string.='<script src="http://crypto-js.googlecode.com/svn/tags/3.1.2/build/rollups/md5.js"></script>';
    		$string.='<script>$(document).ready(function(){$("#geodata").Geodata();});</script>';
    	}
    	
    	
    	$string .= "</td>\n";
    	$string .= "</tr>\n";
    
    	/*Return html code*/
    	return $string;
    }
    
	/**
     * Get safe string input
     * @param array  $item_array
     * @return string
     */
    function get_price_input ( $item_array ) {
    	if($item_array['value']!=''){
    		$value=number_format((int)str_replace(' ', '', $item_array['value']),0,',',' ');
    	}else{
    		$value='';
    	}
    	$id=md5($item_array['name'].'_'.rand(100,999));
    	//$value=(int)$item_array['value'];
    	
		$string .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/js/autoNumeric-1.7.5.js"></script>';
        /*$string .= '<script type="text/javascript">
		    	$(document).ready(function() {
		    		'.($value==0 ? '$("input.price_field").autoNumeric({aSep: \' \', vMax: \'999999999999\', vMin: \'0\'});' : '$("input.price_field").autoNumericSet('.$value.');').'
        			
        			
				});
    		</script>';*/
         $string .= '<script type="text/javascript">
		    	$(document).ready(function() {
		    		$("input#'.$id.'").autoNumeric({aSep: \' \', vMax: \'999999999999\', vMin: \'0\'});
        			
        			
				});
    		</script>';
        
        //echo $value;
        
        $string .= "<tr class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }

        $string .= "<td class=\"$bg_color\"><input type=\"text\" id=\"".$id."\" name=\"".$item_array['name']."\"  size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\" value=\"$value\" /></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
	/**
     * Get safe string input for email
     * @param array  $item_array
     * @return string
     */
    function get_email_input ( $item_array ) {

        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }

        $string .= "<td class=\"$bg_color\"><input type=\"text\" name=\"".$item_array['name']."\" value=\"".htmlspecialchars($item_array['value'])."\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
	/**
     * Get safe string input for mobile phone number
     * @param array  $item_array
     * @return string
     */
    function get_mobilephone_input ( $item_array ) {

        /*Un-quote slashes*/
        $value=htmlspecialchars($item_array['value']);
        $id=md5($item_array['name'].'_'.rand(100,999));
        $string = '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/jquery.maskedinput.min.js"></script>';
        $string .= '<script type="text/javascript">
		    	$(document).ready(function() {
    				$.mask.definitions["h"] = "[0-9]"
		    		$("#'.$id.'").mask("h (hhh) hhh-hh-hh");
      			});
    		</script>';
        
        /*HTML code*/
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }

        $string .= "<td class=\"$bg_color\"><input id=\"".$id."\" type=\"text\" name=\"".$item_array['name']."\" value=\"".htmlspecialchars($item_array['value'])."\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
    /**
     * Get password input
     * @param array  $item_array
     * @return string
     */
    function get_password_input ( $item_array ) {

        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }

        $string .= "<td class=\"$bg_color\"><input type=\"password\" name=\"".$item_array['name']."\" value=\"\" size=\"".$item_array['length']."\" maxlength=\"".$item_array['maxlength']."\" class=\"$css_name\"></td>\n";
        $string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
    
    /**
     * Get photo input
     * @param array $item_array
     * @return string
     */
    function get_photo_input ( $item_array ) {

        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<tr  class=\"row3\" alt=\"".$item_array['name']."\">\n";

        /*Mark required field with simbol '*' */
        if ( $item_array['required'] == "on" ) {
            $string .= "<td class=\"$bg_color\">".$item_array['title']." <span style=\"color: red;\">*</span> </td>\n";
        } else {
            $string .= "<td class=\"$bg_color\">".$item_array['title']."</td>\n";
        }
        
		$string .= '<td>';
		if ( $item_array['value'] != '' ) {
		    $string .= '<img src="'.SITEBILL_MAIN_URL.'/img/data/user/'.$item_array['value'].'" border="0"/><br>';
		}
		$string .= '<input type="file" name="'.$item_array['name'].'" />';
		$string .= '</td>';

		$string .= "</tr>\n";

        /*Return html code*/
        return $string;
    }
    
	
    
    
	/**
     * Get hidden input
     * @param unknown_type $item_array
     * @return string
     */
    function get_hidden_input ( $item_array ) {

        /*Un-quote slashes*/
        $value = stripslashes( $value );
        /*HTML code*/
        $string .= "<input type=\"hidden\" name=\"".$item_array['name']."\" value=\"".$item_array['value']."\" /></td>\n";
        /*Return html code*/
        return $string;
    }
    
}
?>