<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Plugin processor
 * Load plugins from ./lib/plugins/ and run it
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru 
 */
class Plugin_Processor extends Object_Manager {
    private $plugins_dir;
    /**
     * Constructor
     */
    function __construct() {
        $this->plugins_dir = SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/plugins';
        $this->SiteBill();
    }
    
    /**
     * Main
     */
    function main () {
        //load plugins from ./lib/plugins
        $plugins = $this->load_plugins( $this->plugins_dir );
        if ( $plugins ) {
            //run each Plugin::main()
            foreach ( $plugins as $item_id => $plugin_info ) {
                require_once ($this->plugins_dir.'/'.$plugin_info['file']);
                $plugins_class = new $plugin_info['class'];
                $plugins_class->main();
            }
        }
    }
    
    /**
     * Load plugins
     * @param string $plugins_dir
     * @return array
     */
    private function load_plugins ( $plugins_dir ) {
        $ra = array();
        $i = 0;
        if ($dh = opendir($plugins_dir))
        {
            while(($file = readdir($dh)) !== false)
            {
                if($file!="." && $file!=".." && is_file($plugins_dir."/".$file)) {
                    $ra[$i]['file'] = $file;
                    $ra[$i]['class'] = basename($file, ".php");
                    $i++;
                }
            }
            closedir($dh);
        }
        if ( count($ra) > 0 ) {
            return $ra;
        }
        return false;
    }
}
?>
