<?php
/**
 * Robokassa class
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Robox extends SiteBill {
    /**
     * Constructor
     */
    function Robox () {
        $this->SiteBill();
    }
    
    /**
     * Main
     */
    function main () {
        global $init, $config;
        if ( preg_match('/result/', $_SERVER['REQUEST_URI']) ) {
            if ( $this->checkBillInfo( $this->getRequestValue('InvId') ) ) {
                //activate bill
                $this->activateBill($this->getRequestValue('InvId'), $this->getRequestValue('OutSum'));
                $rs = Multilanguage::_('PAYMENT_SUCCESS','system');
                echo "OK".$this->getRequestValue('InvId')."\n";
                exit;
                
            } else {
                $rs = $this->GetErrorMessage();
            }
        } elseif( preg_match('/success/', $_SERVER['REQUEST_URI']) ) {
            $rs = sprintf(Multilanguage::_('PAYMEN_ON_SUM_SUCCESS','system'),$this->getRequestValue('OutSum').' .')."<br><br>";
            $rs .= sprintf(Multilanguage::_('YOU_ACCOUNT_SUM','system'),$this->getAccountValue( $_SESSION['user_id'] ).' .').'<br>';
            $rs .= '<div style="color: green;" align="center"><br>
        		<a href="/add.htm">'.Multilanguage::_('ADD_AD','system').'</a></div>';
            
        } else {
            $rs = Multilanguage::_('PAYMENT_ERROR','system')."</a>";    
        }
        return '<div id="bigger">'.$rs.'</div>';
    }
    
    
    /**
     * Get shop order
     * @param int $bill_id bill id
     * @return mixed
	 */
    function getShopOrder ( $bill_id ) {
        $query = "select so.code from shop_order so, bill b where so.bill_id=b.bill_id and b.bill_id=$bill_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        if ( $this->db->row['code'] != '' ) {
            return $this->db->row['code']; 
        }
        return false;
    }
    
    /**
     * Get account value
     * @param int $user_id
     * @return int
     */
    function getAccountValue( $user_id ) {
        $query = "select account from ".DB_PREFIX."_user where user_id=$user_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        return $this->db->row['account'];
    }
    
    /**
     * Activate bill
     * @param int $bill_id bill id
     * @param string $OutSum OutSum
     * @return boolean
     */
    function activateBill ( $bill_id, $OutSum ) {
        //get user_id
        $query = "select user_id from ".DB_PREFIX."_bill where bill_id=$bill_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        $user_id = $this->db->row['user_id'];
        
        $account_value = $this->getAccountValue( $user_id );
        $account_value += $OutSum;
        
        //set new account value
        $query = "update ".DB_PREFIX."_user set account='$account_value' where user_id=$user_id";
        $this->db->exec($query); 
        
        //set status 
        $query = "update ".DB_PREFIX."_bill set status=1 where bill_id=$bill_id";
        $this->db->exec($query);
    }
    
    /**
     * Check signature
     * @param string $out_sum out sum
     * @param int $inv_id inv id
     * @param int $shp_item 
     * @param string $crc crc
     * @return boolean
     */
    function checkSignature ( $out_summ, $inv_id, $shp_item, $crc ) {
        
        $mrh_pass2 = $this->getConfigValue('robokassa_password2');
        
        $crc = strtoupper($crc);

        $my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass2"));
        if ($my_crc !=$crc) {
            echo "bad sign\n";
            exit();
        }
        return true;
    }
    
    /**
     * Check bill info
     * @param int $bill_id bill id
     * @return boolean
     */
    function checkBillInfo ( $bill_id ) {
        $query = "select status from ".DB_PREFIX."_bill where bill_id=$bill_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        if ( $this->db->row['status'] != 0 ) {
            $this->RiseError(Multilanguage::_('ORDER_PAYED_NOW','system'));
            return false;
        }
        if ( !$this->checkSignature( $_REQUEST["OutSum"], $_REQUEST["InvId"], $_REQUEST["Shp_item"], $_REQUEST["SignatureValue"] ) ) {
            $this->RiseError("bad sign\n");
        }
        return true;
    }
}
?>