<?php
/**
 * Uploadify class 
 * Store data into UPLOADIFY table
 */
if (  !defined('UPLOADIFY_TABLE')  ) 
{
    define('UPLOADIFY_TABLE', DB_PREFIX.'_uploadify');
}

class Sitebill_Uploadify extends Sitebill {
    /**
     * Constructor
     */
    function __construct() {
        $this->Sitebill();
    }
    
    /**
     * Main
     * @param boolean $file_mode
     * @return string
     */
    function main ( $file_mode = false ) {
        if (!empty($_FILES)) {
        	
        	switch($this->getConfigValue('uploader_type')){
        		case 'pluploader' : {
                	$file_container_name='file';
                	break;
                }
                default : {
                	$file_container_name='Filedata';
                }
        	}
        	
        	
	        $tempFile = $_FILES[$file_container_name]['tmp_name'];
            
            $targetPath = $_SERVER['DOCUMENT_ROOT'] .'/'.SITEBILL_MAIN_URL.'/cache/upl' . '/';

	        $arr=split('\.',$_FILES[$file_container_name]['name']);
            $ext=strtolower($arr[count($arr)-1]);
            if ( ($_FILES[$file_container_name]['size'] / 1000000) >   ( (int)str_replace('M', '', ini_get('upload_max_filesize')) ) ) {
                echo 'max_file_size';
                return;
            }
            if ( $file_mode == 'excel' ) {
            	$avail_ext = array('xls','xlsx');
            	if ( !in_array(strtolower($ext), $avail_ext) ) {
            		echo 'wrong_ext';
            		return;
            	}
            } elseif ( $file_mode ) {
                $avail_ext = array('png','jpg','tif','jpeg','doc','docx','xls','xlsx','pdf','txt','zip','rar');
                if ( !in_array(strtolower($ext), $avail_ext) ) {
                    echo 'wrong_ext';
                    return;
                }
            } elseif ( !in_array(strtolower($ext),array('jpg','png','gif','jpeg'))) {
            	echo 'wrong_ext';
                return;
            }
            $i = 1;
            $preview_name_tmp="jpg_".uniqid().'_'.time()."_".$i.".".$ext;
            $targetFile =  str_replace('//','/',$targetPath) . $preview_name_tmp;
            
            while ( file_exists($targetFile) ) {
                $i++;
                $preview_name_tmp="jpg_".uniqid().'_'.time()."_".$i.".".$ext;
                $targetFile =  str_replace('//','/',$targetPath) . $preview_name_tmp;
            }
		    echo str_replace($_SERVER['DOCUMENT_ROOT'],'',$targetFile);
            
		    move_uploaded_file($tempFile,$targetFile);
		    /*  ,        0600*/
		     chmod($targetFile, 0755);
		    /**/
		    
        }
        
        $this->addFile($_REQUEST['session'], $preview_name_tmp);
    }
    
    /**
     * Add file
     * @param string $session_code session code
     * @param string $targetFile target file
     * @return boolean
     */
    function addFile ( $session_code, $targetFile ) {
        $query = "insert into ".UPLOADIFY_TABLE." (session_code, file_name) values ('$session_code', '$targetFile')";
        $this->db->exec($query);
        return true;
    }
}
?>
