<?php
/**
 * User data manager
 * @author http://www.sitebill.ru
 */
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_editor.php');
class User_Data_Manager extends SiteBill_Rent_Editor {
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
    }
    
    function init_more_fields ( $form_data ) {
    	return $form_data;
    }
    
    /**
     * Main
     * @param void
     * @return string
     */
    function main () {
    	
		$user_id=$this->getSessionUserId();
		if ( $user_id == '' or $user_id < 1 ) {
		    return ' ';
		}
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $data_model->get_kvartira_model($this->getConfigValue('ajax_form_in_user'));
	    if ( $this->getConfigValue('more_fields_in_lk') ) {
	    	$form_data = $this->init_more_fields($form_data);
	    }
	    $form_data['data']['fio']['required'] = 'off';
		$rs = $this->getTopMenu();
		
		if ( $this->getConfigValue('special_advert_cost') > 0 ) {
		    $form_data['data']['hot']['title'] = '<br> (    <b>'.$this->getConfigValue('special_advert_cost').' .</b>)';
		}
		
		if($this->getConfigValue('user_add_street_enable')!=1){
			if(isset($form_data['data']['new_street'])){
				unset($form_data['data']['new_street']);
			}
		}

		switch( $this->getRequestValue('do') ){
			case 'up':
				if ( !$this->check_access_to_data($user_id, $this->getRequestValue('id')) ) {
					return ' ';
				}
				
				if ( $this->getConfigValue('apps.billing.enable') ) {
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
					$Account = new Account;
					$company_profile = $Account->get_company_profile($user_id);
					if ( $company_profile['limit_up']['value'] < 1 ) {
						$rs = '   .';
						return $rs;
					}
					//get max id from DB
					$query = "select max(id) as mid from ".DB_PREFIX."_data";
					$this->db->exec($query);
					$this->db->fetch_assoc();
					$mid = $this->db->row['mid'];
					$mid++;
					
					
					$query = "update ".DB_PREFIX."_data set date_added='".date('Y-m-d H:i:s')."', id=$mid where id=".$this->getRequestValue('id');
					//echo $query.'<br>';
					$this->db->exec($query);
					
					//update image link
					$query = "update ".DB_PREFIX."_data_image set id=$mid where id=".$this->getRequestValue('id');
					$this->db->exec($query);
					
					//minus point from company.limit_up
					$new_limit_up = $company_profile['limit_up']['value'] - 1;
					$query = "update ".DB_PREFIX."_company set limit_up=$new_limit_up where company_id=".$company_profile['company_id']['value'];
					$this->db->exec($query);
					//echo $query.'<br>';
							
					$rs .= $this->grid($user_id, $this->getRequestValue('topic_id'));
						
				}
				
			break;
			
			case 'edit_done' : {
			    if ( !$this->check_access_to_data($user_id, $this->getRequestValue('id')) ) {
			        return ' ';
			    }
			    
	            $form_data['data'] = $data_model->init_model_data_from_request($form_data['data']);
	            
	            $new_values=$this->getRequestValue('_new_value');
	            if(1==$this->getConfigValue('use_combobox') && count($new_values)>0){
	            	$remove_this_names=array();
	            	foreach($form_data['data'] as $fd){
	            		if(isset($new_values[$fd['name']]) && $new_values[$fd['name']]!='' && $fd['combo']==1){
	            			$id=md5(time().'_'.rand(100,999));
	            			$remove_this_names[]=$id;
	            			
	            			$form_data['data'][$id]['value'] = $new_values[$fd['name']];
	            			$form_data['data'][$id]['type'] = 'auto_add_value';
	            			$form_data['data'][$id]['dbtype'] = 'notable';
	            			$form_data['data'][$id]['value_table'] = $form_data['data'][$fd['name']]['primary_key_table'];
	            			$form_data['data'][$id]['value_primary_key'] = $form_data['data'][$fd['name']]['primary_key_name'];
	            			$form_data['data'][$id]['value_field'] = $form_data['data'][$fd['name']]['value_name'];
	            			$form_data['data'][$id]['assign_to'] = $fd['name'];
	            			$form_data['data'][$id]['required'] = 'off';
	            			$form_data['data'][$id]['unique'] = 'off';
	            		}
	            	}
	            }
	            
	            
	            $form_data['data']['user_id']['value'] = $this->getSessionUserId(); 
			    
	            $y_id='';
	            if(strpos($form_data['data']['youtube']['value'],'youtube.com')!==FALSE){
					$d=parse_url($form_data['data']['youtube']['value']);
					if(isset($d['query'])){
						parse_str($d['query'],$a);
						$y_id=$a['v'];
					}
				}else{
				
					if(preg_match('/.*([-_A-Za-z0-9]+).*/',$form_data['data']['youtube']['value'],$matches)){
						$y_id=$matches[0];
					}
				}
				$form_data['data']['youtube']['value']=$y_id;
				unset($form_data['data']['view_count']);	
				$data_model->forse_auto_add_values($form_data['data']);
	    		//$data_model->clear_auto_add_values($form_data['data']);
	            
	            if ( !$this->check_data( $form_data['data'] ) ) {
	            	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			        $rs = $this->get_form($form_data['data'], 'edit');
			    } else {
			        $this->edit_data($form_data['data']);
			        if ( $this->getError() ) {
			        	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			            $rs = $this->get_form($form_data['data'], 'edit');
			        } else {
			        	if($this->getConfigValue('apps.realtylog.enable')){
				        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
				        	$Logger=new realtylog_admin();
				        	$Logger->addLog($form_data['data']['id']['value'], $user_id, 'edit', 'data');
			        	}
			        	if($this->getConfigValue('apps.realtylogv2.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
			        		$Logger=new realtylogv2_admin();
			        		$Logger->addLog($form_data['data']['id']['value'], $user_id, 'edit', 'data', 'id');
			        	}
			        	header('Location: '.SITEBILL_MAIN_URL.'/account/data/');
			        	die();
			        }
			    }
			    
			    
			    
			    
				break;
			}
		    
			case 'edit' : {
				
			    if ( !$this->check_access_to_data($user_id, $this->getRequestValue('id')) ) {
			        return ' ';
			    }
			    $_form_data=$form_data;
                $form_data['data'] = $data_model->init_model_data_from_db ( 'data', 'id', $this->getRequestValue('id'), $form_data['data'] );
               
                if(1==$this->getConfigValue('divide_step_form') && isset($_POST['submit'])){
                	$_form_data['data'] = $data_model->init_model_data_from_request($_form_data['data']);
                	foreach($_form_data['data'] as $fdk=>$fdv){
                		if($fdv['type']=='uploadify_image'){
                			unset($_form_data['data'][$fdk]);
                		}
                	}
                	$form_data['data']=array_merge($form_data['data'],$_form_data['data']);
                }
                
                $form_data['data']['user_id']['type']='hidden';
                //echo '<pre>';
                //print_r($form_data['data']);
                unset($form_data['data']['view_count']);			    
			    $rs = $this->get_form($form_data['data'], 'edit');
				if($this->getConfigValue('apps.realtylog.enable')){
					$rs .= '<h2> </h2>';
		        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/site/site.php';
		        	$Logger=new realtylog_site();
		        	$rs .= $Logger->getLogs($this->getRequestValue('id'),$user_id);
	        	}
			    //print_r($logs);
				
			    break;
			}
			case 'delete' : {
			    if ( !$this->check_access_to_data($user_id, $this->getRequestValue('id')) ) {
			        return ' ';
			    }
				if($this->getConfigValue('apps.realtylog.enable')){
		        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
	        		$Logger=new realtylog_admin();
	        		$Logger->addLog($this->getRequestValue('id'), $user_id, 'delete', 'data');
		        }
		        if($this->getConfigValue('apps.realtylogv2.enable')){
		        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
		        	$Logger=new realtylogv2_admin();
		        	$Logger->addLog($this->getRequestValue('id'), $user_id, 'delete', 'data', 'id');
		        }
		        $this->delete_data('data', 'id', $this->getRequestValue('id'));
		        
		        
	            
			    $rs .= $this->grid($user_id, $this->getRequestValue('topic_id'));
		        
				break;
			}
			
			case 'new_done' : {
        		
	            $form_data['data'] = $data_model->init_model_data_from_request($form_data['data']);
	            
	            $new_values=$this->getRequestValue('_new_value');
	            if(1==$this->getConfigValue('use_combobox') && count($new_values)>0){
	            	$remove_this_names=array();
	            	foreach($form_data['data'] as $fd){
	            		if(isset($new_values[$fd['name']]) && $new_values[$fd['name']]!='' && $fd['combo']==1){
	            			$id=md5(time().'_'.rand(100,999));
	            			$remove_this_names[]=$id;
	            			$form_data['data'][$id]['value'] = $new_values[$fd['name']];
	            			$form_data['data'][$id]['type'] = 'auto_add_value';
	            			$form_data['data'][$id]['dbtype'] = 'notable';
	            			$form_data['data'][$id]['value_table'] = $form_data['data'][$fd['name']]['primary_key_table'];
	            			$form_data['data'][$id]['value_primary_key'] = $form_data['data'][$fd['name']]['primary_key_name'];
	            			$form_data['data'][$id]['value_field'] = $form_data['data'][$fd['name']]['value_name'];
	            			$form_data['data'][$id]['assign_to'] = $fd['name'];
	            			$form_data['data'][$id]['required'] = 'off';
	            			$form_data['data'][$id]['unique'] = 'off';
	            		}
	            	}
	            }
	            
	            $form_data['data']['user_id']['value'] = $this->getSessionUserId(); 
	            $form_data['data']['user_id']['type']='hidden';
	            $form_data['data']['date_added']['value'] = date('Y-m-d H:i:s',time());
	             
	             
				$y_id='';
	            if(strpos($form_data['data']['youtube']['value'],'youtube.com')!==FALSE){
					$d=parse_url($form_data['data']['youtube']['value']);
					if(isset($d['query'])){
						parse_str($d['query'],$a);
						$y_id=$a['v'];
					}
				}else{
				
					if(preg_match('/.*([-_A-Za-z0-9]+).*/',$form_data['data']['youtube']['value'],$matches)){
						$y_id=$matches[0];
					}
				}
				$form_data['data']['youtube']['value']=$y_id;
				
			    $data_model->forse_auto_add_values($form_data['data']);
	    		
			    if ( !$this->check_data( $form_data['data'] ) || (1==$this->getConfigValue('filter_double_data') && !$this->checkUniquety($form_data['data'])) ) {
			    	
			    	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			    	$rs = $this->get_form($form_data['data'], 'new');
			        
			    } else {
			        $new_record_id = $this->add_data($form_data['data']);
			        if ( $this->getError() ) {
			        	$form_data['data']=$this->removeTemporaryFields($form_data['data'],$remove_this_names);
			        	$rs = $this->get_form($form_data['data']);
			        } else {
			        	if($this->getConfigValue('apps.realtylog.enable')){
				        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
				        	$Logger=new realtylog_admin();
				        	$Logger->addLog($new_record_id, $user_id, 'new', 'data');
			        	}
			        	if(1==$this->getConfigValue('notify_about_added_realty')){
			        		$this->notifyUserAboutAdding($form_data['data']['user_id']['value'],$new_record_id,$form_data['data']['topic_id']['value']);
			        	}
			        	if($this->getConfigValue('apps.realtylogv2.enable')){
			        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
			        		$Logger=new realtylogv2_admin();
			        		$Logger->addLog($new_record_id, $user_id, 'new', 'data', 'id');
			        	}
			        	header('Location: '.SITEBILL_MAIN_URL.'/account/data/');
			        	die();
			        }
			    }
				break;
			}
			
			case 'new' : {
				if ( $this->getConfigValue('apps.billing.enable') ) {
					if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/tariff/tariff.xml') and $this->getConfigValue('apps.tariff.enable') and file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/billing/billing.xml') ) {
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/billing/lib/billing.php');
						$billing = new Billing();
						$user_limits = $billing->getUserLimits($user_id, 'limit_data');
						if ( $user_limits['total'] >= $user_limits['limits'] ) {
							$rs = '  .    <b>'.$user_limits['total'].'</b>   <b>'.$user_limits['limits'].'</b>   <b>'.$user_limits['period_key'].'</b>';
							return $rs;
						}
						
					} else {
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
						$Account = new Account;
						$company_profile = $Account->get_company_profile($user_id);
						if ( $company_profile['limit_data_left']['value'] < 1 ) {
							$rs = '  .    '.$company_profile['limit_data']['value'].' .      .';
							return $rs;
						}
					}
				}
				$form_data['data'] = $data_model->init_model_data_from_request($form_data['data']);
				$form_data['data']['user_id']['value'] = $this->getSessionUserId();
				$form_data['data']['user_id']['type']='hidden';
				$form_data['data']['active']['value']=1;
				
				//echo '<pre>';
				//print_r($form_data['data']);
			    $rs = $this->get_form($form_data['data']);
				break;
			}
			default : {
			    $rs .= $this->grid($user_id, $this->getRequestValue('topic_id'));
			}
		}
		return $rs;
	}
	
	function checkUniquety($form_data){
		$q='SELECT COUNT(id) AS cnt
    		FROM '.DB_PREFIX.'_data 
    		WHERE city_id='.(int)$form_data['city_id']['value'].'
    		AND street_id='.(int)$form_data['street_id']['value'].'
    		AND number='.(int)$form_data['number']['value'];
	
		$this->db->exec($q);
		$this->db->fetch_assoc();
	
		if((int)$this->db->row['cnt']>0){
			$this->riseError('   ');
			return FALSE;
		}
		return TRUE;
	}
	
	private function notifyUserAboutAdding($user_id ,$id, $topic_id){
		$query='SELECT fio, email FROM '.DB_PREFIX.'_user WHERE user_id='.$user_id.' LIMIT 1';
		$this->db->exec($query);
		$this->db->fetch_assoc();
		$fio=$this->db->row['fio'];
		$useremail=$this->db->row['email'];
		
		$query='SELECT translit_alias FROM '.DB_PREFIX.'_data WHERE id='.$id.' LIMIT 1';
		$this->db->exec($query);
		$this->db->fetch_assoc();
		$translit_alias=$this->db->row['translit_alias'];
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
		$Structure_Manager = new Structure_Manager();
		$category_structure = $Structure_Manager->loadCategoryStructure();
		
		if(1==$this->getConfigValue('apps.seo.level_enable')){
			 
			if($category_structure['catalog'][$topic_id]['url']!=''){
				$parent_category_url=$category_structure['catalog'][$topic_id]['url'].'/';
			}else{
				$parent_category_url='';
			}
		}else{
			$parent_category_url='';
		}
		if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $translit_alias!=''){
			$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.$translit_alias;
		}elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
			$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$id.'.html';
		}else{
			$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$id;
		}
		
		$href='http://'.$_SERVER['HTTP_HOST'].$href;
		require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
		$mailer = new Mailer();
		$subject = $_SERVER['SERVER_NAME'].':  ';
		$from = $this->getConfigValue('order_email_acceptor');
		$body='';
		$body.=', '.$fio.'!<br />';
		$body.='  .<br />';
		$body.='  <a href="'.$href.'">'.$href.'</a><br />';
		$body.=$this->getConfigValue('email_signature');
		if ( $this->getConfigValue('use_smtp') ) {
			$mailer->send_smtp($useremail, $from, $subject, $body, 1);
		} else {
			$mailer->send_simple($useremail, $from, $subject, $body, 1);
		}
		return;
	}
	
	protected function removeTemporaryFields(&$model,$remove_this_names=array()){
		if(count($remove_this_names)>0){
			foreach($remove_this_names as $r){
				unset($model[$r]);
			}
		}
		return $model;
	}
	
	/**
	 * Delete data
	 * @param string $table_name
	 * @param string $primary_key
	 * @param int $primary_key_value
	 */
	function delete_data($table_name, $primary_key, $primary_key_value ) {
	    $query = "delete from ".DB_PREFIX."_".$table_name." where $primary_key = $primary_key_value";
	    //echo $query;
	    $this->db->exec($query);
	}
	
	/**
	 * Check access to data
	 * @param int $user_id
	 * @param int $data_id
	 * @return boolean
	 */
	function check_access_to_data ( $user_id, $data_id ) {
	    $query = "select id from ".DB_PREFIX."_data where user_id=$user_id and id=$data_id";
	    $this->db->exec($query);
	    $this->db->fetch_assoc();
	    if ( $this->db->row['id'] > 0 ) {
	        return true;
	    }
	    return false;
	}
	
	/**
	 * Return grid
	 * @param int $user_id user id
	 * @param int $current_category_id current category id
	 * @return string
	 */
	function grid ( $user_id, $current_category_id ) {
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        $category_tree=$Structure_Manager->get_category_tree_control($current_category_id, $user_id);
	    
        $rs .= '<div class="grids">';
        
        if(1==$this->getConfigValue('show_cattree_left')){
        	 
        	 $rs .= '<table border="0" width="99%" cellpadding="0" cellspacing="0">';
        
	        $rs .= '<tr>';
	        $rs .= '<td style="vertical-align: top;" id="lk_tree">';
	        	$rs .= $category_tree;
	        	$rs .= '</td>';
	        $rs .= '<td style="vertical-align: top;">';
	        $rs .= $this->get_data_grid($user_id, $current_category_id);
	        $rs .= '</td>';
	        $rs .= '</tr>';
	        
	        $rs .= '</table>';
        }else{
        	$rs .= $this->get_data_grid($user_id, $current_category_id);
        }
        
        
       
        $rs .= '</div>';
        
        $this->template->assert('category_tree_account',$category_tree);
        
        return $rs;
        
	}
	
	/**
	 * Get data grid
	 * @param int $user_id
	 * @return string
	 */
	function get_data_grid ( $user_id, $current_category_id = false) {
	    
        global $smarty;
        
        require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
        $grid_constructor = new Grid_Constructor();
        
        $params['topic_id'] = $this->getRequestValue('topic_id');
        $params['order'] = $this->getRequestValue('order');
        $params['region_id'] = $this->getRequestValue('region_id');
        $params['city_id'] = $this->getRequestValue('city_id');
        $params['district_id'] = $this->getRequestValue('district_id');
        $params['metro_id'] = $this->getRequestValue('metro_id');
        $params['street_id'] = $this->getRequestValue('street_id');
        $params['page'] = $this->getRequestValue('page');
        $params['asc'] = $this->getRequestValue('asc');
        $params['price'] = $this->getRequestValue('price');
        $params['user_id'] = $user_id;
        $params['admin'] = true;
        
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        $Structure_Manager = new Structure_Manager();
        $category_structure = $Structure_Manager->loadCategoryStructure();
        
        $res = $grid_constructor->get_sitebill_adv_ext( $params );
        $this->template->assign('grid_items', $res);
        //$this->template->assign('category_tree', $grid_constructor->get_category_tree( $params, $category_structure ) );
        //$this->template->assign('breadcrumbs', $grid_constructor->get_category_breadcrumbs( $params, $category_structure ) );
        //$grid_constructor->get_sales_grid($res);
        
        //$grid_constructor->main($params);
        $smarty->assign('admin', 1);
        $smarty->assign('topic_id', $params['topic_id']);
        
        $html = $smarty->fetch( "realty_grid_account.tpl" );
        return $html;
	}
	
	/**
	 * Get offer list
	 * @param int $user_id
	 * @param mixed $current_category_id
	 * @return mixed
	 */
	function getOfferList($user_id, $current_category_id = false){
		$ret=array();
		if ( $current_category_id ) {
		    $query='SELECT * FROM '.DB_PREFIX.'_data WHERE user_id='.$user_id.' and topic_id = '.$current_category_id;
		} else {
		    $query='SELECT * FROM '.DB_PREFIX.'_data WHERE user_id='.$user_id;
		}
		$this->db->exec($query);
		if($this->db->success){
			while($this->db->fetch_assoc()){
				$ret[]=$this->db->row;
			}
		}
        return $ret;
	}
	
	
	/**
	 * Add data
	 * @param array $form_data form data
	 * @return boolean
	 */
	function add_data ( $form_data ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
	    $account = new Account();
	    $user_balance = $account->getAccountValue($this->getSessionUserId());
	    
	    $form_data['price']['value']=str_replace(' ', '', $form_data['price']['value']);
	     
	    //check balance and cost of service
	    $need_money = 0;
	    if ( $this->getConfigValue('advert_cost') > 0 ) {
	        $need_money += $this->getConfigValue('advert_cost'); 
	    }
	    if ( $this->getConfigValue('special_advert_cost') > 0  and $form_data['hot']['value'] == 1 ) {
	        $need_money += $this->getConfigValue('special_advert_cost'); 
	    }
	    if ( $user_balance < $need_money ) {
	        $this->riseError('     ');
	        return false;
	    }
	    
	    
	    $query = $data_model->get_insert_query(DB_PREFIX.'_data', $form_data);
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	    	echo $this->db->error;
	    }
	    $new_record_id = $this->db->last_insert_id();
        
	    $imgs=$this->editImageMulti('data', 'data', 'id', $new_record_id);
	    
	    if(1==$this->getConfigValue('apps.seo.data_alias_enable')){
	    	$this->saveTranslitAlias($new_record_id);
	    }
	    
		if($this->getConfigValue('is_watermark')){
			$filespath = SITEBILL_DOCUMENT_ROOT.'/img/data/';
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/watermark/watermark.php';
			$Watermark=new Watermark();
			$Watermark->setPosition('bottom-left');
			$Watermark->setOffsets(array(20,50));

			if(!empty($imgs)){
			//if(is_array($imgs)){
				foreach($imgs as $v){
					//$Watermark->printWatermark($filespath.$v['preview']);
					$Watermark->printWatermark($filespath.$v['normal']);
				}
			}
		}
	    
	    //echo '<pre>';
	    //print_r($form_data);
	    //echo '</pre>';
		
	    if ( $new_record_id > 0 ) {
	        if ( $this->getConfigValue('advert_cost') > 0 ) {
	            $account->minusMoney($this->getSessionUserId(), $this->getConfigValue('advert_cost'));
	        }
	        if ( $this->getConfigValue('special_advert_cost') > 0  and $form_data['hot']['value'] == 1 ) {
	            $account->minusMoney($this->getSessionUserId(), $this->getConfigValue('special_advert_cost'));
	        }
	        
	    }
	    return $new_record_id;
	    
	    //echo "new_record_id = $new_record_id<br>";
	    //echo $query;
	}
	
	/**
	 * Edit data
	 * @param array $form_data form data
	 * @return boolean
	 */
	function edit_data ( $form_data ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
	    $account = new Account();
	    $user_balance = $account->getAccountValue($this->getSessionUserId());
	    
	    $form_data['price']['value']=str_replace(' ', '', $form_data['price']['value']);
	     
	    $form_data_tmp = $form_data;
	    
	    //get prev state
        $form_data_tmp = $data_model->init_model_data_from_db ( 'data', 'id', $this->getRequestValue('id'), $form_data_tmp );
	    //if prev hot is 0 and new is 1, calculate money
	    if ( $form_data_tmp['hot']['value'] == 0 and  $form_data['hot']['value'] == 1 ) {
	        if ( $user_balance < $this->getConfigValue('special_advert_cost') ) {
    	        $this->riseError('     ');
	            return false;
	        } else {
	            $account->minusMoney($this->getSessionUserId(), $this->getConfigValue('special_advert_cost'));
	        }
	    }
	    //if no money, rise error
	    
	    $query = $data_model->get_edit_query(DB_PREFIX.'_data', 'id', $this->getRequestValue('id'), $form_data);
	    
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	    	echo $this->db->error;
	    }
	    
	    $imgs=$this->editImageMulti('data', 'data', 'id', $this->getRequestValue('id'));
	    
	    if(1==$this->getConfigValue('apps.seo.data_alias_enable')){
	    	$this->saveTranslitAlias($this->getRequestValue('id'));
	    }
	    
		if($this->getConfigValue('is_watermark')){
			$filespath = SITEBILL_DOCUMENT_ROOT.'/img/data/';
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/watermark/watermark.php';
			$Watermark=new Watermark();
			if(!empty($imgs)){
				foreach($imgs as $v){
					//$Watermark->printWatermark($filespath.$v['preview']);
					$Watermark->printWatermark($filespath.$v['normal']);
				}
			}
		}
	    
	    //$new_record_id = $this->db->last_insert_id();
	    //echo "new_record_id = $new_record_id<br>";
	    //echo $query;
	}
	
	/**
	 * Check data
	 * @param array $form_data
	 * @return boolean
	 */
	function check_data ( $form_data ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    if ( !$data_model->check_data($form_data) ) {
	        $this->riseError($data_model->GetErrorMessage());
	        return false;
	    }
	    if ( $this->getConfigValue('apps.billing.enable') ) {

	    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
	    	$Account = new Account;
	    	$company_profile = $Account->get_company_profile($form_data['user_id']['value']);
	    	if ( $company_profile['limit_special_left']['value'] < 1 and $form_data['hot']['value'] == 1 ) {
	    		$this->riseError('  ');
	    		return false;
	    	}
	    	if ( $company_profile['limit_best_left']['value'] < 1 and $form_data['best']['value'] == 1 ) {
	    		$this->riseError('   ');
	    		return false;
	    	}
	    	
	    }
	    return true;
	}
	
	/**
	 * Get top menu
	 * @param void 
	 * @return string
	 */
	function getTopMenu () {
	    $rs = '';
	    $rs .= '<a class="btn btn-primary" href="'.SITEBILL_MAIN_URL.'/account/data/?do=new"> </a>';
	    $rs .= '<div class="clear"></div>';
		//$rs .= '<form method="post"><input type="hidden" name="action" value="add" /><input type="submit" name="submit" value=" " /></form>';
	    return $rs;
	}
   
   
	
	function get_form ( $form_data=array(), $do = 'new' ) {
		$_SESSION['allow_disable_root_structure_select']=true;
		if(1==$this->getConfigValue('divide_step_form')){
			return $this->_get_form_step_divided($form_data, $do);
		}else{
			return $this->_get_form_standart($form_data, $do);
		}
	}
	
	function getSteps($form_data,$step){
	
		$default_tab_name=$this->getConfigValue('default_tab_name');
		$tabs=array($default_tab_name);
			
		foreach ( $form_data as $item_id => $item_array ) {
			if(isset($item_array['tab']) && $item_array['tab']!=''){
				$tabs[$item_array['tab']]=$item_array['tab'];
			}
	
		}
		$tabs_array=array();
		$i=1;
		foreach($tabs as $t){
			if($i < $step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'done');
			}elseif($i==$step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'current');
			}else{
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'further');
			}
			$i++;
		}
		return $tabs_array;
	}
	
	function _get_form_step_divided($form_data=array(), $do = 'new', $language_id = 0, $button_title = ''){
	
	
	
		//$step=(int)$this->getRequestValue('step')
		$requesturi=trim(parse_url($_SERVER['REQUEST_URI'],PHP_URL_PATH),'/');
		if(SITEBILL_MAIN_URL!=''){
			preg_replace('/^'.trim(SITEBILL_MAIN_URL,'/').'/','',$requesturi);
		}
		if(preg_match('/step(\d+)$/',$requesturi,$matches)){
			$step=(int)$matches[1];
		}else{
			$step=1;
		}
		//echo $step;
	
		$steps_names=$this->getSteps($form_data,$step);
		$last_step=$steps_names[count($steps_names)]['name'];
	
		if(isset($form_data['captcha'])){
			$form_data['captcha']['tab']=$last_step;
		}
	
		foreach($form_data as $k=>$v){
			if($v[type]=='uploadify_image'){
				$form_data[$k]['tab']=$last_step;
			}
		}
		$steps_names=$this->getSteps($form_data,$step);
		
		$steps_total=count($steps_names);
	
	
		$Sitebill_Registry=Sitebill_Registry::getInstance();
		$Sitebill_Registry->addFeedback('divide_step_form',true);
		$Sitebill_Registry->addFeedback('step',$step);
		
		
		global $smarty;
		$el=array();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		 
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		 
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
		$account = new Account();
		$account_value = $account->getAccountValue($this->getSessionUserId());
		$rs .= '<div class="clear"></div>';
		$rs .= $this->get_ajax_functions();
		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
		//$rs .= '<form method="post" action="'.SITEBILL_MAIN_URL.'/account/data/">';
		if(1==$this->getConfigValue('use_combobox')){
			$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
			$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
		}
		
		$el = $form_generator->compile_form_elements($form_data);
		
		$topic_id=(int)$form_data['topic_id']['value'];
		$current_id=(int)$form_data['id']['value'];
		
		if($topic_id!=0 && $current_id!=0){
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
			$Structure_Manager = new Structure_Manager();
			$category_structure = $Structure_Manager->loadCategoryStructure();
			 
			if(1==$this->getConfigValue('apps.seo.level_enable')){
			  
				if($category_structure['catalog'][$topic_id]['url']!=''){
					$parent_category_url=$category_structure['catalog'][$topic_id]['url'].'/';
				}else{
					$parent_category_url='';
				}
			}else{
				$parent_category_url='';
			}
			if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $form_data['translit_alias']['value']!=''){
				$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.$form_data['translit_alias']['value'];
			}elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
				$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$current_id.'.html';
			}else{
				$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$current_id;
			}
			 
			$rs .= '<a class="btn btn-success pull-right" href="'.$href.'" target="_blank">'.Multilanguage::_('L_SEE_AT_SITE').'</a>';
			 
		}
		
		if($step < $steps_total){
			$rs .= '<form id="step_form" method="post" action="'.SITEBILL_MAIN_URL.'/account/data/step'.(1+$step).'" enctype="multipart/form-data" class="user_add_form">';
		}else{
			$rs .= '<form id="step_form" method="post" action="'.SITEBILL_MAIN_URL.'/account/data/step'.$steps_total.'" enctype="multipart/form-data" class="user_add_form">';
		}
		 
		if ( $this->getConfigValue('advert_cost') > 0 and ($do == 'new' or $do == 'new_done' ) ) {
		
			$rs .= '<p><b>    '.$this->getConfigValue('advert_cost').' .</b></p>';
		
			if ( $account_value <  $this->getConfigValue('advert_cost') ) {
				$rs .= '<p>  '.$account_value.' .</p>';
				$rs .= '<b>        , <a href="'.SITEBILL_MAIN_URL.'/account/balance/?do=add_bill"></a></b></td>';
				return $rs;
			}
		}
		
		
		
		if ( $this->getError() ) {
			$smarty->assign('form_error',$form_generator->get_error_message_row($this->GetErrorMessage()));
		}
		
		
		
		$el['form_header']=$rs;
		$el['form_footer']='</form>';
		
		
		if($step < $steps_total){
			if ( $do == 'new' ) {
				$el['private'][]=array('html'=>'<input type="hidden" name="do" value="new" />');
			} else {
				$el['private'][]=array('html'=>'<input type="hidden" name="do" value="edit" />');
			}
		}else{
			if ( $do == 'new' ) {
				$el['private'][]=array('html'=>'<input type="hidden" name="do" value="new_done" />');
			} else {
				$el['private'][]=array('html'=>'<input type="hidden" name="do" value="edit_done" />');
			}
		}
		
		
		if($step>1){
			$el['controls']['back']=array('html'=>'<input type="submit" name="submit" alt="'.($step-1).'" id="formsubmit_back" value="" />');
		}
		
		if($step < $steps_total){
			$button_title=' ';
		}else{
			$button_title='';
		}
		
		$el['controls']['submit']=array('html'=>'<input type="submit" name="submit" id="formsubmit" value="'.$button_title.'" />');
		
		
		$smarty->assign('current_step',$step);
		$smarty->assign('divide_by_step',1);
		$smarty->assign('form_elements',$el);
		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl')){
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl';
		}else{
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/apps/admin/admin/template/data_form.tpl';
		}
		
		return $smarty->fetch($tpl_name);
	
	}
	
	function _get_form_standart($form_data=array(), $do = 'new', $language_id = 0, $button_title = ''){
	
		global $smarty;
		$el=array();
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
	    $account = new Account();
	    $account_value = $account->getAccountValue($this->getSessionUserId());
        $rs .= '<div class="clear"></div>';
	    $rs .= $this->get_ajax_functions();
	    $rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
	    //$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/form_tabs.js"></script>';
	    //$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/system/css/form_tabs.css" />';
	    //$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/css/form_decorator.css" />';
	    if(1==$this->getConfigValue('use_combobox')){
	    	$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
	    	$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
	    }
	    
	    
	    $topic_id=(int)$form_data['topic_id']['value'];
	    $current_id=(int)$form_data['id']['value'];
	     
	    if($topic_id!=0 && $current_id!=0){
	    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
	    	$Structure_Manager = new Structure_Manager();
	    	$category_structure = $Structure_Manager->loadCategoryStructure();
	    	 
	    	if(1==$this->getConfigValue('apps.seo.level_enable')){
	    
	    		if($category_structure['catalog'][$topic_id]['url']!=''){
	    			$parent_category_url=$category_structure['catalog'][$topic_id]['url'].'/';
	    		}else{
	    			$parent_category_url='';
	    		}
	    	}else{
	    		$parent_category_url='';
	    	}
	    	if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $form_data['translit_alias']['value']!=''){
	    		$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.$form_data['translit_alias']['value'];
	    	}elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
	    		$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$current_id.'.html';
	    	}else{
	    		$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$current_id;
	    	}
	    	 
	    	$rs .= '<a href="'.$href.'" target="_blank">'.Multilanguage::_('L_SEE_AT_SITE').'</a>';
	    
	    }
	    
	    $rs .= '<form method="post" action="'.SITEBILL_MAIN_URL.'/account/data/">';
	    
		if ( $this->getConfigValue('advert_cost') > 0 and ($do == 'new' or $do == 'new_done' ) ) {
		    
			$rs .= '<p><b>    '.$this->getConfigValue('advert_cost').' .</b></p>';
		    
		    if ( $account_value <  $this->getConfigValue('advert_cost') ) {
		        $rs .= '<p>  '.$account_value.' .</p>';
		        $rs .= '<b>        , <a href="'.SITEBILL_MAIN_URL.'/account/balance/?do=add_bill"></a></b></td>';
		        return $rs;
	        }
		}
				
		
		
		if ( $this->getError() ) {
			$smarty->assign('form_error',$form_generator->get_error_message_row($this->GetErrorMessage()));
		}
		$el = $form_generator->compile_form_elements($form_data);
		
		$el['form_header']=$rs;
		$el['form_footer']='</form>';
		
		if ( $do == 'new' ) {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="new_done" />');
		} else {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="edit_done" />');
			$el['private'][]=array('html'=>'<input type="hidden" name="id" value="'.$form_data['id']['value'].'">');
		}
		
		$el['controls']['submit']=array('html'=>'<input type="submit" name="submit" id="formsubmit" value="" />');
		 
		$smarty->assign('do',$do);
		$smarty->assign('id',$form_data['id']['value']);
		$smarty->assign('form_elements',$el);
		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data_front.tpl')){
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data_front.tpl';
		}else{
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/apps/admin/admin/template/data_form_front.tpl';
		}
		return $smarty->fetch($tpl_name);
		
	}
	
	protected function saveTranslitAlias($id){
		$query='SELECT re_city.name AS city, re_street.name AS street, re_data.number
				FROM re_data
				LEFT JOIN re_city ON re_city.city_id=re_data.city_id
				LEFT JOIN re_street ON re_street.street_id=re_data.street_id
				WHERE re_data.id='.$id;
		$this->db->exec($query);
		if($this->db->success){
			$p=array();
			$this->db->fetch_assoc();
			if($this->db->row['city']!=''){
				$p[]=$this->transliteMe($this->db->row['city']);
			}
			if($this->db->row['street']!=''){
				$p[]=$this->transliteMe($this->db->row['street']);
			}
			if((int)$this->db->row['number']!=0){
				$p[]=(int)$this->db->row['number'];
			}
			if(!empty($p)){
				$alias=implode('-',$p);
				$query='UPDATE re_data SET translit_alias=\''.$alias.'\' WHERE id='.$id;
				$this->db->exec($query);
			}
	
		}
	
	}
	
}
?>
