<?php
/**
 * Login class
 * @author Kondin Dmitry <kondin@etown.ru>
 */
class Login extends SiteBill {
    var $user_id = 0;
    
    /**
     * Constructor
     */
    function Login () {
        $this->SiteBill();
    }
    /**
     * Main
     * @param void
     * @return string
     */
    function main () {
        global $init;
        if ( $this->getSessionUserId() > 0 ) {
            $rs = $this->wellcomePage();
            return $rs;
        }
        
        switch ( $init->getValue('do', 'default') ) {
        	case 'login_vk':
        		require_once (SITEBILL_DOCUMENT_ROOT . '/apps/socialauth/lib/vk/vk_logger.php');
        		$VK = Vk_Logger::getInstance();
        		$VK->login();
        	break;
            case 'login':
                $this->checkLogin(  $init->getValue('login'), $init->getValue('password')  );
                //echo "error_message = ".$this->error_message."<br>";
                if ( $this->GetError() ){
                    $rs = $this->loginForm();
                } else {
                    $rs = $this->wellcomePage();
                }
            break;
            default:
                if ( $this->getSessionUserId() > 0 ) {
                    $rs = $this->wellcomePage();
                } else {
                    $rs = $this->loginForm();
                }
        }
        return $rs;    
    }
    
    function alreadyLogin () {
        $rs = Multilanguage::_('YOU_AUTHORIZED','system');
        return $rs;
    }
    
    
    public function getAuthData(){
    	global $smarty;
    	$user_id = $this->getSessionUserId();
    	
    	if ( $user_id > 0 ) {
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
    		$Account = new Account;
    		return array('is_logged'=>1,
    				'fio'=>$this->getFio($user_id),
    				'ballance'=>$Account->getAccountValue($user_id),
    				'total_data_count'=>$Account->get_user_data_count($user_id),
    				);
    		/*$smarty->assign('auth_is_logged', 1);
    		$smarty->assign('fio', $this->getFio($user_id));
    		$smarty->assign('ballance', $Account->getAccountValue($user_id));
    		$smarty->assign('total_data_count', $Account->get_user_data_count($user_id));*/
    		//$rs = $smarty->fetch('user_menu.tpl');
    	} else {
    		return array('is_logged'=>0);
    	}
    }
    
    function getUserMenu(){
    	$user_id = $this->getSessionUserId();
    	if ( $user_id > 0 ) {
    		global $smarty;
    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
    		
    		$Account = new Account;
    		$smarty->assign('fio', $this->getFio($user_id));
    		$smarty->assign('ballance', $Account->getAccountValue($user_id));
    		$smarty->assign('total_data_count', $Account->get_user_data_count($user_id));
    		$rs = $smarty->fetch('user_menu.tpl');
    	} else {
    		$rs='';
    	}
    	return $rs;
    }
    
    /**
     * Get auth menu
     * @param void
     * @return string
     */
    function getAuthMenu () {
        global $estate_folder;
        global $smarty;
        //global $config;
        
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
        
        $Account = new Account;
        
        $user_id = $this->getSessionUserId();
        if ( $user_id > 0 ) {
            $smarty->assign('fio', $this->getFio($user_id));
            $smarty->assign('ballance', $Account->getAccountValue($user_id));
            $smarty->assign('total_data_count', $Account->get_user_data_count($user_id));
            $rs = $smarty->fetch('user_menu.tpl');
        } else {
        	if($this->getConfigValue('theme')=='albostar'){
        		$rs = '<h1>'.Multilanguage::_('L_AUTH_TITLE').'</h1>';
		        if ( $this->getConfigValue('ajax_auth_form') ) {
		            $rs .= $this->get_ajax_auth_form();
		        } else {
		            $rs .= $this->get_simple_auth_form(SITEBILL_MAIN_URL.'/login/',$this->getConfigValue('allow_register_account'), $this->getConfigValue('allow_remind_password'));
		        }
		        $rs .= '';
		       
        	}else{
	        	$rs = '<table border="0" cellpadding="0" cellspacing="0" align="center">
		                                        <tr>
		                                            <td class="special">
		                                            	<div id="admin_area">
		        ';
	        	$social_link = false;
	        	if ( $this->getConfigValue('apps.socialauth.fb.enable') ) {
	        		//require_once (SITEBILL_DOCUMENT_ROOT . '/apps/socialauth/lib/facebook/fb_logger.php');
	        		//$FB = FB_Logger::getInstance();
	        		//$rs .= $FB->getLoginURL();
	        	}
	        	
	        	if ( $this->getConfigValue('apps.socialauth.vk.enable') ) {
	        		require_once (SITEBILL_DOCUMENT_ROOT . '/apps/socialauth/lib/vk/vk_logger.php');
	        		$VK = Vk_Logger::getInstance();
	        		$social_link .= $VK->getLoginLink();
	        	}
	        	if ( $social_link ) {
	        		$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/socialauth/css/style.css" />';
	        		$rs .= '<div class="login_label">'.Multilanguage::_('LOGIN_BY','system').':</div> '.$social_link.'<br><div class="clr"></div>';
	        	}
	        	
	        	if ( $this->isDemo() ) {
	        	    $rs .= '<div class="clr"></div>login: admin, password: admin';
	        	}
		        if ( $this->getConfigValue('ajax_auth_form') ) {
		            $rs .= $this->get_ajax_auth_form();
		        } else {
		            $rs .= $this->get_simple_auth_form(SITEBILL_MAIN_URL.'/login/',$this->getConfigValue('allow_register_account'), $this->getConfigValue('allow_remind_password'));
		        }
		        $rs .= '
		                                        </div>    
		        								</td>
		                                        </tr>
		                                    </table>';
		        }
        	}
        
        
        
        
        return $rs;
    }
    
   

    /**
     * Method to generate 32 - digit session key
     * @param void
     * @return string $session_key - session key
     */
    function GenerateSessionKey ( $user_id ) {
    	$this->clear_session_table();
        global $config;
        $user_ip = $_SERVER['REMOTE_ADDR'];
        $session_key = md5(rand().time().$user_ip);

        $query = "insert into ".DB_PREFIX."_session (user_id, ip, session_key, start_date) values ('".$user_id."', '$user_ip', '$session_key', now())";
        $this->db->exec( $query );
        return $session_key;
    }
    
    /**
     * Get wellcome page
     * @param void
     * @return string
     */
    function wellcomePage () {
        $rs = '<h1> !</h1>';
        $rs .= '  <a href="'.SITEBILL_MAIN_URL.'/account/data/"> </a>';
        $rs .= '<script type="text/javascript">location.href="'.SITEBILL_MAIN_URL.'/account/data/"</script>';
        return $rs;
    }

    /**
     * Login form
     * @param void
     * @return string
     */
    function loginForm () {
        global $ETOWN_LANG;
        
        $rs = '            
                                    <table border="0" cellpadding="0" cellspacing="0" align="center">
                                        <tr>
                                            <td class="special">
                                            	<div id="admin_area">
                                                <h1>'.Multilanguage::_('L_AUTH_TITLE').'</h1><br>
        ';
        if ( $this->getConfigValue('ajax_auth_form') ) {
            $rs .= $this->get_ajax_auth_form();
        } else {
            $rs .= $this->get_simple_auth_form(SITEBILL_MAIN_URL.'/login/',$this->getConfigValue('allow_register_account'), $this->getConfigValue('allow_remind_password'));
        }
        $rs .= '
                                        </div>    
        								</td>
                                        </tr>
                                    </table>';
        return $rs;
    }
    
    function get_data($url) {
        $ch = curl_init();
        $timeout = 5;
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
        $data = curl_exec($ch);
        curl_close($ch);
        return $data;
    }

    function direct_add_user ($login, $pass, $fio, $email ) {
    	$query = "insert into ".DB_PREFIX."_user (login, password, fio, email) values ('$login', '$pass', '$fio', '$email')";
    	$this->db->exec($query);
    	if ( !$this->db->success ) {
    		$this->riseError($this->db->error);
    		return false;
    	}
    	return true;
    }
    
    /**
     * Check login
     * @param string $login login
     * @param string $password password
     * @return boolean
     */
    function checkLogin ( $login, $password ) {
        if ( $_SESSION['user_id'] > 0 ) {
            return true; 
        }
        if ( $this->getConfigValue('ajax_auth_form') ) {
            $this->riseError('not login');
            unset($_SESSION['user_id']);
            return false;
        } else {
            if ( $login != '' and $password != '' ) {
                $query = "SELECT user_id, fio FROM ".DB_PREFIX."_user WHERE login='".$login."' and password='".md5($password)."'".(1==$this->getConfigValue('use_registration_email_confirm') ? ' AND active=1' : '');
                //echo $query;
                $this->db->exec($query);
                $this->db->fetch_assoc();
                if ( $this->db->row['user_id'] != '' ) {
                    $session_key = $this->GenerateSessionKey($this->db->row['user_id']);
                    $this->setSessionKey( $session_key );
                    $this->setUserId($this->db->row['user_id']);
                    $_SESSION['user_id']=$this->db->row['user_id'];
                    $_SESSION['current_user_name']=$this->db->row['fio'];
					$this->db->exec('SELECT system_name FROM '.DB_PREFIX.'_group WHERE group_id=(SELECT group_id FROM '.DB_PREFIX.'_user WHERE login=\''.$login.'\')');
					$this->db->fetch_assoc();
					$_SESSION['current_user_group_name']=$this->db->row['system_name'];
					
                    return true;
                }
                $this->riseError(Multilanguage::_('L_ERROR_LOGIN_PASS'));
                return false;
            }
            $this->riseError('not login');
            unset($_SESSION['user_id']);
           return false;
        }
    }
    /**
     * Set session
     * @param string $key session key
     * @return void
     */
    function setSessionKey ( $key ) {
        $_SESSION['key'] = $key;
    }
    
    /**
     * Get user ID
     * @param void
     * @return int
     */
    function getUserId () {
        return $this->user_id;
    }
    
    /**
     * Set user ID
     * @param int $user_id user ID
     * @return void
     */
    function setUserId ( $user_id ) {
        $this->user_id = $user_id;
    }
    
    /**
     * Get user info string
     * @param int $user_id user id
     * @return string
     */
    function getUserInfo ( $user_id ) {
        $query = "select * from ".DB_PREFIX."_user where user_id=$user_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        $rs .= ': '.$this->db->row['fio'].'<br>';
        $rs .= 'email: '.$this->db->row['email'].'<br>';
        return $rs;
    }
    
    /**
     * Get session user ID
     * @param void
     * @return int
     */
    function getSessionUserId ( ) {
        global $init;
        
        $key = $_SESSION['key'];
        if ( $key != '' ) {
        	$query = "select user_id from ".DB_PREFIX."_session where session_key ='$key'";
        	//echo $query;
        	$this->db->exec($query);
        	$this->db->fetch_assoc();
        	$user_id = $this->db->row['user_id'];
        	if ( $user_id != '' and $user_id != 0 ) {
        		$this->user_id = $user_id;
        		//$init->setUserId($user_id);
        		return $user_id;
        	} else {
        		$this->user_id = 0;
        		return 0;
        	}
        }
        $this->user_id = 0;
        return 0;
    }

    /**
     * Get fio
     * @param int $user_id user id
     * @return string
     */
    function getFio ( $user_id ) {
        $query = "select fio from ".DB_PREFIX."_user where user_id=$user_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        return $this->db->row['fio'];
    }
    
    /**
     * Get login
     * @param int $user_id user id
     * @return string
     */
    function getLogin ( $user_id ) {
        $query = "select login from ".DB_PREFIX."_user where user_id=$user_id";
        $this->db->exec($query);
        $this->db->fetch_assoc();
        return $this->db->row['login'];
    }
}
?>