<?php
/**
 * Admin table helper
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Admin_Table_Helper extends SiteBill {
	function create_int ( $item ) {
		$rs = "`{$item['name']}` int(10) unsigned NOT NULL DEFAULT '0'";
		return $rs;
	}
	
	function create_geodata_lat ( $item ) {
		$rs = "`".$item['name']."_lat` decimal(9,6) NULL";
		return $rs;
	}
	
	function create_geodata_lng ( $item ) {
		$rs = "`".$item['name']."_lng` decimal(9,6) NULL";
		return $rs;
	}
	
	function create_varchar ( $item ) {
		$rs = "`{$item['name']}` varchar(255) NOT NULL DEFAULT '{$item['value']}'";
		return $rs;
	}
	
	function create_image ( $item ) {
		
		
		$q='CREATE TABLE IF NOT EXISTS `'.DB_PREFIX.'_'.$item['table_name'].'_image` (
		`'.$item['table_name'].'_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		`'.$item['primary_key'].'` int(11) NOT NULL DEFAULT 0,
		`image_id` int(11) NOT NULL DEFAULT 0,
		`sort_order` int(11) NOT NULL DEFAULT 0,
		PRIMARY KEY (`'.$item['table_name'].'_image_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET='.DB_ENCODING.' AUTO_INCREMENT=1 ;';
		$this->db->exec($q);
		//$rs = "";
		//return $rs;
	}
	
	function create_primary_key ( $item ) {
		$rs = "`{$item['name']}` int(11)  NOT NULL AUTO_INCREMENT, PRIMARY KEY (`{$item['name']}`) ";
		return $rs;
	}
	
	
	function create_text ( $item ) {
		$rs = "`{$item['name']}` text";
		return $rs;
	}
	
	function add_ajax ( $form_data ) {
	    $form_data['data']['date_added']['value'] = date('Y-m-d H:i:s',time());

	    if ( $this->getConfigValue('currency_enable') && !isset($form_data['data']['currency_id'])) {
	    	$form_data['data']['currency_id']['name'] = 'currency_id';
	    	$form_data['data']['currency_id']['primary_key_name'] = 'currency_id';
	    	$form_data['data']['currency_id']['primary_key_table'] = 'currency';
	    	$form_data['data']['currency_id']['title'] = '';
	    	$form_data['data']['currency_id']['value_string'] = '';
	    	$form_data['data']['currency_id']['value'] = 0;
	    	$form_data['data']['currency_id']['length'] = 40;
	    	$form_data['data']['currency_id']['type'] = 'select_by_query';
	    	$form_data['data']['currency_id']['query'] = 'select * from '.DB_PREFIX.'_currency WHERE is_active=1 ORDER BY sort_order ASC, code ASC, currency_id ASC';
	    	$form_data['data']['currency_id']['value_name'] = 'name';
	    	$form_data['data']['currency_id']['title_default'] = '';
	    	$form_data['data']['currency_id']['value_default'] = 0;
	    	$form_data['data']['currency_id']['required'] = 'off';
	    	$form_data['data']['currency_id']['unique'] = 'off';
	    }
	    
	    if ( !$this->getConfigValue('ajax_form_in_admin') ) {
	        return $form_data;
	    }
	     
	    
	    //country
	     
	    if ( $this->getConfigValue('country_in_form') && isset($form_data['data']['country_id'])) {
	    	if ( $form_data['data']['country_id']['title_default'] == '' ) {
	    		$form_data['data']['country_id']['title_default'] = Multilanguage::_('L_CHOOSE_COUNTRY');
	    	}
	        $form_data['data']['country_id']['onchange'] = '';
	        if ( $this->getConfigValue('apps.realty.ajax_region_refresh') ) {
	        	$form_data['data']['country_id']['onchange'] .= ' update_child_list(\'region_id\',this); ';
	        	$form_data['data']['country_id']['ajax_options']['update_child_list'][] = 'region_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_city_refresh') ) {
	        	$form_data['data']['country_id']['onchange'] .= ' set_empty(\'city_id\',this); ';
	        	$form_data['data']['country_id']['ajax_options']['set_empty'][] = 'city_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
	        	$form_data['data']['country_id']['onchange'] .= ' set_empty(\'district_id\',this); ';
	        	$form_data['data']['country_id']['ajax_options']['set_empty'][] = 'district_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
	        	$form_data['data']['country_id']['onchange'] .= ' set_empty(\'metro_id\',this); ';
	        	$form_data['data']['country_id']['ajax_options']['set_empty'][] = 'metro_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
	        	$form_data['data']['country_id']['onchange'] .= ' set_empty(\'street_id\',this); ';
	        	$form_data['data']['country_id']['ajax_options']['set_empty'][] = 'street_id';
	        }
	    }
	    	 
	    
	    //region
	     
	    if ( $this->getConfigValue('region_in_form') && isset($form_data['data']['region_id'])) {
	    	if ( $form_data['data']['region_id']['title_default'] == '' ) {
	    		$form_data['data']['region_id']['title_default'] = Multilanguage::_('L_CHOOSE_REGION');
	    	}
	         
	        if ( $this->getConfigValue('apps.realty.ajax_city_refresh') ) {
	        	$form_data['data']['region_id']['onchange'] .= ' update_child_list(\'city_id\',this); ';
	        	$form_data['data']['region_id']['ajax_options']['update_child_list'][] = 'city_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
	        	$form_data['data']['region_id']['onchange'] .= ' set_empty(\'district_id\',this); ';
	        	$form_data['data']['region_id']['ajax_options']['set_empty'][] = 'district_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
	        	$form_data['data']['region_id']['onchange'] .= ' set_empty(\'metro_id\',this); ';
	        	$form_data['data']['region_id']['ajax_options']['set_empty'][] = 'metro_id';
	        }
	        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
	        	$form_data['data']['region_id']['onchange'] .= ' set_empty(\'street_id\',this); ';
	        	$form_data['data']['region_id']['ajax_options']['set_empty'][] = 'street_id';
	        }
	        if ( $this->getRequestValue('country_id') != 0 and $this->getRequestValue('country_id') != '' ) {
	        	$form_data['data']['region_id']['query'] = 'select * from '.DB_PREFIX.'_region where country_id='.$this->getRequestValue('country_id').' order by name';
	        }
	    }
	    	 
	     
	    
	    //city
	    if ( $this->getConfigValue('city_in_form') && isset($form_data['data']['city_id'])) {
	    	if ( $form_data['data']['city_id']['title_default'] == '' ) {
	    		$form_data['data']['city_id']['title_default'] = Multilanguage::_('L_CHOOSE_CITY');
	    	}
	         
	        if ( $this->getConfigValue('apps.realty.ajax_metro_refresh') ) {
	        	$form_data['data']['city_id']['onchange'] .= ' update_child_list(\'metro_id\',this); ';
	        }
	        if($this->getConfigValue('link_street_to_city')){
	        	if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
	        		$form_data['data']['city_id']['onchange'] .= ' update_child_list(\'district_id\',this); ';
	        		$form_data['data']['city_id']['ajax_options']['update_child_list'][] = 'district_id';
	        	}
	        	if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
	        		$form_data['data']['city_id']['onchange'] .= ' update_child_list(\'street_id\',this); ';
	        		$form_data['data']['city_id']['ajax_options']['update_child_list'][] = 'street_id';
	        	}
	        }else{
	        	if ( $this->getConfigValue('apps.realty.ajax_district_refresh') ) {
	        		$form_data['data']['city_id']['onchange'] .= ' update_child_list(\'district_id\',this); ';
	        		$form_data['data']['city_id']['ajax_options']['update_child_list'][] = 'district_id';
	        	}
	        	if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
	        		$form_data['data']['city_id']['onchange'] .= ' set_empty(\'street_id\',this); ';
	        		$form_data['data']['city_id']['ajax_options']['set_empty'][] = 'street_id';
	        	}
	        }
	        if ( $this->getRequestValue('region_id') != 0 and $this->getRequestValue('region_id') != '' ) {
	        	$form_data['data']['city_id']['query'] = 'select * from '.DB_PREFIX.'_city where region_id='.$this->getRequestValue('region_id').' order by name';
	        }
	    }
	    	 
	    if ( $this->getConfigValue('metro_in_form') && isset($form_data['data']['metro_id'])) {
	    	if ( $form_data['data']['metro_id']['title_default'] == '' ) {
	    		$form_data['data']['metro_id']['title_default'] = Multilanguage::_('L_CHOOSE_METRO');
	    	}
	         
	        if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
	    	    $form_data['data']['metro_id']['query'] = 'select * from '.DB_PREFIX.'_metro where city_id='.$this->getRequestValue('city_id').' order by name';
	        }
	    }
	     
	    
	    //district
	    if ( $this->getConfigValue('district_in_form') && isset($form_data['data']['district_id'])) {
	    	if ( $form_data['data']['district_id']['title_default'] == '' ) {
	    		$form_data['data']['district_id']['title_default'] = Multilanguage::_('L_CHOOSE_DISTRICT');
	    	}
	         
	        if ( $this->getConfigValue('apps.realty.ajax_street_refresh') ) {
	        	if($this->getConfigValue('link_street_to_city')){
	        
	        	}else{
	        		$form_data['data']['district_id']['onchange'] .= ' update_child_list(\'street_id\',this); ';
	        		$form_data['data']['district_id']['ajax_options']['update_child_list'][] = 'street_id';
	        	}
	        }
	        if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
	        	$form_data['data']['district_id']['query'] = 'select * from '.DB_PREFIX.'_district where city_id='.$this->getRequestValue('city_id').' order by name';
	        }
	    }

	    //street
	    if ( $this->getConfigValue('street_in_form') && isset($form_data['data']['street_id'])) {
	    	if ($form_data['data']['street_id']['title_default'] == '') {
	    		$form_data['data']['street_id']['title_default'] = Multilanguage::_('L_CHOOSE_STREET');
	    	}
	         
	        if ( $this->getRequestValue('district_id') != 0 and $this->getRequestValue('district_id') != '' ) {
	        	$form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street where district_id='.$this->getRequestValue('district_id').' order by name';
	        }
	        if($this->getConfigValue('link_street_to_city')){
	        	if ( $this->getRequestValue('city_id') != 0 and $this->getRequestValue('city_id') != '' ) {
	        		$form_data['data']['street_id']['query'] = 'select * from '.DB_PREFIX.'_street where city_id='.$this->getRequestValue('city_id').' order by name';
	        	}
	        }
	    }
	    
	    return $form_data;
	}
	
	function load_model ( $table_name, $ignore_user_group=false ) {
		$group_id=0;
		/*
		echo '<pre>';
		print_r($_SESSION);
		echo '</pre>';
		*/
		if ( intval($_SESSION['user_id_value']) > 0 ) {
		    $user_id = intval($_SESSION['user_id_value']);
		} elseif ( intval($_SESSION['user_id']) > 0 ) {
		    $user_id = intval($_SESSION['user_id']);
		}
		if(!$ignore_user_group && isset($user_id) ){
			$q="SELECT group_id FROM ".DB_PREFIX."_user WHERE user_id={$user_id}";
			//echo $q.'<br>';
			$this->db->exec($q);
			$this->db->fetch_assoc();
			$group_id=(int)$this->db->row['group_id'];
		}
		//echo 'group_id = '.$group_id.'<br>';
		//echo 'user_id = '.$user_id.'<br>';
		
		$model_data = array();
		$query = "select c.* from ".DB_PREFIX."_columns c, ".DB_PREFIX."_table t where t.table_id=c.table_id and t.name='$table_name' and c.active=1 order by c.sort_order";
		$this->db->exec($query);
		while ( $this->db->fetch_assoc() ) {
			if($this->db->row['group_id']!='0'){
				$t=array();
				$t=explode(',',$this->db->row['group_id']);
				if(!in_array($group_id, $t)){
					continue;
				}
			}
			$model_data[$table_name][$this->db->row['name']]['name'] = $this->db->row['name'];
			$model_data[$table_name][$this->db->row['name']]['title'] = $this->db->row['title'];
			$model_data[$table_name][$this->db->row['name']]['value'] = $this->db->row['value'];
			$model_data[$table_name][$this->db->row['name']]['type'] = $this->db->row['type'];
				
			$model_data[$table_name][$this->db->row['name']]['primary_key_name'] = $this->db->row['primary_key_name'];
			$model_data[$table_name][$this->db->row['name']]['primary_key_table'] = $this->db->row['primary_key_table'];
			$model_data[$table_name][$this->db->row['name']]['value_string'] = $this->db->row['value_string'];
			$model_data[$table_name][$this->db->row['name']]['query'] = $this->db->row['query'];
			$model_data[$table_name][$this->db->row['name']]['value_name'] = $this->db->row['value_name'];
			$model_data[$table_name][$this->db->row['name']]['title_default'] = $this->db->row['title_default'];
			$model_data[$table_name][$this->db->row['name']]['value_default'] = $this->db->row['value_default'];
			
			$model_data[$table_name][$this->db->row['name']]['value_table'] = $this->db->row['value_table'];
			$model_data[$table_name][$this->db->row['name']]['value_primary_key'] = $this->db->row['value_primary_key'];
			$model_data[$table_name][$this->db->row['name']]['value_field'] = $this->db->row['value_field'];
			$model_data[$table_name][$this->db->row['name']]['assign_to'] = $this->db->row['assign_to'];
			$model_data[$table_name][$this->db->row['name']]['dbtype'] = $this->db->row['dbtype'];
			//$model_data[$table_name][$this->db->row['name']]['select_data'] = ($this->db->row['select_data']!='' ? unserialize($this->db->row['select_data']) : array());
			if($this->db->row['select_data']!=''){
				$model_data[$table_name][$this->db->row['name']]['select_data'] = $this->unserializeSelectData($this->db->row['select_data']);
			}
			$model_data[$table_name][$this->db->row['name']]['table_name'] = $this->db->row['table_name'];
			$model_data[$table_name][$this->db->row['name']]['primary_key'] = $this->db->row['primary_key'];
			$model_data[$table_name][$this->db->row['name']]['primary_key_value'] = $this->db->row['primary_key_value'];
			$model_data[$table_name][$this->db->row['name']]['action'] = $this->db->row['action'];
			$model_data[$table_name][$this->db->row['name']]['tab'] = $this->db->row['tab'];
			$model_data[$table_name][$this->db->row['name']]['hint'] = $this->db->row['hint'];
			$model_data[$table_name][$this->db->row['name']]['active_in_topic'] = $this->db->row['active_in_topic'];
			$model_data[$table_name][$this->db->row['name']]['group_id'] = $this->db->row['group_id'];
			$model_data[$table_name][$this->db->row['name']]['entity'] = $this->db->row['entity'];
			$model_data[$table_name][$this->db->row['name']]['combo'] = $this->db->row['combo'];
			
			if ( $this->db->row['required'] ) {
				$required = 'on';
			} else {
				$required = 'off';
			}
			$model_data[$table_name][$this->db->row['name']]['required'] = $required;
				
			if ( $this->db->row['unique'] ) {
				$unique = 'on';
			} else {
				$unique = 'off';
			}
			$model_data[$table_name][$this->db->row['name']]['unique'] = $unique;
		}
		
		//echo '<pre>';
		///print_r($model_data);
		//echo '</pre>';
		
		return $model_data;
	
	}
	
	function unserializeSelectData($str){
		$ret=array();
		$matches=array();
		preg_match_all('/\{[^\}]+\}/',$str,$matches);
		if(count($matches)>0){
			foreach($matches[0] as $v){
				$v=str_replace(array('{','}'), '', $v);
				$d=explode('~~',$v);
				$ret[$d[0]]=$d[1];
			}
		}
		return $ret;
		//print_r($matches);
	}
	
	
	function update_table ( $table_name ) {
		$table_model = $this->load_model($table_name);
		$ra = $this->columns_define_generator($table_model[$table_name]);
		foreach ( $ra as $item_id => $item ) {
			$query = "alter table ".DB_PREFIX."_{$table_name} add column $item";
			$this->db->exec($query);
		}
		$rs = " {$table_name}  ";
		return $rs;
	}
	
	function columns_define_generator ( $table_model ) {
		$ra = array();
		if ( empty($table_model) ) {
			return $ra;
		}
		foreach ( $table_model as $item_id => $item_array ) {
			switch ( $item_array['type'] ) {
				case 'primary_key':
					$ra[] = $this->create_primary_key($item_array);
					break;
				case 'price':
					$ra[] = $this->create_int($item_array);
					break;
				case 'select_box':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'email':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'mobilephone':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'select_by_query':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'select_by_query_multiple':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'select_box_structure':
					$ra[] = $this->create_int($item_array);
					break;
					
				case 'structure':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'select_box_structure_simple_multiple':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'shop_select_box_structure':
					$ra[] = $this->create_int($item_array);
					break;
					
				case 'geodata':
					$ra[] = $this->create_geodata_lat($item_array);
					$ra[] = $this->create_geodata_lng($item_array);
					break;
		
				case 'service_type_select_box_structure':
					{
						$ra[] = $this->create_int($item_array);
					}
					break;
					/*
					 case 'uploader':
					$ra[] = $this->get_uploader_row($item_array);
					break;
		
					case 'pluploader':
					$ra[] = $this->get_pluploader_row($item_array);
					break;
					*/
				case 'uploadify_image':
					$this->create_image($item_array);
					break;
		
				case 'uploadify_file':
					//$ra[] = $this->create_image($item_array);
					break;
		
				case 'separator':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'checkbox':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'textarea':
					$ra[] = $this->create_text($item_array);
					break;
		
				case 'textarea_editor':
					$ra[] = $this->create_text($item_array);
					break;
		
				case 'grade':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'date':
					$ra[] = $this->create_int($item_array);
					break;
		
				case 'auto_add_value':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'safe_string':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'password':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'photo':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'hidden':
					$ra[] = $this->create_varchar($item_array);
					break;
		
				case 'values_list':
					$ra[] = $this->create_varchar($item_array);
					break;
			}
		}
		return $ra;
	}
	
	
	function create_table ( $table_name ) {
		$table_model = $this->load_model($table_name);
		$ra = $this->columns_define_generator($table_model[$table_name]);
		$create_table_query = "
		CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_{$table_name}` (
		".implode(' , ',$ra)."
		) ENGINE=MyISAM DEFAULT CHARSET=".DB_ENCODING." ;
		";
		//echo $create_table_query;
		$this->db->exec($create_table_query);
		if ( $this->db->success ) {
			$rs = " {$table_name}  ";
		} else {
			$rs = "    {$table_name}: {$this->db->error} ";
		}
		return $rs;
	}
	
	function check_table_exist ( $table_name ) {
		$query = "select * from ".DB_PREFIX."_{$table_name} limit 1";
		$this->db->exec($query);
		return $this->db->success;
	}
}