<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
/**
 * Yandex.Realty generator backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class yandexrealty_admin extends Object_Manager {
	
	protected $export_file='export.yandexrealty.xml';
	protected $export_file_storage=SITEBILL_DOCUMENT_ROOT;
	private $critical_term=30;
	private $min_normal_term=1; // 
	private $max_normal_term=5;
	private $currency='RUR';
	private $rent_period='';
	private $topicsOperations=array();
	private $enabled_topics=array();
	private $export_mode='YANDEX';
	//private $export_to_file=1;
    /**
     * Constructor
     */
    function __construct( $realty_type = false ) {
		if($this->getRequestValue('foretown')){
			$this->export_mode='ETOWN';
		}
    	$this->action='yandexrealty';
        $this->SiteBill();
        Multilanguage::appendAppDictionary('yandexrealty');
        $this->site_url='http://'.$_SERVER['SERVER_NAME'].(SITEBILL_MAIN_URL!='' ? SITEBILL_MAIN_URL.'/' : '/');
        $this->filename=date('YmdHis',time()).'.'.$this->fileextension;
		$this->file_header='<?xml version="1.0" encoding="windows-1251"?>'."\n";
		//$this->enabled_topics=$this->getEnabledTopics();
		$this->enabled_topics=array();
		$this->topicsOperations=array();
		//$this->topicsOperations=$this->getTopicsOperations($this->enabled_topics);
				
		
		$this->file_gen_date='<generation-date>'.$this->formdate().'</generation-date>'."\n";
		
		$this->file_start='<realty-feed xmlns="http://webmaster.yandex.ru/schemas/feed/realty/2010-06">'."\n";
		//$this->file_start.='<site>'.$this->site_url.'</site>'."\n";
		$this->file_end='</realty-feed>';
        
    }
    
    function getInfo () {
    	/*$rs = "<p>URL  : <a href=\"".$this->site_url."yandexrealty/\" target=\"_blank\">".$this->site_url."yandexrealty/</a></p>
<p> Yandex.Realty    ,         .: <a href=\"http://realty.yandex.ru/\" target=\"_blank\">http://realty.yandex.ru/</a></p>
<p>       <a href=\"http://www.etown.ru/\" target=\"_blank\">  </a>.<br>        ,         ,        .<br>       <a href=\"http://www.etown.ru/\" target=\"_blank\">  </a>       XML-     ,   : <a href=\"".$this->site_url."yandexrealty/\" target=\"_blank\">".$this->site_url."yandexrealty/</a></p> 
    ";*/
    	$rs=sprintf(Multilanguage::_('INFO','yandexrealty'),$this->site_url."yandexrealty/",$this->site_url."yandexrealty/",$this->site_url."yandexrealty/",$this->site_url."yandexrealty/");
    	return $rs;
    }
    
    function main(){
    	//$rs=$this->getTopMenu();
    	$rs=$this->getInfo();
    	switch($this->getRequestValue('do')){
			/*
    		case 'assoc_table_show' : {
    			$rs.=$this->showAssocTable();
    			break;
    		}
    		case 'assoc_table_show_save' : {
    			$this->saveChanges($_POST['data']);
    			$rs.=$this->showAssocTable();
    			break;
    		}
    		case 'make_table' : {
    			$this->x();
    			break;
    		}
			case 'create_table' : {
    			if($this->createAssocTable()){
					$rs.='  ';
				}else{
					$rs.='   .    .';
				}
    			break;
    		}
			*/
    		case 'export' : {
    			$rs.=$this->export();
    			break;
    		}
    	}
    	return $rs;
    }
    /*
    private function saveChanges($data){
    	if(!empty($data)){
    		foreach($data as $k=>$v){
    			if($v['delete']=='on'){
    				$query='DELETE FROM '.DB_PREFIX.'_yandexrealty_assoc WHERE topic_id='.$k;
    			}else{
    				$query='UPDATE '.DB_PREFIX.'_yandexrealty_assoc SET realty_type='.$v['realty_type'].', operation_type='.$v['operation_type'].' WHERE topic_id='.$k;
    			}
    			
    			//echo $query;
    			$this->db->exec($query);
    		}
    	}
    }
    */
    /*
    function showAssocTable(){
    	//echo '<pre>';
    	//print_r($_POST);
    	$ret='<table>';
    	$ret.='<form method="post" action="/admin/index.php">';
    	$ret.='<tr><td></td><td> </td><td> </td><td> <br /></td></tr>';
    	$query='SELECT * FROM '.DB_PREFIX.'_yandexrealty_assoc';
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$ret.='<tr><td>'.$this->db->row['topic_name'].'</td><td>'.$this->getRealtyTypeSelectbox($this->db->row['realty_type'],$this->db->row['topic_id']).'</td><td>'.$this->getOperationTypeSelectbox($this->db->row['operation_type'],$this->db->row['topic_id']).'</td><td><input type="checkbox" name="data['.$this->db->row['topic_id'].'][delete]" /></td></tr>';
    	}
    	$ret.='<input type="hidden" name="action" value="'.$this->action.'">';
    	$ret.='<input type="hidden" name="do" value="assoc_table_show_save">';
    	$ret.='<tr><td><input type="submit" name="submit" value="submit"></td></tr>';
    	$ret.='</form>';
    	$ret.='</table>';
    	return $ret;
    }
    */
    /*
    function x(){
    	$query='SELECT id, name FROM '.DB_PREFIX.'_topic';
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$data[]=$this->db->row;
    	}
    	if(!empty($data)){
    		foreach($data as $d){
    			$query='INSERT IGNORE INTO '.DB_PREFIX.'_yandexrealty_assoc (topic_id, topic_name) VALUES ('.$d['id'].',\''.$d['name'].'\')';
    			$this->db->exec($query);
    		}
    	}
    }
    */
    public function export(){
		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php';
		$Structure=new Structure_Manager();
		
		
		$category_structure = $Structure->loadCategoryStructure();
		
		$x=$Structure->createCatalogChains();
		$catalogChains=$x['txt'];
		$rs='';
    	$data=$this->collectData();
		if(empty($data)){
    		return Multilanguage::_('EXPORT_FAILED','yandexrealty');
    	}
    	$limit_time_arenda = time()-604800;
    	$count=0;
    	foreach($data as $data_item){
    		
    		if($data_item['price'] > 0 AND $data_item['city'] !== ''){
				$count++;
				
			
				$rs.='<offer internal-id="'.$data_item['id'].'">'."\n";
				
				
				if(isset($data_item['optype'])){
					$optype=(int)$data_item['optype'];
				}else{
					$optype=0;
				}
				
				if($optype==1){
					$rs.='<type></type>'."\n";
				}else{
					$rs.='<type></type>'."\n";
				}
				
				if(isset($data_item['property_type']) && $data_item['property_type']!=''){
					$rs.='<property-type>'.$data_item['property_type'].'</property-type>'."\n";
				}else{
					$rs.='<property-type></property-type>'."\n";
				}
				
				
				
				if($this->export_mode=='ETOWN'){
					$rs.='<category>'.$catalogChains[$data_item['topic_id']].'</category>'."\n";
				}else{
					$rs.='<category>'.$data_item['topic'].'</category>'."\n";
				}
				
				
				
				//if($optype==1){
				//	$rs.='<type></type>'."\n";
				//}else{
				//	$rs.='<type></type>'."\n";
				//}
				
				//$rs.='<property-type></property-type>'."\n";
				/*
				if($this->getConfigValue('apps.realtypro.enable')==1){
					if($data_item['realty_type_id']==1){
						$rs.='<category></category>'."\n";
					}elseif($data_item['realty_type_id']==2){
						$rs.='<category></category>'."\n";
					}elseif($data_item['realty_type_id']==3){
						$rs.='<category></category>'."\n";
					}else{
						$rs.='<category>'.$data_item['topic'].'</category>'."\n";
					}
				}else{
					$rs.='<category>'.$data_item['topic'].'</category>'."\n";
				}
				*/
				$parent_category_url='';
				$href='';
				if(1==$this->getConfigValue('apps.seo.level_enable')){
					 
					if($category_structure['catalog'][$data_item['topic_id']]['url']!=''){
						$parent_category_url=$category_structure['catalog'][$data_item['topic_id']]['url'].'/';
					}
				}
				if(1==$this->getConfigValue('apps.seo.data_alias_enable') && $data_item['translit_alias']!=''){
					$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.$data_item['translit_alias'];
				}elseif(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
					$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$data_item['id'].'.html';
				}else{
					$href=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$data_item['id'];
				}

				$rs.='<url>http://'.$_SERVER['HTTP_HOST'].$href.'</url>'."\n";
				$date_timestamp=strtotime($data_item['date_added']);
				//echo '1:'.$date_item['date_added'].'<br>';
				//echo date('d-m-Y', $date_timestamp).'<br>';
				$rs.='<creation-date>'.$this->formdate($date_timestamp).'</creation-date>'."\n";
				if((time()-$date_timestamp)>($this->critical_term*24*3600)){
					$rs.='<last-update-date>'.$this->formdate(time()-(rand($this->min_normal_term,$this->max_normal_term)*24*3600)).'</last-update-date>'."\n";
				}
				//$rs.='<last-update-date>'.$this->formdate().'</last-update-date>'."\n";
				$rs.='<location>'."\n";
				$rs.='<country>'.($data_item['country']=='' ? '' : $data_item['country']).'</country>'."\n";
				/*
				if($ref_city[$db->row['city_id']]!='-'){
					$rs.='<region>'.$ref_region[$db->row['region_id']].'</region>'."\n";
				}
				*/
				
		    	if($data_item['city']!=''){
					$rs.='<locality-name>'.$data_item['city'].'</locality-name>'."\n";
				}
		    	if($data_item['district']!=''){
					$rs.='<sub-locality-name>'.$data_item['district'].'</sub-locality-name>'."\n";
				}
				$rs.='<address>';
				$street = str_replace('.', '', $data_item['street']);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('-', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
				$street = str_replace('.', '', $street);
					
				$rs.= $street;
				if($data_item['number']!=''){
					$rs.=', '.$data_item['number'];
				}
				$rs.='</address>'."\n";
				if($data_item['metro']!=''){
					$rs.='<metro>'."\n";
						$rs.='<name>'.$data_item['metro'].'</name>'."\n";
					$rs.='</metro>'."\n";
				}
				$rs.='</location>'."\n";

				$rs.='<sales-agent>'."\n";
				if($data_item['fio']!='' AND $data_item['user_id']==$this->getUnregisteredUserId()){
					$rs.='<category>owner</category>'."\n";
					$rs.='<phone>'.$data_item['phone'].'</phone>'."\n";
					$rs.='<email>'.$data_item['email'].'</email>'."\n";
					$rs.='<name>'.$data_item['fio'].'</name>'."\n";
				}else{
					///   
					require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/users_manager.php';
					$UM=new Users_Manager();
					$user=$UM->getUserProfileData($data_item['user_id']);
					
					if($this->getConfigValue('apps.company.enable')==1){
						if($user['company_id']!=0){
							require_once SITEBILL_DOCUMENT_ROOT.'/apps/company/admin/admin.php';
							$CA=new company_admin();
							$company=$CA->load_by_id($user['company_id']);
							//print_r($company);
							$rs.='<phone>'.$db->row['agency_agentphone'].'</phone>'."\n";
							$rs.='<organization>'.$company['name']['value'].'</organization>'."\n";
							$rs.='<category>agency</category>'."\n";
							$rs.='<url>'.$company['site']['value'].'</url>'."\n";
							$rs.='<email>'.$company['email']['value'].'</email>'."\n";
							$rs.='<name>'.$company['name']['value'].'</name>'."\n";
							$rs.='<phone>'.$company['phone1']['value'].'</phone>'."\n";
						}else{
							$rs.='<category>owner</category>'."\n";
							$rs.='<phone>'.$user['phone'].'</phone>'."\n";
							$rs.='<email>'.$user['email'].'</email>'."\n";
							$rs.='<name>'.$user['fio'].'</name>'."\n";
						}
					}else{
						$rs.='<category>owner</category>'."\n";
						$rs.='<phone>'.$user['phone'].'</phone>'."\n";
						$rs.='<email>'.$user['email'].'</email>'."\n";
						$rs.='<name>'.$user['fio'].'</name>'."\n";
					}
					
					
					
				}
				
				$rs.='</sales-agent>'."\n";
				
				$rs.='<price>'."\n";
				$rs.='<value>'.$data_item['price'].'</value>'."\n";
				$rs.='<currency>'.$this->currency.'</currency>'."\n";
				$rs.='</price>'."\n";
				/*
				if($db->row['operation_type']==1){
					$rs.='<price>'."\n";
					$rs.='<value>'.$data_item['price'].'</value>'."\n";
					$rs.='<currency>'.$this->currency.'</currency>'."\n";
					$rs.='</price>'."\n";
				}else{
					$rs.='<price>'."\n";
					$rs.='<value>'.$data_item['price'].'</value>'."\n";
					$rs.='<currency>'.$this->currency.'</currency>'."\n";
					$rs.='<period>'.$this->rent_period.'</period>'."\n";
					$rs.='</price>'."\n";

				}
				*/
				$rs.='<description>'.htmlspecialchars(strip_tags($data_item['text']),ENT_QUOTES,'cp1251').'</description>'."\n";
				
				$imgids=array();
				$imgs=array();
				//$db1=new Db($this->db_server,$this->db_db,$this->db_user,$this->db_password);
				$query='SELECT image_id FROM '.DB_PREFIX.'_data_image WHERE id='.$data_item['id'];
				$this->db->exec($query);
				while($this->db->fetch_assoc()){
					$imgids[]=$this->db->row['image_id'];
				}
				if(count($imgids)>0){
					$query='SELECT normal,preview FROM '.DB_PREFIX.'_image WHERE image_id IN ('.implode(',',$imgids).')';
					$this->db->exec($query);
					while($this->db->fetch_assoc()){
						$imgs[]=$this->db->row;
					}
				}
				
				if(count($imgs)>0){
				
					foreach($imgs as $v){
						if($this->export_mode=='ETOWN'){
							$rs.='<imagefile>'."\n";
							$rs.='<image>http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/img/data/'.$v['preview'].'</image>'."\n";
							$rs.='<image>http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/img/data/'.$v['normal'].'</image>'."\n";
							$rs.='</imagefile>'."\n";
						}else{
							$rs.='<image>http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/img/data/'.$v['preview'].'</image>'."\n";
						}
						
					}
					
				}
				
				//$rs.='<image></image>'."\n";
				
		    $x=preg_replace('/[^0-9\.,]/','',$data_item['square_all']);
				if($x!=''){
					$rs.='<area>'."\n";
					$rs.='<value>'.$x.'</value>'."\n";
					$rs.='<unit>.</unit>'."\n";
					$rs.='</area>'."\n";
				}
				
				$x=preg_replace('/[^0-9\.,]/','',$data_item['square_live']);
				if($x!=''){
					$rs.='<living-space>'."\n";
					$rs.='<value>'.($x!='' ? $x : 0).'</value>'."\n";
					$rs.='<unit>.</unit>'."\n";
					$rs.='</living-space>'."\n";
				}
				
				$x=preg_replace('/[^0-9\.,]/','',$data_item['square_kitchen']);
				if($x!=''){
					$rs.='<kitchen-space>'."\n";
					$rs.='<value>'.($x!='' ? $x : 0).'</value>'."\n";
					$rs.='<unit>.</unit>'."\n";
					$rs.='</kitchen-space>'."\n";
				}
				$rs.='<rooms>'.(int)$data_item['room_count'].'</rooms>'."\n";
				$rs.='<rooms-offered>'.(int)$data_item['room_count'].'</rooms-offered>'."\n";
				if($data_item['is_telephone']!=''){
					$rs.='<phone>'.$data_item['is_telephone'].'</phone>'."\n";
				}
				if($data_item['floor']!=''){
					$rs.='<floor>'.(int)$data_item['floor'].'</floor>'."\n";
				}
				if($data_item['floor']!=''){
					$rs.='<floors-total>'.(int)$data_item['floor_count'].'</floors-total>'."\n";
				}
				
				if($data_item['walls']!=''){
					$rs.='<building-type>'.$data_item['walls'].'</building-type>'."\n";
				}
				if($data_item['elite']==1){
					$rs.='<is-elite></is-elite>'."\n";
				}
				
				//if($db->row['parking_id']!=1){
				//	$rs.='<parking></parking>'."\n";
				//}
				
				//if((int)$db->row['security_id']>1){
				//	$rs.='<alarm></alarm>'."\n";
				//}
				
			$rs.='</offer>'."\n";
			
	    	}
    	}
		
		/*
		$f=fopen($this->export_file_storage.'/'.$this->export_file, 'w');
		fwrite($f,$this->file_header.$this->file_start.$this->file_gen_date.$rs.$this->file_end);
    	fclose($f);
		*/
    	echo $this->file_header;
		echo $this->file_start;
		echo $this->file_gen_date;
		echo $rs;
		echo $this->file_end;
	}
    /*
    private function getEnabledTopics(){
    	$topics=array();
    	$query='SELECT topic_id FROM '.DB_PREFIX.'_yandexrealty_assoc WHERE realty_type NOT IN (0,4,6) AND operation_type IN (1,2)';
    	//echo $query;
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$topics[]=$this->db->row['topic_id'];
    	}
    	return $topics;
    }
    */
	/*
	private function createAssocTable(){
		$query="CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_yandexrealty_assoc` (
		  `topic_id` int(11) NOT NULL,
		  `topic_name` varchar(255) NOT NULL,
		  `realty_type` tinyint(4) NOT NULL DEFAULT '0',
		  `operation_type` tinyint(4) NOT NULL DEFAULT '0',
		  PRIMARY KEY (`topic_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=cp1251;";
		$this->db->exec($query);
		if($this->db->success){
			return TRUE;
		}else{
			return FALSE;
		}
	}
	*/
	/*
    private function getTopicsOperations($topics){
    	$ret=array();
    	if(!empty($topics)){
    		$query='SELECT topic_id, operation_type FROM '.DB_PREFIX.'_yandexrealty_assoc WHERE topic_id IN ('.implode(',',$topics).')';
	    	$this->db->exec($query);
	    	while($this->db->fetch_assoc()){
	    		$ret[$this->db->row['topic_id']]=$this->db->row['operation_type'];
	    	}
    	}
    	return $ret;
    }
    */
    private function collectData(){
    	$data=array();
		/*
    	if(!empty($this->enabled_topics)){
	    	//$query='SELECT dt.*, tp.name AS topic, ct.name AS city, ds.name AS district, cr.name AS country, st.name AS street, mt.name AS metro FROM '.DB_PREFIX.'_data dt LEFT JOIN '.DB_PREFIX.'_topic tp ON tp.id=dt.topic_id LEFT JOIN '.DB_PREFIX.'_city ct ON dt.city_id=ct.city_id LEFT JOIN '.DB_PREFIX.'_district ds ON dt.district_id=ds.id LEFT JOIN '.DB_PREFIX.'_metro mt ON dt.metro_id=mt.metro_id LEFT JOIN '.DB_PREFIX.'_street st ON st.street_id=dt.street_id LEFT JOIN '.DB_PREFIX.'_country cr ON cr.country_id=dt.country_id WHERE dt.active=1 AND dt.topic_id IN ('.implode(',',$this->enabled_topics).')';
			
    	}
		*/
    	//   6-
    	$max_date = date('Y-m-d', time()- 15552000 );
    	$max_date=0;
		$query='SELECT dt.*, tp.name AS topic, ct.name AS city, ds.name AS district, cr.name AS country, st.name AS street, mt.name AS metro FROM '.DB_PREFIX.'_data dt LEFT JOIN '.DB_PREFIX.'_topic tp ON tp.id=dt.topic_id LEFT JOIN '.DB_PREFIX.'_city ct ON dt.city_id=ct.city_id LEFT JOIN '.DB_PREFIX.'_district ds ON dt.district_id=ds.id LEFT JOIN '.DB_PREFIX.'_metro mt ON dt.metro_id=mt.metro_id LEFT JOIN '.DB_PREFIX.'_street st ON st.street_id=dt.street_id LEFT JOIN '.DB_PREFIX.'_country cr ON cr.country_id=dt.country_id WHERE dt.active=1 and dt.date_added > \''.$max_date.'\'';
		//echo $query.'<br>';
		$this->db->exec($query);
		while($this->db->fetch_assoc()){
			$data[]=$this->db->row;
		}
    	return $data;
    }
    
    
	private function formdate($time=NULL){
		if($time===NULL){
			$localtm=time();
		}else{
			$localtm=$time;
		}
		
		$off=date('Z',$localtm); //10800
		//echo $off;
		$offset=$off/3600; //3
		//echo $offset;
		if($off>=0){
			$gmtoff='+'.gmdate('H:i',$off);
		}else{
			$gmtoff=gmdate('H:i',$off);
		}
		
		$gmttime=$localtm-$off;
		$gmtdate=date('Y-m-d\TH:i:s',$gmttime);
		return $gmtdate.$gmtoff;
	}
	/*
	private function getRealtyTypeSelectbox($realty_type,$topic_id){
		$re_types=array('0'=>'','1'=>'','4'=>'','6'=>'');
		$ret='';
		$ret.='<select name="data['.$topic_id.'][realty_type]">';
		foreach($re_types as $k=>$v){
			if($realty_type==$k){
				$ret.='<option value="'.$k.'" selected="selected">'.$v.'</option>';
			}else{
				$ret.='<option value="'.$k.'">'.$v.'</option>';
			}
		}
		$ret.='</select>';
		return $ret;
	}
	
	private function getOperationTypeSelectbox($operation_type,$topic_id){
		$op_types=array('0'=>'','1'=>'','2'=>'');
		$ret='';
		$ret.='<select name="data['.$topic_id.'][operation_type]">';
		foreach($op_types as $k=>$v){
			if($operation_type==$k){
				$ret.='<option value="'.$k.'" selected="selected">'.$v.'</option>';
			}else{
				$ret.='<option value="'.$k.'">'.$v.'</option>';
			}
		}
		$ret.='</select>';
		return $ret;
	}
	*/
	function getTopMenu () {
	    $rs = '';
	    //$rs.='<p>1.         </p>';
	    //$rs.='<p>2.    ,       ,   \'/  \'      .       .</p>';
	    //$rs.='<p>3.      ,          \'/  \'      .       .</p>';
		//$rs .= '<a href="?action='.$this->action.'&do=create_table" class="btn btn-primary">    </a>';
	    //$rs .= '<a href="?action='.$this->action.'&do=make_table" class="btn btn-primary">/  </a>';
		//$rs .= '<a href="?action='.$this->action.'&do=assoc_table_show" class="btn btn-primary">  </a>';
	    $rs .= '<a href="?action='.$this->action.'&do=export" class="btn btn-primary">'.Multilanguage::_('EXPORT','yandexrealty').'</a>';
		
	    return $rs;
	}
	
}