CREATE TABLE IF NOT EXISTS `re_captcha_session` (
  `captcha_session_id` int(11) NOT NULL AUTO_INCREMENT,
  `captcha_session_key` varchar(255) DEFAULT NULL,
  `captcha_string` varchar(32) NOT NULL DEFAULT '0',
  `start_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`captcha_session_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE `re_banner` (
  `banner_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `body` text,
  `catalog_id` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `url` text NOT NULL,
  PRIMARY KEY (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;        
#
CREATE TABLE IF NOT EXISTS `re_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `config_key` varchar(255) NOT NULL DEFAULT '',
  `value` text,
  `title` text,
  `sort_order` int(10) unsigned DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `config_key_idx` (`config_key`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_data` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `type_id` int(10) unsigned NOT NULL DEFAULT '0',
  `topic_id` int(10) unsigned NOT NULL DEFAULT '0',
  `country_id` int(10) unsigned NOT NULL DEFAULT '0',
  `city_id` int(10) unsigned NOT NULL DEFAULT '0',
  `metro_id` int(10) unsigned NOT NULL DEFAULT '0',
  `district_id` int(10) unsigned NOT NULL DEFAULT '0',
  `street` text NOT NULL,
  `price` int(10) unsigned DEFAULT '0',
  `text` text,
  `contact` text,
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `agent_tel` text,
  `room_count` int(11) DEFAULT NULL,
  `elite` int(10) unsigned DEFAULT '0',
  `session_id` text NOT NULL,
  `active` int(11) NOT NULL DEFAULT '0',
  `sub_id1` int(10) unsigned NOT NULL DEFAULT '0',
  `sub_id2` int(10) unsigned NOT NULL DEFAULT '0',
  `reviews_count` int(10) unsigned NOT NULL DEFAULT '0',
  `hot` int(10) unsigned DEFAULT '0',
  `floor` int(11) NOT NULL DEFAULT '0',
  `floor_count` int(11) NOT NULL DEFAULT '0',
  `walls` varchar(255) NOT NULL DEFAULT '',
  `balcony` varchar(255) NOT NULL DEFAULT '',
  `square_all` varchar(255) NOT NULL DEFAULT '',
  `square_live` varchar(255) NOT NULL DEFAULT '',
  `square_kitchen` varchar(255) NOT NULL DEFAULT '',
  `bathroom` varchar(255) NOT NULL DEFAULT '',
  `img1` varchar(255) NOT NULL DEFAULT '',
  `img2` varchar(255) NOT NULL DEFAULT '',
  `img3` varchar(255) NOT NULL DEFAULT '',
  `img4` varchar(255) NOT NULL DEFAULT '',
  `img5` varchar(255) NOT NULL DEFAULT '',
  `img1_preview` varchar(255) NOT NULL DEFAULT '',
  `img2_preview` varchar(255) NOT NULL DEFAULT '',
  `img3_preview` varchar(255) NOT NULL DEFAULT '',
  `img4_preview` varchar(255) NOT NULL DEFAULT '',
  `img5_preview` varchar(255) NOT NULL DEFAULT '',
  `is_telephone` varchar(255) NOT NULL DEFAULT '',
  `furniture` varchar(255) NOT NULL DEFAULT '',
  `plate` varchar(255) NOT NULL DEFAULT 'нет',
  `agent_email` varchar(255) NOT NULL DEFAULT '',
  `number` varchar(255) NOT NULL DEFAULT '',
  `spec` tinyint(4) NOT NULL DEFAULT '0',
  `floor_cover` text,
  `square_room` text,
  `is_kitchen` tinyint(4) NOT NULL DEFAULT '0',
  `region_id` int(10) unsigned NOT NULL DEFAULT '0',
  `street_id` int(10) unsigned NOT NULL DEFAULT '0',
  `planning` text NOT NULL,
  `dom` text NOT NULL,
  `flat_number` text NOT NULL,
  `owner` text NOT NULL,
  `source` text NOT NULL,
  `adv_date` text NOT NULL,
  `more1` text NOT NULL,
  `more2` text NOT NULL,
  `more3` text NOT NULL,
  `youtube` text NOT NULL,
  `fio` varchar(255) NOT NULL DEFAULT '',
  `phone` varchar(255) NOT NULL DEFAULT '',
  `realty_type_id` int(10) unsigned NOT NULL DEFAULT '0',
  `view_count` int(10) unsigned NOT NULL DEFAULT '0',
  `best` int(10) unsigned NOT NULL DEFAULT '0',
  `email` varchar(255) NOT NULL DEFAULT '',
  `distance` varchar(255) NOT NULL DEFAULT '',
  `tmp_password` varchar(255) NOT NULL DEFAULT '',
  `ad_mobile_phone` varchar(255) NOT NULL DEFAULT '',
  `ad_stacionary_phone` varchar(255) NOT NULL DEFAULT '',
  `can_call_start` varchar(255) NOT NULL DEFAULT '',
  `can_call_end` varchar(255) NOT NULL DEFAULT '',
  `currency_id` int(10) unsigned NOT NULL DEFAULT '1',
  `meta_title` text,
  `meta_description` text,
  `meta_keywords` text,
  `geo_lat` decimal(9,6) DEFAULT NULL,
  `geo_lng` decimal(9,6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `kre_data_FKIndex1` (`district_id`),
  KEY `kre_data_FKIndex3` (`topic_id`),
  KEY `re_data_FKIndex4` (`type_id`),
  KEY `re_data_FKIndex5` (`user_id`),
  KEY `sub_id1` (`sub_id1`),
  KEY `sub_id2` (`sub_id2`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE `re_data_get_rent` (
  `data_get_rent_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `type_id` int(10) unsigned NOT NULL DEFAULT '0',
  `room_type_id` int(11) NOT NULL DEFAULT '0',
  `time_range_id` int(11) NOT NULL DEFAULT '0',
  `district_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `phone` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `more` varchar(255) NOT NULL DEFAULT '',
  `date_added` int(11) NOT NULL DEFAULT '0',
  `topic_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`data_get_rent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_data_image` (
  `data_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`data_image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_district` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `short_name1` text,
  `city_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_image` (
  `image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `normal` varchar(255) NOT NULL DEFAULT '',
  `preview` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`image_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_land` (
  `land_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `type_id` int(10) unsigned NOT NULL DEFAULT '0',
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `coord` text,
  `number` varchar(255) NOT NULL DEFAULT '',
  `function` text,
  `location` text,
  `price` int(11) NOT NULL DEFAULT '0',
  `square` float NOT NULL DEFAULT '0',
  `price_per_unit` float NOT NULL DEFAULT '0',
  `description` text,
  PRIMARY KEY (`land_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_land_image` (
  `land_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `land_id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`land_image_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_news` (
  `news_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `description` text,
  `date` int(11) NOT NULL DEFAULT '0',
  `img` varchar(255) NOT NULL DEFAULT '',
  `img_preview` varchar(255) NOT NULL DEFAULT '',
  `anons` text,
  PRIMARY KEY (`news_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_news_image` (
  `news_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `news_id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`news_image_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_operation_type` (
  `operation_type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  PRIMARY KEY (`operation_type_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_page` (
  `page_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `uri` varchar(255) NOT NULL DEFAULT '',
  `meta_keywords` text,
  `meta_description` text,
  `body` text,
  `date` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`page_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_region` (
  `region_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `country_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`region_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_request` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `time` int(10) unsigned DEFAULT NULL,
  `request` text NOT NULL,
  `name` text NOT NULL,
  `contact` text,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_session` (
  `user_id` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(255) DEFAULT NULL,
  `session_key` varchar(32) NOT NULL DEFAULT '0',
  `start_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_street` (
  `street_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `prefix` varchar(255) DEFAULT NULL,
  `name` text,
  `district_id` int(11) NOT NULL DEFAULT '0',
  `city_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`street_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_topic` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `name_en` text,
  `active` int(10) unsigned DEFAULT '0',
  `parent_id` int(10) unsigned DEFAULT '0',
  `order` int(11) DEFAULT '0',
  `sql_where` text,
  `obj_type_id` int(11) NOT NULL DEFAULT '0',
  `def_id1` int(10) unsigned NOT NULL DEFAULT '0',
  `def_id2` int(10) unsigned NOT NULL DEFAULT '0',
  `operation_type_id` int(11) NOT NULL DEFAULT '0',
  `url` text NOT NULL DEFAULT '',
  `description` text NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `parent` (`parent_id`),
  KEY `erased` (`active`),
  KEY `name` (`name`(3))
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_topic_image` (
`topic_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`id` int(11) NOT NULL DEFAULT '0',
`image_id` int(11) NOT NULL DEFAULT '0',
`sort_order` int(11) NOT NULL DEFAULT '0',
PRIMARY KEY (`topic_image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1 ;
#
CREATE TABLE IF NOT EXISTS `re_type` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` text,
  `short_name1` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_upload` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `data_id` int(10) unsigned NOT NULL DEFAULT '0',
  `date` int(10) unsigned NOT NULL DEFAULT '0',
  `file_data` mediumblob,
  `file_size` int(10) unsigned DEFAULT NULL,
  `file_name` text,
  `comment_2` text,
  `ip` varchar(15) NOT NULL DEFAULT '',
  `mime` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `re_upload_FKIndex1` (`data_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_user` (
  `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `login` varchar(255) NOT NULL,
  `pass` text NOT NULL,
  `active` int(10) unsigned DEFAULT '0',
  `reg_date` datetime DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `fio` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `account` varchar(255) DEFAULT '0',
  `group_id` int(11) NOT NULL DEFAULT '0',
  `company_id` int(11) NOT NULL DEFAULT '0',
  `phone` varchar(200) NOT NULL DEFAULT '',
  `site` varchar(200) NOT NULL DEFAULT '',
  `imgfile` varchar(200) NOT NULL DEFAULT '',
  `mobile` varchar(200) NOT NULL DEFAULT '',
  `icq` varchar(200) NOT NULL DEFAULT '',
  PRIMARY KEY (`user_id`),
  UNIQUE(`login`),
  UNIQUE(`email`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_metro` (
  `metro_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `city_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`metro_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_country` (
  `country_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  PRIMARY KEY (`country_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_city` (
  `city_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `region_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`city_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_uploadify` (
  `uploadify_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `session_code` varchar(255) NOT NULL DEFAULT '',
  `file_name` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`uploadify_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_version` (
  `version_id` int(11) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `code` text,
  `name` text,
  PRIMARY KEY (`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_bill` (
  `bill_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `sum` varchar(255) NOT NULL DEFAULT '0',
  `date` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `description` text,
  `http_x_real_ip` varchar(255) NOT NULL DEFAULT '',
  `http_referer` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`bill_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_component` (
  `component_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`component_id`),
  UNIQUE(`name`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_component_function` (
  `component_function_id` int(11) NOT NULL AUTO_INCREMENT,
  `component_id` int(11) NOT NULL DEFAULT '0',
  `function_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`component_function_id`),
  UNIQUE KEY `cf_key_idx` (`component_id`, `function_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_dna` (
  `group_id` int(11) NOT NULL DEFAULT '0',
  `component_id` int(11) NOT NULL DEFAULT '0',
  `function_id` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `dna_key_idx` (`group_id`, `component_id`, `function_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_function` (
  `function_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `description` text,
  PRIMARY KEY (`function_id`),
  UNIQUE(`name`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_group` (
  `group_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `system_name` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`group_id`),
  UNIQUE(`system_name`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_menu` (
  `menu_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `tag` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`menu_id`),
  UNIQUE(`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_menu_structure` (
  `menu_structure_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `url` text,
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `menu_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`menu_structure_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_password_recovery` (
  `pr_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `recovery_code` varchar(50) NOT NULL,
  PRIMARY KEY (`pr_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE IF NOT EXISTS `re_currency` (
`currency_id` int(11) NOT NULL AUTO_INCREMENT,
`code` varchar(3) NOT NULL,
`name` varchar(30) NOT NULL,
`sort_order` tinyint(4) NOT NULL,
`course` varchar(10) NOT NULL,
`is_default` tinyint(4) NOT NULL DEFAULT '0',
`is_active` tinyint(4) NOT NULL DEFAULT '1',
PRIMARY KEY (`currency_id`),
UNIQUE(`code`),
UNIQUE(`name`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
#
CREATE TABLE IF NOT EXISTS `re_mailbox` (
    `mailbox_id` int(11) NOT NULL AUTO_INCREMENT,
    `sender_id` int(10) unsigned NOT NULL DEFAULT '0',
    `reciever_id` int(10) unsigned NOT NULL DEFAULT '0',
    `theme` varchar(255) NOT NULL,
    `message` text NOT NULL,
    `name` varchar(255) NOT NULL,
    `phone` varchar(30) NOT NULL,
    `email` varchar(100) NOT NULL,
    `realty_id` int(10) unsigned NOT NULL DEFAULT '0',
    `status` tinyint(4) NOT NULL DEFAULT '0',
    `creation_date` datetime NOT NULL,
    PRIMARY KEY (`mailbox_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE `re_gallery` (
  `gallery_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` text,
  `short_description` text,
  `long_description` text,
  `create_date` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `gallery_type` int(11) NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`gallery_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
#
CREATE TABLE `re_gallery_image` (
  `gallery_image_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `gallery_id` int(11) NOT NULL DEFAULT '0',
  `image_id` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`gallery_image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251 ;
