<?php
class frontend_main extends SiteBill_Krascap {
	
	function local_apps_processor () {
		$this->apps_dir = SITEBILL_DOCUMENT_ROOT.'/apps';
		
		if ( preg_match('/simpleeditor/', $_SERVER['REQUEST_URI']) ) {
			$this->run_apps('fasteditor');
		} elseif ( preg_match('/freeorder/', $_SERVER['REQUEST_URI']) ) {
			$this->run_apps('freeorder');
		} elseif ( $this->run_apps('page') ) {
			
		} else {
			$this->run_apps('realtypro');
		}
	}
	
	/**
	 * Set executed apps
	 * @param string $apps_name
	 */
	private function set_executed_apps ( $apps_name ) {
		$this->apps_executed[] = $apps_name;
	}
	
	/**
	 * Get executed apps
	 * @return Array
	 */
	function get_executed_apps () {
		return $this->apps_executed;
	}
	
	
	function run_apps ( $app_dir ) {
		if ( is_dir($this->apps_dir.'/'.$app_dir) and !preg_match('/\./', $app_dir) ) {
			if ( is_file($this->apps_dir.'/'.$app_dir.'/site/site.php') ) {
				require_once ($this->apps_dir.'/'.$app_dir.'/admin/admin.php');
				require_once ($this->apps_dir.'/'.$app_dir.'/site/site.php');
				$app_class_name = $app_dir.'_site';
				//echo $app_class_name.'<br>';
				$app_class_inst = new $app_class_name;
				if ( $app_class_inst->frontend() ) {
					$this->set_executed_apps($app_class_name);
					//closedir($dh);
					return true;
				}
			}
		}
		return false;
	}
	
	/**
	 * Main
	 * @param void
	 * @return string
	 */
	function main () {
		/*require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/sitebill_includer.php');
			$Sitebill_Includer=Sitebill_Includer::getInstance();
			$Sitebill_Includer->addCss('/template/frontend/agency/css/style.css');
			$Sitebill_Includer->addCss('/template/frontend/agency/css/style3.css');
			*/
			
			global $__site_title, $folder, $smarty;
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/apps/apps_processor.php');
			$apps_processor = new Apps_Processor();
			$apps_processor->run_preload();
	
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
			$Structure_Manager = new Structure_Manager();
	
			$this->template->assert('template_vars_logo', $this->getConfigValue('template.'.$this->getConfigValue('theme').'.logo'));
			$this->template->assert('current_theme_name', $this->getConfigValue('theme'));
			$this->template->assert('allow_register_account', $this->getConfigValue('allow_register_account'));
	
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/search/kvartira_search.php');
			$kvartira_search_form = new Kvartira_Search_Form();
			$kvartira_search_form->main();
			$this->template->assert('search_form_template', 'search_form.tpl');
			//$this->template->assert('available_langs', Multilanguage::availableLanguages());
			if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/upper/upper.xml') ) {
			    $this->template->assert('show_upper', 'true');
			}
	
			if ( $this->getConfigValue('menu_type') == 'purecss' ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/menu/purecssmenu.php');
				$purecssmenu = new PureCSS_Menu();
				$this->template->assert('slide_menu', $purecssmenu->get_menu());
			} elseif ( $this->getConfigValue('menu_type') == 'onelevel' ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/onelevelmenu/lib/onelevelmenu.php');
				$onelevel = new Onelevel_Menu();
				$this->template->assert('slide_menu', $onelevel->get_menu());
			} else {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/menu/slidemenu.php');
				$slidemenu = new Slide_Menu();
				$this->template->assert('slide_menu', $slidemenu->get_menu());
			}
	
			
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/plugin/plugin_processor.php');
			$Plugin_Processor = new Plugin_Processor();
			$Plugin_Processor->main();
	
	
			$extendedSearchFormParams=$this->getExtendedSearchFormParams();
			$this->template->assert('max_floor_count', $extendedSearchFormParams['max_floor_count']);
			$this->template->assert('max_price', $extendedSearchFormParams['max_price']);
			
			//$this->template->assert('type_list', $this->getTypeString());
			//set default value
			$this->template->assert('base', SITEBILL_MAIN_URL);
			$this->template->assert('show_demo_banners', $this->getConfigValue('show_demo_banners'));
			$this->template->assert('REQUEST_URI', $_SERVER['REQUEST_URI']);
			$this->template->assert('type_list2', '');
			$this->template->assert('type_list3', '');
			$this->template->assert('title', $this->getConfigValue('site_title'));
			$this->template->assert('city_by_default', $this->getConfigValue('city'));
			$this->template->assert('estate_folder', $folder);
			$this->template->assert('right_column', 1);
	
			$this->template->assert('structure_box', $Structure_Manager->getCategorySelectBoxWithName('topic_id', $this->getRequestValue('topic_id') ));
			//print_r($_SESSION);
	
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/login.php');
			$Login = new Login();
	
			if ( preg_match('/\/logout/', $_SERVER['REQUEST_URI']) ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/logout.php');
				$Logout = new Logout;
				$Logout->main();
			}
			
			
			if(1==$this->getConfigValue('apps.company.enable')){
				$this->template->assign('app_company_namespace',$this->getConfigValue('apps.company.namespace'));
			}
			
	
			$this->template->assert('user_id', $Login->getSessionUserId());
			//$this->template->assert('auth_menu', $Login->getAuthMenu());
			$this->template->assert('user_menu', $Login->getUserMenu());
			
			if ( $this->getConfigValue('allow_register_account') ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/register_using_model.php');
				$Register = new Register_Using_Model();
				//$smarty->assign->assert('main', $Register->main());
				$rs1 = $Register->getRegisterFormElements();
				$this->template->assert('register_form_elements', $rs1);
				
				
			}
			
	
			if ( $_SERVER['REQUEST_URI'] == '/' ) {
				$this->grid_special();
			}
	
			$this->grid_special_right();
			/*
			 if ( $_SERVER['REQUEST_URI'] == '/' and ($page_array = $this->getPageByURI('/index.html')) ) {
	
			} else {
			$page_array = $this->getPageByURI($_SERVER['REQUEST_URI']);
			}
			if ( $page_array ) {
			$this->template->assert('main', $page_array['body']);
			$this->template->assert('title', $page_array['title']);
			$this->template->assert('meta_keywords', $page_array['meta_keywords']);
			$this->template->assert('meta_description', $page_array['meta_description']);
			$this->template->render();
			$rs = $this->template->toHTML();
			return $rs;
			}
			*/
			
	
			if($this->getConfigValue('apps.freeorder.enable')==1){
				require_once SITEBILL_DOCUMENT_ROOT.'/apps/freeorder/admin/admin.php';
				require_once SITEBILL_DOCUMENT_ROOT.'/apps/freeorder/site/site.php';
				$FreeOrder=new freeorder_site();
				$this->template->assert('freeorder_form', $FreeOrder->getForm());
				$this->template->assert('freeorder_on', 'yes');
			}else{
				$this->template->assert('freeorder_on', 'no');
			}
	
			$this->template->assert('meta_keywords', '');
			$this->template->assert('meta_description', '');
			
			
			
			
			
			
			if ( preg_match('/\/myfavorites/', $_SERVER['REQUEST_URI']) ) {
	        	
	        			
	        	
	        	$this->template->assert('main', '<p><br></p>'.$this->grid_adv_favorites());
				$this->template->render();
	        	$rs = $this->template->toHTML();
	        	
	        	return $rs;
	        }
	
	
			if ( preg_match('/\/robox/', $_SERVER['REQUEST_URI']) ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/robokassa/robokassa.php');
				$robokassa = new Robox();
				$rs = $robokassa->main();
				if ( preg_match('/result/', $_SERVER['REQUEST_URI']) ) {
					echo $rs;
					exit;
				}
				$this->template->assert('main', $rs);
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
			
			if ( preg_match('/\/map(\/(\?.*)?)?$/', $_SERVER['REQUEST_URI']) ) {
				$this->template->assert('main', '<p><br></p>'.$this->map());
				//$this->map();
				return true;
			}
			if ( preg_match('/\/map_full_screen(\/(\?.*)?)?$/', $_SERVER['REQUEST_URI']) ) {
			    echo '&nbsp;';
			    $this->template->assert('data', $this->map(true));
				return true;
			}
				
			if ( $this->getConfigValue('apps.geodata.on_home') and $_SERVER['REQUEST_URI'] == '/' ) {
			    $this->template->assert('geodata_on_home', 1);
			    $this->template->assert('_geo_data', $this->map(true));
			}
			
			if ( preg_match('/\/goroda\//', $_SERVER['REQUEST_URI']) ) {
				$city=$this->getCityListTr();
				$topic=$this->getTopicListTr();
				//print_r($city);
				//print_r($topic);
				if(count($city)>0 && count($topic)>0){
					foreach($city as $c){
						foreach($topic as $t){
							$rs.='<a href="/'.$c['translit_name'].'-'.$t['translit_name'].'.html">'.$c['name'].' ('.$t['name'].')</a><br />';
						}
					}
				}
				$this->template->assert('main', $rs);
				/*$this->template->assert('search_form', $land_front->getSearchForm());
				*/
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
	
			if ( preg_match('/\/register/', $_SERVER['REQUEST_URI']) ) {
				if ( !$this->getConfigValue('allow_register_account') ) {
					$this->template->assert('main', '   ');
				} else {
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/register_using_model.php');
					$Register = new Register_Using_Model();
					//$smarty->assign->assert('main', $Register->main());
					$rs1 = $Register->main();
					$this->template->assert('main', $rs1);
				}
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
			if ( preg_match('/\/remind/', $_SERVER['REQUEST_URI']) ) {
				if ( !$this->getConfigValue('allow_remind_password') ) {
					$this->template->assert('main', '    ');
				} else {
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/user.php');
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/remind.php');
					$remind = new Remind;
					//$smarty->assign('main', $remind->main());
					$this->template->assert('main', $remind->main());
				}
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
			if ( preg_match('/\/login/', $_SERVER['REQUEST_URI']) ) {
				$this->template->assert('main', $Login->main());
				if ( $Login->getSessionUserId() > 0 ) {
					$this->template->assert('auth_menu', $Login->getAuthMenu());
				}
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
				//$resultString .= $this->getHomePageString();
				//return $resultString;
			}
	
	
	
			if ( $this->getConfigValue('theme') != 'kgs' ) {
				if ( SITEBILL_MAIN_URL != '' ) {
					$regexp = '/^\\'.SITEBILL_MAIN_URL.'\\/add(\/)*/';
				} else {
					$regexp = '/^\/add(\/)*/';
				}
				if ( preg_match($regexp, $_SERVER['REQUEST_URI']) ) {
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/form/add.php');
					$user_add = new User_Add();
					 
					$this->template->assert('main', $user_add->main());
					$this->template->render();
					$rs = $this->template->toHTML();
					return $rs;
				}
			}
	
			if ( preg_match('/\/ipotekaorder\//', $_SERVER['REQUEST_URI']) ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/form/ipoteka.php');
				$ipoteka_order = new Ipoteka_Order_Form();
	
				$this->template->assert('main', $ipoteka_order->main());
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
			if ( preg_match('/\/contactus\//', $_SERVER['REQUEST_URI']) ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/form/contactus.php');
				$contactus_form = new contactus_Form();
	
				$this->template->assert('main', $contactus_form->main());
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
	
			if ( preg_match('/\/land\//', $_SERVER['REQUEST_URI']) ) {
				require_once('lib/admin/land/land_manager.php');
				require_once('lib/frontend/land/land_front.php');
				$land_front = new Land_Front();
				 
				$this->template->assert('main', $land_front->main());
				$this->template->assert('search_form', $land_front->getSearchForm());
	
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
		
			
			$apps_processor->run_frontend();
			if ( count($apps_processor->get_executed_apps()) > 0 ) {
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
			
			if ( preg_match('/\/getrent\//', $_SERVER['REQUEST_URI']) ) {
				require_once (SITEBILL_DOCUMENT_ROOT.'/apps/getrent/admin/admin.php');
				require_once (SITEBILL_DOCUMENT_ROOT.'/apps/getrent/site/site.php');
				$getrent_site = new getrent_site();
				$getrent_site->frontend();
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
	
	
			if ( preg_match('/\/account/', $_SERVER['REQUEST_URI']) ) {
				$this->template->assert('right_column', '');
				$this->template->assert('is_account', '1');
				$this->template->assert('search_form_template', '');
	
				//return;
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/account.php');
				$Account = new Account;
	
				if ( $Account->get_user_id() > 0 ) {
					$company_profile = $Account->get_company_profile($Account->get_user_id());
					$this->template->assert('company', $company_profile);
				}
	
	
				$this->template->assert('breadcrumbs',
						$this->get_breadcrumbs(
								array(
										'<a href="'.$folder.'/">'.Multilanguage::_('L_HOME').'</a>',
										'<a href="'.$folder.'/account/"> </a>'
								)));
	
				if ( preg_match('/profile/', $_SERVER['REQUEST_URI']) ) {
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/profile.php');
					$profile = new User_Profile();
					$this->template->assert('breadcrumbs',
							$this->get_breadcrumbs(
									array(
											'<a href="'.$folder.'/">'.Multilanguage::_('L_HOME').'</a>',
											'<a href="'.$folder.'/account/"> </a>',
											'<a href="'.$folder.'/account/profile/"></a>'
									)));
	
					$this->template->assert('main', $profile->main());
				} elseif ( preg_match('/balance/', $_SERVER['REQUEST_URI']) ) {
	
					$this->template->assert('breadcrumbs',
							$this->get_breadcrumbs(
									array(
											'<a href="'.$folder.'/">'.Multilanguage::_('L_HOME').'</a>',
											'<a href="'.$folder.'/account/"> </a>',
											'<a href="'.$folder.'/account/balance/"></a>'
									)));
	
					$this->template->assert('main', $Account->main());
				} elseif ( preg_match('/\/user/', $_SERVER['REQUEST_URI'] ) ) {
					if ( $this->getConfigValue('apps.company.enable') ) {
						$this->template->assert('breadcrumbs',
								$this->get_breadcrumbs(
										array(
												'<a href="'.$folder.'/">'.Multilanguage::_('L_HOME').'</a>',
												'<a href="'.$folder.'/account/"> </a>',
												'<a href="'.$folder.'/account/user/"></a>'
										)));
	
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/user/user_company_manager.php');
						$user_company_manager = new User_Company_Manager();
						$this->template->assert('main', $user_company_manager->frontend_main());
					}
	
				} else {
	
					$this->template->assert('breadcrumbs',
							$this->get_breadcrumbs(
									array(
											'<a href="'.$folder.'/">'.Multilanguage::_('L_HOME').'</a>',
											'<a href="'.$folder.'/account/"> </a>',
											'<a href="'.$folder.'/account/data/"> </a>'
									)));
	
					if(preg_match('/add/', $_SERVER['REQUEST_URI'])){
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_admin.php');
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_editor.php');
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/data/user_data.php');
						$user_data_manager = new User_Data_Manager();
						$this->template->assert('main', $user_data_manager->add());
					}else{
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_admin.php');
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_editor.php');
						require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/data/user_data.php');
						$user_data_manager = new User_Data_Manager();
						$this->template->assert('main', $user_data_manager->main());
					}
	
				} 
				$this->template->render();
				$rs = $this->template->toHTML();
				return $rs;
			}
			
		if(1==$this->getConfigValue('apps.seo.data_alias_enable')){
			$requesturi=trim(parse_url($_SERVER['REQUEST_URI'],PHP_URL_PATH),'/');
			$requesturi=str_replace('\\', '/', $requesturi);
			if(SITEBILL_MAIN_URL!=''){
				preg_replace('/^'.trim(SITEBILL_MAIN_URL,'/').'/','',$requesturi);
			}
				
			$url_string_parts=explode('/',$requesturi);
			if(count($url_string_parts)>0){
				$possible_alias=$url_string_parts[count($url_string_parts)-1];
				
				$possible_alias=preg_replace('/[^A-Za-z0-9_-]/','',urldecode($possible_alias));
				if($possible_alias!=''){
					$q="SELECT id FROM ".DB_PREFIX."_data WHERE translit_alias='".$possible_alias."'";
					$this->db->exec($q);
					if($this->db->success){
						$this->db->fetch_assoc();
						if((int)$this->db->row['id']>0){
							
							$realty_id=(int)$this->db->row['id'];
							$this->growCounter('data', 'id', $realty_id, $this->getSessionUserId());
							require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/view/kvartira_view.php');
							$kvartira_view = new Kvartira_View();
								
							$this->template->assert('main', $kvartira_view->main($realty_id));
							return;
						}
					}
				}
			}
		}
        
	
	
		//if ( $this->getRequestValue('do') == 'view' ) {
		if ( preg_match('/realty/', $_SERVER['REQUEST_URI']) ) {
			if ( SITEBILL_MAIN_URL != '' ) {
			    $realty_view_regexp = '/^'.'\\'.SITEBILL_MAIN_URL.'\/realty/';
			} else {
			    $realty_view_regexp = '/^\/realty/';
			}
			if(1==$this->getConfigValue('apps.seo.level_enable') && preg_match($realty_view_regexp, $_SERVER['REQUEST_URI'])){
				$realty_id = $this->getIDfromURI($_SERVER['REQUEST_URI']);
				//echo 'realty_id = '.$realty_id;
				if($realty_id){
					$query='SELECT topic_id FROM '.DB_PREFIX.'_data WHERE id='.$realty_id;
					$this->db->exec($query);
					$this->db->fetch_assoc();
					$topic_id=$this->db->row['topic_id'];
					//echo $topic_id;
					require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
					$Structure_Manager = new Structure_Manager();
					$category_structure = $Structure_Manager->loadCategoryStructure();
					
					if($category_structure['catalog'][$topic_id]['url']!=''){
						$parent_category_url=$category_structure['catalog'][$topic_id]['url'].'/';
					}else{
						$parent_category_url='';
					}
					
					if(1==$this->getConfigValue('apps.seo.html_prefix_enable')){
						$new_location=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$realty_id.'.html';
					}else{
						$new_location=SITEBILL_MAIN_URL.'/'.$parent_category_url.'realty'.$realty_id;
					}
					header('HTTP/1.1 301 Moved Permanently');
					header('Location: '.$new_location);
				}else {
					header("Status: 404 Not Found");
					$this->template->assign('title', '  ');
					$this->template->assign('error_message', '<h1>  </h1>');
					$this->template->assign('main_file_tpl', 'error_message.tpl');
				}
				
			}elseif(1==$this->getConfigValue('apps.seo.level_enable') && !preg_match($realty_view_regexp, $_SERVER['REQUEST_URI'])){
				$realty_id = $this->getIDfromURI($_SERVER['REQUEST_URI']);
				$this->growCounter('data', 'id', $realty_id, $this->getSessionUserId());
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/view/kvartira_view.php');
				$kvartira_view = new Kvartira_View();
			
				$this->template->assert('main', $kvartira_view->main($realty_id));
			} elseif(0==$this->getConfigValue('apps.seo.level_enable') && preg_match($realty_view_regexp, $_SERVER['REQUEST_URI'])){
				$realty_id = $this->getIDfromURI($_SERVER['REQUEST_URI']);
				$this->growCounter('data', 'id', $realty_id, $this->getSessionUserId());
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/view/kvartira_view.php');
				$kvartira_view = new Kvartira_View();
					
				$this->template->assert('main', $kvartira_view->main($realty_id));
			}else {
				header("Status: 404 Not Found");
				$this->template->assign('title', '  ');
				$this->template->assign('error_message', '<h1>  </h1>');
				$this->template->assign('main_file_tpl', 'error_message.tpl');
			}
			
			
			
			
			
			
			
			
			/*
			$realty_id = $this->getIDfromURI($_SERVER['REQUEST_URI']);
			$this->growCounter('data', 'id', $realty_id, $this->getSessionUserId());
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/view/kvartira_view.php');
			$kvartira_view = new Kvartira_View();*/
	
			//$this->template->assert('main', $kvartira_view->main($realty_id));
		} elseif(preg_match('/user(\d+).html/', $_SERVER['REQUEST_URI'], $matches)){
			$this->setRequestValue('user_id', (int)$matches[1]);
			$this->template->assert('main', '<p><br></p>'.$this->grid_adv());
		} elseif( $this->getRequestValue('do') == 'news' ) {
			$this->template->assert('main', $this->viewNews( $this->getRequestValue('news_id') ));
		} elseif( $this->getRequestValue('do') == 'buy' ) {
			$this->template->assert('main', $this->processAdvancedForm('buy'));
		} elseif( $this->getRequestValue('do') == 'rent' ) {
			$this->template->assert('main', $this->processAdvancedForm('rent'));
		} elseif ( $this->getRequestValue('view') != '' ) {
			$this->template->assert('main', $this->getPage($this->getRequestValue('view')));
		} else {
			if($this->getConfigValue('apps.realtypro.enable')!=1){
				$this->template->assert('main', '<p><br></p>'.$this->grid_adv());
			}
	
		}
		$this->template->render();
		$rs = $this->template->toHTML();
		return $rs;
	}
}
?>